(*==============*)
        // AN EVENT IS RAN
(*--------------*)
        // A MESSAGE IS POSTED OR SENT
(*++++++++++++++*)
        // AN EXCEPTION IS RAISED




        // registry and network implementation after HNetwork.        

// v4.0
//##############################################################################
//#######                            DEVICES                              ######
//##############################################################################


        (*
          DEFINE THREADSAFE TO MAKE ALL THE OBJECTS THREADSAFE.
          || TAScreen
          || TABrowser
          || TANetwork
        *)
        {$DEFINE SCREEN_THREADSAFE}
        {$DEFINE BROWSER_THREADSAFE}
        {$DEFINE NETWORK_THREADSAFE}


        (*
          DEFINE CDROM_MCI_STARTUP TO INITIALIZE THE CDROM MONITOR
          ON THE APPLICATION STARTUP. THAT MIGHT CAUSE DELAY IN.
          STARTING THE PROGRAM
        *)
        {$DEFINE CDROM_MCI_STARTUP}


//##############################################################################
//#######                            DEVICES                              ######
//##############################################################################
Unit ADevices;




        		//###############
        		//## INTERFACE ##
        		//###############
        		Interface

        		//##############
        		//##   USES   ##
        		//##############
        		Uses
                        //######################################################
        		//######################## SYSTEM ######################
                                		  {System,}
                                		  HWindows,
                                                  HMessages,
                                                  HMultimedia,
                                                  HNetwork,

                        //######################################################
                        //######################### OWN ########################
                                                  AHeap,
                                                  ARoutine;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                                INTERFACE                                 ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################




                        //##############
                        //### CONST  ###
                        //##############
                        Const
                        //######################################################
                        //################ MOUSE BUTTON CONSTANTS ##############

  MB_NONE       = 0;
  MB_LEFT       = MK_LBUTTON;
  MB_RIGHT      = MK_RBUTTON;
  MB_MIDDLE     = MK_MBUTTON;

                        //######################################################
                        //################ SHIFT STATE CONSTANTS ###############

  SS_NONE               = 0;
  SS_SHIFT              = 1;
    SS_LSHIFT           = 2;
    SS_RSHIFT           = 4;
  SS_CONTROL            = 8;
    SS_LCONTROL         = 16;
    SS_RCONTROL         = 32;
  SS_ALT                = 64;
    SS_LALT             = 128;
    SS_RALT             = 256;

                        //######################################################
                        //############### LOCKS LIGHTS CONSTANTS ###############

  LIGHT_NONE    = 0;
  LIGHT_CAPS    = 4;
  LIGHT_NUM     = 2;
  LIGHT_SCROLL  = 1;




                        //##############
                        //### TYPES  ###
                        //##############
                        Type
                        //######################################################
                        //################## MOUSEWHEEL EVENT ##################

  TOnWheelEvent = procedure(Sender: TObject; x, y: Integer; Delta: Integer; Buttons: Integer);

                        //######################################################
                        //################## CDROM TRAY EVENT ##################

  TTrayEvent = procedure(Sender: TObject; const Drives: String);

                        //######################################################
                        //################ DRIVE CLUSTER STRUCT ################

  TClusterInfo = record
    SectorsPerCluster: Cardinal;
    BytesPerSector: Cardinal;
    FreeClusters: Cardinal;
    Clusters: Cardinal;
  end;

                        //######################################################
                        //################## WORKGROUP STRUCT ##################

  PWorkgroupRec = ^TWorkgroupRec;
  TWorkgroupRec = record
    Users: TAStringList;
    UserCount: Integer;
    Name: String;
  end;

  PDriveRec = ^TDriveRec;
  TDriveRec = record
    Drive: Char;
    Path: String;
  end;

  PShareRec = ^TShareRec;
  TShareRec = record
    Path: String;
    ResType: Integer;
  end;

                        //######################################################
                        //####################### CLASS TYPES ##################

  TAScreen = class;
  TAMouse = class;
  TAKeyboard = class;
  //#
  TADrives = class;
  TACdrom = class;
  TABrowser = class;
  TANetwork = class;
  //#
  TAClipboard = class;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                            EXPLICIT INTERFACE                            ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################




//##############################################################################
//##                                  SCREEN                                  ##
//##############################################################################




  TAScreen = class(TObject)
  protected
    FDC: Cardinal;
    FRectList: TARectList;
    //#
    FLock: TALock;
(*============================================================================*)
    function GetDesktopBounds: TRect;
    function GetBounds: TRect;
(*============================================================================*)
  public
    //#
    //#
    constructor Create;
    destructor Destroy; override;
    //#
    //#
    function ChangeSettings(AWidth, AHeight, ABpp, ARefresh: Integer): Boolean;
    //#
    procedure Repaint(AUpdateNow: Boolean); overload;
    procedure Repaint(ARect: TRect; AUpdateNow: Boolean); overload;
    procedure FlushGdi;
    //#
    procedure ListAdd(ARect: TRect; Mode: Integer);
    procedure ListClear;
    procedure ListFlush(AUpdateNow: Boolean);
    property ListLock: TALock read FLock;
    //#
    property DesktopBounds: TRect read GetDesktopBounds;
    property Bounds: TRect read GetBounds;
    property DC: Cardinal read FDC;
  end;




//##############################################################################
//##                                 MOUSE                                    ##
//##############################################################################




  TAMouse = class(TObject)
  protected
    FVisible: Boolean;
(*============================================================================*)
    function GetPosition: TPoint;
    procedure SetPosition(APos: TPoint);
    function GetButton: Integer;
    procedure SetVisible(AVisible: Boolean);
    //#
    function GetClipRect: TRect;
    procedure SetClipRect(AClipRect: TRect);
    //#
    function GetMousePresent: Boolean;
    function GetWheelPresent: Boolean;
    function GetSwapButton: Boolean;
    function GetButtonCount: Integer;
(*============================================================================*)
  public
    //#
    //#
    constructor Create;
    //#
    //#
    function MessagePosition: TPoint;
    property Position: TPoint read GetPosition write SetPosition;
    property Button: Integer read GetButton;
    property Visible: Boolean read FVisible write SetVisible;
    //#
    property ClipRect: TRect read GetClipRect write SetClipRect;
    //#
    property MousePresent: Boolean read GetMousePresent;
    property WheelPresent: Boolean read GetWheelPresent;
    property SwapButton: Boolean read GetSwapButton;
    property ButtonCount: Integer read GetButtonCount;
  end;




//##############################################################################
//##                                 KEYBOARD                                 ##
//##############################################################################




  TAKeyboard = class(TObject)
  protected
    function GetCapsLock: Boolean;
    function GetNumLock: Boolean;
    function GetScrollLock: Boolean;
    //#
    function GetLights: Byte;
    procedure SetLights(ALights: Byte);
(*============================================================================*)
  public
    //#
    //#
    destructor Destroy; override;
    //#
    //#
    function KeyDown(Key: Integer): Boolean;
    function ShiftState: Integer;
    //#
    property CapsLock: Boolean read GetCapsLock;
    property NumLock: Boolean read GetNumLock;
    property ScrollLock: Boolean read GetScrollLock;
    //#
    // the readlights function returns the lights as they should be.
    property Lights: Byte read GetLights write SetLights;
    // use this function to set the lights according to the locks.
    procedure LightsDefault;
  end;




//##############################################################################
//##                                  DRIVES                                  ##
//##############################################################################




  TADrives = class(TObject)
  protected
    FDriveCount,
    FFloppyCount,
    FFixedCount,
    FCdromCount: Integer;
    //#
    FDrives,
    FFloppyDrives,
    FFixedDrives,
    FCdromDrives: String;
(*============================================================================*)
    function GetName(Drive: Char): String;
    procedure SetName(Drive: Char; const AName: String);
(*============================================================================*)
  public
    //#
    //#
    procedure Update;
    //#
    //#
    property Drives: String read FDrives;
    property FloppyDrives: String read FFloppyDrives;
    property FixedDrives: String read FFixedDrives;
    property CdromDrives: String read FCdRomDrives;
    //#
    property DriveCount: Integer read FDriveCount;
    property FloppyCount: Integer read FFloppyCount;
    property FixedCount: Integer read FFixedCount;
    property CdromCount: Integer read FCdRomCount;
    function DriveType(ADrive: Char): Integer;
    function ClusterInfo(Drive: Char): TClusterInfo;
    //#
    property Name[Drive: Char]: String read GetName write SetName;
    function Id(Drive: Char): String;
    function Size(Drive: Char): Int64;
    function FreeSpace(Drive: Char): Int64;
    function System(Drive: Char): String;
  end;




//##############################################################################
//##                                 CD-ROM                                   ##
//##############################################################################




  TACdrom = class(TObject)
  protected
    FHandle: Integer;
    FWindowProcInstance: Pointer;
    //#
    FDeviceId: Integer;
    //#
    FDrives: String;
    FDriveCount: Integer;
    FMCIEnabled: Boolean;
(*============================================================================*)
    FOnTrayClose,
    FOnTrayOpen: TTrayEvent;
(*============================================================================*)
    procedure SetOnTrayClose(AOnTrayClose: TTrayEvent);
    procedure SetOnTrayOpen(AOnTrayOpen: TTrayEvent);
(*============================================================================*)
    function WindowProc(AHandle: Cardinal; Msg, WParam, LParam: Integer): Integer; stdcall;
    //#
    function CreateHandle: Boolean;
    function DestroyHandle: Boolean;
    // create a global device to monitor the close and
    // open of trays on all cd-roms.
    procedure EnableMCI;
    procedure DisableMCI;
(*============================================================================*)
  public
    //#
    //#
    constructor Create;
    destructor Destroy; override;
    //#
    //#
    procedure Update;
    //#
    //#
    property Drives: String read FDrives;
    property DriveCount: Integer read FDriveCount;
    //#
    function Id(Drive: Char): String;
    function Name(Drive: Char): String;
    function Size(Drive: Char): Int64;
    //#
    function IsAudioCD(Drive: Char): Boolean;
    //#
    // these events are triggered only when a cd is removed or put into
    // the cd-rom drive so a drive becomes avaible or unavaible.
    procedure TrayOpen(Drive: Char);
    procedure TrayClose(Drive: Char);
(*============================================================================*)
    property OnTrayClose: TTrayEvent read FOnTrayClose write SetOnTrayClose;
    property OnTrayOpen: TTrayEvent read FOnTrayOpen write SetOnTrayOpen;
  end;




//##############################################################################
//##                                  BROWSER                                 ##
//##############################################################################




  TABrowser = class(TObject)
  protected
    FFileList: TAStringList;
    FFileCount: Integer;
    FDirList: TAStringList;
    FDirCount: Integer;
    //#
    FLock: TALock;
(*============================================================================*)
    function GetFile(AIndex: Integer): String;
    function GetDir(AIndex: Integer): String;
(*============================================================================*)
  public
    //#
    //#
    constructor Create;
    destructor Destroy; override;
    //#
    //#
    procedure Update(const ADir, AWildcard: String; AExcludeAttr: Integer = 0);
    //#
    //#
    property Files[AIndex: Integer]: String read GetFile;
    property FileCount: Integer read FFileCount;
    property Dirs[AIndex: Integer]: String read GetDir;
    property DirCount: Integer read FDirCount;
    property ListLock: TALock read FLock;
  end;




//##############################################################################
//##                                  NETWORK                                 ##
//##############################################################################




  TANetwork = class
  protected
    FWorkgroupList: TAList;
    FWorkgroupCount: Integer;
    FDriveList: TAList;
    FDriveCount: Integer;
    FShareList: TAList;
    FShareCount: Integer;
    //#
    FLock: TALock;
(*============================================================================*)
    function GetWorkgroup(AIndex: Integer): TWorkgroupRec;
    function GetDrive(AIndex: Integer): TDriveRec;
    function GetShare(AIndex: Integer): TShareRec;
(*============================================================================*)
  public
    //#
    //#
    constructor Create;
    destructor Destroy; override;
    //#
    //#
    procedure UpdateWorkgroups;
    procedure UpdateDrives;
    procedure UpdateShares(const AUserName: String);
    //#
    //#
    function UserName: String;
    function ComputerName: String;
    function AddDrive(const APath: String; ADrive: Char; const APassword: String = ''): Boolean;
    function RemoveDrive(ADrive: Char; Force: Boolean = False): Boolean;
    //#
    property Workgroups[AIndex: Integer]: TWorkgroupRec read GetWorkgroup;
    property WorkgroupCount: Integer read FWorkgroupCount;
    //#
    property Drives[AIndex: Integer]: TDriveRec read GetDrive;
    property DriveCount: Integer read FDriveCount;
    //#
    property Shares[AIndex: Integer]: TShareRec read GetShare;
    property ShareCount: Integer read FShareCount;
    property ListLock: TALock read FLock;
  end;




//##############################################################################
//##                                CLIPBOARD                                 ##
//##############################################################################




  TAClipboard = class(TObject)
  public
    procedure SetText(AText: String);
    function GetText: String;
  end;




//##############################################################################
//##                              init and final                              ##
//##############################################################################

procedure Init;
procedure Final;




                        //##############
                        //###  VAR   ###
                        //##############
                        Var
                        //######################################################
                        //##################### GLOBAL USED ####################

    Screen: TAScreen;
    Mouse: TAMouse;
    Keyboard: TAKeyboard;

    Drives: TADrives;
    Cdrom: TACdrom;
    Browser: TABrowser;
    Network: TANetwork;

    Clipboard: TAClipboard;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                              IMPLEMENTATION                              ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
Implementation

        		//##############
        		//##   USES   ##
        		//##############
        		Uses
                        //######################################################
                        //######################### OWN ########################
                                                  UCore;




                        //##############
                        //### CONST  ###
                        //##############
                        Const
                        //######################################################
                        //############### BASE CLASS FOR CD-ROM ################

  CDROMWindowClass: TWndClass = (
            Style: 0;
            lpfnWndProc: @DefWindowProc;
            cbClsExtra: 0;
            cbWndExtra: 0;
            hInstance: 0;
            hIcon: 0;
            hCursor: 0;
            hbrBackground: 0;
            lpszMenuName: nil;
            lpszClassName: 'classACDROM');




//##############################################################################
//##                                  SCREEN                                  ##
//##############################################################################


{ TAScreen }




constructor TAScreen.Create;
begin
{$IFDEF SCREEN_THREADSAFE}
 FLock:= TALock.Create('Screen list lock');
{$ENDIF}



        FDC:= HWindows.GetDC(0);

        FRectList:= TARectList.Create;
end;


destructor TAScreen.Destroy;
begin
        FreeNil(FRectList);

        HWindows.ReleaseDC(0, FDC);



{$IFDEF SCREEN_THREADSAFE}
 FreeNil(FLock);
{$ENDIF}

inherited;
end;


function TAScreen.GetDesktopBounds: TRect;
begin
        HWindows.SystemParametersInfo(SPI_GETWORKAREA, 0, @Result, 0);
end;


function TAScreen.GetBounds: TRect;
begin
        Result:= NewRect(0, 0,
                         HWindows.GetSystemMetrics(SM_CXSCREEN),
                         HWindows.GetSystemMetrics(SM_CYSCREEN)
                         );
end;


function TAScreen.ChangeSettings(AWidth, AHeight, ABpp, ARefresh: Integer): Boolean;
var ADevMode: TDeviceMode;
begin
        ADevMode.dmSize:= SizeOf(TDeviceMode);
        ADevMode.dmPelsWidth:= AWidth;
        ADevMode.dmPelsHeight:= AHeight;
        ADevMode.dmBitsPerPel:= ABpp;
        ADevMode.dmDisplayFrequency:= ARefresh;
        ADevMode.dmFields:= DM_PELSWIDTH or DM_PELSHEIGHT or DM_BITSPERPEL or DM_DISPLAYFREQUENCY;

        Result:= HWindows.ChangeDisplaySettings(ADEVMODE, 0) = DISP_CHANGE_SUCCESSFUL;
end;


procedure TAScreen.Repaint(AUpdateNow: Boolean);
Var AHandle: Cardinal;
    ARect: TRect;
    UpdateNow, EraseNow: Integer;
begin
        case AUpdateNow of
          True:
          begin
                UpdateNow:= RDW_UPDATENOW;
                EraseNow:= RDW_ERASENOW;
          end;
          //
          else begin
                UpdateNow:= 0;
                EraseNow:= 0;
          end;
          //
        end;

        ARect:= GetBounds;
        AHandle:= HWindows.GetTopWindow(0);
        while (AHandle <> 0) do
        begin
                HWindows.RedrawWindow(AHandle, @ARect, 0,
                                      // invalidate and update before the function returns.
                                      RDW_INVALIDATE or UpdateNow or
                                      // erasebkg and update before the function returns.
                                      RDW_ERASE or EraseNow or
                                      RDW_FRAME or RDW_ALLCHILDREN
                                      );

                AHandle:= HWindows.GetWindow(AHandle, GW_HWNDNEXT);
        end;
end;


procedure TAScreen.Repaint(ARect: TRect; AUpdateNow: Boolean);
Var AHandle: Cardinal;
    AClientRect: TRect;
    UpdateNow, EraseNow: Integer;
begin
        case AUpdateNow of
          True:
          begin
                UpdateNow:= RDW_UPDATENOW;
                EraseNow:= RDW_ERASENOW;
          end;
          //
          else begin
                UpdateNow:= 0;
                EraseNow:= 0;
          end;
          //
        end;

        AHandle:= HWindows.GetTopWindow(0);
        while (AHandle <> 0) do
        begin
                AClientRect:= ARect;
                HWindows.ScreenToClient(AHandle, AClientRect.LeftTop);
                HWindows.ScreenToClient(AHandle, AClientRect.RightBottom);

                HWindows.RedrawWindow(AHandle, @AClientRect, 0,
                                      // invalidate and update before the function returns.
                                      RDW_INVALIDATE or UpdateNow or
                                      // erasebkg and update before the function returns.
                                      RDW_ERASE or EraseNow or
                                      RDW_FRAME or RDW_ALLCHILDREN
                                      );

                AHandle:= HWindows.GetWindow(AHandle, GW_HWNDNEXT);
        end;
end;


procedure TAScreen.FlushGdi;
begin
        HWindows.GdiFlush;
end;


procedure TAScreen.ListAdd(ARect: TRect; Mode: Integer);
begin
      {$IFDEF SCREEN_THREADSAFE}
       ThreadManager.SetExclusive(FLock);
      {$ENDIF}

        FRectList.Add(ARect, Mode);

      {$IFDEF SCREEN_THREADSAFE}
       ThreadManager.ClearExclusive(FLock);
      {$ENDIF}
end;


procedure TAScreen.ListClear;
begin
      {$IFDEF SCREEN_THREADSAFE}
       ThreadManager.SetExclusive(FLock);
      {$ENDIF}

        FRectList.Clear;

      {$IFDEF SCREEN_THREADSAFE}
       ThreadManager.ClearExclusive(FLock);
      {$ENDIF}
end;


procedure TAScreen.ListFlush(AUpdateNow: Boolean);
var i: Integer;
begin
      {$IFDEF SCREEN_THREADSAFE}
       ThreadManager.SetExclusive(FLock);
      {$ENDIF}

        for i:= 0 to FRectList.Count-1 do
                Repaint(FRectList.Items[i], AUpdateNow);

        FRectList.Clear;

      {$IFDEF SCREEN_THREADSAFE}
       ThreadManager.ClearExclusive(FLock);
      {$ENDIF}
end;




//##############################################################################
//##                                 MOUSE                                    ##
//##############################################################################


{ TAMouse }




constructor TAMouse.Create;
begin
        FVisible:= True;
end;


function TAMouse.GetPosition: TPoint;
begin
        HWindows.GetCursorPos(Result);
end;


procedure TAMouse.SetPosition(APos: TPoint);
begin
        HWindows.SetCursorPos(APos.X, APos.Y);
end;


function TAMouse.GetButton: Integer;
begin
        Result:= MB_NONE;

        if (HWindows.GetKeyState(VK_LBUTTON) < 0) then Result:= Result or MB_LEFT;
        if (HWindows.GetKeyState(VK_RBUTTON) < 0) then Result:= Result or MB_RIGHT;
        if (HWindows.GetKeyState(VK_MBUTTON) < 0) then Result:= Result or MB_MIDDLE;
end;


procedure TAMouse.SetVisible(AVisible: Boolean);
begin
        if (FVisible <> AVisible) then
        begin
                FVisible:= AVisible;


                HWindows.ShowCursor(FVisible);
        end;
end;


function TAMouse.GetClipRect: TRect;
begin
        HWindows.GetClipCursor(Result);
end;


procedure TAMouse.SetClipRect(AClipRect: TRect);
begin
        HWindows.ClipCursor(@AClipRect);
end;


function TAMouse.GetMousePresent: Boolean;
begin
        Result:= Boolean(HWindows.GetSystemMetrics(SM_MOUSEPRESENT));
end;


function TAMouse.GetWheelPresent: Boolean;
begin
        Result:= Boolean(HWindows.GetSystemMetrics(SM_MOUSEWHEELPRESENT));
end;


function TAMouse.GetSwapButton: Boolean;
begin
        Result:= Boolean(HWindows.GetSystemMetrics(SM_SWAPBUTTON));
end;


function TAMouse.GetButtonCount: Integer;
begin
        Result:= HWindows.GetSystemMetrics(SM_CMOUSEBUTTONS);
end;


function TAMouse.MessagePosition: TPoint;
var Pos: Integer;
begin
        Pos:= HWindows.GetMessagePos;

        Result.X:= LowInt(Pos);
        Result.Y:= HighInt(Pos);
end;




//##############################################################################
//##                                 KEYBOARD                                 ##
//##############################################################################


{ TAKeyboard }




destructor TAKeyboard.Destroy;
begin
        LightsDefault;



inherited;
end;


function TAKeyboard.GetCapsLock: Boolean;
begin
        Result:= (HWindows.GetKeyState(VK_CAPSLOCK) and 1) <> 0;
end;


function TAKeyboard.GetNumLock: Boolean;
begin
        Result:= (HWindows.GetKeyState(VK_NUMLOCK) and 1) <> 0;
end;


function TAKeyboard.GetScrollLock: Boolean;
begin
        Result:= (HWindows.GetKeyState(VK_SCROLLOCK) and 1) <> 0;
end;


function TAKeyboard.GetLights: Byte;
begin
        Result:= LIGHT_NONE;

        if CapsLock then Result:= Result or LIGHT_CAPS;
        if NumLock then Result:= Result or LIGHT_NUM;
        if ScrollLock then Result:= Result or LIGHT_SCROLL;
end;


procedure TAKeyboard.SetLights(ALights: Byte);
asm
        mov al, $ED
        out $60, al
        mov al, dl
        out $60, al
end;


function TAKeyboard.KeyDown(Key: Integer): Boolean;
begin
        Result:= HWindows.GetKeyState(Key) < 0;
end;


function TAKeyboard.ShiftState: Integer;
begin
        Result:= SS_NONE;

        if KeyDown(VK_SHIFT) then Result:= Result or SS_SHIFT;
        if KeyDown(VK_LSHIFT) then Result:= Result or SS_LSHIFT;
        if KeyDown(VK_RSHIFT) then Result:= Result or SS_RSHIFT;

        if KeyDown(VK_CONTROL) then Result:= Result or SS_CONTROL;
        if KeyDown(VK_LCONTROL) then Result:= Result or SS_LCONTROL;
        if KeyDown(VK_RCONTROL) then Result:= Result or SS_RCONTROL;

        if KeyDown(VK_ALT) then Result:= Result or SS_ALT;
        if KeyDown(VK_LALT) then Result:= Result or SS_LALT;
        if KeyDown(VK_RALT) then Result:= Result or SS_RALT;
end;


procedure TAKeyboard.LightsDefault;
var L: Byte;
begin
        // windows xp does not allow access to interrupts.
        if (WindowsFamily <> WINFAMILY_NT) then
        begin
                L:= 0;

                if CapsLock then L:= L or LIGHT_CAPS;
                if NumLock then L:= L or LIGHT_NUM;
                if ScrollLock then L:= L or LIGHT_SCROLL;

                SetLights(L);
        end;
end;




//##############################################################################
//##                                  DRIVES                                  ##
//##############################################################################


{ TADrives }




function TADrives.GetName(Drive: Char): String;
begin
        Result:= ARoutine.DriveGetName(Drive);
end;


procedure TADrives.SetName(Drive: Char; const AName: String);
begin
        ARoutine.DriveSetName(Drive, AName);
end;


procedure TADrives.Update;
var i: Integer;
begin
        FDriveCount:= ARoutine.DriveCount;
        FFloppyCount:= 0;
        FFixedCount:= 0;
        FCDROMCount:= 0;

        for i:= 0 to 25 do
        begin
                case ARoutine.DriveType(Char(i + Byte(FIRST_DRIVE))) of
                  DT_FLOPPY:
                  begin
                        Inc(FFloppyCount);
                        FDrives:= FDrives + Char(Byte(FIRST_DRIVE) + i);
                        FFloppyDrives:= FFloppyDrives + Char(Byte(FIRST_DRIVE) + i);
                  end;
                  //
                  DT_FIXED:
                  begin
                        Inc(FFixedCount);
                        FDrives:= FDrives + Char(Byte(FIRST_DRIVE) + i);
                        FFixedDrives:= FFixedDrives + Char(Byte(FIRST_DRIVE) + i);
                  end;
                  //
                  DT_CDROM:
                  begin
                        Inc(FCDROMCount);
                        FDrives:= FDrives + Char(Byte(FIRST_DRIVE) + i);
                        FCdRomDrives:= FCdRomDrives + Char(Byte(FIRST_DRIVE) + i);
                  end;
                  //
                end;
        end;
end;


function TADrives.DriveType(ADrive: Char): Integer;
begin
        Result:= ARoutine.DriveType(ADrive);
end;


function TADrives.ClusterInfo(Drive: Char): TClusterInfo;
begin
          HWindows.GetDiskFreeSpace(PChar(String(Drive + ':\')),
                                    Result.SectorsPerCluster, Result.BytesPerSector,
                                    Result.FreeClusters, Result.Clusters
                                    );
end;


function TADrives.Id(Drive: Char): String;
begin
        Result:= ARoutine.DriveId(Drive);
end;


function TADrives.Size(Drive: Char): Int64;
begin
        Result:= ARoutine.DriveSize(Drive);
end;


function TADrives.FreeSpace(Drive: Char): Int64;
begin
        Result:= ARoutine.DriveFree(Drive);
end;


function TADrives.System(Drive: Char): String;
begin
        Result:= ARoutine.DriveSystem(Drive);
end;




//##############################################################################
//##                                 CD-ROM                                   ##
//##############################################################################


{ TACdrom }




constructor TACdrom.Create;
begin
        FMCIEnabled:= False;



        CreateHandle;

        {$IFDEF CDROM_MCI_STARTUP}
         EnableMCI;
        {$ENDIF}
end;


destructor TACdrom.Destroy;
begin
        DisableMCI;

        DestroyHandle;



inherited;
end;


procedure TACdrom.SetOnTrayClose(AOnTrayClose: TTrayEvent);
begin
        FOnTrayClose:= AOnTrayClose;

        EnableMCI;
end;


procedure TACdrom.SetOnTrayOpen(AOnTrayOpen: TTrayEvent);
begin
        FOnTrayOpen:= AOnTrayOpen;

        EnableMCI;
end;


procedure TACdrom.Update;
begin
        ADevices.Drives.Update;

        FDrives:= ADevices.Drives.CDROMDrives;
        FDriveCount:= ADevices.Drives.CDROMCount;
end;


function TACdrom.Id(Drive: Char): String;
begin
        Result:= ARoutine.DriveId(Drive);
end;


function TACdrom.Name(Drive: Char): String;
begin
        Result:= ARoutine.DriveGetName(Drive);
end;


function TACdrom.Size(Drive: Char): Int64;
begin
        Result:= ARoutine.DriveSize(Drive);
end;


function TACdrom.IsAudioCD(Drive: Char): Boolean;
begin
        Result:= StringMatchIndexLeft('AUDIO CD', DriveGetName(Drive), False) <> 0;
end;


procedure TACdrom.TrayClose(Drive: Char);
var OpenParm: TMCI_OPEN_PARMS;
    Id: Integer;
begin
        OpenParm.dwCallback:= 0;
        OpenParm.lpstrDeviceType:= 'CDAudio';
        OpenParm.lpstrElementName:= PChar(String(Drive + ':'));

        HMultimedia.mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE or MCI_OPEN_ELEMENT or MCI_OPEN_SHAREABLE, Integer(@OpenParm));

        Id:= OpenParm.wDeviceID;
        HMultimedia.mciSendCommand(Id, MCI_SET, MCI_SET_DOOR_CLOSED, 0);

        HMultimedia.mciSendCommand(Id, MCI_CLOSE, MCI_OPEN_TYPE or MCI_OPEN_ELEMENT or MCI_OPEN_SHAREABLE, Integer(@OpenParm));
end;


procedure TACdrom.TrayOpen(Drive: Char);
var OpenParm: TMCI_OPEN_PARMS;
    Id: Integer;
begin
        OpenParm.dwCallback:= 0;
        OpenParm.lpstrDeviceType:= 'CDAudio';
        OpenParm.lpstrElementName:= PChar(String(Drive + ':\'));

        HMultimedia.mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE or MCI_OPEN_ELEMENT or MCI_OPEN_SHAREABLE, Integer(@OpenParm));

        Id:= OpenParm.wDeviceID;
        HMultimedia.mciSendCommand(Id, MCI_SET, MCI_SET_DOOR_OPEN, 0);

        HMultimedia.mciSendCommand(Id, MCI_CLOSE, MCI_OPEN_TYPE or MCI_OPEN_ELEMENT or MCI_OPEN_SHAREABLE, Integer(@OpenParm));
end;


function TACdrom.WindowProc(AHandle: Cardinal; Msg, WParam, LParam: Integer): Integer;
var PDEVH: PDEV_BROADCAST_HDR;
    PDEVV: PDEV_BROADCAST_VOLUME;
begin
        PDEVH:= PDEV_BROADCAST_HDR(LParam);

        if (Msg = WM_DEVICECHANGE) then
        begin
                case WParam of
                  DBT_DEVICEARRIVAL:
                  if PDEVH^.DBCH_DEVICETYPE = DBT_DEVTYP_VOLUME then
                  begin
                         PDEVV:= PDEV_BROADCAST_VOLUME(LParam);
                         if (PDEVV^.DBCV_FLAGS and DBTF_MEDIA = 1) then
                                (*==============*)
                                (**) if Assigned(FOnTrayClose) then FOnTrayClose(Self, DrivesBitmaskToString(PDEVV^.DBCV_UNITMASK));
                                (*==============*)
                  end;
                  //
                  DBT_DEVICEREMOVECOMPLETE:
                  begin
                         PDEVV:= PDEV_BROADCAST_VOLUME(LParam);
                         if (PDEVV^.DBCV_FLAGS and DBTF_MEDIA = 1) then
                                (*==============*)
                                (**) if Assigned(FOnTrayOpen) then FOnTrayOpen(Self, DrivesBitmaskToString(PDEVV^.DBCV_UNITMASK));
                                (*==============*)
                  end;
                  //
                end;
        end;


        // always pass the message to the default
        // window procedure (windows handled).
        Result:= HWindows.DefWindowProc(FHandle, Msg, WParam, LParam);
end;


function TACdrom.CreateHandle: Boolean;
begin
        if (FHandle = 0) then
        begin
                FWindowProcInstance:= MethodToProcedure(Self, @TACdrom.WindowProc);

                CDROMWindowClass.hInstance:= MainInstance;
                HWindows.RegisterClass(CDROMWindowClass);

                FHandle:= HWindows.CreateWindow(CDROMWindowClass.lpszClassName, nil,
                                                WS_POPUP,
                                                0, 0, 0, 0, 0, 0,
                                                HInstance, nil);

                (*++++++++++++++*)
                (**) if (FHandle = 0) then RaiseException('Cannot create handle for cd-rom device.', 'TACdrom.CreateHandle', Self, True);
                (*++++++++++++++*)

                // now we set the real WindowProc.
                HWindows.SetWindowLong(FHandle, GWL_WNDPROC, Integer(FWindowProcInstance));
                Result:= (FHandle <> 0);
        end
        else Result:= False;
end;


function TACdrom.DestroyHandle: Boolean;
begin
        if (FHandle <> 0) then
        begin
                // free the handle and unregister the class
                // flush queue and kill timers.
                HWindows.DestroyWindow(FHandle);
                FHandle:= 0;

                FreeMem(FWindowProcInstance);
                Result:= True;
        end
        else Result:= False;
end;


procedure TACdrom.EnableMCI;
var OpenParm: TMCI_OPEN_PARMS;
begin
        if (not FMCIEnabled) then
        begin
                OpenParm.dwCallback:= 0;
                OpenParm.lpstrDeviceType:= 'CDAudio';
                OpenParm.lpstrElementName:= nil;

                HMultimedia.mciSendCommand(0, MCI_OPEN, MCI_NOTIFY or MCI_OPEN_TYPE or MCI_OPEN_SHAREABLE, Integer(@OpenParm));

                FDeviceID:= OpenParm.wDeviceID;
                FMCIEnabled:= True;
        end;
end;


procedure TACdrom.DisableMCI;
begin
        if (FMCIEnabled) then
        begin
                HMultimedia.mciSendCommand(FDeviceId, MCI_CLOSE, MCI_OPEN_TYPE or MCI_OPEN_SHAREABLE, 0);

                FDeviceID:= 0;
                FMCIEnabled:= False;
        end;
end;




//##############################################################################
//##                                  BROWSER                                 ##
//##############################################################################


{ TABrowser }




constructor TABrowser.Create;
begin
{$IFDEF BROWSER_THREADSAFE}
 FLock:= TALock.Create('Browser list lock');
{$ENDIF}



        FFileCount:= 0;
        FDirCount:= 0;



        FFileList:= TAStringList.Create;
        FDirList:= TAStringList.Create;
end;


destructor TABrowser.Destroy;
begin
        FreeNil(FFileList);
        FreeNil(FDirList);



{$IFDEF BROWSER_THREADSAFE}
 FreeNil(FLock);
{$ENDIF}

inherited;
end;


function TABrowser.GetFile(AIndex: Integer): String;
begin
      {$IFDEF BROWSER_THREADSAFE}
       ThreadManager.SetExclusive(FLock);
      {$ENDIF}

        if (AIndex > -1)and(AIndex < FFileCount) then Result:= FFileList.Items[AIndex]
        else begin
                Result:= '';

                {$IFDEF BROWSER_THREADSAFE}
                 ThreadManager.ClearExclusive(FLock);
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Getfile index out of bounds.', 'TABrowser.GetFile', Self);
                (*++++++++++++++*)
        end;

      {$IFDEF BROWSER_THREADSAFE}
       ThreadManager.ClearExclusive(FLock);
      {$ENDIF}
end;


function TABrowser.GetDir(AIndex: Integer): String;
begin
      {$IFDEF BROWSER_THREADSAFE}
       ThreadManager.SetExclusive(FLock);
      {$ENDIF}

        if (AIndex > -1)and(AIndex < FDirCount) then Result:= FDirList.Items[AIndex]
        else begin
                Result:= '';

                {$IFDEF BROWSER_THREADSAFE}
                 ThreadManager.ClearExclusive(FLock);
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Getdir index out of bounds.', 'TABrowser.GetDir', Self);
                (*++++++++++++++*)
        end;

      {$IFDEF BROWSER_THREADSAFE}
       ThreadManager.ClearExclusive(FLock);
      {$ENDIF}
end;


procedure TABrowser.Update(const ADir, AWildcard: String; AExcludeAttr: Integer = 0);
var F: TSearchRec;
    Result: Boolean;
begin
      {$IFDEF BROWSER_THREADSAFE}
       ThreadManager.SetExclusive(FLock);
      {$ENDIF}

        FFileList.Clear;
        FFileCount:= 0;
        FDirList.Clear;
        FDirCount:= 0;

        Result:= FindFirst(PathAddSlash(ADir) + AWildcard, AExcludeAttr, F);

        if (Result) then
        begin
                if (F.Attr and FA_DIRECTORY <> 0) then
                begin
                        Inc(FDirCount);
                        FDirList.Add(F.Name);
                end
                else begin
                        Inc(FFileCount);
                        FFileList.Add(F.Name);
                end;

                while FindNext(F) do
                begin
                        if (F.Attr and FA_DIRECTORY <> 0) then
                        begin
                                Inc(FDirCount);
                                FDirList.Add(F.Name);
                        end
                        else begin
                                Inc(FFileCount);
                                FFileList.Add(F.Name);
                        end;
                end;

                FindClose(F);
        end;

      {$IFDEF BROWSER_THREADSAFE}
       ThreadManager.ClearExclusive(FLock);
      {$ENDIF}
end;




//##############################################################################
//##                                  NETWORK                                 ##
//##############################################################################


{ TANetwork }




constructor TANetwork.Create;
begin
{$IFDEF NETWORK_THREADSAFE}
 FLock:= TALock.Create('Network list lock');
{$ENDIF}



        FWorkgroupList:= TAList.Create;
        FWorkgroupCount:= 0;

        FDriveList:= TAList.Create;
        FDriveCount:= 0;

        FShareList:= TAList.Create;
        FShareCount:= 0;
end;


destructor TANetwork.Destroy;
var AGroup: PWorkgroupRec;
    ADrive: PDriveRec;
    AShare: PShareRec;
begin
        // delete all share info.
        while (FShareCount > 0) do
        begin
                AShare:= FShareList.Items[0];
                FreeMem(AShare);
                FShareList.Delete(0);
                Dec(FShareCount);
        end;

        FreeNil(FShareList);

        // delete all drive info.
        while (FDriveCount > 0) do
        begin
                ADrive:= FDriveList.Items[0];
                FreeMem(ADrive);
                FDriveList.Delete(0);
                Dec(FDriveCount);
        end;

        FreeNil(FDriveList);

        // delete all user info.
        while (FWorkgroupCount > 0) do
        begin
                AGroup:= FWorkgroupList.Items[0];
                FreeNil(AGroup.Users);
                FreeMem(AGroup);
                FWorkgroupList.Delete(0);
                Dec(FWorkgroupCount);
        end;

        FreeNil(FWorkgroupList);



{$IFDEF NETWORK_THREADSAFE}
 FreeNil(FLock);
{$ENDIF}

inherited;
end;


function TANetwork.GetWorkgroup(AIndex: Integer): TWorkgroupRec;
begin
      {$IFDEF NETWORK_THREADSAFE}
       ThreadManager.SetExclusive(FLock);
      {$ENDIF}

        if (AIndex > -1)and(AIndex < FWorkgroupCount) then Result:= PWorkgroupRec(FWorkgroupList.Items[AIndex])^
        else begin
                {$IFDEF NETWORK_THREADSAFE}
                 ThreadManager.ClearExclusive(FLock);
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Getworkgroup index out of bounds.', 'TANetwork.GetWorkgroup', Self);
                (*++++++++++++++*)
        end;

      {$IFDEF NETWORK_THREADSAFE}
       ThreadManager.ClearExclusive(FLock);
      {$ENDIF}
end;


function TANetwork.GetDrive(AIndex: Integer): TDriveRec;
begin
      {$IFDEF NETWORK_THREADSAFE}
       ThreadManager.SetExclusive(FLock);
      {$ENDIF}

        if (AIndex > -1)and(AIndex < FDriveCount) then Result:= PDriveRec(FDriveList.Items[AIndex])^
        else begin
                {$IFDEF NETWORK_THREADSAFE}
                 ThreadManager.ClearExclusive(FLock);
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Getdrive index out of bounds.', 'TANetwork.GetDrive', Self);
                (*++++++++++++++*)
        end;

      {$IFDEF NETWORK_THREADSAFE}
       ThreadManager.ClearExclusive(FLock);
      {$ENDIF}
end;


function TANetwork.GetShare(AIndex: Integer): TShareRec;
begin
      {$IFDEF NETWORK_THREADSAFE}
       ThreadManager.SetExclusive(FLock);
      {$ENDIF}

        if (AIndex > -1)and(AIndex < FShareCount) then Result:= PShareRec(FShareList.Items[AIndex])^
        else begin
                {$IFDEF NETWORK_THREADSAFE}
                 ThreadManager.ClearExclusive(FLock);
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Getshare index out of bounds.', 'TANetwork.GetShare', Self);
                (*++++++++++++++*)
        end;

      {$IFDEF NETWORK_THREADSAFE}
       ThreadManager.ClearExclusive(FLock);
      {$ENDIF}
end;


function TANetwork.UserName: String;
begin
        Result:= ARoutine.NetworkUserName;
end;


function TANetwork.ComputerName: String;
begin
        Result:= ARoutine.NetworkComputerName;
end;


function TANetwork.AddDrive(const APath: String; ADrive: Char; const APassword: String = ''): Boolean;
begin
        Result:= NetworkAddDrive(APath, ADrive, APassword);

        UpdateDrives;
end;


function TANetwork.RemoveDrive(ADrive: Char; Force: Boolean = False): Boolean;
begin
        Result:= NetworkRemoveDrive(ADrive, Force);

        UpdateDrives;
end;


procedure TANetwork.UpdateWorkgroups;
var AGroup: PWorkgroupRec;
    AHandle: Cardinal;
    Root: PNetResource;
    Workgroups, Users: Pointer;
    Size, Count: Cardinal;
    WorkgroupsSize, WorkgroupsCount: Cardinal;
    UsersSize, UsersCount: Cardinal;
    W, U: PNetResource;
    i, j: Integer;
begin
      {$IFDEF NETWORK_THREADSAFE}
       ThreadManager.SetExclusive(FLock);
      {$ENDIF}

        // empty the list.
        while (FWorkgroupCount > 0) do
        begin
                AGroup:= FWorkgroupList.Items[0];
                Finalize(AGroup^.Name);
                FreeNil(AGroup.Users);
                FreeMem(AGroup);
                FWorkgroupList.Delete(0);
                Dec(FWorkgroupCount);
        end;


        // get root
        WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, RESOURCEUSAGE_CONTAINER, nil, AHandle);
        Count:= 1;
        Size:= $4000;
        GetMem(Root, Size);
        WNetEnumResource(AHandle, Count, Root, Size);
        WNetCloseEnum(AHandle);


        // get workgroups
        WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, 0, Root, AHandle);
        WorkgroupsCount:= Cardinal(-1);
        WorkgroupsSize:= $4000;
        GetMem(Workgroups, WorkgroupsSize);
        WNetEnumResource(AHandle, WorkgroupsCount, Workgroups, WorkgroupsSize);
        WNetCloseEnum(AHandle);


        W:= Workgroups;
        for i:= 0 to WorkgroupsCount-1 do
        begin
                GetMem(AGroup, SizeOf(TWorkgroupRec));
                AGroup.Users:= TAStringList.Create;
                AGroup.UserCount:= 0;
                AGroup.Name:= W^.lpRemoteName;
                FWorkgroupList.Add(AGroup);
                Inc(FWorkgroupCount);

                // get users
                WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, 0, W, AHandle);
                UsersCount:= Cardinal(-1);
                UsersSize:= $4000;
                GetMem(Users, UsersSize);
                WNetEnumResource(AHandle, UsersCount, Users, UsersSize);
                WNetCloseEnum(AHandle);

                U:= Users;
                for j:= 0 to UsersCount-1 do
                begin
                        AGroup.Users.Add(Copy(U^.lpRemoteName, 3, MaxInt));
                        Inc(AGroup.UserCount);

                        Inc(Integer(U), SizeOf(U^));
                end;
                FreeMem(Users);

                Inc(Integer(W), SizeOf(W^));
        end;

        FreeMem(Workgroups);
        FreeMem(Root);

      {$IFDEF NETWORK_THREADSAFE}
       ThreadManager.ClearExclusive(FLock);
      {$ENDIF}
end;


procedure TANetwork.UpdateDrives;
var ADrive: PDriveRec;
    AHandle: Cardinal;
    Drives: Pointer;
    Size, Count: Cardinal;
    D: PNetResource;
    i: Integer;
begin
      {$IFDEF NETWORK_THREADSAFE}
       ThreadManager.SetExclusive(FLock);
      {$ENDIF}

        // empty the list.
        while (FDriveCount > 0) do
        begin
                ADrive:= FDriveList.Items[0];
                Finalize(ADrive^.Path);
                FreeMem(ADrive);
                FDriveList.Delete(0);
                Dec(FDriveCount);
        end;

        // get drives
        WNetOpenEnum(RESOURCE_CONNECTED, RESOURCETYPE_DISK, 0, nil, AHandle);
        Count:= 1;
        Size:= $4000;
        GetMem(Drives, Size);
        WNetEnumResource(AHandle, Count, Drives, Size);
        WNetCloseEnum(AHandle);

        D:= Drives;
        for i:= 0 to Count-1 do
        begin
                GetMem(ADrive, SizeOf(TDriveRec));
                ADrive^.Drive:= D^.lpLocalName[1];
                ADrive^.Path:= D^.lpRemoteName;
                FDriveList.Add(ADrive);
                Inc(FDriveCount);

                Inc(Integer(D), SizeOf(D^));
        end;

        FreeMem(Drives);

      {$IFDEF NETWORK_THREADSAFE}
       ThreadManager.ClearExclusive(FLock);
      {$ENDIF}
end;


procedure TANetwork.UpdateShares(const AUserName: String);
var AShare: PShareRec;
    AHandle: Cardinal;
    Root: PNetResource;
    Workgroups, Users, Shares: Pointer;
    Size, Count: Cardinal;
    WorkgroupsSize, WorkgroupsCount: Cardinal;
    UsersSize, UsersCount: Cardinal;
    SharesSize, SharesCount: Cardinal;
    W, U, S: PNetResource;
    i, j, k: Integer;
begin
      {$IFDEF NETWORK_THREADSAFE}
       ThreadManager.SetExclusive(FLock);
      {$ENDIF}

        // empty the list.
        while (FShareCount > 0) do
        begin
                AShare:= FShareList.Items[0];
                Finalize(AShare^.Path);
                FreeMem(AShare);
                FShareList.Delete(0);
                Dec(FShareCount);
        end;


        // get root
        WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, RESOURCEUSAGE_CONTAINER, nil, AHandle);
        Count:= 1;
        Size:= $4000;
        GetMem(Root, Size);
        WNetEnumResource(AHandle, Count, Root, Size);
        WNetCloseEnum(AHandle);


        // get workgroups
        WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, 0, Root, AHandle);
        WorkgroupsCount:= Cardinal(-1);
        WorkgroupsSize:= $4000;
        GetMem(Workgroups, WorkgroupsSize);
        WNetEnumResource(AHandle, WorkgroupsCount, Workgroups, WorkgroupsSize);
        WNetCloseEnum(AHandle);


        W:= Workgroups;
        for i:= 0 to WorkgroupsCount-1 do
        begin
                // get users
                WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, 0, W, AHandle);
                UsersCount:= Cardinal(-1);
                UsersSize:= $4000;
                GetMem(Users, UsersSize);
                WNetEnumResource(AHandle, UsersCount, Users, UsersSize);
                WNetCloseEnum(AHandle);

                U:= Users;
                for j:= 0 to UsersCount-1 do
                begin
                        if StringEqual(Copy(U^.lpRemoteName, 3, MaxInt), AUserName, False) then
                        begin
                                // get users
                                WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, 0, U, AHandle);
                                SharesCount:= Cardinal(-1);
                                SharesSize:= $4000;
                                GetMem(Shares, SharesSize);
                                WNetEnumResource(AHandle, SharesCount, Shares, SharesSize);
                                WNetCloseEnum(AHandle);

                                S:= Shares;
                                for k:= 0 to SharesCount-1 do
                                begin
                                        GetMem(AShare, SizeOf(TShareRec));
                                        AShare.Path:= Copy(S^.lpRemoteName, 3 + Pos('\', Copy(S^.lpRemoteName, 3, MAX_INT)), MAX_INT);
                                        AShare.ResType:= S^.dwType;
                                        FShareList.Add(AShare);
                                        Inc(FShareCount);

                                        Inc(Integer(S), SizeOf(S^));
                                end;

                                FreeMem(Users);
                                FreeMem(Workgroups);
                                FreeMem(Root);

                                {$IFDEF NETWORK_THREADSAFE}
                                 ThreadManager.ClearExclusive(FLock);
                                {$ENDIF}

                                Exit;
                        end;


                        Inc(Integer(U), SizeOf(U^));
                end;
                FreeMem(Users);

                Inc(Integer(W), SizeOf(W^));
        end;

        FreeMem(Workgroups);
        FreeMem(Root);

      {$IFDEF NETWORK_THREADSAFE}
       ThreadManager.ClearExclusive(FLock);
      {$ENDIF}
end;




(*var ARead, ATotal, AHandle: Cardinal;
    ASharePtr: LPBYTE;
    AShare: PChar;
    Buff1: array[0..max_Path-1] of char;
    Buff2: array[0..max_Path-1] of char;
    e: DWORD;}
begin

      {$IFDEF NETWORK_THREADSAFE}
       ThreadManager.SetExclusive(FLock);
      {$ENDIF}

        ARead:= 0;
        ATotal:= 0;
        AHandle:= 0;
        ASharePtr:= nil;
        e:= SNetwork.NetFileEnum(nil, nil, nil, 2, ASharePtr, $40000, @ARead, @ATotal, @AHandle);
        if e = 0 then
        begin
                AShare:= Pointer(ASharePtr^);
        end
        else
        begin
                WNetGetLastError(e, Buff1, SizeOf(Buff1), Buff2, SizeOf(buff2));
                RaiseException(Buff1, buff2, nil);
        end;



      {$IFDEF NETWORK_THREADSAFE}
       ThreadManager.ClearExclusive(FLock);
      {$ENDIF}
end;        *)




//##############################################################################
//##                                CLIPBOARD                                 ##
//##############################################################################


{ TAClipboard }




procedure TAClipboard.SetText(AText: String);
var P, D: PChar;
    TextHandle: Cardinal;
begin
        if HWindows.OpenClipboard(0) then
        begin
                P:= PChar(AText + #0);
                TextHandle:= HWindows.GlobalAlloc(GMEM_MOVEABLE or GMEM_DDESHARE, PCharLen(P) + 1);

                D:= HWindows.GlobalLock(TextHandle);
                HeapCopyByte(D, P, PCharLen(P) + 1);
                HWindows.GlobalUnlock(TextHandle);

                HWindows.SetClipboardData(CF_TEXT, TextHandle);
                HWindows.CloseClipboard;
        end;
end;


function TAClipboard.GetText: String;
var P: PChar;
    TextHandle: Cardinal;
begin
        if HWindows.OpenClipboard(0) then
        begin
                TextHandle:= HWindows.GetClipboardData(CF_TEXT);

                P:= HWindows.GlobalLock(TextHandle);
                Result:= P;
                HWindows.GlobalUnlock(TextHandle);


                HWindows.CloseClipboard;
        end;
end;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//#######################                                 ######################
//#######################                                 ######################
//##                              INITIALIZATION                              ##
//#######################                                 ######################
//#######################                                 ######################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
procedure Init;
begin
        try
          Screen:= TAScreen.Create;
          Mouse:= TAMouse.Create;
          Keyboard:= TAKeyboard.Create;

          Drives:= TADrives.Create;
          // cdrom uses some drives functions to perform it's
          // operations so we create it last.
          Cdrom:= TACdrom.Create;
          Browser:= TABrowser.Create;
          Network:= TANetwork.Create;

          Clipboard:= TAClipboard.Create;
        except
          (*++++++++++++++*)
          (**) HandleException('ADevices initialization');
          (*++++++++++++++*)
        end;
end;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//#######################                                 ######################
//#######################                                 ######################
//##                                FINALIZATION                              ##
//#######################                                 ######################
//#######################                                 ######################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
procedure Final;
begin
        try
          FreeNil(Clipboard);

          FreeNil(Network);
          FreeNil(Browser);
          FreeNil(Cdrom);
          FreeNil(Drives);

          FreeNil(Keyboard);
          FreeNil(Mouse);
          FreeNil(Screen);
        except
          (*++++++++++++++*)
          (**) ARoutine.HandleException('ADevices finalization');
          (*++++++++++++++*)
        end;
end;

//##############################################################################
//##############################################################################

End.