{$ALIGN ON}
{$MINENUMSIZE 4}

// v4.0
//########################################################
//#######               NETWORK                     ######
//########################################################
Unit HNetwork;



		//###############
		//## INTERFACE ##
		//###############
		Interface

		//##############
		//##   USES   ##
		//##############
		Uses
		  //## SYSTEM ##
		  HWindows;



//###################################################################
//###################################################################
//###################################################################
//###################################################################
//###################################################################
//####################                          #####################
//####################                          #####################
//##                          INTERFACE                            ##
//####################                          #####################
//####################                          #####################
//###################################################################
//###################################################################
//###################################################################
//###################################################################
//###################################################################


//#############
//### CONST ###
//#############
Const

  { Network types }

  WNNC_NET_MSNET              = $00010000;
  WNNC_NET_LANMAN             = $00020000;
  WNNC_NET_NETWARE            = $00030000;
  WNNC_NET_VINES              = $00040000;
  WNNC_NET_10NET              = $00050000;
  WNNC_NET_LOCUS              = $00060000;
  WNNC_NET_SUN_PC_NFS         = $00070000;
  WNNC_NET_LANSTEP            = $00080000;
  WNNC_NET_9TILES             = $00090000;
  WNNC_NET_LANTASTIC          = $000A0000;
  WNNC_NET_AS400              = $000B0000;
  WNNC_NET_FTP_NFS            = $000C0000;
  WNNC_NET_PATHWORKS          = $000D0000;
  WNNC_NET_LIFENET            = $000E0000;
  WNNC_NET_POWERLAN           = $000F0000;
  WNNC_NET_BWNFS              = $00100000;
  WNNC_NET_COGENT             = $00110000;
  WNNC_NET_FARALLON           = $00120000;
  WNNC_NET_APPLETALK          = $00130000;
  WNNC_NET_INTERGRAPH         = $00140000;
  WNNC_NET_SYMFONET           = $00150000;
  WNNC_NET_CLEARCASE          = $00160000;

{ Network Resources. }

  RESOURCE_CONNECTED    = 1;
  RESOURCE_GLOBALNET    = 2;
  RESOURCE_REMEMBERED   = 3;
  RESOURCE_RECENT       = 4;
  RESOURCE_CONTEXT      = 5;

  RESOURCETYPE_ANY      = 0;
  RESOURCETYPE_DISK     = 1;
  RESOURCETYPE_PRINT    = 2;
  RESOURCETYPE_RESERVED = 8;
  RESOURCETYPE_UNKNOWN  = DWORD($FFFFFFFF);

  RESOURCEUSAGE_CONNECTABLE     = 1;
  RESOURCEUSAGE_CONTAINER       = 2;
  RESOURCEUSAGE_NOLOCALDEVICE   = 4;
  RESOURCEUSAGE_SIBLING         = 8;

  RESOURCEUSAGE_ATTACHED        = $00000010;
  RESOURCEUSAGE_ALL             = (RESOURCEUSAGE_CONNECTABLE or RESOURCEUSAGE_CONTAINER or RESOURCEUSAGE_ATTACHED);
  RESOURCEUSAGE_RESERVED        = DWORD($80000000);

  RESOURCEDISPLAYTYPE_GENERIC            = $00000000;
  RESOURCEDISPLAYTYPE_DOMAIN             = $00000001;
  RESOURCEDISPLAYTYPE_SERVER             = $00000002;
  RESOURCEDISPLAYTYPE_SHARE              = $00000003;
  RESOURCEDISPLAYTYPE_FILE               = $00000004;
  RESOURCEDISPLAYTYPE_GROUP              = $00000005;
  RESOURCEDISPLAYTYPE_NETWORK            = $00000006;
  RESOURCEDISPLAYTYPE_ROOT               = $00000007;
  RESOURCEDISPLAYTYPE_SHAREADMIN         = $00000008;
  RESOURCEDISPLAYTYPE_DIRECTORY          = $00000009;
  RESOURCEDISPLAYTYPE_TREE               = $0000000A;
  RESOURCEDISPLAYTYPE_NDSCONTAINER       = $0000000B;

//#############
//### TYPES ###
//#############
Type

  NETRESOURCEA = packed record
    dwScope: DWORD;
    dwType: DWORD;
    dwDisplayType: DWORD;
    dwUsage: DWORD;
    lpLocalName: PAnsiChar;
    lpRemoteName: PAnsiChar;
    lpComment: PAnsiChar;
    lpProvider: PAnsiChar;
  end;

  NETRESOURCEW = packed record
    dwScope: DWORD;
    dwType: DWORD;
    dwDisplayType: DWORD;
    dwUsage: DWORD;
    lpLocalName: PWideChar;
    lpRemoteName: PWideChar;
    lpComment: PWideChar;
    lpProvider: PWideChar;
  end;

  PNetResourceA = ^TNetResourceA;
  PNetResourceW = ^TNetResourceW;
  PNetResource = PNetResourceA;
  TNetResourceA = NETRESOURCEA;
  TNetResourceW = NETRESOURCEW;
  TNetResource = TNetResourceA;

//#############
//### CONST ###
//#############
Const

  { Network Connections. }

  NETPROPERTY_PERSISTENT = 1;

  CONNECT_UPDATE_PROFILE          = $00000001;
  CONNECT_UPDATE_RECENT           = $00000002;
  CONNECT_TEMPORARY               = $00000004;
  CONNECT_INTERACTIVE             = $00000008;
  CONNECT_PROMPT                  = $00000010;
  CONNECT_NEED_DRIVE              = $00000020;
  CONNECT_REFCOUNT                = $00000040;
  CONNECT_REDIRECT                = $00000080;
  CONNECT_LOCALDRIVE              = $00000100;
  CONNECT_CURRENT_MEDIA           = $00000200;
  CONNECT_DEFERRED                = $00000400;
  CONNECT_RESERVED                = DWORD($FF000000);

function WNetAddConnection(lpRemoteName, lpPassword, lpLocalName: PChar): DWORD; stdcall;
function WNetAddConnectionA(lpRemoteName, lpPassword, lpLocalName: PAnsiChar): DWORD; stdcall;
function WNetAddConnectionW(lpRemoteName, lpPassword, lpLocalName: PWideChar): DWORD; stdcall;
function WNetAddConnection2(var lpNetResource: TNetResource; lpPassword, lpUserName: PChar; dwFlags: DWORD): DWORD; stdcall;
function WNetAddConnection2A(var lpNetResource: TNetResourceA; lpPassword, lpUserName: PAnsiChar; dwFlags: DWORD): DWORD; stdcall;
function WNetAddConnection2W(var lpNetResource: TNetResourceW; lpPassword, lpUserName: PWideChar; dwFlags: DWORD): DWORD; stdcall;
function WNetAddConnection3(hwndOwner: HWND; var lpNetResource: TNetResource; lpPassword, lpUserName: PChar; dwFlags: DWORD): DWORD; stdcall;
function WNetAddConnection3A(hwndOwner: HWND; var lpNetResource: TNetResourceA; lpPassword, lpUserName: PAnsiChar; dwFlags: DWORD): DWORD; stdcall;
function WNetAddConnection3W(hwndOwner: HWND; var lpNetResource: TNetResourceW; lpPassword, lpUserName: PWideChar; dwFlags: DWORD): DWORD; stdcall;
function WNetCancelConnection(lpName: PChar; fForce: BOOL): DWORD; stdcall;
function WNetCancelConnectionA(lpName: PAnsiChar; fForce: BOOL): DWORD; stdcall;
function WNetCancelConnectionW(lpName: PWideChar; fForce: BOOL): DWORD; stdcall;
function WNetCancelConnection2(lpName: PChar; dwFlags: DWORD; fForce: BOOL): DWORD; stdcall;
function WNetCancelConnection2A(lpName: PAnsiChar; dwFlags: DWORD; fForce: BOOL): DWORD; stdcall;
function WNetCancelConnection2W(lpName: PWideChar; dwFlags: DWORD; fForce: BOOL): DWORD; stdcall;
function WNetGetConnection(lpLocalName: PChar; lpRemoteName: PChar; var lpnLength: DWORD): DWORD; stdcall;
function WNetGetConnectionA(lpLocalName: PAnsiChar; lpRemoteName: PAnsiChar; var lpnLength: DWORD): DWORD; stdcall;
function WNetGetConnectionW(lpLocalName: PWideChar; lpRemoteName: PWideChar; var lpnLength: DWORD): DWORD; stdcall;
function WNetUseConnection(hwndOwner: HWND; var lpNetResource: TNetResource; lpUserID: PChar; lpPassword: PChar; dwFlags: DWORD; lpAccessName: PChar; var lpBufferSize: DWORD; var lpResult: DWORD): DWORD; stdcall;
function WNetUseConnectionA(hwndOwner: HWND; var lpNetResource: TNetResourceA; lpUserID: PAnsiChar; lpPassword: PAnsiChar; dwFlags: DWORD; lpAccessName: PAnsiChar; var lpBufferSize: DWORD; var lpResult: DWORD): DWORD; stdcall;
function WNetUseConnectionW(hwndOwner: HWND; var lpNetResource: TNetResourceW; lpUserID: PWideChar; lpPassword: PWideChar; dwFlags: DWORD; lpAccessName: PWideChar; var lpBufferSize: DWORD; var lpResult: DWORD): DWORD; stdcall;
function WNetSetConnection(lpName: PChar; dwProperties: DWORD; pvValues: Pointer): DWORD; stdcall;
function WNetSetConnectionA(lpName: PAnsiChar; dwProperties: DWORD; pvValues: Pointer): DWORD; stdcall;
function WNetSetConnectionW(lpName: PWideChar; dwProperties: DWORD; pvValues: Pointer): DWORD; stdcall;

{ Network Connection Dialogs. }

function WNetConnectionDialog(hwnd: HWND; dwType: DWORD): DWORD; stdcall;
function WNetDisconnectDialog(hwnd: HWND; dwType: DWORD): DWORD; stdcall;

//#############
//### TYPES ###
//#############
Type
  CONNECTDLGSTRUCTA = packed record
    cbStructure: DWORD;          { size of this structure in bytes }
    hwndOwner: HWND;             { owner window for the dialog }
    lpConnRes: PNetResource;     { Requested Resource info    }
    dwFlags: DWORD;              { flags (see below) }
    dwDevNum: DWORD;             { number of devices connected to }
  end;
  PConnectDlgStruct = ^TConnectDlgStruct;
  TConnectDlgStruct = CONNECTDLGSTRUCTA;

//#############
//### CONST ###
//#############
Const

  CONNDLG_RO_PATH       = 1;    { Resource path should be read-only     }
  CONNDLG_CONN_POINT    = 2;    { Netware -style movable connection point enabled  }
  CONNDLG_USE_MRU       = 4;    { Use MRU combobox   }
  CONNDLG_HIDE_BOX      = 8;    { Hide persistent connect checkbox   }

  { NOTE:  Set at most ONE of the below flags.  If neither flag is set,
           then the persistence is set to whatever the user chose during
           a previous connection }

  CONNDLG_PERSIST       = $10;       { Force persistent connection  }
  CONNDLG_NOT_PERSIST   = $20;       { Force connection NOT persistent  }

function WNetConnectionDialog1(var lpConnDlgStruct: TConnectDlgStruct): DWORD; stdcall;
function WNetConnectionDialog1A(var lpConnDlgStruct: TConnectDlgStruct): DWORD; stdcall;
function WNetConnectionDialog1W(var lpConnDlgStruct: TConnectDlgStruct): DWORD; stdcall;

//#############
//### TYPES ###
//#############
Type

  DISCDLGSTRUCTA = packed record
    cbStructure: DWORD;       { size of this structure in bytes }
    hwndOwner: HWND;          { owner window for the dialog }
    lpLocalName: PAnsiChar;       { local device name }
    lpRemoteName: PAnsiChar;      { network resource name }
    dwFlags: DWORD;
  end;

  DISCDLGSTRUCTW = packed record
    cbStructure: DWORD;       { size of this structure in bytes }
    hwndOwner: HWND;          { owner window for the dialog }
    lpLocalName: PWideChar;       { local device name }
    lpRemoteName: PWideChar;      { network resource name }
    dwFlags: DWORD;
  end;

  PDiscDlgStructA = ^TDiscDlgStructA;
  PDiscDlgStructW = ^TDiscDlgStructW;
  PDiscDlgStruct = PDiscDlgStructA;
  TDiscDlgStructA = DISCDLGSTRUCTA;
  TDiscDlgStructW = DISCDLGSTRUCTW;
  TDiscDlgStruct = TDiscDlgStructA;

//#############
//### CONST ###
//#############
Const

  DISC_UPDATE_PROFILE   = 1;
  DISC_NO_FORCE         = $40;

function WNetDisconnectDialog1(var lpConnDlgStruct: TDiscDlgStruct): DWORD; stdcall;
function WNetDisconnectDialog1A(var lpConnDlgStruct: TDiscDlgStructA): DWORD; stdcall;
function WNetDisconnectDialog1W(var lpConnDlgStruct: TDiscDlgStructW): DWORD; stdcall;

{ Network Browsing. }

function WNetOpenEnum(dwScope, dwType, dwUsage: DWORD; lpNetResource: PNetResource; var lphEnum: THandle): DWORD; stdcall;
function WNetOpenEnumA(dwScope, dwType, dwUsage: DWORD; lpNetResource: PNetResourceA; var lphEnum: THandle): DWORD; stdcall;
function WNetOpenEnumW(dwScope, dwType, dwUsage: DWORD; lpNetResource: PNetResourceW; var lphEnum: THandle): DWORD; stdcall;
function WNetEnumResource(hEnum: THandle; var lpcCount: DWORD; lpBuffer: Pointer; var lpBufferSize: DWORD): DWORD; stdcall;
function WNetEnumResourceA(hEnum: THandle; var lpcCount: DWORD; lpBuffer: Pointer; var lpBufferSize: DWORD): DWORD; stdcall;
function WNetEnumResourceW(hEnum: THandle; var lpcCount: DWORD; lpBuffer: Pointer; var lpBufferSize: DWORD): DWORD; stdcall;
function WNetCloseEnum(hEnum: THandle): DWORD; stdcall;
function WNetGetResourceParent(lpNetResource: PNetResource; lpBuffer: Pointer; var cbBuffer: DWORD): DWORD; stdcall;
function WNetGetResourceParentA(lpNetResource: PNetResourceA; lpBuffer: Pointer; var cbBuffer: DWORD): DWORD; stdcall;
function WNetGetResourceParentW(lpNetResource: PNetResourceW; lpBuffer: Pointer; var cbBuffer: DWORD): DWORD; stdcall;

//#############
//### CONST ###
//#############
Const
{ Universal Naming. }

  UNIVERSAL_NAME_INFO_LEVEL     = 1;
  REMOTE_NAME_INFO_LEVEL        = 2;

//#############
//### TYPES ###
//#############
Type

  UNIVERSAL_NAME_INFOA = packed record
    lpUniversalName: PAnsiChar;
  end;

  UNIVERSAL_NAME_INFOW = packed record
    lpUniversalName: PWideChar;
  end;

  PUniversalNameInfoA = ^TUniversalNameInfoA;
  PUniversalNameInfoW = ^TUniversalNameInfoW;
  PUniversalNameInfo = PUniversalNameInfoA;
  TUniversalNameInfoA = UNIVERSAL_NAME_INFOA;
  TUniversalNameInfoW = UNIVERSAL_NAME_INFOW;
  TUniversalNameInfo = TUniversalNameInfoA;

  REMOTE_NAME_INFOA = packed record
    lpUniversalName: PAnsiChar;
    lpConnectionName: PAnsiChar;
    lpRemainingPath: PAnsiChar;
  end;

  REMOTE_NAME_INFOW = packed record
    lpUniversalName: PWideChar;
    lpConnectionName: PWideChar;
    lpRemainingPath: PWideChar;
  end;

  PRemoteNameInfoA = ^TRemoteNameInfoA;
  PRemoteNameInfoW = ^TRemoteNameInfoW;
  PRemoteNameInfo = PRemoteNameInfoA;
  TRemoteNameInfoA = REMOTE_NAME_INFOA;
  TRemoteNameInfoW = REMOTE_NAME_INFOW;
  TRemoteNameInfo = TRemoteNameInfoA;

function WNetGetUniversalName(lpLocalPath: PChar; dwInfoLevel: DWORD; lpBuffer: Pointer; var lpBufferSize: DWORD): DWORD; stdcall;
function WNetGetUniversalNameA(lpLocalPath: PAnsiChar; dwInfoLevel: DWORD; lpBuffer: Pointer; var lpBufferSize: DWORD): DWORD; stdcall;
function WNetGetUniversalNameW(lpLocalPath: PWideChar; dwInfoLevel: DWORD; lpBuffer: Pointer; var lpBufferSize: DWORD): DWORD; stdcall;

{ Authentication and Logon/Logoff }

function WNetGetUser(lpName: PChar; lpUserName: PChar; var lpnLength: DWORD): DWORD; stdcall;
function WNetGetUserA(lpName: PAnsiChar; lpUserName: PAnsiChar; var lpnLength: DWORD): DWORD; stdcall;
function WNetGetUserW(lpName: PWideChar; lpUserName: PWideChar; var lpnLength: DWORD): DWORD; stdcall;

//#############
//### CONST ###
//#############
Const

  WNFMT_MULTILINE       = 1;
  WNFMT_ABBREVIATED     = 2;
  WNFMT_INENUM          = $10;
  WNFMT_CONNECTION      = $20;

function WNetGetProviderName(dwNetType: DWORD; lpProviderName: PChar; var lpBufferSize: DWORD): DWORD; stdcall;
function WNetGetProviderNameA(dwNetType: DWORD; lpProviderName: PAnsiChar; var lpBufferSize: DWORD): DWORD; stdcall;
function WNetGetProviderNameW(dwNetType: DWORD; lpProviderName: PWideChar; var lpBufferSize: DWORD): DWORD; stdcall;

//#############
//### TYPES ###
//#############
Type

  NETINFOSTRUCT = record
    cbStructure: DWORD;
    dwProviderVersion: DWORD;
    dwStatus: DWORD;
    dwCharacteristics: DWORD;
    dwHandle: DWORD;
    wNetType: Word;
    dwPrinters: DWORD;
    dwDrives: DWORD;
  end;
  PNetInfoStruct = ^TNetInfoStruct;
  TNetInfoStruct = NETINFOSTRUCT;

//#############
//### CONST ###
//#############
Const

  NETINFO_DLL16         = 1;      { Provider running as 16 bit Winnet Driver  }
  NETINFO_DISKRED       = 4;      { Provider requires disk redirections to connect  }
  NETINFO_PRINTERRED    = 8;      { Provider requires printer redirections to connect  }

function WNetGetNetworkInformation(lpProvider: PChar; var lpNetInfoStruct: TNetInfoStruct): DWORD; stdcall;
function WNetGetNetworkInformationA(lpProvider: PAnsiChar; var lpNetInfoStruct: TNetInfoStruct): DWORD; stdcall;
function WNetGetNetworkInformationW(lpProvider: PWideChar; var lpNetInfoStruct: TNetInfoStruct): DWORD; stdcall;

//#############
//### TYPES ###
//#############
Type

  { User Profiles }

  TFNGetProfilePath = TFarProc;
  TFNReconcileProfile = TFarProc;

//#############
//### CONST ###
//#############
Const

  RP_LOGON   = 1;  { if set, do for logon, else for logoff }
  RP_INIFILE = 2;  { if set, reconcile .INI file, else reg. hive }

//#############
//### TYPES ###
//#############
Type

  { Policies }

  TFNProcessPolicies = TFarProc;

//#############
//### CONST ###
//#############
Const

  PP_DISPLAYERRORS = 1;  { if set, display error messages, else fail silently if error }

{ Error handling }

function WNetGetLastError(var lpError: DWORD; lpErrorBuf: PChar; nErrorBufSize: DWORD; lpNameBuf: PChar; nNameBufSize: DWORD): DWORD; stdcall;
function WNetGetLastErrorA(var lpError: DWORD; lpErrorBuf: PAnsiChar; nErrorBufSize: DWORD; lpNameBuf: PAnsiChar; nNameBufSize: DWORD): DWORD; stdcall;
function WNetGetLastErrorW(var lpError: DWORD; lpErrorBuf: PWideChar; nErrorBufSize: DWORD; lpNameBuf: PWideChar; nNameBufSize: DWORD): DWORD; stdcall;

//#############
//### CONST ###
//#############
Const

{ STATUS CODES }

  { General }

  WN_SUCCESS            = NO_ERROR;
  WN_NO_ERROR           = NO_ERROR;
  WN_NOT_SUPPORTED      = ERROR_NOT_SUPPORTED;
  WN_CANCEL             = ERROR_CANCELLED;
  WN_RETRY              = ERROR_RETRY;
  WN_NET_ERROR          = ERROR_UNEXP_NET_ERR;
  WN_MORE_DATA          = ERROR_MORE_DATA;
  WN_BAD_POINTER        = ERROR_INVALID_ADDRESS;
  WN_BAD_VALUE          = ERROR_INVALID_PARAMETER;
  WN_BAD_USER           = ERROR_BAD_USERNAME;
  WN_BAD_PASSWORD       = ERROR_INVALID_PASSWORD;
  WN_ACCESS_DENIED      = ERROR_ACCESS_DENIED;
  WN_FUNCTION_BUSY      = ERROR_BUSY;
  WN_WINDOWS_ERROR      = ERROR_UNEXP_NET_ERR;
  WN_OUT_OF_MEMORY      = ERROR_NOT_ENOUGH_MEMORY;
  WN_NO_NETWORK         = ERROR_NO_NETWORK;
  WN_EXTENDED_ERROR     = ERROR_EXTENDED_ERROR;
  WN_BAD_LEVEL          = ERROR_INVALID_LEVEL;
  WN_BAD_HANDLE         = ERROR_INVALID_HANDLE;
  WN_NOT_INITIALIZING   = ERROR_ALREADY_INITIALIZED;
  WN_NO_MORE_DEVICES    = ERROR_NO_MORE_DEVICES;

{ Connection }

  WN_NOT_CONNECTED       = ERROR_NOT_CONNECTED;
  WN_OPEN_FILES          = ERROR_OPEN_FILES;
  WN_DEVICE_IN_USE       = ERROR_DEVICE_IN_USE;
  WN_BAD_NETNAME         = ERROR_BAD_NET_NAME;
  WN_BAD_LOCALNAME       = ERROR_BAD_DEVICE;
  WN_ALREADY_CONNECTED   = ERROR_ALREADY_ASSIGNED;
  WN_DEVICE_ERROR        = ERROR_GEN_FAILURE;
  WN_CONNECTION_CLOSED   = ERROR_CONNECTION_UNAVAIL;
  WN_NO_NET_OR_BAD_PATH  = ERROR_NO_NET_OR_BAD_PATH;
  WN_BAD_PROVIDER        = ERROR_BAD_PROVIDER;
  WN_CANNOT_OPEN_PROFILE = ERROR_CANNOT_OPEN_PROFILE;
  WN_BAD_PROFILE         = ERROR_BAD_PROFILE;
  WN_BAD_DEV_TYPE        = ERROR_BAD_DEV_TYPE;
  WN_DEVICE_ALREADY_REMEMBERED = ERROR_DEVICE_ALREADY_REMEMBERED;

{ Enumeration }

  WN_NO_MORE_ENTRIES = ERROR_NO_MORE_ITEMS;
  WN_NOT_CONTAINER   = ERROR_NOT_CONTAINER;

{ Authentication }

  WN_NOT_AUTHENTICATED = ERROR_NOT_AUTHENTICATED;
  WN_NOT_LOGGED_ON     = ERROR_NOT_LOGGED_ON;
  WN_NOT_VALIDATED     = ERROR_NO_LOGON_SERVERS;

//#############
//### TYPES ###
//#############
Type

  { For Shell }

  NETCONNECTINFOSTRUCT = packed record
    cbStructure: DWORD;
    dwFlags: DWORD;
    dwSpeed: DWORD;
    dwDelay: DWORD;
    dwOptDataSize: DWORD;
  end;
  PNetConnectInfoStruct = ^TNetConnectInfoStruct;
  TNetConnectInfoStruct = NETCONNECTINFOSTRUCT;

//#############
//### CONST ###
//#############
Const

  WNCON_FORNETCARD = 1;
  WNCON_NOTROUTED  = 2;
  WNCON_SLOWLINK   = 4;
  WNCON_DYNAMIC    = 8;

function MultinetGetConnectionPerformance(lpNetResource: PNetResource; lpNetConnectInfoStruc: PNetConnectInfoStruct): DWORD; stdcall;
function MultinetGetConnectionPerformanceA(lpNetResource: PNetResourceA; lpNetConnectInfoStruc: PNetConnectInfoStruct): DWORD; stdcall;
function MultinetGetConnectionPerformanceW(lpNetResource: PNetResourceW; lpNetConnectInfoStruc: PNetConnectInfoStruct): DWORD; stdcall;

//#############
//### CONST ###
//#############
Const

  mpr       = 'mpr.dll';



//###################################################################
//###################################################################
//###################################################################
//###################################################################
//###################################################################
//####################                          #####################
//####################                          #####################
//##                        IMPLEMENTATION                         ##
//####################                          #####################
//####################                          #####################
//###################################################################
//###################################################################
//###################################################################
//###################################################################
//###################################################################
Implementation



{ Externals from mpr.dll }

function MultinetGetConnectionPerformance; external mpr name 'MultinetGetConnectionPerformanceA';
function MultinetGetConnectionPerformanceA; external mpr name 'MultinetGetConnectionPerformanceA';
function MultinetGetConnectionPerformanceW; external mpr name 'MultinetGetConnectionPerformanceW';
function WNetAddConnection2; external mpr name 'WNetAddConnection2A';
function WNetAddConnection2A; external mpr name 'WNetAddConnection2A';
function WNetAddConnection2W; external mpr name 'WNetAddConnection2W';
function WNetAddConnection3; external mpr name 'WNetAddConnection3A';
function WNetAddConnection3A; external mpr name 'WNetAddConnection3A';
function WNetAddConnection3W; external mpr name 'WNetAddConnection3W';
function WNetAddConnection; external mpr name 'WNetAddConnectionA';
function WNetAddConnectionA; external mpr name 'WNetAddConnectionA';
function WNetAddConnectionW; external mpr name 'WNetAddConnectionW';
function WNetCancelConnection2; external mpr name 'WNetCancelConnection2A';
function WNetCancelConnection2A; external mpr name 'WNetCancelConnection2A';
function WNetCancelConnection2W; external mpr name 'WNetCancelConnection2W';
function WNetCancelConnection; external mpr name 'WNetCancelConnectionA';
function WNetCancelConnectionA; external mpr name 'WNetCancelConnectionA';
function WNetCancelConnectionW; external mpr name 'WNetCancelConnectionW';
function WNetCloseEnum; external mpr name 'WNetCloseEnum';
function WNetConnectionDialog1; external mpr name 'WNetConnectionDialog1A';
function WNetConnectionDialog1A; external mpr name 'WNetConnectionDialog1A';
function WNetConnectionDialog1W; external mpr name 'WNetConnectionDialog1W';
function WNetConnectionDialog; external mpr name 'WNetConnectionDialog';
function WNetDisconnectDialog1; external mpr name 'WNetDisconnectDialog1A';
function WNetDisconnectDialog1A; external mpr name 'WNetDisconnectDialog1A';
function WNetDisconnectDialog1W; external mpr name 'WNetDisconnectDialog1W';
function WNetDisconnectDialog; external mpr name 'WNetDisconnectDialog';
function WNetEnumResource; external mpr name 'WNetEnumResourceA';
function WNetEnumResourceA; external mpr name 'WNetEnumResourceA';
function WNetEnumResourceW; external mpr name 'WNetEnumResourceW';
function WNetGetConnection; external mpr name 'WNetGetConnectionA';
function WNetGetConnectionA; external mpr name 'WNetGetConnectionA';
function WNetGetConnectionW; external mpr name 'WNetGetConnectionW';
function WNetGetLastError; external mpr name 'WNetGetLastErrorA';
function WNetGetLastErrorA; external mpr name 'WNetGetLastErrorA';
function WNetGetLastErrorW; external mpr name 'WNetGetLastErrorW';
function WNetGetNetworkInformation; external mpr name 'WNetGetNetworkInformationA';
function WNetGetNetworkInformationA; external mpr name 'WNetGetNetworkInformationA';
function WNetGetNetworkInformationW; external mpr name 'WNetGetNetworkInformationW';
function WNetGetProviderName; external mpr name 'WNetGetProviderNameA';
function WNetGetProviderNameA; external mpr name 'WNetGetProviderNameA';
function WNetGetProviderNameW; external mpr name 'WNetGetProviderNameW';
function WNetGetResourceParent; external mpr name 'WNetGetResourceParentA';
function WNetGetResourceParentA; external mpr name 'WNetGetResourceParentA';
function WNetGetResourceParentW; external mpr name 'WNetGetResourceParentW';
function WNetGetUniversalName; external mpr name 'WNetGetUniversalNameA';
function WNetGetUniversalNameA; external mpr name 'WNetGetUniversalNameA';
function WNetGetUniversalNameW; external mpr name 'WNetGetUniversalNameW';
function WNetGetUser; external mpr name 'WNetGetUserA';
function WNetGetUserA; external mpr name 'WNetGetUserA';
function WNetGetUserW; external mpr name 'WNetGetUserW';
function WNetOpenEnum; external mpr name 'WNetOpenEnumA';
function WNetOpenEnumA; external mpr name 'WNetOpenEnumA';
function WNetOpenEnumW; external mpr name 'WNetOpenEnumW';
function WNetSetConnection; external mpr name 'WNetSetConnectionA';
function WNetSetConnectionA; external mpr name 'WNetSetConnectionA';
function WNetSetConnectionW; external mpr name 'WNetSetConnectionW';
function WNetUseConnection; external mpr name 'WNetUseConnectionA';
function WNetUseConnectionA; external mpr name 'WNetUseConnectionA';
function WNetUseConnectionW; external mpr name 'WNetUseConnectionW';


End.
