(*++++++++++++++*)
        // AN EXCEPTION IS RAISED


        

// v3.0
//##############################################################################
//#######                           FOOT                                  ######
//##############################################################################

        // in loc de mov ax, [esi+eax] shi operatzie reg, ah -> direct operatzie reg, [esi+eax+1]

        // Contrast + Brightness + Saturation + Hue will be implemented as RenderFX or AddFX
        // Rotate will be implemented as RenderFX or AddFX
        // Stretch will be implemented as RenderFX or AddFX


//##############################################################################
//#######                           FOOT                                  ######
//##############################################################################
Unit Foot;




        		//###############
        		//## INTERFACE ##
        		//###############
        		Interface

        		//##############
        		//##   USES   ##
        		//##############
        		Uses
                        //######################################################
        		//######################## SYSTEM ######################
                                		  {System,}
                                		  HWindows,

                        //######################################################
                        //######################### OWN ########################
                                                  AHeap,
                                                  ARoutine;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                                INTERFACE                                 ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################




                        //##############
                        //### CONST  ###
                        //##############
                        Const
                        //######################################################
                        //####################### TILE IDS #####################

  TID_LEFT_TOP            = 0;
  TID_RIGHT_TOP           = 1;
  TID_LEFT_BOTTOM         = 2;
  TID_RIGHT_BOTTOM        = 3;
  TID_LEFT                = 4;
  TID_RIGHT               = 5;
  TID_TOP                 = 6;
  TID_BOTTOM              = 7;
  TID_CENTER              = 8;

                        //######################################################
                        //############### OFFSETS FOR GETFOOTDATA ##############
  FO_WIDTH      = 0;
  FO_HEIGHT     = 1;
  FO_SIZE       = 2;
  FO_BYTESIZE   = 3;
  FO_BYTEWIDTH  = 4;
  FO_BUFFER     = 5;
  FO_FILENAME   = 6;
  FO_USAGE      = 7;

                        //######################################################
                        //############# OFFSETS FOR GETTILEFOOTDATA ############

  TFO_WIDTHS     = 0;
  TFO_HEIGHTS    = 8;
  TFO_SIZES      = 16;
  TFO_BYTESIZES  = 24;
  TFO_BYTEWIDTHS = 32;
  TFO_BUFFERS    = 40;
  TFO_FILENAME   = 48;
  TFO_USAGE      = 49;

                        //######################################################
                        //########### RENDERMODE, FIELDS, EXTENTIONS ###########

  RM_STORED             = 0;            //00000000;
  //#
  RM_COPY               = 1;            //00000001;
  //#
  RM_GLOBALALPHA        = 9;            //00001001;
  //#
  RM_TRANSPARENCE       = 3;            //00000011;
  RM_LOCALALPHA         = 7;            //00000111;
  RM_GLOBALALPHA_TRANSPARENCE  = 11;    //00001011;
  RM_GLOBALALPHA_LOCALALPHA    = 15;    //00001111;
  RM_ALL                       = 15;    //00001111;        // reserved
  //#
  // specify on what fields of the ARGB structure should
  // the renderer apply transformations to.
  RMF_NOCOLOR                   = 16;   //00010000;
  RMF_NOALPHA                   = 32;   //00100000;
  RMF_NONE                      = 48;   //00110000;
  RMF_ALL                       = 48;   //00110000;        // reserved
  //#
  // when rendering to a backbuffer or a foot with an undefined alpha use this
  // flag to consider the destination buffer's local alpha A_OPAQUE.
  RMX_FLAT                      = 64;   //01000000;
  RMX_TILE                      = 128;  //10000000;
  RMX_ALL                       = 192;  //11000000;        // reserved

                        //######################################################
                        //###################### FOOT TYPE #####################
  FT_FOOT     = 0;
  FT_TILEFOOT = 1;

                        //######################################################
                        //##################### ALPHA VALUES ###################
  A_OPAQUE = 255;
  A_CLEAR  = 0;

                        //######################################################
                        //################## ALPHA MASK CONSTANTS ##############

  AM_BLUE    = 0;
  AM_GREEN   = 1;
  AM_RED     = 2;
  AM_AVERAGE = 3;

                        //######################################################
                        //##################### MASK CONSTANTS #################

  M_ALPHACOLOR = $FFFFFFFF;
  M_COLOR      = $00FFFFFF;
  M_ALPHA      = $FF000000;
  M_RED        = $00FF0000;
  M_GREEN      = $0000FF00;
  M_BLUE       = $000000FF;

                        //######################################################
                        //################# MANIPULATE OPERATIONS ##############

  MOP_FILL      = 0;
  MOP_ADD       = 1;
  MOP_SUBSTRACT = 2;


//##############################################################################
//##                                 FX types                                 ##
//##############################################################################

  FX_TILE       = 1;



                        //##############
                        //### TYPES  ###
                        //##############
                        Type
                        //######################################################
                        //####### COLOR IN ARGB (READS BGRA IN MEMORY) #########

  TAlphaColor= LongWord;
  PAlphaColor= ^TAlphaColor;

                        //######################################################
                        //###################### FILE HEADERS ##################


  // FILE HEADERS ARE A FRAGMENT OF THEIR RESPECTIVE DATA TYPE SO WE CAN
  // READ ALL THE FILE TO A DATA STRUCTURE IN ONE STEP.

  TFootHeader = record
    Width, Height, Size, ByteSize, ByteWidth: Integer;
    //
    Buffer: Pointer;
  end;


  TTileFootHeader = record
    Width, Height, Size, ByteSize, ByteWidth: array[0..8] of Integer;
    LocalAlpha: Boolean;
    //
    Buffer: array[0..8] of Pointer;
  end;

                        //######################################################
                        //#################### RENDERER PARAMS #################

  TRectParams = record
    DestCROffset: Integer;
    Width, Height: Integer;
    DestStartPtr: Pointer;
  end;


  TDualRectParams = record
    SrcCROffset, DestCROffset: Integer;
    Width, Height: Integer;
    SrcStartPtr, DestStartPtr: Pointer;
  end;

  PRectParams = ^TRectParams;
  PDualRectParams = ^TDualRectParams;

                        //######################################################
                        //################## RENDERER PROCEDURE ################

  TRenderer = procedure (AParams: PDualRectParams; AGlobalAlpha: Byte);

                        //######################################################
                        //##################### CACHE ENTRIES ##################

  TFootData = record
    Width, Height, Size, ByteSize, ByteWidth: Integer;
    //
    Buffer: Pointer;
    //
    FileName: String;
    Usage: Integer;                
  end;


  TTileFootData = record
    Width, Height, Size, ByteSize, ByteWidth: array[0..8] of Integer;
    LocalAlpha: Boolean;
    //
    Buffer: array[0..8] of Pointer;
    //
    FileName: String;
    Usage: Integer;
  end;


  PFootData = ^TFootData;
  PTileFootData = ^TTileFootData;

                        //######################################################
                        //####################### CLASS TYPES ##################
  TFoot = class;
  TTileFoot = class;
  TFont = class;
  //#
  TFootManager = class;
  //#
  TFontManager = class;




//##############################################################################
//##                                 FX structs                               ##
//##############################################################################




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                            EXPLICIT INTERFACE                            ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################




//##############################################################################
//##                                   FOOT                                   ##
//##############################################################################




  // FOOT CAN BE CACHED, MEANING THAT WHEN THE SAME IMAGE IS LOADED IN SEVERAL
  // FOOT OBJECTS, A SINGLE BUFFER IS LOADED INTO MEMORY. ON A RENDER OPERATION
  // OR RESIZE THE FOOT WILL BE UNCACHED UNLESS SPECIFIED NOT TO DO SO, THUS
  // MODIFYING THE MULTI-USED USED BUFFER.

  TFoot = class(TObject)
  protected
    FFootData: PFootData;
    //#
    FBitmapInfo: TBitmapInfo;
    //#
    FRenderMode: Integer;
(*============================================================================*)
    function GetFootData(ADWordOffset: Integer): Integer;
    function GetFileName: String;
    function GetBuffer: Pointer;
    procedure SetBuffer(ABuffer: Pointer);
    //
    function GetEmpty: Boolean;
    procedure SetEmpty(AEmpty: Boolean);
    procedure SetWidth(AIndex: Integer; AWidth: Integer);
    procedure SetHeight(AIndex: Integer; AHeight: Integer);
    //#
    procedure SetPixel(x, y: Integer; AAlphaColor: TAlphaColor);
    function GetPixel(x, y: Integer): TAlphaColor;
    procedure SetPixelColor(x, y: Integer; AColor: LongWord);
    function GetPixelColor(x, y: Integer): LongWord;
    procedure SetPixelAlpha(x, y: Integer; AAlpha: Byte);
    function GetPixelAlpha(x, y: Integer): Byte;
    //#
    function GetCached: Boolean;
    procedure SetCached(ACached: Boolean);
(*============================================================================*)
    // this function restricts the globalalpha, chooses a renderer, but returns
    // false if no rendering is needed.
    function ProcessRenderer(var ARenderer: TRenderer; var AGlobalAlpha: Byte; var ARenderMode: Integer): Boolean;
    // this function draws the tiles using the optimized method.
    function ProcessTile(ARenderer: TRenderer; ADest: TFoot; ADestRect: TRect; ASrcRect: TRect; AGlobalAlpha: Byte; ARenderMode: Integer): Boolean;
    // this function restricts the srcrect, destrect to the bounds and fills the params with the
    // needed data for the renderer but it returns false if no rendering is needed.
    function ProcessParams(var AParams: TDualRectParams; ADest: TFoot; var ADestRect: TRect; var ASrcRect: TRect): Boolean; overload;
    function ProcessParams(var AParams: TRectParams; var ADestRect: TRect): Boolean; overload;
    function ProcessParams(ADest: HDC; var ADestPos: TPoint; var ASrcRect: TRect): Boolean; overload;
    //#
    //#
    class function LoadBitmap(const AFileName: String; AFoot: TFoot): Boolean;
    class function LoadFoot(const AFileName: String; AFoot: TFoot): Boolean;
    class procedure SaveBitmap(const AFileName: String; AFoot: TFoot);
    class procedure SaveFoot(const AFileName: String; AFoot: TFoot);
(*============================================================================*)
  public
    constructor Create; virtual;
    destructor Destroy; override;
    //#
    //#
    function Load(const AFileName: String): Boolean; overload; virtual;
    function Save(const AFileName: String): Boolean; virtual;
    function LoadMask(const AFileName: String; AMode: Integer; AllInstance: Boolean = False): Boolean;
    //#
    function Load(AFoot: TFoot; CloneBuffer: Boolean; AllInstance: Boolean = False): Boolean; overload;
    function Load(ATileFoot: TTileFoot; ATileIndex: Integer; CloneBuffer: Boolean; AllInstance: Boolean = False): Boolean; overload;
    function Load(ABuffer: Pointer; AWidth, AHeight: Integer; CloneBuffer: Boolean; AllInstance: Boolean = False): Boolean; overload;
    //#
    //#
    // if a value different than A_OPAQUE is given to globalalpha then the RM_GLOBALALPHA
    // flag is automatically included in the rendermode.
    procedure Render(ADest: TFoot; AGlobalAlpha: Byte = A_OPAQUE; ARenderMode: Integer = RM_STORED; AllInstance: Boolean = False); overload; stdcall;
    procedure Render(ADest: TFoot; ADestPos: TPoint; AGlobalAlpha: Byte = A_OPAQUE; ARenderMode: Integer = RM_STORED; AllInstance: Boolean = False); overload; stdcall;
    procedure Render(ADest: TFoot; ADestPos: TPoint; ASrcRect: TRect; AGlobalAlpha: Byte = A_OPAQUE; ARenderMode: Integer = RM_STORED; AllInstance: Boolean = False); overload; stdcall;
    procedure Render(ADest: TFoot; ADestRect: TRect; AGlobalAlpha: Byte = A_OPAQUE; ARenderMode: Integer = RM_STORED; AllInstance: Boolean = False); overload; stdcall;
    procedure Render(ADest: TFoot; ADestRect: TRect; ASrcRect: TRect; AGlobalAlpha: Byte = A_OPAQUE; ARenderMode: Integer = RM_STORED; AllInstance: Boolean = False); overload; stdcall;
    procedure Render(DC: HDC; FROP: Integer = SRCCOPY); overload;
    procedure Render(DC: HDC; ADestPos: TPoint; FROP: Integer = SRCCOPY); overload;
    procedure Render(DC: HDC; ADestPos: TPoint; ASrcRect: TRect; FROP: Integer = SRCCOPY); overload;
    //#
    property RenderMode: Integer read FRenderMode write FRenderMode;
    procedure Enable(AFlag: Integer);
    procedure Disable(AFlag: Integer);
    //#
    function PixelPointer(x, y: Integer): Pointer;
    property Pixel[x, y: Integer]: TAlphaColor read GetPixel write SetPixel;
    property PixelColor[x, y: Integer]: LongWord read GetPixelColor write SetPixelColor;
    property PixelAlpha[x, y: Integer]: Byte read GetPixelAlpha write SetPixelAlpha;
    //#
    property Size: Integer index FO_SIZE read GetFootData;
    property ByteSize: Integer index FO_BYTESIZE read GetFootData;
    property ByteWidth: Integer index FO_BYTEWIDTH read GetFootData;
    property Width: Integer index FO_WIDTH read GetFootData write SetWidth;
    property Height: Integer index FO_HEIGHT read GetFootData write SetHeight;
    property Empty: Boolean read GetEmpty write SetEmpty;
    procedure Resize(AWidth, AHeight: Integer; AllInstance: Boolean = False);
    //#
    // cached means that the same image was loaded several times
    // but only a copy of it resides in memory.
    property Cached: Boolean read GetCached write SetCached;
    property FileName: String read GetFileName;
    property Data: PFootData read FFootData;
    property Buffer: Pointer read GetBuffer write SetBuffer;
    //#
    procedure UpdateBitmapInfo;
    //#
    //#
    // fill a rectlist with all the rectangles that contain alpha >= than aalphamin.
    procedure ProcessOpacity(ARectList: TARectList; AAlphaMin: Byte); overload;
    procedure ProcessOpacity(ARectList: TARectList; ARect: TRect; AAlphaMin: Byte); overload;
    //#
    //#
    // specify an alpha value to set to all the pixels with the value specified in
    // searchvalue and searchmask.
    procedure ApplyAlpha(AValue: Byte; ADestRect: TRect; ASearchValue, ASearchMask: LongWord; AllInstance: Boolean = False);
    // set A_CLEAR alpha value to all the pixels with the value specified in
    // searchvalue and searchmask.
    procedure ApplyTransparence(ADestRect: TRect; ASearchValue, ASearchMask: LongWord; AllInstance: Boolean = False);
    // apply an FX procedure on the buffer of the foot. AFX specifies the type of FX
    // to apply. AParameter is a FX-type-specific structure passed to the selected FX proc.
    procedure ApplyFX(AFX: Integer; AParameter: Pointer; AllInstance: Boolean = False);
    //#
    //#
    // specify a mask of the value to (fill, add, substract) all pixels with.
    procedure Manipulate(AOperation: Integer; AValue, AMask: LongWord; AllInstance: Boolean = False); overload;
    // specify a mask of the value to (fill, add, substract) all pixels with, in a given rect.
    procedure Manipulate(AOperation: Integer; AValue, AMask: LongWord; ADestRect: TRect; AllInstance: Boolean = False); overload;
    // specify a mask of the value to (fill, add, substract) all pixels with the value specified in
    // searchvalue and searchmask.
    procedure Manipulate(AOperation: Integer; AValue, AValueMask: LongWord; ASearchValue, ASearchMask: LongWord; AllInstance: Boolean = False); overload;
    // specify a mask of the value to (fill, add, substract) all pixels with the value specified in
    // searchvalue and searchmask, in a given rect.
    procedure Manipulate(AOperation: Integer; AValue, AValueMask: LongWord; ADestRect: TRect; ASearchValue, ASearchMask: LongWord; AllInstance: Boolean = False); overload;
  end;




//##############################################################################
//##                                 TILEFOOT                                 ##
//##############################################################################




  // THE TILES ARE CACHED AS ONE. THE TILES ARE REPAINTED ON THE FOOTBUFFER
  // ON LOAD AND ON RESIZE. THE FOOTBUFFER WILL ALWAYS BE UNCACHED ON THE UPDATEBUFFER
  // ACTION, BUT AN IMAGE CAN BE LOADED INTO THE FOOTBUFFER.

  TTileFoot = class(TFoot)
  protected
    FTileFootData: PTileFootData;
    //#
    FLocalAlpha: Boolean;
(*============================================================================*)
    function GetTileFootData(ADWordOffset: Integer): Integer;
    function GetTileFileName: String;
    //#
    function GetTileEmpty: Boolean;
    procedure SetTileEmpty(AEmpty: Boolean);
    //#
    function GetTileCached: Boolean;
    procedure SetTileCached(ACached: Boolean);
    //#
    function GetTileSize(ATileIndex: Integer): Integer;
    function GetTileByteSize(ATileIndex: Integer): Integer;
    function GetTileByteWidth(ATileIndex: Integer): Integer;
    function GetTileWidth(ATileIndex: Integer): Integer;
    function GetTileHeight(ATileIndex: Integer): Integer;
    function GetTileBuffer(ATileIndex: Integer): Pointer;
    procedure SetTileBuffer(ATileIndex: Integer; ABuffer: Pointer);
    procedure SetTileWidth(ATileIndex: Integer; AWidth: Integer);
    procedure SetTileHeight(ATileIndex: Integer; AHeight: Integer);
    //#
    procedure SetLocalAlpha(ALocalAlpha: Boolean);
(*============================================================================*)
    class function LoadTileFoot(const AFileName: String; AFoot: TTileFoot): Boolean;
    class procedure SaveTileFoot(const AFileName: String; AFoot: TTileFoot);
(*============================================================================*)
  public
    constructor Create; override;
    destructor Destroy; override;
    //#
    //#
    function Load(const AFileName: String): Boolean; override;
    function Save(const AFileName: String): Boolean; override;
    function LoadTile(const AFileName: String; ATileIndex: Integer; AllInstance: Boolean = False): Boolean; overload;
    function LoadTileMask(const AFileName: String; AMode: Integer; ATileIndex: Integer; AllInstance: Boolean = False): Boolean;
    //#
    function LoadTile(AFoot: TFoot; ATileIndex: Integer; CloneBuffer: Boolean; AllInstance: Boolean = False): Boolean; overload;
    function LoadTile(ATileFoot: TTileFoot; ATileIndex: Integer; CloneBuffer: Boolean; AllInstance: Boolean = False): Boolean; overload;
    function LoadTile(ATileFoot: TTileFoot; CloneBuffer: Boolean; AllInstance: Boolean = False): Boolean; overload;
    function LoadTile(ABuffer: Pointer; ATileIndex: Integer; AWidth, AHeight: Integer; CloneBuffer: Boolean; AllInstance: Boolean = False): Boolean; overload;
    //#
    //#
    property TileSize[AIndex: Integer]: Integer read GetTileSize;
    property TileByteSize[AIndex: Integer]: Integer read GetTileByteSize;
    property TileByteWidth[AIndex: Integer]: Integer read GetTileByteWidth;
    property TileWidth[AIndex: Integer]: Integer read GetTileWidth write SetTileWidth;
    property TileHeight[AIndex: Integer]: Integer read GetTileHeight write SetTileHeight;
    property TileEmpty: Boolean read GetTileEmpty write SetTileEmpty;
    procedure TileResize(ATileIndex: Integer; AWidth, AHeight: Integer; AllInstance: Boolean = False);
    //#
    // cached means that the same tile collection was loaded several times
    // but only a copy of it resides in memory. tiles are cached as a single entity.
    property TileCached: Boolean read GetTileCached write SetTileCached;
    property TileFileName: String read GetTileFileName;
    property TileData: PTileFootData read FTileFootData;
    //#
    property TileBuffer[AIndex: Integer]: Pointer read GetTileBuffer write SetTileBuffer;
    //#
    property LeftTop: Pointer index TID_LEFT_TOP read GetTileBuffer;
    property RightTop: Pointer index TID_RIGHT_TOP read GetTileBuffer;
    property LeftBottom: Pointer index TID_LEFT_BOTTOM read GetTileBuffer;
    property RightBottom: Pointer index TID_RIGHT_BOTTOM read GetTileBuffer;
    property Left: Pointer index TID_LEFT read GetTileBuffer;
    property Right: Pointer index TID_RIGHT read GetTileBuffer;
    property Top: Pointer index TID_TOP read GetTileBuffer;
    property Bottom: Pointer index TID_BOTTOM read GetTileBuffer;
    property Center: Pointer index TID_CENTER read GetTileBuffer;
    //#
    property LocalAlpha: Boolean read FLocalAlpha write SetLocalAlpha;
    procedure UpdateBuffer;
  end;




//##############################################################################
//##                                    FONT                                  ##
//##############################################################################




  TFont = class(TFoot)
  protected
    FLefts,
    FWidths: array[0..255] of Integer;
    //#
    FName: String;
(*============================================================================*)
    class function LoadFont(const AFileName: String; AFont: TFont): Boolean;
    class procedure SaveFont(const AFileName: String; AFont: TFont);
(*============================================================================*)
  public
    function Load(const AFileName: String): Boolean; override;
    function Save(const AFileName: String): Boolean; override;
  end;




//##############################################################################
//##                                FOOTMANAGER                               ##
//##############################################################################




  TFootManager = class(TObject)
  protected
    FFootData: TAList;
    FFootDataCount: Integer;
    //#
    FTileFootData: TAList;
    FTileFootDataCount: Integer;
    //#
    FList: TAList;
    FListCount: Integer;
    //#
    FCache,
    FReload: Boolean;
(*============================================================================*)
    function GetData(AIndex: Integer; AFootType: Integer): Pointer;
(*============================================================================*)
  public
    constructor Create;
    destructor Destroy; override;
    //#
    //#
    property Reload: Boolean read FReload write FReload;
    property Cache: Boolean read FCache write FCache;
    procedure ReloadAll(AllFoot, AllTileFoot: Boolean);
    procedure UncacheAll(AllFoot, AllTileFoot: Boolean);
    //#
    //#
    // searches the data for the filename. if found in data then it increments the
    // usage, returns true and a data struct to use. if not found then it returns
    // false and an empty data struct to fill with usage set to 1 and the filename afilename.
    function AddData(const AFileName: String; AFootType: Integer; var ACached: Boolean): Pointer; overload;
    // if cache is on then it increments usage. if not then it clones the stuct and
    // the buffer it holds and sets usage 1.
    function AddData(AData: Pointer; AFootType: Integer): Pointer; overload;
    // creates and returns an empty data struct to fill with usage set to 1.
    function AddData(AFootType: Integer): Pointer; overload;
    // decrements the usage of the data struct or deletes it
    // if the usage is zero.
    function RemoveData(AData: Pointer; AFootType: Integer): Boolean;
    //#
    property Data[AIndex: Integer; AFootType: Integer]: Pointer read GetData;
    function FindData(const AFileName: String; AFootType: Integer): Integer; overload;
    function FindData(AData: Pointer; AFootType: Integer): Integer; overload;
  end;




//##############################################################################
//##                               FONTMANAGER                                ##
//##############################################################################




  TFontManager = class(TObject)
  protected
    FFontList: TAList;
    FFontCount: Integer;
(*============================================================================*)
  public
    constructor Create;
    destructor Destroy; override;
    //#
    function AddFont(const AFileName: String): Boolean; overload;
    function RemoveFont(const AName: String): Boolean; overload;
    function FindFont(const AName: String): Integer; overload;
    //#
    procedure RenderText(const AFontName: String; ADest: TFoot; ADestPos: TPoint; const AText: String; AAlpha: Integer; ARenderMode: Integer; MultiLine: Boolean = True); overload;
    procedure RenderText(const AFontName: String; ADest: TFoot; ADestPos: TPoint; ABounds: TRect; const AText: String; AAlpha: Integer; ARenderMode: Integer; MultiLine: Boolean = True); overload;
    //#
    function FontSize(const AFontName: String): TPoint;
    function FontStringSize(const AFontName: String; const AText: String; MultiLine: Boolean = True): TPoint;
  end;




                        //##############
                        //###  VAR   ###
                        //##############
                        Var
                        //######################################################
                        //##################### GLOBAL USED ####################

    FootManager: TFootManager;
    FontManager: TFontManager;

    AlphaTable: Pointer;




//##############################################################################
//##                              init and final                              ##
//##############################################################################

procedure Init;
procedure Final;

//##############################################################################
//##                            alphatable functions                          ##
//##############################################################################

procedure CreateAlphaTable(ATable: Pointer);

//##############################################################################
//##                        color conversion functions                        ##
//##############################################################################

function GetRed(Color: TAlphaColor): Byte;
function GetGreen(Color: TAlphaColor): Byte;
function GetBlue(Color: TAlphaColor): Byte;
function GetAlpha(Color: TAlphaColor): Byte;
//#
function NewAColor(R, G, B: Byte): TAlphaColor; overload;
function NewAColor(R, G, B, A: Byte): TAlphaColor; overload;

//##############################################################################
//##                            renderer  functions                           ##
//##############################################################################
//#
procedure Renderer_Copy_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_Copy_Color(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_Copy_Alpha(AParams: PDualRectParams; AAlpha: Byte);
//#
procedure Renderer_Transparence_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_Transparence_Color(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_Transparence_Alpha(AParams: PDualRectParams; AAlpha: Byte);
//#
procedure Renderer_GlobalAlphaFlat_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_GlobalAlphaFlat_Color(AParams: PDualRectParams; AAlpha: Byte);
//#
procedure Renderer_GlobalAlpha_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_GlobalAlpha_Color(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_GlobalAlpha_Alpha(AParams: PDualRectParams; AAlpha: Byte);
//#
procedure Renderer_GlobalAlpha_TransparenceFlat_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_GlobalAlpha_TransparenceFlat_Color(AParams: PDualRectParams; AAlpha: Byte);
//#
procedure Renderer_GlobalAlpha_Transparence_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_GlobalAlpha_Transparence_Color(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_GlobalAlpha_Transparence_Alpha(AParams: PDualRectParams; AAlpha: Byte);
//#
procedure Renderer_LocalAlphaFlat_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_LocalAlphaFlat_Color(AParams: PDualRectParams; AAlpha: Byte);
//#
procedure Renderer_LocalAlpha_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_LocalAlpha_Color(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_LocalAlpha_Alpha(AParams: PDualRectParams; AAlpha: Byte);
//#
procedure Renderer_CombinedAlphaFlat_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_CombinedAlphaFlat_Color(AParams: PDualRectParams; AAlpha: Byte);
//#
procedure Renderer_CombinedAlpha_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_CombinedAlpha_Color(AParams: PDualRectParams; AAlpha: Byte);
procedure Renderer_CombinedAlpha_Alpha(AParams: PDualRectParams; AAlpha: Byte);

//##############################################################################
//##                              fill functions                              ##
//##############################################################################

procedure Fill_AlphaColor(AParams: PRectParams; Color: LongWord);
procedure Fill_Color(AParams: PRectParams; Color: LongWord);
procedure Fill_Alpha(AParams: PRectParams; Color: LongWord);
procedure Fill_Mask(AParams: PRectParams; Color, Mask: LongWord);

//##############################################################################
//##                              add functions                               ##
//##############################################################################

procedure Add_AlphaColor(AParams: PRectParams; Color: LongWord);
procedure Add_Color(AParams: PRectParams; Color: LongWord);
procedure Add_Alpha(AParams: PRectParams; Color: LongWord);

//##############################################################################
//##                           substract functions                            ##
//##############################################################################

procedure Substract_AlphaColor(AParams: PRectParams; Color: LongWord);
procedure Substract_Color(AParams: PRectParams; Color: LongWord);
procedure Substract_Alpha(AParams: PRectParams; Color: LongWord);

//##############################################################################
//##                          alpha bitmap functions                          ##
//##############################################################################

// converts the buffer from the format BGR to BGRA format. only used when
// loading bitmaps the direction is from the end to the beginning of the buffer.
procedure InsertAlpha(PDEnd, PSEnd: Pointer; Size: Integer);
// add values from a bitmap buffer as the alpha of a foot buffer.
procedure FillAlpha_RGB(PBuffer, MaskBuffer: Pointer; PSize, Component: Integer);
procedure FillAlpha_Average(PBuffer, MaskBuffer: Pointer; PSize: Integer);

//##############################################################################
//##                                 FX functions                             ##
//##############################################################################

//##############################################################################
//##                                 other functions                          ##
//##############################################################################

function GetOpaqueLineWidth(var StartPtr: Pointer; MaxWidth: Integer; Alpha: Byte): Integer;
function BypassTransparence(var StartPtr: Pointer; MaxWidth: Integer; Alpha: Byte): Integer;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                              IMPLEMENTATION                              ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
Implementation




//##############################################################################
//##                            alphatable functions                          ##
//##############################################################################

procedure CreateAlphaTable(ATable: Pointer);
asm
        push edi

        mov edi, ATable  //eax
        xor cx, cx
@loop:
        mov al, ch
        mul cl
        stosw
        inc cx
        jnz @loop

        pop edi
end;

//##############################################################################
//##                        color conversion functions                        ##
//##############################################################################

function GetRed(Color: TAlphaColor): Byte;
asm
        shr eax, 16
        mov @Result, al
end;


function GetGreen(Color: TAlphaColor): Byte;
asm
        mov @Result, ah
end;


function GetBlue(Color: TAlphaColor): Byte;
asm
        mov @Result, al
end;


function GetAlpha(Color: TAlphaColor): Byte;
asm
        shr eax, 16
        mov @Result, ah
end;


function NewAColor(R, G, B: Byte): TAlphaColor;
asm
        xchg al, dl
        mov dh, $FF
        shl edx, 16
        mov dh, al
        mov dl, cl
        mov @Result, edx
end;


function NewAColor(R, G, B, A: Byte): TAlphaColor;
asm
        xchg al, dl
        mov dh, A
        shl edx, 16
        mov dh, al
        mov dl, cl
        mov @Result, edx
end;

//##############################################################################
//##                            renderer functions                            ##
//##############################################################################

procedure Renderer_Copy_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// (Rd, Gd, Bd, Ad) <- (Rs, Gs, Bs, As)
var Stack: Pointer;
    DestCROffset: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

        mov edi, eax // Params

        mov esp, [edi] // SrcCROffset
        mov ebx, [edi+4]
        mov DestCROffset, ebx // DestCROffset


        mov ebx, [edi+8] // Width
        mov edx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr
        cld
@loop:
        mov ecx, ebx
        rep movsd

        add edi, DestCROffset
        add esi, esp
        dec edx
        jnz @loop

        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_Copy_Color(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// (Rd, Gd, Bd, Ad) <- (Rs, Gs, Bs, Ad)
var Stack: Pointer;
    DestCROffset: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

        mov edi, eax // Params

        mov esp, [edi] // SrcCROffset
        mov ebx, [edi+4]
        mov DestCROffset, ebx // DestCROffset


        mov ebx, [edi+8] // Width
        mov edx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr
        cld
@loop1:
        mov ecx, ebx
@loop2:
        movsw
        movsb
        inc edi
        inc esi
        dec ecx
        jnz @loop2

        add edi, DestCROffset
        add esi, esp
        dec edx
        jnz @loop1

        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_Copy_Alpha(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// (Rd, Gd, Bd, Ad) <- (Rd, Gd, Bd, As)
var Stack: Pointer;
    DestCROffset: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

        mov edi, eax // Params

        mov esp, [edi] // SrcCROffset
        mov ebx, [edi+4]
        mov DestCROffset, ebx // DestCROffset


        mov ebx, [edi+8] // Width
        mov edx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr
        cld
@loop1:
        mov ecx, ebx
@loop2:
        add edi, 3
        add esi, 3
        movsb
        dec ecx
        jnz @loop2

        add edi, DestCROffset
        add esi, esp
        dec edx
        jnz @loop1

        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


//#
procedure Renderer_Transparence_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// If As<>0 : (Rd, Gd, Bd, Ad) <- (Rs, Gs, Bs, As)
// If As=0 : (Rd, Gd, Bd, Ad) <- (Rd, Gd, Bd, Ad)
var Stack: Pointer;
    DestCROffset: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

        mov edi, eax // Params

        mov esp, [edi] // SrcCROffset
        mov ebx, [edi+4]
        mov DestCROffset, ebx // DestCROffset

        mov ebx, [edi+8] // Width
        mov edx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr
        cld
@loop1:
        mov ecx, ebx
@loop2:
        lodsd
        test eax, $FF000000
        jz @Transparence
        mov [edi], eax
@Transparence:
        add edi, 4
        dec ecx
        jnz @loop2

        add edi, DestCROffset
        add esi, esp
        dec edx
        jnz @loop1

        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_Transparence_Color(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// If As<>0 : (Rd, Gd, Bd, Ad) <- (Rs, Gs, Bs, Ad)
// If As=0 : (Rd, Gd, Bd, Ad) <- (Rd, Gd, Bd, Ad)
var Stack: Pointer;
    DestCROffset,
    SrcCROffset: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]
        mov DestCROffset, ebx // DestCROffset

        mov ebx, [edi+8] // Width
        mov esp, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr
        cld
@loop1:
        mov ecx, ebx
@loop2:
        lodsw
        mov dx, ax
        lodsw
        test ax, $FF00
        jz @Transparence
        mov word ptr [edi], dx
        mov byte ptr [edi+2], al
@Transparence:
        add edi, 4
        dec ecx
        jnz @loop2

        add edi, DestCROffset
        add esi, SrcCROffset
        dec esp
        jnz @loop1

        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_Transparence_Alpha(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// If As<>0 : (Rd, Gd, Bd, Ad) <- (Rd, Gd, Bd, As)
// If As=0 : (Rd, Gd, Bd, Ad) <- (Rd, Gd, Bd, Ad)
var Stack: Pointer;
    DestCROffset: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

        mov edi, eax // Params

        mov esp, [edi] // SrcCROffset
        mov ebx, [edi+4]
        mov DestCROffset, ebx // DestCROffset

        mov ebx, [edi+8] // Width
        mov edx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        add esi, 3
        mov edi, [edi+20] // DestStartPtr
        add edi, 3
        cld
@loop1:
        mov ecx, ebx
@loop2:
        mov al, [esi] // al <- SAlpha
        test al, al // test if SAlpha=0
        jz @Transparence
        mov byte ptr [edi], al // DAlpha <- SAlpha
@Transparence:
        add edi, 4
        add esi, 4        
        dec ecx
        jnz @loop2

        add edi, DestCROffset
        add esi, esp
        dec edx
        jnz @loop1

        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


//#
//#
procedure Renderer_GlobalAlphaFlat_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)*AAlpha]/256
// Ad <- 255
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov bl, dl // AAlpha
        mov edx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:

@Blue:

        // BLUE
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, bl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha

        test bh, bh
        jnz @NegativeDiffB// if the difference was negative
        add [edi], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Green

@NegativeDiffB:
        sub [edi], ah // D <- D - abs(S-D)*SAlpha/256


@Green:
        // GREEN
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, bl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha

        test bh, bh
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Red
@NegativeDiffG:
        sub [edi+1], ah // D <- D - abs(S-D)*SAlpha/256


@Red:
        // RED
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, bl // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha

        test bh, bh
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Alpha

@NegativeDiffR:
        sub [edi+2], ah // D <- D - abs(S-D)*SAlpha/256


@Alpha:
        mov byte ptr [edi+3], $FF // DAlpha <- 255

@Next:
        add esi, 4
        add edi, 4

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec edx
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_GlobalAlphaFlat_Color(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)*AAlpha]/256
// Ad <- Ad
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov bl, dl // AAlpha
        mov edx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:

@Blue:

        // BLUE
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, bl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha

        test bh, bh
        jnz @NegativeDiffB// if the difference was negative
        add [edi], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Green

@NegativeDiffB:
        sub [edi], ah // D <- D - abs(S-D)*SAlpha/256


@Green:
        // GREEN
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, bl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha

        test bh, bh
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Red
@NegativeDiffG:
        sub [edi+1], ah // D <- D - abs(S-D)*SAlpha/256


@Red:
        // RED
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, bl // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha

        test bh, bh
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Next

@NegativeDiffR:
        sub [edi+2], ah // D <- D - abs(S-D)*SAlpha/256

@Next:
        add esi, 4
        add edi, 4

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec edx
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


//#
procedure Renderer_GlobalAlpha_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// EAlpha <- Ad + AAlpha*(256 - Ad)/256
// (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)]*AAlpha/EAlpha
// Ad <- EAlpha
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width, Height: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov ebx, [edi+12]
        mov Height, ebx // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov dh, dl
        neg dh // dh <- 255-AAlpha

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:


        // ALPHA
        xor eax, eax // clears eax

        mov al, [edi+3] // al <- DAlpha
        test al, al // checks if DAlpha=0
        jz @Opacity
        mov ah, dh // ah <- 255-AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- (256-AAlpha)*DAlpha
        mov bl, dl // bl <- AAlpha
        add bl, ah // bl <- EAlpha = (256-AAlpha)*DAlpha/256 + AAlpha

@Blue:
        // BLUE
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, dl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha
        div bl // al <- abs(S-D)*AAlpha/EAlpha

        test bh, bh
        jnz @NegativeDiffB// if the difference was negative
        add [edi], al // D <- D + abs(S-D)*AAlpha/EAlpha
        jmp @Green

@NegativeDiffB:
        sub [edi], al // D <- D - abs(S-D)*AAlpha/EAlpha


@Green:
        // GREEN
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, dl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha
        div bl // al <- abs(S-D)*AAlpha/EAlpha

        test bh, bh
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], al // D <- D + abs(S-D)*AAlpha/EAlpha
        jmp @Red
@NegativeDiffG:
        sub [edi+1], al // D <- D - abs(S-D)*AAlpha/EAlpha


@Red:
        // RED
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, dl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha
        div bl // al <- abs(S-D)*AAlpha/EAlpha

        test bh, bh
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], al // D <- D + abs(S-D)*AAlpha/EAlpha
        jmp @Alpha

@NegativeDiffR:
        sub [edi+2], al // D <- D - abs(S-D)*AAlpha/EAlpha


@Alpha:
        mov [edi+3], bl // DAlpha <- EAlpha

        add esi, 4
        add edi, 4
        jmp @Next

@Opacity:
        movsw
        movsb
        mov [edi], dl // AAlpha
        inc edi
        inc esi

@Next:

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec Height
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_GlobalAlpha_Color(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// EAlpha <- Ad + AAlpha*(256 - Ad)/256
// (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)]*AAlpha/EAlpha
// Ad <- Ad
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width, Height: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov ebx, [edi+12]
        mov Height, ebx // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov dh, dl
        neg dh // dh <- 255-AAlpha

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:


        // ALPHA
        xor eax, eax // clears eax

        mov al, [edi+3] // al <- DAlpha
        test al, al // checks if DAlpha=0
        jz @Opacity
        mov ah, dh // ah <- 255-AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- (256-AAlpha)*DAlpha
        mov bl, dl // bl <- AAlpha
        add bl, ah // bl <- EAlpha = (256-AAlpha)*DAlpha/256 + AAlpha

@Blue:
        // BLUE
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, dl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha
        div bl // al <- abs(S-D)*AAlpha/EAlpha

        test bh, bh
        jnz @NegativeDiffB// if the difference was negative
        add [edi], al // D <- D + abs(S-D)*AAlpha/EAlpha
        jmp @Green

@NegativeDiffB:
        sub [edi], al // D <- D - abs(S-D)*AAlpha/EAlpha


@Green:
        // GREEN
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, dl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha
        div bl // al <- abs(S-D)*AAlpha/EAlpha

        test bh, bh
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], al // D <- D + abs(S-D)*AAlpha/EAlpha
        jmp @Red
@NegativeDiffG:
        sub [edi+1], al // D <- D - abs(S-D)*AAlpha/EAlpha


@Red:
        // RED
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, dl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha
        div bl // al <- abs(S-D)*AAlpha/EAlpha

        test bh, bh
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], al // D <- D + abs(S-D)*AAlpha/EAlpha
        jmp @Alpha

@NegativeDiffR:
        sub [edi+2], al // D <- D - abs(S-D)*AAlpha/EAlpha


@Alpha:
        add esi, 4
        add edi, 4
        jmp @Next

@Opacity:
        movsw
        movsb
        inc edi
        inc esi

@Next:

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec Height
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_GlobalAlpha_Alpha(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// EAlpha <- Ad + AAlpha*(256 - Ad)/256
// (Rd, Gd, Bd) <- (Rd, Gd, Bd)
// Ad <- EAlpha
var Stack: Pointer;
    DestCROffset: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8] // Width
        mov esi, [edi+12]  // Height
        mov edi, [edi+20] // DestStartPtr
        add edi, 3

        mov dh, dl
        neg dh // dh <- 255-AAlpha

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, ebx // ecx <- Width
@loop2:

        // ALPHA
        xor eax, eax // clears eax

        mov al, [edi] // al <- DAlpha
        test al, al // checks if DAlpha=0
        jz @Opacity
        mov ah, dh // ah <- 255-AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- (256-AAlpha)*DAlpha
        add ah, dl // ah <- EAlpha = (256-AAlpha)*DAlpha/256 + AAlpha
        mov [edi], ah // DAlpha <- EAlpha
        jmp @Next

@Opacity:
        mov [edi], dl // DAlpha <- AAlpha

@Next:
        add edi, 4
        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        dec esi
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


//#
procedure Renderer_GlobalAlpha_TransparenceFlat_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// if As<> 0 then :
//              (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)*AAlpha]/256
//              Ad <- 255
// else : (Rd, Gd, Bd, Ad) <- (Rd, Gd, Bd, Ad)
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov bl, dl // AAlpha
        mov edx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:

        test [esi+3], $FF // checks if SAlpha=0 (Transparence)
        jz @Next

@Blue:

        // BLUE
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, bl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha

        test bh, bh
        jnz @NegativeDiffB// if the difference was negative
        add [edi], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Green

@NegativeDiffB:
        sub [edi], ah // D <- D - abs(S-D)*SAlpha/256


@Green:
        // GREEN
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, bl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha

        test bh, bh
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Red
@NegativeDiffG:
        sub [edi+1], ah // D <- D - abs(S-D)*SAlpha/256


@Red:
        // RED
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, bl // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha

        test bh, bh
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Alpha

@NegativeDiffR:
        sub [edi+2], ah // D <- D - abs(S-D)*SAlpha/256


@Alpha:
        mov byte ptr [edi+3], $FF // DAlpha <- 255

@Next:
        add esi, 4
        add edi, 4

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec edx
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_GlobalAlpha_TransparenceFlat_Color(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// if As<> 0 then :
//              (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)*AAlpha]/256
//              Ad <- Ad
// else : (Rd, Gd, Bd, Ad) <- (Rd, Gd, Bd, Ad)
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov bl, dl // AAlpha
        mov edx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:

        test [esi+3], $FF // checks if SAlpha=0 (Transparence)
        jz @Next

@Blue:

        // BLUE
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, bl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha

        test bh, bh
        jnz @NegativeDiffB// if the difference was negative
        add [edi], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Green

@NegativeDiffB:
        sub [edi], ah // D <- D - abs(S-D)*SAlpha/256


@Green:
        // GREEN
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, bl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha

        test bh, bh
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Red
@NegativeDiffG:
        sub [edi+1], ah // D <- D - abs(S-D)*SAlpha/256


@Red:
        // RED
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, bl // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha

        test bh, bh
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Next

@NegativeDiffR:
        sub [edi+2], ah // D <- D - abs(S-D)*SAlpha/256

@Next:
        add esi, 4
        add edi, 4

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec edx
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


//#
procedure Renderer_GlobalAlpha_Transparence_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// if As<> 0 then :
//              EAlpha <- Ad + AAlpha*(256 - Ad)/256
//              (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)]*AAlpha/EAlpha
//              Ad <- EAlpha
// else : (Rd, Gd, Bd, Ad) <- (Rd, Gd, Bd, Ad)
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width, Height: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov ebx, [edi+12]
        mov Height, ebx // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov dh, dl
        neg dh // dh <- 255-AAlpha

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:

        test [esi+3], $FF // checks if SAlpha=0 (Transparence)
        jz @Transparence

        // ALPHA
        xor eax, eax // clears eax

        mov al, [edi+3] // al <- DAlpha
        test al, al // checks if DAlpha=0
        jz @Opacity
        mov ah, dh // ah <- 255-AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- (256-AAlpha)*DAlpha
        mov bl, dl // bl <- AAlpha
        add bl, ah // bl <- EAlpha = (256-AAlpha)*DAlpha/256 + AAlpha

@Blue:
        // BLUE
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, dl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha
        div bl // al <- abs(S-D)*AAlpha/EAlpha

        test bh, bh
        jnz @NegativeDiffB// if the difference was negative
        add [edi], al // D <- D + abs(S-D)*AAlpha/EAlpha
        jmp @Green

@NegativeDiffB:
        sub [edi], al // D <- D - abs(S-D)*AAlpha/EAlpha


@Green:
        // GREEN
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, dl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha
        div bl // al <- abs(S-D)*AAlpha/EAlpha

        test bh, bh
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], al // D <- D + abs(S-D)*AAlpha/EAlpha
        jmp @Red
@NegativeDiffG:
        sub [edi+1], al // D <- D - abs(S-D)*AAlpha/EAlpha


@Red:
        // RED
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, dl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha
        div bl // al <- abs(S-D)*AAlpha/EAlpha

        test bh, bh
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], al // D <- D + abs(S-D)*AAlpha/EAlpha
        jmp @Alpha

@NegativeDiffR:
        sub [edi+2], al // D <- D - abs(S-D)*AAlpha/EAlpha


@Alpha:
        mov [edi+3], bl // DAlpha <- EAlpha

@Transparence:
        add esi, 4
        add edi, 4
        jmp @Next

@Opacity:
        movsw
        movsb
        mov [edi], dl // AAlpha
        inc edi
        inc esi

@Next:

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec Height
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_GlobalAlpha_Transparence_Color(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// if As<> 0 then :
//              EAlpha <- Ad + AAlpha*(256 - Ad)/256
//              (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)]*AAlpha/EAlpha
//              Ad <- Ad
// else : (Rd, Gd, Bd, Ad) <- (Rd, Gd, Bd, Ad)
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width, Height: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov ebx, [edi+12]
        mov Height, ebx // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov dh, dl
        neg dh // dh <- 255-AAlpha

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:

        test [esi+3], $FF // checks if SAlpha=0 (Transparence)
        jz @Transparence


        // ALPHA
        xor eax, eax // clears eax

        mov al, [edi+3] // al <- DAlpha
        test al, al // checks if DAlpha=0
        jz @Opacity
        mov ah, dh // ah <- 255-AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- (256-AAlpha)*DAlpha
        mov bl, dl // bl <- AAlpha
        add bl, ah // bl <- EAlpha = (256-AAlpha)*DAlpha/256 + AAlpha

@Blue:
        // BLUE
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, dl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha
        div bl // al <- abs(S-D)*AAlpha/EAlpha

        test bh, bh
        jnz @NegativeDiffB// if the difference was negative
        add [edi], al // D <- D + abs(S-D)*AAlpha/EAlpha
        jmp @Green

@NegativeDiffB:
        sub [edi], al // D <- D - abs(S-D)*AAlpha/EAlpha


@Green:
        // GREEN
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, dl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha
        div bl // al <- abs(S-D)*AAlpha/EAlpha

        test bh, bh
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], al // D <- D + abs(S-D)*AAlpha/EAlpha
        jmp @Red
@NegativeDiffG:
        sub [edi+1], al // D <- D - abs(S-D)*AAlpha/EAlpha


@Red:
        // RED
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, dl // ah <- AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*AAlpha
        div bl // al <- abs(S-D)*AAlpha/EAlpha

        test bh, bh
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], al // D <- D + abs(S-D)*AAlpha/EAlpha
        jmp @Transparence

@NegativeDiffR:
        sub [edi+2], al // D <- D - abs(S-D)*AAlpha/EAlpha


@Transparence:
        add esi, 4
        add edi, 4
        jmp @Next

@Opacity:
        movsw
        movsb
        inc edi
        inc esi

@Next:

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec Height
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_GlobalAlpha_Transparence_Alpha(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// if As<> 0 then :
//              EAlpha <- Ad + AAlpha*(256 - Ad)/256
//              (Rd, Gd, Bd) <- (Rd, Gd, Bd)
//              Ad <- EAlpha
// else : (Rd, Gd, Bd, Ad) <- (Rd, Gd, Bd, Ad)
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov ebx, [edi+12]  // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr
        add edi, 3
        add esi, 3

        mov dh, dl
        neg dh // dh <- 255-AAlpha

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width // ecx <- Width
@loop2:

        test [esi], $FF // checks if SAlpha=0 (Transparence)
        jz @Next

        // ALPHA
        xor eax, eax // clears eax

        mov al, [edi] // al <- DAlpha
        test al, al // checks if DAlpha=0
        jz @Opacity
        mov ah, dh // ah <- 255-AAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- (256-AAlpha)*DAlpha
        add ah, dl // ah <- EAlpha = (256-AAlpha)*DAlpha/256 + AAlpha
        mov [edi], ah // DAlpha <- EAlpha
        jmp @Next

@Opacity:
        mov [edi], dl // DAlpha <- AAlpha

@Next:
        add edi, 4
        add esi, 4
        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec ebx
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


//#
procedure Renderer_LocalAlphaFlat_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)]*As/256
// if As<>0 then Ad <- 255
// else Ad <- Ad
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov edx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:


        // ALPHA
        xor eax, eax // clears eax


        mov bl, [esi+3] // bl <- SAlpha
        test bl, bl // checks if SAlpha=0
        jz @Transparence
        inc bl // checks if SAlpha=$FF
        jc @Opacity
        dec bl

@Blue:
        // BLUE
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, bl // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha

        test bh, bh
        jnz @NegativeDiffB// if the difference was negative
        add [edi], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Green

@NegativeDiffB:
        sub [edi], ah // D <- D - abs(S-D)*SAlpha/256

@Green:
        // GREEN
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, bl // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha

        test bh, bh
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Red
@NegativeDiffG:
        sub [edi+1], ah // D <- D - abs(S-D)*SAlpha/256


@Red:
        // RED
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, bl // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha

        test bh, bh
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Alpha

@NegativeDiffR:
        sub [edi+2], ah // D <- D - abs(S-D)*SAlpha/256


@Alpha:
        mov byte ptr [edi+3], $FF // DAlpha <- 255

@Transparence:
        add esi, 4
        add edi, 4
        jmp @Next

@Opacity:
        movsw
        movsb
        mov byte ptr [edi], $FF // DAlpha <- 255
        inc edi
        inc esi

@Next:

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec edx
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_LocalAlphaFlat_Color(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)]*As/256
// Ad <- Ad
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov edx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:


        // ALPHA
        xor eax, eax // clears eax


        mov bl, [esi+3] // bl <- SAlpha
        test bl, bl // checks if SAlpha=0
        jz @Transparence
        inc bl // checks if SAlpha=$FF
        jc @Opacity
        dec bl

@Blue:
        // BLUE
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, bl // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha

        test bh, bh
        jnz @NegativeDiffB// if the difference was negative
        add [edi], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Green

@NegativeDiffB:
        sub [edi], ah // D <- D - abs(S-D)*SAlpha/256

@Green:
        // GREEN
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, bl // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha

        test bh, bh
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Red
@NegativeDiffG:
        sub [edi+1], ah // D <- D - abs(S-D)*SAlpha/256


@Red:
        // RED
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, bl // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha

        test bh, bh
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], ah // D <- D + abs(S-D)*SAlpha/256
        jmp @Transparence

@NegativeDiffR:
        sub [edi+2], ah // D <- D - abs(S-D)*SAlpha/256

@Transparence:
        add esi, 4
        add edi, 4
        jmp @Next

@Opacity:
        movsw
        movsb
        inc edi
        inc esi

@Next:

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec edx
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


//#
procedure Renderer_LocalAlpha_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// EAlpha <- Ad + As*(256 - Ad)/256
// (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)]*As/EAlpha
// Ad <- EAlpha
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov edx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:


        // ALPHA
        xor eax, eax // clears eax
        xor ebx, ebx // clears ebx

        mov al, [edi+3] // al <- DAlpha
        test al, al // checks if DAlpha=0
        jz @Opacity
        mov bl, al // bl <- DAlpha
        neg al // al <- 255-DAlpha
        mov ah, [esi+3] // ah <- SAlpha
        test ah, $FF // checks if SAlpha=0
        jz @Transparence
        inc ah
        jc @Opacity
        dec ah
        mov bh, ah // bh <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- (256-DAlpha)*SAlpha
        add bl, ah // bl <- EAlpha = (256-DAlpha)*SAlpha/256 + DAlpha

@Blue:
        // BLUE
        xor eax, eax // clears eax

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        or ebx, $00010000 // use ebx as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, bh // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha
        div bl // al <- abs(S-D)*SAlpha/EAlpha

        test ebx, $FFFF0000
        jnz @NegativeDiffB// if the difference was negative
        add [edi], al // D <- D + abs(S-D)*SAlpha/EAlpha
        jmp @Green

@NegativeDiffB:
        sub [edi], al // D <- D - abs(S-D)*SAlpha/EAlpha

@Green:
        // GREEN
        xor eax, eax // clears eax
        and ebx, $0000FFFF // clears positivity part of ebx

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        or ebx, $00010000 // use ebx as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, bh // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha
        div bl // al <- abs(S-D)*SAlpha/EAlpha

        test ebx, $FFFF0000
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], al // D <- D + abs(S-D)*SAlpha/EAlpha
        jmp @Red
@NegativeDiffG:
        sub [edi+1], al // D <- D - abs(S-D)*SAlpha/EAlpha


@Red:
        // RED
        xor eax, eax // clears eax
        and ebx, $0000FFFF // clears positivity part of ebx

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        or ebx, $00010000 // use ebx as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, bh // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha
        div bl // al <- abs(S-D)*SAlpha/EAlpha

        test ebx, $FFFF0000
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], al // D <- D + abs(S-D)*SAlpha/EAlpha
        jmp @Alpha

@NegativeDiffR:
        sub [edi+2], al // D <- D - abs(S-D)*SAlpha/EAlpha


@Alpha:
        mov [edi+3], bl // DAlpha <- EAlpha

@Transparence:
        add esi, 4
        add edi, 4
        jmp @Next

@Opacity:
        movsd

@Next:

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec edx
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_LocalAlpha_Color(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// EAlpha <- Ad + As*(256 - Ad)/256
// (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)]*As/EAlpha
// Ad <- Ad
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov edx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:


        // ALPHA
        xor eax, eax // clears eax
        xor ebx, ebx // clears ebx

        mov al, [edi+3] // al <- DAlpha
        test al, al // checks if DAlpha=0
        jz @Opacity
        mov bl, al // bl <- DAlpha
        neg al // al <- 255-DAlpha
        mov ah, [esi+3] // ah <- SAlpha
        test ah, ah // checks if SAlpha=0
        jz @Transparence
        inc ah
        jc @Opacity
        dec ah
        mov bh, ah // bh <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- (256-DAlpha)*SAlpha
        add bl, ah // bl <- EAlpha = (256-DAlpha)*SAlpha/256 + DAlpha

@Blue:
        // BLUE
        xor eax, eax // clears eax

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        or ebx, $00010000 // use ebx as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, bh // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha
        div bl // al <- abs(S-D)*SAlpha/EAlpha

        test ebx, $FFFF0000
        jnz @NegativeDiffB// if the difference was negative
        add [edi], al // D <- D + abs(S-D)*SAlpha/EAlpha
        jmp @Green

@NegativeDiffB:
        sub [edi], al // D <- D - abs(S-D)*SAlpha/EAlpha


@Green:
        // GREEN
        xor eax, eax // clears eax
        and ebx, $0000FFFF // clears positivity part of ebx

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        or ebx, $00010000 // use ebx as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, bh // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha
        div bl // al <- abs(S-D)*SAlpha/EAlpha

        test ebx, $FFFF0000
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], al // D <- D + abs(S-D)*SAlpha/EAlpha
        jmp @Red
@NegativeDiffG:
        sub [edi+1], al // D <- D - abs(S-D)*SAlpha/EAlpha

@Red:
        // RED
        xor eax, eax // clears eax
        and ebx, $0000FFFF // clears positivity part of ebx

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        or ebx, $00010000 // use ebx as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, bh // ah <- SAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*SAlpha
        div bl // al <- abs(S-D)*SAlpha/EAlpha

        test ebx, $FFFF0000
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], al // D <- D + abs(S-D)*SAlpha/EAlpha
        jmp @Transparence

@NegativeDiffR:
        sub [edi+2], al // D <- D - abs(S-D)*SAlpha/EAlpha

@Transparence:
        add esi, 4
        add edi, 4
        jmp @Next

@Opacity:
        movsw
        movsb
        inc edi
        inc esi

@Next:

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec edx
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_LocalAlpha_Alpha(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// EAlpha <- Ad + As*(256 - Ad)/256
// (Rd, Gd, Bd) <- (Rd, Gd, Bd)
// Ad <- EAlpha
var Stack: Pointer;
    SrcCROffset, DestCROffset: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]  // Width
        mov edx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        add esi, 3
        add edi, 3

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, ebx
@loop2:

        // ALPHA
        xor eax, eax // clears eax

        mov al, [edi] // al <- DAlpha
        test al, al // checks if DAlpha=0
        jz @Opacity
        neg al // al <- 255-DAlpha
        mov ah, [esi] // ah <- SAlpha
        test ah, ah // checks if SAlpha=0
        jz @Transparence
        inc ah
        jc @Opacity
        dec ah
        shl eax, 1
        mov ax, [esp+eax] // ax <- (256-DAlpha)*SAlpha
        add [edi], ah // DAlpha <- EAlpha = (256-DAlpha)*SAlpha/256 + DAlpha

@Transparence:
        add esi, 4
        add edi, 4
        jmp @Next

@Opacity:
        movsb
        add esi, 3
        add edi, 3

@Next:
        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec edx
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


//#
procedure Renderer_CombinedAlphaFlat_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// CAlpha <- As*AAlpha/256
// (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)]*CAlpha/256
// if CAlpha<>0 then Ad <- 255
// else Ad <- Ad
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width, Height: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov ebx, [edi+12]
        mov Height, ebx // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:


        // ALPHA
        xor eax, eax // clears eax
        xor ebx, ebx // clears ebx

        mov bl, [esi+3] // bl <- SAlpha
        mov bh, dl // bh <- AAlpha
        shl ebx, 1
        mov bl, [esp+ebx+1] // bl <- CAlpha = AAlpha*SAlpha/256


        test bl, bl // checks if CAlpha=0
        jz @Transparence
        inc bl // checks if CAlpha=$FF
        jc @Opacity
        dec bl

@Blue:
        // BLUE
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, bl // ah <- CAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*CAlpha

        test bh, bh
        jnz @NegativeDiffB// if the difference was negative
        add [edi], ah // D <- D + abs(S-D)*CAlpha/256
        jmp @Green

@NegativeDiffB:
        sub [edi], ah // D <- D - abs(S-D)*CAlpha/256

@Green:
        // GREEN
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, bl // ah <- CAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*CAlpha

        test bh, bh
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], ah // D <- D + abs(S-D)*CAlpha/256
        jmp @Red
@NegativeDiffG:
        sub [edi+1], ah // D <- D - abs(S-D)*CAlpha/256


@Red:
        // RED
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, bl // ah <- CAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*CAlpha

        test bh, bh
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], ah // D <- D + abs(S-D)*CAlpha/256
        jmp @Alpha

@NegativeDiffR:
        sub [edi+2], ah // D <- D - abs(S-D)*CAlpha/256


@Alpha:
        mov byte ptr [edi+3], $FF // DAlpha <- 255

@Transparence:
        add esi, 4
        add edi, 4
        jmp @Next

@Opacity:
        movsw
        movsb
        mov byte ptr [edi], $FF // DAlpha <- 255
        inc edi
        inc esi

@Next:

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec Height
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_CombinedAlphaFlat_Color(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// CAlpha <- As*AAlpha/256
// (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)]*CAlpha/256
// Ad <- Ad
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width, Height: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov ebx, [edi+12]
        mov Height, ebx // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:


        // ALPHA
        xor eax, eax // clears eax
        xor ebx, ebx // clears ebx

        mov bl, [esi+3] // bl <- SAlpha
        mov bh, dl // bh <- AAlpha
        shl ebx, 1
        mov bl, [esp+ebx+1] // bl <- CAlpha = AAlpha*SAlpha/256


        test bl, bl // checks if CAlpha=0
        jz @Transparence
        inc bl // checks if CAlpha=$FF
        jc @Opacity
        dec bl

@Blue:
        // BLUE
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, bl // ah <- CAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*CAlpha

        test bh, bh
        jnz @NegativeDiffB// if the difference was negative
        add [edi], ah // D <- D + abs(S-D)*CAlpha/256
        jmp @Green

@NegativeDiffB:
        sub [edi], ah // D <- D - abs(S-D)*CAlpha/256

@Green:
        // GREEN
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, bl // ah <- CAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*CAlpha

        test bh, bh
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], ah // D <- D + abs(S-D)*CAlpha/256
        jmp @Red
@NegativeDiffG:
        sub [edi+1], ah // D <- D - abs(S-D)*CAlpha/256


@Red:
        // RED
        xor eax, eax // clears eax
        xor bh, bh // clears bh

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        not bh // use bh as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, bl // ah <- CAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*CAlpha

        test bh, bh
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], ah // D <- D + abs(S-D)*CAlpha/256
        jmp @Transparence

@NegativeDiffR:
        sub [edi+2], ah // D <- D - abs(S-D)*CAlpha/256

@Transparence:
        add esi, 4
        add edi, 4
        jmp @Next

@Opacity:
        movsw
        movsb
        inc edi
        inc esi

@Next:

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec Height
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


//#
procedure Renderer_CombinedAlpha_AlphaColor(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// CAlpha <- As*AAlpha/256
// EAlpha <- Ad + CAlpha*(256 - Ad)/256
// (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)]*CAlpha/EAlpha
// Ad <- EAlpha
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width, Height: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov ebx, [edi+12]
        mov Height, ebx // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:


        // ALPHA
        xor eax, eax // clears eax
        xor ebx, ebx // clears ebx

        mov bl, [esi+3] // bl <- SAlpha
        mov bh, dl // bh <- AAlpha
        shl ebx, 1
        mov bh, [esp+ebx+1] // bh <- CAlpha = AAlpha*SAlpha/256

        mov al, [edi+3] // al <- DAlpha
        test al, al // checks if DAlpha=0
        jz @Opacity

        test bh, bh // checks if CAlpha=0
        jz @Transparence

        mov bl, al // bl <- DAlpha
        neg al // al <- 255-DAlpha
        mov ah, bh // ah <- CAlpha
        shl eax, 1
        add bl, [esp+eax+1] // bl <- EAlpha = (256-DAlpha)*SAlpha/256 + DAlpha

@Blue:
        // BLUE
        xor eax, eax // clears eax
        and ebx, $0000FFFF // clears positivity part of ebx

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        or ebx, $00010000 // use ebx as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, bh // ah <- CAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*CAlpha
        div bl // al <- abs(S-D)*CAlpha/EAlpha

        test ebx, $FFFF0000
        jnz @NegativeDiffB// if the difference was negative
        add [edi], al // D <- D + abs(S-D)*CAlpha/EAlpha
        jmp @Green

@NegativeDiffB:
        sub [edi], al // D <- D - abs(S-D)*CAlpha/EAlpha

@Green:
        // GREEN
        xor eax, eax // clears eax
        and ebx, $0000FFFF // clears positivity part of ebx

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        or ebx, $00010000 // use ebx as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, bh // ah <- CAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*CAlpha
        div bl // al <- abs(S-D)*CAlpha/EAlpha

        test ebx, $FFFF0000
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], al // D <- D + abs(S-D)*CAlpha/EAlpha
        jmp @Red
@NegativeDiffG:
        sub [edi+1], al // D <- D - abs(S-D)*CAlpha/EAlpha


@Red:
        // RED
        xor eax, eax // clears eax
        and ebx, $0000FFFF // clears positivity part of ebx

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        or ebx, $00010000 // use ebx as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, bh // ah <- CAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*CAlpha
        div bl // al <- abs(S-D)*CAlpha/EAlpha

        test ebx, $FFFF0000
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], al // D <- D + abs(S-D)*CAlpha/EAlpha
        jmp @Alpha

@NegativeDiffR:
        sub [edi+2], al // D <- D - abs(S-D)*CAlpha/EAlpha


@Alpha:
        mov [edi+3], bl // DAlpha <- EAlpha

@Transparence:
        add esi, 4
        add edi, 4
        jmp @Next

@Opacity:
        movsw
        movsb
        mov [edi], bh
        inc edi
        inc esi

@Next:

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec Height
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_CombinedAlpha_Color(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// CAlpha <- As*AAlpha/256
// EAlpha <- Ad + CAlpha*(256 - Ad)/256
// (Rd, Gd, Bd) <- (Rd, Gd, Bd) + [(Rs, Gs, Bs)-(Rd, Gd, Bd)]*CAlpha/EAlpha
// Ad <- Ad
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width, Height: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx // Width
        mov ebx, [edi+12]
        mov Height, ebx // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:


        // ALPHA
        xor eax, eax // clears eax
        xor ebx, ebx // clears ebx


        mov bl, [esi+3] // bl <- SAlpha
        mov bh, dl // bh <- AAlpha
        shl ebx, 1
        mov bh, [esp+ebx+1] // bh <- CAlpha = AAlpha*SAlpha/256

        mov al, [edi+3] // al <- DAlpha
        test al, al // checks if DAlpha=0
        jz @Opacity

        test bh, bh // checks if CAlpha=0
        jz @Transparence

        mov bl, al // bl <- DAlpha
        neg al // al <- 255-DAlpha
        mov ah, bh // ah <- CAlpha
        shl eax, 1
        add bl, [esp+eax+1] // bl <- EAlpha = (256-DAlpha)*SAlpha/256 + DAlpha

@Blue:
        // BLUE
        xor eax, eax // clears eax
        and ebx, $0000FFFF // clears positivity part of ebx

        mov al, [esi] // al <- S
        sub al, [edi] // al <- S-D
        jnc @PositiveDiffB // if S-D is positive
        or ebx, $00010000 // use ebx as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffB:
        mov ah, bh // ah <- CAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*CAlpha
        div bl // al <- abs(S-D)*CAlpha/EAlpha

        test ebx, $FFFF0000
        jnz @NegativeDiffB// if the difference was negative
        add [edi], al // D <- D + abs(S-D)*CAlpha/EAlpha
        jmp @Green

@NegativeDiffB:
        sub [edi], al // D <- D - abs(S-D)*CAlpha/EAlpha


@Green:
        // GREEN
        xor eax, eax // clears eax
        and ebx, $0000FFFF // clears positivity part of ebx

        mov al, [esi+1] // al <- S
        sub al, [edi+1] // al <- S-D
        jnc @PositiveDiffG // if S-D is positive
        or ebx, $00010000 // use ebx as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffG:

        mov ah, bh // ah <- CAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*CAlpha
        div bl // al <- abs(S-D)*CAlpha/EAlpha

        test ebx, $FFFF0000
        jnz @NegativeDiffG// if the difference was negative
        add [edi+1], al // D <- D + abs(S-D)*CAlpha/EAlpha
        jmp @Red
@NegativeDiffG:
        sub [edi+1], al // D <- D - abs(S-D)*CAlpha/EAlpha

@Red:
        // RED
        xor eax, eax // clears eax
        and ebx, $0000FFFF // clears positivity part of ebx

        mov al, [esi+2] // al <- S
        sub al, [edi+2] // al <- S-D
        jnc @PositiveDiffR // if S-D is positive
        or ebx, $00010000 // use ebx as a flag to indicate a positive/negative difference
        neg al // al <- abs(S-D)

@PositiveDiffR:

        mov ah, bh // ah <- CAlpha
        shl eax, 1
        mov ax, [esp+eax] // ax <- abs(S-D)*CAlpha
        div bl // al <- abs(S-D)*CAlpha/EAlpha

        test ebx, $FFFF0000
        jnz @NegativeDiffR// if the difference was negative
        add [edi+2], al // D <- D + abs(S-D)*CAlpha/EAlpha
        jmp @Transparence

@NegativeDiffR:
        sub [edi+2], al // D <- D - abs(S-D)*CAlpha/EAlpha

@Transparence:
        add esi, 4
        add edi, 4
        jmp @Next

@Opacity:
        movsw
        movsb
        inc edi
        inc esi

@Next:

        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec Height
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Renderer_CombinedAlpha_Alpha(AParams: PDualRectParams; AAlpha: Byte);
// Source : (Rs, Gs, Bs, As)
// Destination : (Rd, Gd, Bd, Ad)
// After rendering source on destination :
// CAlpha <- As*AAlpha/256
// EAlpha <- Ad + CAlpha*(256 - Ad)/256
// (Rd, Gd, Bd) <- (Rd, Gd, Bd)
// Ad <- EAlpha
var Stack: Pointer;
    SrcCROffset, DestCROffset, Width: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, [edi]
        mov SrcCROffset, ebx // SrcCROffset
        mov ebx, [edi+4]   // DestCROffset
        mov DestCROffset, ebx // SrcCROffset

        mov ebx, [edi+8]
        mov Width, ebx  // Width
        mov ebx, [edi+12] // Height
        mov esi, [edi+16] // SrcStartPtr
        mov edi, [edi+20] // DestStartPtr

        add esi, 3
        add edi, 3

        mov esp, AlphaTable
        cld
@loop1:
        mov ecx, Width
@loop2:

        // ALPHA
        xor eax, eax // clears eax

        mov al, [esi] // al <- SAlpha
        mov ah, dl // ah <- AAlpha
        shl eax, 1
        mov ah, [esp+eax+1] // ah <- CAlpha = AAlpha*SAlpha/256

        and eax, $0000FFFF // clears eax

        test ah, ah // checks if CAlpha=0
        jz @Transparence

        mov al, [edi] // al <- DAlpha
        test al, al // checks if DAlpha=0
        jz @Opacity
        neg al // al <- 255-DAlpha

        shl eax, 1
        mov ah, [esp+eax+1] // ah <- (256-DAlpha)*CAlpha/256
        add [edi], ah // DAlpha <- EAlpha = (256-DAlpha)*CAlpha/256 + DAlpha

@Transparence:
        add esi, 4
        add edi, 4
        jmp @Next

@Opacity:
        mov [edi], ah
        add esi, 4
        add edi, 4

@Next:
        dec ecx
        jnz @loop2
        add edi, DestCROffset // next line in dest ( adds destination offset )
        add esi, SrcCROffset // next line in source ( adds source offset )
        dec ebx
        jnz @loop1 // end of block test
@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;

//##############################################################################
//##                              fill functions                              ##
//##############################################################################

procedure Fill_AlphaColor(AParams: PRectParams; Color: LongWord);
asm
        push edi
        push esi
        push ebx

@Start:
        mov edi, eax // Params

        mov eax, edx // Color

        mov ebx, [edi] // DestCROffset
        mov edx, [edi+4] // Width
        mov esi, [edi+8] // Height
        mov edi, [edi+12] // DestStartPtr
        cld
@loop:
        mov ecx, edx
        rep stosd

        add edi, ebx
        dec esi
        jnz @loop

@Exit:
        pop ebx
        pop esi
        pop edi
end;


procedure Fill_Color(AParams: PRectParams; Color: LongWord);
var Stack: Pointer;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov eax, edx // Color
        mov ebx, eax
        shr ebx, 16

        mov esp, [edi] // DestCROffset
        mov edx, [edi+4] // Width
        mov esi, [edi+8] // Height
        mov edi, [edi+12] // DestStartPtr
        cld
@loop1:
        mov ecx, edx
@loop2:
        stosw // store $GB
        mov [edi], bl // store $R
        add edi, 2

        dec ecx
        jnz @loop2

        add edi, esp
        dec esi
        jnz @loop1

@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Fill_Alpha(AParams: PRectParams; Color: LongWord);
asm
        push edi
        push esi
        push ebx

@Start:
        mov edi, eax // Params

        mov eax, edx // Color
        shr eax, 24 // al <- Alpha

        mov ebx, [edi] // DestCROffset
        mov edx, [edi+4] // Width
        mov esi, [edi+8] // Height
        mov edi, [edi+12] // DestStartPtr
        add edi, 3
        cld
@loop1:
        mov ecx, edx
@loop2:
        stosb // store Alpha
        add edi, 3

        dec ecx
        jnz @loop2

        add edi, ebx
        dec esi
        jnz @loop1

@Exit:
        pop ebx
        pop esi
        pop edi
end;


procedure Fill_Mask(AParams: PRectParams; Color, Mask: LongWord);
var Stack: Pointer;
    DestCROffset: LongWord;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        and edx, ecx // apply mask to color
        not ecx // reverse the mask
        mov esp, ecx // esp <- reversed mask

        mov ebx, [edi]
        mov DestCROffset, ebx // DestCROffset
        mov ebx, [edi+4] // Width
        mov esi, [edi+8] // Height
        mov edi, [edi+12] // DestStartPtr
        cld
@loop1:
        mov ecx, ebx
@loop2:
        mov eax, [edi]
        and eax, esp // apply reversed mask to colour
        or eax, edx // combine the two parts of the result color

        stosd // store $ARGB

        dec ecx
        jnz @loop2

        add edi, DestCROffset
        dec esi
        jnz @loop1

@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


//##############################################################################
//##                              add functions                               ##
//##############################################################################

procedure Add_AlphaColor(AParams: PRectParams; Color: LongWord);
var Stack: Pointer;
    DestCROffset : Longword;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, edx // low Color bytes(bl = B, bh = G)
        shr edx, 16 // high Color bytes (dl = R, dh = A)

        mov esi, [edi]
        mov DestCROffset, esi // DestCROffset
        mov esp, [edi+4] // Width
        mov esi, [edi+8] // Height
        mov edi, [edi+12] // DestStartPtr
        cld
@loop:
        mov ecx, esp

// for each byte (B, G, R, A) add the Color component
// if result exceeds 255 then force 255
@blue:
        mov ax, [edi] // ah = G, al = B
        add al, bl
        jnc @green
        mov al, 255
@green:
        add ah, bh
        jnc @red
        mov ah, 255
@red:
        stosw

        mov ax, [edi] // ah = A, al = R
        add al, dl
        jnc @alpha
        mov al, 255
@alpha:
        add ah, dh
        jnc @next
        mov aH, 255
@next:
        stosw

        dec ecx
        jnz @blue

        add edi, DestCROffset
        dec esi
        jnz @loop

@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Add_Color(AParams: PRectParams; Color: LongWord);
var Stack: Pointer;
    DestCROffset : Longword;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, edx // low Color bytes(bl = B, bh = G)
        shr edx, 16 // high Color bytes (dl = R, dh = A)

        mov esi, [edi]
        mov DestCROffset, esi // DestCROffset
        mov esp, [edi+4] // Width
        mov esi, [edi+8] // Height
        mov edi, [edi+12] // DestStartPtr
        cld
@loop:
        mov ecx, esp

// for each byte (B, G, R) add the Color component
// if result exceeds 255 then force 255
@blue:
        mov ax, [edi] // ah = G, al = B
        add al, bl
        jnc @green
        mov al, 255
@green:
        add ah, bh
        jnc @red
        mov ah, 255
@red:
        stosw

        mov ax, [edi] // ah = A, al = R
        add al, dl
        jnc @next
        mov al, 255
@next:
        stosw

        dec ecx
        jnz @blue

        add edi, DestCROffset
        dec esi
        jnz @loop

@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Add_Alpha(AParams: PRectParams; Color: LongWord);
var Stack: Pointer;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        shr edx, 16 // high Color bytes (dl = R, dh = A)

        mov ebx, [edi] // DestCROffset
        mov esp, [edi+4] // Width
        mov esi, [edi+8] // Height
        mov edi, [edi+12] // DestStartPtr
        cld

@loop:
        mov ecx, esp

// for the alpha byte add the Color alpha component
// if result exceeds 255 then force 255
@alpha:
        add edi, 3

        mov al, [edi] // al = A
        add al, dh
        jnc @next
        mov al, 255
@next:
        stosb

        dec ecx
        jnz @alpha

        add edi, ebx
        dec esi
        jnz @loop

@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;

//##############################################################################
//##                           substract functions                            ##
//##############################################################################

procedure Substract_AlphaColor(AParams: PRectParams; Color: LongWord);
var Stack: Pointer;
    DestCROffset : Longword;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, edx // low Color bytes(bl = B, bh = G)
        shr edx, 16 // high Color bytes (dl = R, dh = A)

        mov esi, [edi]
        mov DestCROffset, esi // DestCROffset
        mov esp, [edi+4] // Width
        mov esi, [edi+8] // Height
        mov edi, [edi+12] // DestStartPtr
        cld
@loop:
        mov ecx, esp

// for each byte (B, G, R, A) substract the Color component
// if result is negative then force 0
@blue:
        mov ax, [edi] // ah = G, al = B
        sub al, bl
        jnc @green
        xor al, al
@green:
        sub ah, bh
        jnc @red
        xor ah, ah
@red:
        stosw

        mov ax, [edi] // ah = A, al = R
        sub al, dl
        jnc @alpha
        xor al, al
@alpha:
        sub ah, dh
        jnc @next
        xor ah, ah
@next:
        stosw

        dec ecx
        jnz @blue

        add edi, DestCROffset
        dec esi
        jnz @loop

@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Substract_Color(AParams: PRectParams; Color: LongWord);
var Stack: Pointer;
    DestCROffset : Longword;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        mov ebx, edx // low Color bytes(bl = B, bh = G)
        shr edx, 16 // high Color bytes (dl = R, dh = A)

        mov esi, [edi]
        mov DestCROffset, esi // DestCROffset
        mov esp, [edi+4] // Width
        mov esi, [edi+8] // Height
        mov edi, [edi+12] // DestStartPtr
        cld
@loop:
        mov ecx, esp

// for each byte (B, G, R) substract the Color component
// if result is negative then force 0
@blue:
        mov ax, [edi] // ah = G, al = B
        sub al, bl
        jnc @green
        xor al, al
@green:
        sub ah, bh
        jnc @red
        xor ah, ah
@red:
        stosw

        mov ax, [edi] // ah = A, al = R
        sub al, dl
        jnc @next
        xor al, al
@next:
        stosw

        dec ecx
        jnz @blue

        add edi, DestCROffset
        dec esi
        jnz @loop

@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;


procedure Substract_Alpha(AParams: PRectParams; Color: LongWord);
var Stack: Pointer;
asm
        push edi
        push esi
        push ebx
        mov Stack, esp

@Start:
        mov edi, eax // Params

        shr edx, 16 // high Color bytes (dl = R, dh = A)

        mov ebx, [edi] // DestCROffset
        mov esp, [edi+4] // Width
        mov esi, [edi+8] // Height
        mov edi, [edi+12] // DestStartPtr
        cld

@loop:
        mov ecx, esp

// for the alpha byte add the Color alpha component
// if result exceeds 255 then force 255
@alpha:
        add edi, 3

        mov al, [edi] // al = A
        sub al, dh
        jnc @next
        xor al, al
@next:
        stosb

        dec ecx
        jnz @alpha

        add edi, ebx
        dec esi
        jnz @loop

@Exit:
        mov esp, Stack
        pop ebx
        pop esi
        pop edi
end;

//##############################################################################
//##                          alpha bitmap functions                          ##
//##############################################################################

procedure InsertAlpha(PDEnd, PSEnd: Pointer; Size: Integer);
asm
        push edi
        push esi

        mov edi, PDEnd
        mov esi, PSEnd
        mov ecx, Size
        mov al, $FF
        std
@loop:
        stosb // A
        movsb // R
        movsb // G
        movsb // B
        dec ecx
        jnz @loop
        cld   // clearing direction


        pop esi
        pop edi
end;


procedure FillAlpha_RGB(PBuffer, MaskBuffer: Pointer; PSize, Component: Integer);
asm
        push edi
        push esi

        mov edi, eax // PBuffer
        mov esi, edx // MaskBuffer
        cld
        mov eax, Component
        and eax, 3 // keep the 3 least sign. bits
        cmp al, 3 // verifies al to be 0, 1 or 2, and not heigher
        jb @OffsetOK
        mov al, 0
@OffsetOK:
        add esi, eax
//        mov ecx, PSize

@loop:
        // copies alfa values from mask, byte by byte
        add edi, 3
        movsb
        add esi, 2

        dec ecx
        jnz @loop

        pop esi
        pop edi
end;


procedure FillAlpha_Average(PBuffer, MaskBuffer: Pointer; PSize: Integer);
asm
        push edi
        push esi

        mov edi, eax // PBuffer
        mov esi, edx // MaskBuffer
//        mov ecx, PSize
        cld
@loop:
        // copies alfa values from mask, byte by byte

        xor eax, eax
        lodsb
        mov dx, ax // dx <- B
        lodsb
        add dx, ax // dx <- B+G
        lodsb
        add ax, dx // ax <- B+G+R
        mov dl, 3
        div dl // al <- B+G+R DIV 3

        add edi, 3
        stosb

        dec ecx
        jnz @loop

        pop esi
        pop edi
end;

//#############################################################################
//##                                FX functions                             ##
//#############################################################################

//#############################################################################
//##                                other functions                          ##
//#############################################################################

function GetOpaqueLineWidth(var StartPtr: Pointer; MaxWidth: Integer; Alpha: Byte): Integer;
asm
        push edi
        push esi
        push ebx

        mov edi, eax
        mov esi, [edi] // StartPtr
        mov ebx, edx  // clones initial MaxWidth
        mov cl, Alpha // Alpha
@loop:
        lodsw
        lodsw
        cmp ah, cl // cl = Alpha
        jb @exit1
        dec edx
        jnz @loop
        jmp @exit2
@exit1:
        sub esi, 4
@exit2:
        sub ebx, edx // scanned width = initial MaxWidth(ebx) - current MaxWidth(edx)
        mov @Result, ebx
        mov [edi], esi // updated StartPtr

        pop ebx
        pop esi
        pop edi
end;


function BypassTransparence(var StartPtr: Pointer; MaxWidth: Integer; Alpha: Byte): Integer;
asm
        push edi
        push esi
        push ebx

        mov edi, eax
        mov esi, [edi] // StartPtr
        mov ebx, edx  // clones initial MaxWidth
        mov cl, Alpha // Alpha
@loop:
        lodsw
        lodsw
        cmp ah, cl // cl = Alpha
        jae @exit1
        dec edx
        jnz @loop
        jmp @exit2
@exit1:
        sub esi, 4
@exit2:
        sub ebx, edx // scanned width = initial MaxWidth(ebx) - current MaxWidth(edx)
        mov @Result, ebx
        mov [edi], esi // updated StartPtr

        pop ebx
        pop esi
        pop edi
end;




//##############################################################################
//##                                  FOOT                                    ##
//##############################################################################


{ TFoot }




constructor TFoot.Create;
begin
        FRenderMode:= RM_COPY;



        FFootData:= FootManager.AddData(FT_FOOT);

        UpdateBitmapInfo;

        // add the foot to the footmanager list.
        FootManager.FList.Add(Self);
        Inc(FootManager.FListCount);
end;

destructor TFoot.Destroy;
begin
        // remove the foot from the footmanager list.
        FootManager.FList.Remove(Self);
        Dec(FootManager.FListCount);

        FootManager.RemoveData(FFootData, FT_FOOT);



inherited;
end;


function TFoot.GetFootData(ADWordOffset: Integer): Integer;
var P: ^Integer;
begin
        Pointer(P):= Pointer(FFootData);
        Integer(P):= Integer(P) + (ADWordOffset shl 2);
        Result:= P^;
end;


function TFoot.GetFileName: String;
begin
        Result:= FFootData^.FileName;
end;


function TFoot.GetBuffer: Pointer;
begin
        Result:= FFootData^.Buffer;
end;


procedure TFoot.SetBuffer(ABuffer: Pointer);
begin
        FFootData^.Buffer:= ABuffer;
end;


function TFoot.GetEmpty: Boolean;
begin
        Result:= (FFootData^.Width = 0)or(FFootData^.Height = 0);
end;


procedure TFoot.SetEmpty(AEmpty: Boolean);
begin
        if (AEmpty)and(FFootData^.Width <> 0)and(FFootData^.Height <> 0) then
        begin
                // remove current data.
                FootManager.RemoveData(FFootData, FT_FOOT);
                // create a new data structure.
                FFootData:= FootManager.AddData(FT_FOOT);

                UpdateBitmapInfo;
        end;
end;


procedure TFoot.SetWidth(AIndex: Integer; AWidth: Integer);
begin
        if (AWidth <> FFootData^.Width) then
                Resize(AWidth, FFootData^.Height);
end;


procedure TFoot.SetHeight(AIndex: Integer; AHeight: Integer);
begin
        if (AHeight <> FFootData^.Height) then
                Resize(FFootData^.Width, AHeight);
end;


procedure TFoot.SetPixel(x, y: Integer; AAlphaColor: TAlphaColor);
var P: ^LongWord;
begin
        P:= PixelPointer(x, y);
        P^:= AAlphaColor;
end;


function TFoot.GetPixel(x, y: Integer): TAlphaColor;
var P: ^LongWord;
begin
        P:= PixelPointer(x, y);
        Result:= P^;
end;


procedure TFoot.SetPixelColor(x, y: Integer; AColor: LongWord);
var P: ^LongWord;
begin
        P:= PixelPointer(x, y);
        P^:= (P^ and $FF000000) or (AColor and $00FFFFFF);
end;


function TFoot.GetPixelColor(x, y: Integer): LongWord;
var P: ^LongWord;
begin
        P:= PixelPointer(x, y);
        Result:= P^ and $00FFFFFF;
end;


procedure TFoot.SetPixelAlpha(x, y: Integer; AAlpha: Byte);
var P: ^Byte;
begin
        P:= PixelPointer(x, y);
        Integer(P):= Integer(P) + 3;
        P^:= AAlpha;
end;


function TFoot.GetPixelAlpha(x, y: Integer): Byte;
var P: ^Byte;
begin
        P:= PixelPointer(x, y);
        Integer(P):= Integer(P) + 3;
        Result:= P^;
end;


function TFoot.GetCached: Boolean;
begin
        Result:= ((FFootData^.Usage > 1)or(FFootData^.FileName <> ''));
end;


procedure TFoot.SetCached(ACached: Boolean);
var Data: PFootData;
begin
        if (not ACached)and((FFootData^.Usage > 1)or(FFootData^.FileName <> '')) then
        begin
               // create a new data struct but copy the buffer.
               Data:= FootManager.AddData(FT_FOOT);
               HeapCopyByte(Data, FFootData, SizeOf(TFootData) - 8); // don't copy filename and usage.

               GetMem(PFootData(Data)^.Buffer, PFootData(Data)^.ByteSize);
               HeapCopy(PFootData(Data)^.Buffer, PFootData(FFootData)^.Buffer, PFootData(Data)^.Size);

               // remove the data.
               FootManager.RemoveData(FFootData, FT_FOOT);
               FFootData:= Data;
        end;
end;


function TFoot.ProcessRenderer(var ARenderer: TRenderer; var AGlobalAlpha: Byte; var ARenderMode: Integer): Boolean;
var RenderMode: Integer;
    RenderFields: Integer;
    RenderExtentions: Integer;
begin
        Result:= True;
        RenderMode:= ARenderMode and RM_ALL;
        RenderFields:= ARenderMode and RMF_ALL;
        RenderExtentions:= ARenderMode and RMX_ALL;

        if (RenderMode = RM_STORED) then RenderMode:= FRenderMode;
        if (AGlobalAlpha = A_OPAQUE) then RenderMode:= RenderMode and (not (RM_GLOBALALPHA xor RM_COPY));
        if (AGlobalAlpha = A_CLEAR) then Result:= False;


        ARenderMode:= RenderMode or RenderFields or RenderExtentions;


        case RenderFields of
         RMF_NONE: Result:= False;
         //
         RMF_NOCOLOR:
         begin
                case RenderMode of
                 RM_COPY:                     ARenderer:= Renderer_Copy_Alpha;
                 RM_TRANSPARENCE:             ARenderer:= Renderer_Transparence_Alpha;
                 RM_GLOBALALPHA:              ARenderer:= Renderer_GlobalAlpha_Alpha;
                 RM_LOCALALPHA:               ARenderer:= Renderer_LocalAlpha_Alpha;
                 RM_GLOBALALPHA_TRANSPARENCE: ARenderer:= Renderer_GlobalAlpha_Transparence_Alpha;
                 RM_GLOBALALPHA_LOCALALPHA:   ARenderer:= Renderer_CombinedAlpha_Alpha;
                 else Result:= False;
                end;
         end;
         //
         RMF_NOALPHA:
         begin
                case RenderMode of
                 RM_COPY:                     ARenderer:= Renderer_Copy_Color;
                 RM_TRANSPARENCE:             ARenderer:= Renderer_Transparence_Color;
                 RM_GLOBALALPHA:              if (RenderExtentions and RMX_FLAT = 0) then ARenderer:= Renderer_GlobalAlpha_Color
                                              else ARenderer:= Renderer_GlobalAlphaFlat_Color;
                 RM_LOCALALPHA:               if (RenderExtentions and RMX_FLAT = 0) then ARenderer:= Renderer_LocalAlpha_Color
                                              else ARenderer:= Renderer_LocalAlphaFlat_Color;
                 RM_GLOBALALPHA_TRANSPARENCE: if (RenderExtentions and RMX_FLAT = 0) then ARenderer:= Renderer_GlobalAlpha_Transparence_Color
                                              else ARenderer:= Renderer_GlobalAlpha_TransparenceFlat_Color;
                 RM_GLOBALALPHA_LOCALALPHA:   if (RenderExtentions and RMX_FLAT = 0) then ARenderer:= Renderer_CombinedAlpha_Color
                                              else ARenderer:= Renderer_CombinedAlphaFlat_Color;
                 else Result:= False;
                end;
         end;
         //
         else begin
                case RenderMode of
                 RM_COPY:                     ARenderer:= Renderer_Copy_AlphaColor;
                 RM_TRANSPARENCE:             ARenderer:= Renderer_Transparence_AlphaColor;
                 RM_GLOBALALPHA:              if (RenderExtentions and RMX_FLAT = 0) then ARenderer:= Renderer_GlobalAlpha_AlphaColor
                                              else ARenderer:= Renderer_GlobalAlphaFlat_AlphaColor;
                 RM_LOCALALPHA:               if (RenderExtentions and RMX_FLAT = 0) then ARenderer:= Renderer_LocalAlpha_AlphaColor
                                              else ARenderer:= Renderer_LocalAlphaFlat_AlphaColor;
                 RM_GLOBALALPHA_TRANSPARENCE: if (RenderExtentions and RMX_FLAT = 0) then ARenderer:= Renderer_GlobalAlpha_Transparence_AlphaColor
                                              else ARenderer:= Renderer_GlobalAlpha_TransparenceFlat_AlphaColor;
                 RM_GLOBALALPHA_LOCALALPHA:   if (RenderExtentions and RMX_FLAT = 0) then ARenderer:= Renderer_CombinedAlpha_AlphaColor
                                              else ARenderer:= Renderer_CombinedAlphaFlat_AlphaColor;
                 else Result:= False;
                end;
         end;
         //
        end;
end;


function TFoot.ProcessTile(ARenderer: TRenderer; ADest: TFoot; ADestRect: TRect; ASrcRect: TRect; AGlobalAlpha: Byte; ARenderMode: Integer): Boolean;
var ADestTop, ASrcRight, ASrcBottom: Integer;
    AParams: TDualRectParams;
begin
        if (ASrcRect.Left < 0) then ADestRect.Left:= ADestRect.Left - ASrcRect.Left;
        if (ASrcRect.Top < 0) then ADestRect.Top:= ADestRect.Top - ASrcRect.Top;
        Restrict(ASrcRect, NewRect(0, 0, FFootData^.Width, FFootData^.Height));

        if (ADestRect.Left < 0) then ASrcRect.Left:= ASrcRect.Left - ADestRect.Left;
        if (ADestRect.Top < 0) then ASrcRect.Top:= ASrcRect.Top - ADestRect.Top;
        Restrict(ADestRect, NewRect(0, 0, ADest.FFootData^.Width, ADest.FFootData^.Height));


        if (ARenderMode and RMX_TILE <> 0)and(not Empty)and(not ADest.Empty)and
           ((ADestRect.Right - ADestRect.Left > ASrcRect.Right - ASrcRect.Left)or
           (ADestRect.Bottom - ADestRect.Top > ASrcRect.Bottom - ASrcRect.Top)) then
        begin
                Result:= True;
                ADestTop:= ADestRect.Top;
                ASrcRight:= ASrcRect.Right;
                ASrcBottom:= ASrcRect.Bottom;

                while (ADestRect.Left < ADestRect.Right) do
                begin
                        ADestRect.Top:= ADestTop;

                        while (ADestRect.Top < ADestRect.Bottom) do
                        begin
                                ASrcRect.Right:= ASrcRight;
                                ASrcRect.Bottom:= ASrcBottom;

                                with ASrcRect do
                                begin
                                        Restrict(Right, 0, Left + Min(ADestRect.Right, ADest.FFootData^.Width) - ADestRect.Left);
                                        Restrict(Bottom, 0, Top + Min(ADestRect.Bottom, ADest.FFootData^.Height) - ADestRect.Top);
                                end;

                                with AParams do
                                begin
                                        SrcStartPtr:= PixelPointer(ASrcRect.Left, ASrcRect.Top);
                                        DestStartPtr:= ADest.PixelPointer(ADestRect.Left, ADestRect.Top);
                                        Width:= (ASrcRect.Right - ASrcRect.Left);
                                        Height:= (ASrcRect.Bottom - ASrcRect.Top);
                                        SrcCROffset:= FFootData^.ByteWidth - (Width shl 2);
                                        DestCROffset:= ADest.FFootData^.ByteWidth - (Width shl 2);
                                end;

                                ARenderer(@AParams, AGlobalAlpha);

                                Inc(ADestRect.Top, ASrcRect.Bottom - ASrcRect.Top);
                        end;

                        Inc(ADestRect.Left, ASrcRect.Right - ASrcRect.Left);
                end;
        end
        else Result:= False;
end;


function TFoot.ProcessParams(var AParams: TDualRectParams; ADest: TFoot; var ADestRect: TRect; var ASrcRect: TRect): Boolean;
begin
        Result:= True;


        if (Empty)or(ADest.Empty) then Result:= False;
        //
        if (ASrcRect.Left < 0) then ADestRect.Left:= ADestRect.Left - ASrcRect.Left;
        if (ASrcRect.Top < 0) then ADestRect.Top:= ADestRect.Top - ASrcRect.Top;
        Restrict(ASrcRect, NewRect(0, 0, FFootData^.Width, FFootData^.Height));

        if (ADestRect.Left < 0) then ASrcRect.Left:= ASrcRect.Left - ADestRect.Left;
        if (ADestRect.Top < 0) then ASrcRect.Top:= ASrcRect.Top - ADestRect.Top;
        Restrict(ADestRect, NewRect(0, 0, ADest.FFootData^.Width, ADest.FFootData^.Height));

        with ASrcRect do
        begin
                Restrict(Right, 0, Left + Min(ADestRect.Right, ADest.FFootData^.Width) - ADestRect.Left);
                Restrict(Bottom, 0, Top + Min(ADestRect.Bottom, ADest.FFootData^.Height) - ADestRect.Top);
        end;
        //
        if RectEmpty(ASrcRect) then Result:= False;


        with AParams do
        begin
                SrcStartPtr:= PixelPointer(ASrcRect.Left, ASrcRect.Top);
                DestStartPtr:= ADest.PixelPointer(ADestRect.Left, ADestRect.Top);
                Width:= (ASrcRect.Right - ASrcRect.Left);
                Height:= (ASrcRect.Bottom - ASrcRect.Top);
                SrcCROffset:= FFootData^.ByteWidth - (Width shl 2);
                DestCROffset:= ADest.FFootData^.ByteWidth - (Width shl 2);
        end;
end;


function TFoot.ProcessParams(var AParams: TRectParams; var ADestRect: TRect): Boolean;
begin
        Result:= True;


        Restrict(ADestRect, NewRect(0, 0, FFootData^.Width, FFootData^.Height));
        //
        if RectEmpty(ADestRect) then Result:= False;


        with AParams do
        begin
                DestStartPtr:= PixelPointer(ADestRect.Left, ADestRect.Top);
                Width:= (ADestRect.Right - ADestRect.Left);
                Height:= (ADestRect.Bottom - ADestRect.Top);
                DestCROffset:= FFootData^.ByteWidth - (Width shl 2);
        end;
end;


function TFoot.ProcessParams(ADest: HDC; var ADestPos: TPoint; var ASrcRect: TRect): Boolean;
begin
        Result:= True;


        if (Empty)then Result:= False;
        //
        if (ASrcRect.Left < 0) then ADestPos.X:= ADestPos.X - ASrcRect.Left;
        if (ASrcRect.Top < 0) then ADestPos.Y:= ADestPos.Y - ASrcRect.Top;
        Restrict(ASrcRect, NewRect(0, 0, FFootData^.Width, FFootData^.Height));

        if (ADestPos.X < 0) then
        begin
                ASrcRect.Left:= ASrcRect.Left - ADestPos.X;
                ADestPos.X:= 0;
        end;
        if (ADestPos.Y < 0) then
        begin
                ASrcRect.Top:= ASrcRect.Top - ADestPos.Y;
                ADestPos.Y:= 0;
        end;
        //
        if RectEmpty(ASrcRect) then Result:= False;
end;


class function TFoot.LoadBitmap(const AFileName: String; AFoot: TFoot): Boolean;
var AFileStream: TAFileStream;

    Data: PFootData;
    Cached: Boolean;

    FileHeader: TBitmapFileHeader;
    InfoHeader: TBitmapInfoHeader;
    AByteWidth, AWidthDiff: Integer;
    P: Pointer;
    i: Integer;
begin
        // remove the old data in the foot.
        FootManager.RemoveData(AFoot.FFootData, FT_FOOT);
        // retrive a data struct from cache or create a new one.
        Data:= FootManager.AddData(PathComplete(AFileName), FT_FOOT, Cached);

        if (not Cached) then
        begin
                AFileStream:= TAFileStream.Create(AFileName, FM_READ, FM_SHARE_NONE, FM_ACCESS_SEQUENTIAL);
                AFileStream.ReadBuffer(FileHeader, SizeOf(FileHeader));
                AFileStream.ReadBuffer(InfoHeader, SizeOf(InfoHeader));
                AFileStream.Seek(FileHeader.bfOffBits, FM_SEEK_BEGIN);

                // fill the foot data.
                Data^.Width:= InfoHeader.biWidth;
                Data^.Height:= Abs(InfoHeader.biHeight);
                Data^.Size:= Data^.Width * Data^.Height;
                Data^.ByteSize:= Data^.Size shl 2;
                Data^.ByteWidth:= Data^.Width shl 2;

                GetMem(Data^.Buffer, Data^.ByteSize);

                if (Data^.Buffer <> nil) then
                begin
                        // the bitmap is in BGR format so we have Width bytes less.
                        AByteWidth:= Data^.ByteWidth - Data^.Width;
                        // a line from the bitmap is stored in a full number of words.
                        AWidthDiff:= (AByteWidth shr 3) shl 3 + Integer(AByteWidth mod 8 <> 0) shl 3 - AByteWidth;

                        if (InfoHeader.biHeight >= 0) then
                        begin
                                // the extra unused no of bytes at the end of the line.
                                P:= Pointer(Integer(Data^.Buffer) + (AByteWidth*(Data^.Height - 1)));
                                for i:= 1 to Data^.Height do
                                begin
                                        AFileStream.ReadBuffer(P^, AByteWidth); // copies a line from the BMP into the buffer.
                                        P:= Pointer(Integer(P) - AByteWidth); // refreshes the current position.
                                        AFileStream.Seek(AWidthDiff, FM_SEEK_CURRENT); // ignores the extra unused no of bytes at the end of the line.
                                end;
                        end
                        else AFileStream.ReadBuffer(Data^.Buffer^, AByteWidth * Data^.Height);


                        P:= Pointer(Integer(Data^.Buffer) + (AByteWidth * Data^.Height) - 1);
                        // converts the buffer from the format BGR to BGRA format
                        // using alpha values of 255 (full opacity).
                        if (InfoHeader.biBitCount = 24) then InsertAlpha(Pointer(Integer(Data^.Buffer) + Data^.ByteSize - 1), P, Data^.Size);
                end;

                AFileStream.Free;

                Result:= True;
        end
        else Result:= False;

        AFoot.FFootData:= Data;
        AFoot.UpdateBitmapInfo;
end;


class function TFoot.LoadFoot(const AFileName: String; AFoot: TFoot): Boolean;
var AFileStream: TAFileStream;

    Data: PFootData;
    Cached: Boolean;
begin
        // remove the old data in the foot.
        FootManager.RemoveData(AFoot.FFootData, FT_FOOT);
        // retrive a data struct from cache or create a new one.
        Data:= FootManager.AddData(PathComplete(AFileName), FT_FOOT, Cached);

        if (not Cached) then
        begin
                AFileStream:= TAFileStream.Create(AFileName, FM_READ, FM_SHARE_NONE, FM_ACCESS_SEQUENTIAL);
                AFileStream.ReadBuffer(Data^, SizeOf(TFootHeader));


                GetMem(Data^.Buffer, Data^.ByteSize);


                AFileStream.ReadBuffer(Data^.Buffer^, Data^.ByteSize);
                AFileStream.Free;

                Result:= True;
        end
        else Result:= False;

        AFoot.FFootData:= Data;
        AFoot.UpdateBitmapInfo;
end;


class procedure TFoot.SaveBitmap(const AFileName: String; AFoot: TFoot);
var AFileStream: TAFileStream;

    FileHeader: TBitmapFileHeader;
    InfoHeader: TBitmapInfoHeader;
begin
        AFileStream:= TAFileStream.Create(AFileName, FM_WRITE or FM_EMPTY, FM_SHARE_NONE, FM_ACCESS_SEQUENTIAL);

        HeapFillByte(@FileHeader, 0, SizeOf(FileHeader));
        FileHeader.bfType:= 19778;
        FileHeader.bfSize:= SizeOf(FileHeader) + SizeOf(InfoHeader) + AFoot.FFootData^.ByteSize;
        FileHeader.bfOffBits:= SizeOf(FileHeader) + SizeOf(InfoHeader);

        HeapFillByte(@InfoHeader, 0, SizeOf(InfoHeader));
        InfoHeader.biSize:= SizeOf(InfoHeader);
        InfoHeader.biWidth:= AFoot.FFootData^.Width;
        InfoHeader.biHeight:= -AFoot.FFootData^.Height;
        InfoHeader.biPlanes:= 1;
        InfoHeader.biBitCount:= 32;
        InfoHeader.biCompression:= BI_RGB;
        InfoHeader.biSizeImage:= AFoot.FFootData^.ByteSize;

        AFileStream.WriteBuffer(FileHeader, SizeOf(FileHeader));
        AFileStream.WriteBuffer(InfoHeader, SizeOf(InfoHeader));
        AFileStream.WriteBuffer(AFoot.FFootData^.Buffer^, AFoot.FFootData^.ByteSize);

        AFileStream.Free;
end;


class procedure TFoot.SaveFoot(const AFileName: String; AFoot: TFoot);
var AFileStream: TAFileStream;
begin
        AFileStream:= TAFileStream.Create(AFileName, FM_WRITE or FM_EMPTY, FM_SHARE_NONE, FM_ACCESS_SEQUENTIAL);

        AFileStream.WriteBuffer(AFoot.FFootData^, SizeOf(TFootHeader));
        AFileStream.WriteBuffer(AFoot.FFootData^.Buffer^, AFoot.FFootData^.ByteSize);

        AFileStream.Free;
end;


function TFoot.Load(const AFileName: String): Boolean;
var Ext: String;
begin
        if (FileExists(AFileName)) then
        begin
                Ext:= StringUpper(FileExtractExt(AFileName));

                if (Ext = 'BMP') then Result:= TFoot.LoadBitmap(AFileName, Self)
                //
                else if (Ext = 'F') then Result:= TFoot.LoadFoot(AFileName, Self)
                //
                else Result:= False;
        end
        else Result:= False;
end;


function TFoot.Save(const AFileName: String): Boolean;
var Ext: String;
begin
        Ext:= StringUpper(FileExtractExt(AFileName));
        Result:= True;

        if (Ext = 'BMP') then TFoot.SaveBitmap(AFileName, Self)
        //
        else if (Ext = 'F') then TFoot.SaveFoot(AFileName, Self)
        //
        else Result:= False;
end;


function TFoot.LoadMask(const AFileName: String; AMode: Integer; AllInstance: Boolean = False): Boolean;
var AFileStream: TAFileStream;

    FileHeader: TBitmapFileHeader;
    InfoHeader: TBitmapInfoHeader;
    AByteWidth, AWidthDiff: Integer;
    P: Pointer;
    i: Integer;

    MaskBuffer: Pointer;
begin
        if FileExists(AFileName) then
        begin
                AFileStream:= TAFileStream.Create(AFileName, FM_READ, FM_SHARE_NONE, FM_ACCESS_SEQUENTIAL);
                AFileStream.ReadBuffer(FileHeader, SizeOf(FileHeader));
                AFileStream.ReadBuffer(InfoHeader, SizeOf(InfoHeader));
                AFileStream.Seek(FileHeader.bfOffBits, FM_SEEK_BEGIN);

                if (InfoHeader.biWidth = FFootData^.Width)and(InfoHeader.biHeight = FFootData^.Height) then
                begin
                        if (not AllInstance) then SetCached(False);


                        // the bitmap is in BGR format so we have Width bytes less.
                        AByteWidth:= (InfoHeader.biWidth shl 2) - InfoHeader.biWidth;
                        // a line from the bitmap is stored in a full number of words.
                        AWidthDiff:= (((AByteWidth shl 3 + 31) shr 5) shl 2) - AByteWidth;

                        GetMem(MaskBuffer, AByteWidth * InfoHeader.biHeight);

                        if (InfoHeader.biHeight >= 0) then
                        begin
                                // the extra unused no of bytes at the end of the line.
                                P:= Pointer(Integer(MaskBuffer) + (AByteWidth*(Data^.Height - 1)));
                                for i:= 1 to InfoHeader.biHeight do
                                begin
                                        AFileStream.ReadBuffer(P^, AByteWidth); // copies a line from the BMP into the buffer.
                                        P:= Pointer(Integer(P) - AByteWidth); // refreshes the current position.
                                        AFileStream.Seek(AWidthDiff, FM_SEEK_CURRENT); // ignores the extra unused no of bytes at the end of the line.
                                end;
                        end
                        else AFileStream.ReadBuffer(MaskBuffer^, AByteWidth * Abs(InfoHeader.biHeight));

                        Result:= True;
                        case AMode of
                         AM_AVERAGE: FillAlpha_Average(FFootData^.Buffer, MaskBuffer, InfoHeader.biWidth * InfoHeader.biHeight);
                         //
                         AM_RED,
                         AM_GREEN,
                         AM_BLUE: FillAlpha_RGB(FFootData^.Buffer, MaskBuffer, InfoHeader.biWidth * InfoHeader.biHeight, AMode);
                         //
                         else Result:= False;
                         //
                        end;

                        FreeMem(MaskBuffer);
                end
                else Result:= False;

                AFileStream.Free;
        end
        else Result:= False;
end;


function TFoot.Load(AFoot: TFoot; CloneBuffer: Boolean; AllInstance: Boolean = False): Boolean;
begin
        if (AFoot <> nil) then
        begin
                if (not AllInstance)and((FFootData^.Usage > 1)or(FFootData^.FileName <> '')) then
                begin
                        // remove current data.
                        FootManager.RemoveData(FFootData, FT_FOOT);
                        // create a new data structure.
                        FFootData:= FootManager.AddData(FT_FOOT);
                end;


                if (not CloneBuffer) then
                begin
                        // copy the buffer data but not the buffer.
                        HeapCopyByte(FFootData, AFoot.FFootData, SizeOf(TFootData) - 12); // don't copy buffer, filename, usage.

                        FreeMem(FFootData^.Buffer);
                        FFootData^.Buffer:= AFoot.FFootData^.Buffer;
                end
                else begin
                        // remove current data.
                        FootManager.RemoveData(FFootData, FT_FOOT);
                        // clone the afoot data.
                        FFootData:= FootManager.AddData(AFoot.FFootData, FT_FOOT);
                end;

                Result:= True;
        end
        else Result:= False;
end;


function TFoot.Load(ATileFoot: TTileFoot; ATileIndex: Integer; CloneBuffer: Boolean; AllInstance: Boolean = False): Boolean;
begin
        if (ATileFoot <> nil) then
        begin
                Result:= Load(ATileFoot.FTileFootData^.Buffer[ATileIndex],
                              ATileFoot.FTileFootData^.Width[ATileIndex],
                              ATileFoot.FTileFootData^.Height[ATileIndex],
                              CloneBuffer, AllInstance);
        end
        else Result:= False;
end;


function TFoot.Load(ABuffer: Pointer; AWidth, AHeight: Integer; CloneBuffer: Boolean; AllInstance: Boolean = False): Boolean;
begin
        if (not AllInstance)and((FFootData^.Usage > 1)or(FFootData^.FileName <> '')) then
        begin
                // remove current data.
                FootManager.RemoveData(FFootData, FT_FOOT);
                // create a new data structure.
                FFootData:= FootManager.AddData(FT_FOOT);
        end;


        FFootData^.Width:= AWidth;
        FFootData^.Height:= AHeight;

        FFootData^.Size:= FFootData^.Width * FFootData^.Height;
        FFootData^.ByteSize:= FFootData^.Size shl 2;
        FFootData^.ByteWidth:= FFootData^.Width shl 2;

        if (not CloneBuffer) then
        begin
                FreeMem(FFootData^.Buffer);
                FFootData^.Buffer:= ABuffer;
        end
        else begin
                ReAllocMem(FFootData^.Buffer, FFootData^.ByteSize);
                HeapCopyByte(FFootData^.Buffer, ABuffer, FFootData^.ByteSize);
        end;

        Result:= True;
end;


procedure TFoot.Render(ADest: TFoot; AGlobalAlpha: Byte = A_OPAQUE; ARenderMode: Integer = RM_STORED; AllInstance: Boolean = False);
var ARenderer: TRenderer;
    AParams: TDualRectParams;
    ADestRect, ASrcRect: TRect;
begin
        if (not AllInstance) then ADest.SetCached(False);

        ADestRect:= NewRect(0, 0, ADest.FFootData^.Width, ADest.FFootData^.Height);
        ASrcRect:= NewRect(0, 0, FFootData^.Width, FFootData^.Height);
        if (not ProcessRenderer(ARenderer, AGlobalAlpha, ARenderMode)) then Exit;
        if (ProcessTile(ARenderer, ADest, ADestRect, ASrcRect, AGlobalAlpha, ARenderMode)) then Exit;
        if (not ProcessParams(AParams, ADest, ADestRect, ASrcRect)) then Exit;

        ARenderer(@AParams, AGlobalAlpha);
end;


procedure TFoot.Render(ADest: TFoot; ADestPos: TPoint; AGlobalAlpha: Byte = A_OPAQUE; ARenderMode: Integer = RM_STORED; AllInstance: Boolean = False);
var ARenderer: TRenderer;
    AParams: TDualRectParams;
    ADestRect, ASrcRect: TRect;
begin
        if (not AllInstance) then ADest.SetCached(False);

        ADestRect:= NewRect(ADestPos.X, ADestPos.Y, ADest.FFootData^.Width, ADest.FFootData^.Height);
        ASrcRect:= NewRect(0, 0, FFootData^.Width, FFootData^.Height);
        if (not ProcessRenderer(ARenderer, AGlobalAlpha, ARenderMode)) then Exit;
        if (ProcessTile(ARenderer, ADest, ADestRect, ASrcRect, AGlobalAlpha, ARenderMode)) then Exit;
        if (not ProcessParams(AParams, ADest, ADestRect, ASrcRect)) then Exit;

        ARenderer(@AParams, AGlobalAlpha);
end;


procedure TFoot.Render(ADest: TFoot; ADestPos: TPoint; ASrcRect: TRect; AGlobalAlpha: Byte = A_OPAQUE; ARenderMode: Integer = RM_STORED; AllInstance: Boolean = False);
var ARenderer: TRenderer;
    AParams: TDualRectParams;
    ADestRect: TRect;
begin
        if (not AllInstance) then ADest.SetCached(False);

        ADestRect:= NewRect(ADestPos.X, ADestPos.Y, ADest.FFootData^.Width, ADest.FFootData^.Height);
        if (not ProcessRenderer(ARenderer, AGlobalAlpha, ARenderMode)) then Exit;
        if (ProcessTile(ARenderer, ADest, ADestRect, ASrcRect, AGlobalAlpha, ARenderMode)) then Exit;
        if (not ProcessParams(AParams, ADest, ADestRect, ASrcRect)) then Exit;

        ARenderer(@AParams, AGlobalAlpha);
end;


procedure TFoot.Render(ADest: TFoot; ADestRect: TRect; AGlobalAlpha: Byte = A_OPAQUE; ARenderMode: Integer = RM_STORED; AllInstance: Boolean = False);
var ARenderer: TRenderer;
    AParams: TDualRectParams;
    ASrcRect: TRect;
begin
        if (not AllInstance) then ADest.SetCached(False);

        ASrcRect:= NewRect(0, 0, FFootData^.Width, FFootData^.Height);
        if (not ProcessRenderer(ARenderer, AGlobalAlpha, ARenderMode)) then Exit;
        if (ProcessTile(ARenderer, ADest, ADestRect, ASrcRect, AGlobalAlpha, ARenderMode)) then Exit;
        if (not ProcessParams(AParams, ADest, ADestRect, ASrcRect)) then Exit;

        ARenderer(@AParams, AGlobalAlpha);
end;


procedure TFoot.Render(ADest: TFoot; ADestRect: TRect; ASrcRect: TRect; AGlobalAlpha: Byte = A_OPAQUE; ARenderMode: Integer = RM_STORED; AllInstance: Boolean = False);
var ARenderer: TRenderer;
    AParams: TDualRectParams;
begin
        if (not AllInstance) then ADest.SetCached(False);

        if (not ProcessRenderer(ARenderer, AGlobalAlpha, ARenderMode)) then Exit;
        if (ProcessTile(ARenderer, ADest, ADestRect, ASrcRect, AGlobalAlpha, ARenderMode)) then Exit;
        if (not ProcessParams(AParams, ADest, ADestRect, ASrcRect)) then Exit;

        ARenderer(@AParams, AGlobalAlpha);
end;


procedure TFoot.Render(DC: HDC; FROP: Integer = SRCCOPY);
var ASrcRect: TRect;
    ADestPos: TPoint;
begin
        ASrcRect:= NewRect(0, 0, FFootData^.Width, FFootData^.Height);
        ADestPos:= NewPoint(0, 0);
        if (not ProcessParams(DC, ADestPos, ASrcRect)) then Exit;


        StretchDIBits(DC, ADestPos.X, ADestPos.Y, (ASrcRect.Right - ASrcRect.Left), (ASrcRect.Bottom - ASrcRect.Top), ASrcRect.Left, FFootData^.Height - ASrcRect.Bottom,
                      (ASrcRect.Right - ASrcRect.Left), (ASrcRect.Bottom - ASrcRect.Top), FFootData^.Buffer, FBitmapInfo,
                      DIB_RGB_COLORS, FROP);
end;


procedure TFoot.Render(DC: HDC; ADestPos: TPoint; FROP: Integer = SRCCOPY);
var ASrcRect: TRect;
begin
        ASrcRect:= NewRect(0, 0, FFootData^.Width, FFootData^.Height);
        if (not ProcessParams(DC, ADestPos, ASrcRect)) then Exit;


        StretchDIBits(DC, ADestPos.X, ADestPos.Y, (ASrcRect.Right - ASrcRect.Left), (ASrcRect.Bottom - ASrcRect.Top), ASrcRect.Left, FFootData^.Height - ASrcRect.Bottom,
                      (ASrcRect.Right - ASrcRect.Left), (ASrcRect.Bottom - ASrcRect.Top), FFootData^.Buffer, FBitmapInfo,
                      DIB_RGB_COLORS, FROP);
end;


procedure TFoot.Render(DC: HDC; ADestPos: TPoint; ASrcRect: TRect; FROP: Integer = SRCCOPY);
begin
        if (not ProcessParams(DC, ADestPos, ASrcRect)) then Exit;


        StretchDIBits(DC, ADestPos.X, ADestPos.Y, (ASrcRect.Right - ASrcRect.Left), (ASrcRect.Bottom - ASrcRect.Top), ASrcRect.Left, FFootData^.Height - ASrcRect.Bottom,
                      (ASrcRect.Right - ASrcRect.Left), (ASrcRect.Bottom - ASrcRect.Top), FFootData^.Buffer, FBitmapInfo,
                      DIB_RGB_COLORS, FROP);
end;


procedure TFoot.Enable(AFlag: Integer);
begin
        FRenderMode:= FRenderMode or AFlag;
end;


procedure TFoot.Disable(AFlag: Integer);
begin
        FRenderMode:= FRenderMode and (not AFlag);
end;


function TFoot.PixelPointer(x, y: Integer): Pointer;
begin
        if (PointInRect(x, y, 0, 0, FFootData^.Width, FFootData^.Height))and(FFootData^.Buffer <> nil) then
                Integer(Result):= Integer(FFootData^.Buffer) + (y * FFootData^.ByteWidth) + (x shl 2)
        else Result:= nil;
end;

procedure TFoot.Resize(AWidth, AHeight: Integer; AllInstance: Boolean = False);
begin
        Restrict(AWidth, 0, MaxInt);
        Restrict(AHeight, 0, MaxInt);

        if (AWidth <> FFootData^.Width)or(AHeight <> FFootData^.Height) then
        begin
                if (not AllInstance)and((FFootData^.Usage > 1)or(FFootData^.FileName <> '')) then
                begin
                        // remove current data.
                        FootManager.RemoveData(FFootData, FT_FOOT);
                        // create a new data structure.
                        FFootData:= FootManager.AddData(FT_FOOT);


                        FFootData^.Width:= AWidth;
                        FFootData^.Height:= AHeight;

                        FFootData^.Size:= FFootData^.Width * FFootData^.Height;
                        FFootData^.ByteSize:= FFootData^.Size shl 2;
                        FFootData^.ByteWidth:= FFootData^.Width shl 2;

                        GetMem(FFootData^.Buffer, FFootData^.ByteSize);
                end
                else begin
                        FFootData^.Width:= AWidth;
                        FFootData^.Height:= AHeight;

                        FFootData^.Size:= FFootData^.Width * FFootData^.Height;
                        FFootData^.ByteSize:= FFootData^.Size shl 2;
                        FFootData^.ByteWidth:= FFootData^.Width shl 2;

                        ReallocMem(FFootData^.Buffer, FFootData^.ByteSize);
                end;

                UpdateBitmapInfo;
                if (Self is TTileFoot) then TTileFoot(Self).UpdateBuffer;
        end;
end;


procedure TFoot.UpdateBitmapInfo;
begin
        // set some info for DC blitting.
        with FBitmapInfo.bmiHeader do
        begin
                biSize:= 40;
                biWidth:= FFootData^.Width;
                biHeight:= -FFootData^.Height;
                biPlanes:= 1;
                biBitCount:= 32;
                biCompression:= BI_RGB;
                biSizeImage:= FFootData^.ByteSize;
                biXPelsPerMeter:= 0;
                biYPelsPerMeter:= 0;
                biClrUsed:= 0;
                biClrImportant:= 0;
        end;
end;


procedure TFoot.ProcessOpacity(ARectList: TARectList; AAlphaMin: Byte);
begin
        ProcessOpacity(ARectList, NewRect(0, 0, FFootData^.Width, FFootData^.Height), AAlphaMin);
end;


procedure TFoot.ProcessOpacity(ARectList: TARectList; ARect: TRect; AAlphaMin: Byte);
var PtrPos: Pointer;
    H, Left, Right: Integer;
    Rect: TRect;
begin
        Restrict(ARect, NewRect(0, 0, FFootData^.Width, FFootData^.Height));
        ARectList.Clear;


        if (not RectEmpty(ARect)) then
        begin
                PtrPos:= FFootData.Buffer;
                Inc(Integer(PtrPos), (FFootData^.Width * ARect.Top + ARect.Left)*4);

                for H:= ARect.Top to ARect.Bottom - 1 do
                begin
                        Left:= ARect.Left + BypassTransparence(PtrPos, ARect.Right - ARect.Left, AAlphaMin);

                        while (Left < ARect.Right) do
                        begin
                                Right:= Left + GetOpaqueLineWidth(PtrPos, ARect.Right - Left, AAlphaMin);

                                if (ARectList.Count > 0) then Rect:= ARectList.Items[ARectList.Count - 1];
                                if (ARectList.Count > 0)and(Rect.Left = Left)and(Rect.Right = Right)and(Rect.Bottom = H) then
                                begin
                                        ARectList.Delete(ARectList.Count - 1);
                                        Rect.Bottom:= H + 1;
                                end
                                else begin
                                        Rect.Left:= Left;
                                        Rect.Right:= Right;
                                        Rect.Top:= H;
                                        Rect.Bottom:= H + 1;
                                end;
                                ARectList.Add(Rect);

                                if (Right < ARect.Right) then Left:= Right + BypassTransparence(PtrPos, ARect.Right - Right, AAlphaMin)
                                else Left:= Right;
                        end;

                        Inc(Integer(PtrPos), (FFootData^.Width - ARect.Right + ARect.Left) * SizeOf(Pointer));
                end;
        end;
end;


procedure TFoot.ApplyAlpha(AValue: Byte; ADestRect: TRect; ASearchValue, ASearchMask: LongWord; AllInstance: Boolean = False);
begin
        Manipulate(MOP_FILL, AValue shl 6, M_ALPHA, ADestRect, AllInstance);
end;


procedure TFoot.ApplyTransparence(ADestRect: TRect; ASearchValue, ASearchMask: LongWord; AllInstance: Boolean = False);
begin
        Manipulate(MOP_FILL, 0, M_ALPHA, ADestRect, AllInstance);
end;


procedure TFoot.ApplyFX(AFX: Integer; AParameter: Pointer; AllInstance: Boolean = False);
begin
        if (not AllInstance) then SetCached(False);
end;


procedure TFoot.Manipulate(AOperation: Integer; AValue, AMask: LongWord; AllInstance: Boolean = False);
begin
        Manipulate(AOperation, AValue, AMask, NewRect(0, 0, FFootData^.Width, FFootData^.Height), AllInstance);
end;


procedure TFoot.Manipulate(AOperation: Integer; AValue, AMask: LongWord; ADestRect: TRect; AllInstance: Boolean = False);
var AParams: TRectParams;
begin
        if (not AllInstance) then SetCached(False);

        if (not ProcessParams(AParams, ADestRect)) then Exit;

        case AOperation of
         MOP_FILL:
         begin
                case AMask of
                  M_ALPHACOLOR: Fill_AlphaColor(@AParams, AValue);
                  M_COLOR: Fill_Color(@AParams, AValue);
                  M_ALPHA: Fill_Alpha(@AParams, AValue);
                  //
                  else Fill_Mask(@AParams, AValue, AMask);
                end;
         end;
         //
         MOP_ADD:
         begin
                case AMask of
                  M_ALPHACOLOR: Add_AlphaColor(@AParams, AValue);
                  M_COLOR: Add_Color(@AParams, AValue);
                  M_ALPHA: Add_Alpha(@AParams, AValue);
                end;
         end;
         //
         MOP_SUBSTRACT:
         begin
                case AMask of
                  M_ALPHACOLOR: Substract_AlphaColor(@AParams, AValue);
                  M_COLOR: Substract_Color(@AParams, AValue);
                  M_ALPHA: Substract_Alpha(@AParams, AValue);
                end;
         end;
         //
        end;
end;


procedure TFoot.Manipulate(AOperation: Integer; AValue, AValueMask: LongWord; ASearchValue, ASearchMask: LongWord; AllInstance: Boolean = False);
begin
        Manipulate(AOperation, AValue, AValueMask, NewRect(0, 0, FFootData^.Width, FFootData^.Height), ASearchValue, ASearchMask, AllInstance);
end;


procedure TFoot.Manipulate(AOperation: Integer; AValue, AValueMask: LongWord; ADestRect: TRect; ASearchValue, ASearchMask: LongWord; AllInstance: Boolean = False);
var AParams: TRectParams;
begin
        if (not AllInstance) then SetCached(False);

        if (not ProcessParams(AParams, ADestRect)) then Exit;
end;




//##############################################################################
//##                                TILEFOOT                                  ##
//##############################################################################


{ TTileFoot }




constructor TTileFoot.Create;
begin
        FRenderMode:= RM_COPY;
        FLocalAlpha:= False;



        FFootData:= FootManager.AddData(FT_FOOT);
        FTileFootData:= FootManager.AddData(FT_TILEFOOT);

        UpdateBitmapInfo;

        // add the foot to the footmanager list.
        FootManager.FList.Add(Self);
        Inc(FootManager.FListCount);
end;

destructor TTileFoot.Destroy;
begin
        // add the foot to the footmanager list.
        FootManager.FList.Remove(Self);
        Dec(FootManager.FListCount);

        FootManager.RemoveData(FFootData, FT_FOOT);
        FootManager.RemoveData(FTileFootData, FT_TILEFOOT);



inherited;
end;


function TTileFoot.GetTileFootData(ADWordOffset: Integer): Integer;
var P: ^Integer;
begin
        Pointer(P):= Pointer(FTileFootData);
        Integer(P):= Integer(P) + (ADWordOffset shl 2);
        Result:= P^;
end;


function TTileFoot.GetTileFileName: String;
begin
        Result:= FTileFootData^.FileName;
end;


function TTileFoot.GetTileEmpty: Boolean;
begin
        Result:= ((FTileFootData^.Width[TID_LEFT_TOP] = 0)or(FTileFootData^.Height[TID_LEFT_TOP] = 0))and
                 ((FTileFootData^.Width[TID_RIGHT_BOTTOM] = 0)or(FTileFootData^.Height[TID_RIGHT_BOTTOM] = 0))and
                 ((FTileFootData^.Width[TID_CENTER] = 0)or(FTileFootData^.Height[TID_CENTER] = 0));
end;


procedure TTileFoot.SetTileEmpty(AEmpty: Boolean);
begin
        if (AEmpty)and(not GetTileEmpty) then
        begin
                // remove current data.
                FootManager.RemoveData(FTileFootData, FT_TILEFOOT);

                // create a new data structure.
                FTileFootData:= FootManager.AddData(FT_TILEFOOT);
        end;
end;


function TTileFoot.GetTileCached: Boolean;
begin
        Result:= (FTileFootData^.Usage > 1)or(FTileFootData^.FileName <> '');
end;


procedure TTileFoot.SetTileCached(ACached: Boolean);
var Data: PTileFootData;
    i: Integer;
begin
        if (not ACached)and((FTileFootData^.Usage > 1)or(FTileFootData^.FileName <> '')) then
        begin
                // create a new data struct but copy the buffers..
                Data:= FootManager.AddData(FT_TILEFOOT);
                HeapCopyByte(Data, FTileFootData, SizeOf(TTileFootData) - 8); // don't copy filename and usage.

                for i:= 0 to 8 do
                begin
                        GetMem(PTileFootData(Data)^.Buffer[i], PTileFootData(Data)^.ByteSize[i]);
                        HeapCopy(PTileFootData(Data)^.Buffer[i], PTileFootData(FTileFootData)^.Buffer[i], PTileFootData(Data)^.Size[i]);
                end;

                // remove the old data.
                FootManager.RemoveData(FTileFootData, FT_TILEFOOT);
                FTileFootData:= Data;
        end;
end;


function TTileFoot.GetTileSize(ATileIndex: Integer): Integer;
begin
        Result:= FTileFootData^.Size[ATileIndex];
end;


function TTileFoot.GetTileByteSize(ATileIndex: Integer): Integer;
begin
        Result:= FTileFootData^.ByteSize[ATileIndex];
end;


function TTileFoot.GetTileByteWidth(ATileIndex: Integer): Integer;
begin
        Result:= FTileFootData^.ByteWidth[ATileIndex];
end;


function TTileFoot.GetTileWidth(ATileIndex: Integer): Integer;
begin
        Result:= FTileFootData^.Width[ATileIndex];
end;


function TTileFoot.GetTileHeight(ATileIndex: Integer): Integer;
begin
        Result:= FTileFootData^.Height[ATileIndex];
end;


function TTileFoot.GetTileBuffer(ATileIndex: Integer): Pointer;
begin
        Result:= FTileFootData^.Buffer[ATileIndex];
end;

procedure TTileFoot.SetTileBuffer(ATileIndex: Integer; ABuffer: Pointer);
begin
        FTileFootData^.Buffer[ATileIndex]:= ABuffer;
end;


procedure TTileFoot.SetTileWidth(ATileIndex: Integer; AWidth: Integer);
begin
        if (AWidth <> FTileFootData^.Width[ATileIndex]) then
                TileResize(ATileIndex, AWidth, FTileFootData^.Height[ATileIndex]);
end;


procedure TTileFoot.SetTileHeight(ATileIndex: Integer; AHeight: Integer);
begin
        if (AHeight <> FTileFootData^.Height[ATileIndex]) then
                TileResize(ATileIndex, FTileFootData^.Width[ATileIndex], AHeight);
end;


procedure TTileFoot.SetLocalAlpha(ALocalAlpha: Boolean);
begin
        if (FLocalAlpha <> ALocalAlpha) then
        begin
                FLocalAlpha:= ALocalAlpha;

                UpdateBuffer;
        end;
end;


class function TTileFoot.LoadTileFoot(const AFileName: String; AFoot: TTileFoot): Boolean;
var AFileStream: TAFileStream;

    Data: PTileFootData;
    Cached: Boolean;

    i: Integer;
begin
        // remove the old data in the tilefoot.
        FootManager.RemoveData(AFoot.FTileFootData, FT_TILEFOOT);
        // retrive a data struct from cache or create a new one.
        Data:= FootManager.AddData(PathComplete(AFileName), FT_TILEFOOT, Cached);

        if (not Cached) then
        begin
                AFileStream:= TAFileStream.Create(AFileName, FM_READ, FM_SHARE_NONE, FM_ACCESS_SEQUENTIAL);
                AFileStream.ReadBuffer(Data^, SizeOf(TTileFootHeader));


                for i:= 0 to 8 do GetMem(Data^.Buffer[i], Data^.ByteSize[i]);


                for i:= 0 to 8 do AFileStream.ReadBuffer(Data^.Buffer[i]^, Data^.ByteSize[i]);
                AFileStream.Free;

                Result:= True;
        end
        else Result:= False;

        AFoot.FTileFootData:= Data;
        AFoot.UpdateBitmapInfo;
        AFoot.UpdateBuffer;
end;


class procedure TTileFoot.SaveTileFoot(const AFileName: String; AFoot: TTileFoot);
var AFileStream: TAFileStream;

    i: Integer;
begin
        AFileStream:= TAFileStream.Create(AFileName, FM_WRITE or FM_EMPTY, FM_SHARE_NONE, FM_ACCESS_SEQUENTIAL);

        AFileStream.WriteBuffer(AFoot.FTileFootData^, SizeOf(TTileFootHeader));
        for i:= 0 to 8 do AFileStream.WriteBuffer(AFoot.FTileFootData^.Buffer[i], AFoot.FTileFootData^.ByteSize[i]);

        AFileStream.Free;
end;


function TTileFoot.Load(const AFileName: String): Boolean;
var Ext: String;
begin
        if (FileExists(AFileName)) then
        begin
                Ext:= StringUpper(FileExtractExt(AFileName));

                if (Ext = 'BMP') then Result:= TFoot.LoadBitmap(AFileName, Self)
                //
                else if (Ext = 'F') then Result:= TFoot.LoadFoot(AFileName, Self)
                //
                else if (Ext = 'TF') then Result:= TTileFoot.LoadTileFoot(AFileName, Self)
                //
                else Result:= False;
        end
        else Result:= False;
end;


function TTileFoot.Save(const AFileName: String): Boolean;
var Ext: String;
begin
        Ext:= StringUpper(FileExtractExt(AFileName));
        Result:= True;

        if (Ext = 'BMP') then TFoot.SaveBitmap(AFileName, Self)
        //
        else if (Ext = 'F') then TFoot.SaveFoot(AFileName, Self)
        //
        else if (Ext = 'TF') then TTileFoot.SaveTileFoot(AFileName, Self)
        //
        else Result:= False;
end;


function TTileFoot.LoadTileMask(const AFileName: String; AMode: Integer; ATileIndex: Integer; AllInstance: Boolean = False): Boolean;
var AFoot: TFoot;
begin
        if FileExists(AFileName) then
        begin
                if (not AllInstance) then SetTileCached(False);


                AFoot:= TFoot.Create;
                AFoot.Load(Self, ATileIndex, True);

                AFoot.LoadMask(AFileName, AMode);
                Result:= True;

                AFoot.Free;
        end
        else Result:= False;
end;


function TTileFoot.LoadTile(const AFileName: String; ATileIndex: Integer; AllInstance: Boolean = False): Boolean;
var AFoot: TFoot;
begin
        if FileExists(AFileName) then
        begin
                AFoot:= TFoot.Create;
                AFoot.Load(AFileName);

                LoadTile(AFoot.FFootData^.Buffer, ATileIndex, AFoot.FFootData^.Width, AFoot.FFootData^.Height, True, AllInstance);
                Result:= True;

                AFoot.Free;
        end
        else Result:= False;
end;


function TTileFoot.LoadTile(AFoot: TFoot; ATileIndex: Integer; CloneBuffer: Boolean; AllInstance: Boolean = False): Boolean;
begin
        if (AFoot <> nil) then
        begin
                if (not AllInstance) then SetTileCached(False);


                FTileFootData^.Width[ATileIndex]:= AFoot.FFootData^.Width;
                FTileFootData^.Height[ATileIndex]:= AFoot.FFootData^.Height;

                FTileFootData^.Size[ATileIndex]:= AFoot.FFootData^.Size;
                FTileFootData^.ByteSize[ATileIndex]:= AFoot.FFootData^.ByteSize;
                FTileFootData^.ByteWidth[ATileIndex]:= AFoot.FFootData^.ByteWidth;

                if (not CloneBuffer) then
                begin
                        FreeMem(FTileFootData^.Buffer[ATileIndex]);
                        FTileFootData^.Buffer[ATileIndex]:= AFoot.FFootData^.Buffer;
                end
                else begin
                        ReAllocMem(FTileFootData^.Buffer[ATileIndex], FTileFootData^.ByteSize[ATileIndex]);
                        HeapCopyByte(FTileFootData^.Buffer[ATileIndex], AFoot.FFootData^.Buffer, FTileFootData^.ByteSize[ATileIndex]);
                end;

                UpdateBuffer;
                Result:= True;
        end
        else Result:= False;
end;


function TTileFoot.LoadTile(ATileFoot: TTileFoot; ATileIndex: Integer; CloneBuffer: Boolean; AllInstance: Boolean = False): Boolean;
begin
        if (ATileFoot <> nil) then
        begin
                if (not AllInstance) then SetTileCached(False);


                FTileFootData^.Width[ATileIndex]:= ATileFoot.FTileFootData^.Width[ATileIndex];
                FTileFootData^.Height[ATileIndex]:= ATileFoot.FTileFootData^.Height[ATileIndex];

                FTileFootData^.Size[ATileIndex]:= ATileFoot.FTileFootData^.Size[ATileIndex];
                FTileFootData^.ByteSize[ATileIndex]:= ATileFoot.FTileFootData^.ByteSize[ATileIndex];
                FTileFootData^.ByteWidth[ATileIndex]:= ATileFoot.FTileFootData^.ByteWidth[ATileIndex];

                if (not CloneBuffer) then
                begin
                        FreeMem(FTileFootData^.Buffer[ATileIndex]);
                        FTileFootData^.Buffer[ATileIndex]:= ATileFoot.FTileFootData^.Buffer[ATileIndex];
                end
                else begin
                        ReAllocMem(FTileFootData^.Buffer[ATileIndex], FTileFootData^.ByteSize[ATileIndex]);
                        HeapCopyByte(FTileFootData^.Buffer[ATileIndex], ATileFoot.FTileFootData^.Buffer[ATileIndex], FTileFootData^.ByteSize[ATileIndex]);
                end;

                UpdateBuffer;
                Result:= True;
        end
        else Result:= False;
end;


function TTileFoot.LoadTile(ATileFoot: TTileFoot; CloneBuffer: Boolean; AllInstance: Boolean = False): Boolean;
var i: Integer;
begin
        if (ATileFoot <> nil) then
        begin
                if (not AllInstance)and((FTileFootData^.Usage > 1)or(FTileFootData^.FileName <> '')) then
                begin
                        // remove current data.
                        FootManager.RemoveData(FTileFootData, FT_TILEFOOT);
                        // create a new data structure.
                        FTileFootData:= FootManager.AddData(FT_TILEFOOT);
                end;


                if (not CloneBuffer) then
                begin
                        // copy the buffer data but not the buffer.
                        HeapCopyByte(FTileFootData, ATileFoot.FTileFootData, SizeOf(TTileFootData) - 40); // don't copy buffers, filename, usage.

                        for i:= 0 to 8 do
                        begin
                                FreeMem(FTileFootData^.Buffer[i]);
                                FTileFootData^.Buffer[i]:= ATileFoot.FTileFootData^.Buffer[i];
                        end;
                end
                else begin
                        // remove current data.
                        FootManager.RemoveData(FTileFootData, FT_TILEFOOT);
                        // clone the atilefoot data.
                        FTileFootData:= FootManager.AddData(ATileFoot.FTileFootData, FT_TILEFOOT);
                end;

                UpdateBuffer;
                Result:= True;
        end
        else Result:= False;
end;


function TTileFoot.LoadTile(ABuffer: Pointer; ATileIndex: Integer; AWidth, AHeight: Integer; CloneBuffer: Boolean; AllInstance: Boolean = False): Boolean;
begin
        if (not AllInstance) then SetTileCached(False);


        FTileFootData^.Width[ATileIndex]:= AWidth;
        FTileFootData^.Height[ATileIndex]:= AHeight;

        FTileFootData^.Size[ATileIndex]:= AWidth * AHeight;
        FTileFootData^.ByteSize[ATileIndex]:= FTileFootData^.Size[ATileIndex] shl 2;
        FTileFootData^.ByteWidth[ATileIndex]:= AWidth shl 2;

        if (not CloneBuffer) then
        begin
                FreeMem(FTileFootData^.Buffer[ATileIndex]);
                FTileFootData^.Buffer[ATileIndex]:= ABuffer;
        end
        else begin
                ReAllocMem(FTileFootData^.Buffer[ATileIndex], FTileFootData^.ByteSize[ATileIndex]);
                HeapCopyByte(FTileFootData^.Buffer[ATileIndex], ABuffer, FTileFootData^.ByteSize[ATileIndex]);
        end;

        UpdateBuffer;
        Result:= True;
end;


procedure TTileFoot.TileResize(ATileIndex: Integer; AWidth, AHeight: Integer; AllInstance: Boolean = False);
begin
        Restrict(AWidth, 0, MaxInt);
        Restrict(AHeight, 0, MaxInt);

        if (AWidth <> FTileFootData^.Width[ATileIndex])or(AHeight <> FTileFootData^.Height[ATileIndex]) then
        begin
                if (not AllInstance) then SetTileCached(False);


                FTileFootData^.Width[ATileIndex]:= AWidth;
                FTileFootData^.Height[ATileIndex]:= AHeight;

                FTileFootData^.Size[ATileIndex]:= FTileFootData^.Width[ATileIndex] * FTileFootData^.Height[ATileIndex];
                FTileFootData^.ByteSize[ATileIndex]:= FTileFootData^.Size[ATileIndex] shl 2;
                FTileFootData^.ByteWidth[ATileIndex]:= FTileFootData^.Width[ATileIndex] shl 2;

                ReallocMem(FTileFootData^.Buffer[ATileIndex], FTileFootData^.ByteSize[ATileIndex]);
        end;
end;


procedure TTileFoot.UpdateBuffer;
var AFoot: TFoot;
    ARenderMode: Integer;
begin
        if (FFootData^.Width <> 0)and(FFootData^.Height <> 0) then
        begin
                AFoot:= TFoot.Create;


                AFoot.Load(Self, TID_CENTER, False, True);
                if (FLocalAlpha) then
                begin
                        ARenderMode:= RM_LOCALALPHA;
                        AFoot.Render(Self, NewRect(0, 0, FFootData^.Width, FFootData^.Height), A_OPAQUE, RM_COPY or RMX_TILE)
                end
                else begin
                        ARenderMode:= RM_COPY;
                        AFoot.Render(Self, NewRect(FTileFootData^.Width[TID_LEFT_TOP], FTileFootData^.Height[TID_LEFT_TOP], FFootData^.Width - FTileFootData^.Width[TID_RIGHT_BOTTOM], FFootData^.Height - FTileFootData^.Height[TID_RIGHT_BOTTOM]), A_OPAQUE, RM_COPY or RMX_TILE)
                end;
                AFoot.Buffer:= nil;


                AFoot.Load(Self, TID_LEFT_TOP, False, True);
                AFoot.Render(Self, A_OPAQUE, ARenderMode);
                AFoot.Buffer:= nil;

                AFoot.Load(Self, TID_RIGHT_TOP, False, True);
                AFoot.Render(Self, NewPoint(FFootData^.Width - FTileFootData^.Width[TID_RIGHT_TOP], 0), A_OPAQUE, ARenderMode);
                AFoot.Buffer:= nil;

                AFoot.Load(Self, TID_LEFT_BOTTOM, False, True);
                AFoot.Render(Self, NewPoint(0, FFootData^.Height - FTileFootData^.Height[TID_LEFT_BOTTOM]), A_OPAQUE, ARenderMode);
                AFoot.Buffer:= nil;

                AFoot.Load(Self, TID_RIGHT_BOTTOM, False, True);
                AFoot.Render(Self, NewPoint(FFootData^.Width - FTileFootData^.Width[TID_RIGHT_BOTTOM], FFootData^.Height - FTileFootData^.Height[TID_RIGHT_BOTTOM]), A_OPAQUE, ARenderMode);
                AFoot.Buffer:= nil;


                AFoot.Load(Self, TID_LEFT, False, True);
                AFoot.Render(Self, NewRect(0, FTileFootData^.Height[TID_LEFT_TOP], FTileFootData^.Width[TID_LEFT], FFootData^.Height - FTileFootData^.Height[TID_LEFT_BOTTOM]), A_OPAQUE, ARenderMode or RMX_TILE);
                AFoot.Buffer:= nil;

                AFoot.Load(Self, TID_RIGHT, False, True);
                AFoot.Render(Self, NewRect(FFootData^.Width - FTileFootData^.Width[TID_RIGHT], FTileFootData^.Height[TID_RIGHT_TOP], FFootData^.Width, FFootData^.Height - FTileFootData^.Height[TID_RIGHT_BOTTOM]), A_OPAQUE, ARenderMode or RMX_TILE);
                AFoot.Buffer:= nil;

                AFoot.Load(Self, TID_TOP, False, True);
                AFoot.Render(Self, NewRect(FTileFootData^.Width[TID_LEFT_TOP], 0, FFootData^.Width - FTileFootData^.Width[TID_RIGHT_TOP], FTileFootData^.Height[TID_TOP]), A_OPAQUE, ARenderMode or RMX_TILE);
                AFoot.Buffer:= nil;

                AFoot.Load(Self, TID_BOTTOM, False, True);
                AFoot.Render(Self, NewRect(FTileFootData^.Width[TID_LEFT_BOTTOM], FFootData^.Height - FTileFootData^.Height[TID_BOTTOM], FFootData^.Width - FTileFootData^.Width[TID_RIGHT_BOTTOM], FFootData^.Height), A_OPAQUE, ARenderMode or RMX_TILE);
                AFoot.Buffer:= nil;


                AFoot.Free;
        end;
end;




//##############################################################################
//##                              FOOTMANAGER                                 ##
//##############################################################################


{ TFootManager }




constructor TFootManager.Create;
begin
        FCache:= True;
        FReload:= False;



        FFootData:= TAList.Create;
        FFootDataCount:= 0;

        FTileFootData:= TAList.Create;
        FTileFootDataCount:= 0;

        FList:= TAList.Create;
        FListCount:= 0;
end;


destructor TFootManager.Destroy;
begin
        FList.Free;

        // free the data left in the cache (there shouldn't be
        // any unless custom P*FootData manipulation was erronous.

        FFootData.Free;
        FTileFootData.Free;



inherited;
end;


procedure TFootManager.ReloadAll(AllFoot, AllTileFoot: Boolean);
var AFoot: TFoot;
    AReload: Boolean;
    i: Integer;
begin
        AReload:= FReload;
        FReload:= True;

        for i:= 0 to FListCount - 1 do
        begin
                AFoot:= FList.Items[i];

                if (AllFoot)and(AFoot.FFootData^.FileName <> '') then AFoot.Load(AFoot.FFootData^.FileName);
                if (AllTileFoot)and(AFoot is TTileFoot)and(TTileFoot(AFoot).FTileFootData^.FileName <> '') then AFoot.Load(TTileFoot(AFoot).FTileFootData^.FileName);
        end;

        FReload:= AReload;
end;


procedure TFootManager.UncacheAll(AllFoot, AllTileFoot: Boolean);
var AFoot: TFoot;
    i: Integer;
begin
        for i:= 0 to FListCount - 1 do
        begin
                AFoot:= FList.Items[i];

                if (AllFoot) then AFoot.SetCached(False);
                if (AllTileFoot)and(AFoot is TTileFoot) then TTileFoot(AFoot).SetTileCached(False);
        end;
end;


function TFootManager.GetData(AIndex: Integer; AFootType: Integer): Pointer;
begin
        case AFootType of
         FT_FOOT:
         begin
                if (AIndex > -1)and(AIndex < FFootDataCount) then Result:= FFootData.Items[AIndex]
                else begin
                        Result:= nil;

                        (*++++++++++++++*)
                        (**) RaiseException('Getdata index out of bounds.', 'TAFootManager.GetData', Self);
                        (*++++++++++++++*)
                end;
         end;
         //
         FT_TILEFOOT:
         begin
                if (AIndex > -1)and(AIndex < FTileFootDataCount) then Result:= FTileFootData.Items[AIndex]
                else begin
                        Result:= nil;

                        (*++++++++++++++*)
                        (**) RaiseException('Getdata index out of bounds.', 'TAFootManager.GetData', Self);
                        (*++++++++++++++*)
                end;
         end;
         //
         else Result:= nil;
         //
        end
end;


function TFootManager.AddData(const AFileName: String; AFootType: Integer; var ACached: Boolean): Pointer;
var AIndex: Integer;
    i: Integer;
begin
        if (AFileName <> '') then
        begin
                // if cache is enabled then search for a foot with the same filname,
                // otherwise just return the empty struct with usage set to 1.
                if (FCache) then
                begin
                        AIndex:= FindData(AFileName, AFootType);
                        ACached:= (AIndex <> -1);
                end
                else begin
                        AIndex:= -1;
                        ACached:= False;
                end;


                if (ACached) then
                begin
                        case AFootType of
                         FT_FOOT:
                         begin
                                Result:= FFootData.Items[AIndex];
                                Inc(PFootData(Result)^.Usage);

                                // if reload is needed then free the buffer and
                                // act as if the data was not taken from cache.
                                if (FReload) then
                                begin
                                        ACached:= False;
                                        FreeMem(PFootData(Result)^.Buffer);
                                end;
                         end;
                         //
                         FT_TILEFOOT:
                         begin
                                Result:= FTileFootData.Items[AIndex];
                                Inc(PTileFootData(Result)^.Usage);

                                // if reload is needed then free the buffer and
                                // act as if the data was not taken from cache.
                                if (FReload) then
                                begin
                                        ACached:= False;
                                        for i:= 0 to 8 do FreeMem(PTileFootData(Result)^.Buffer[i]);
                                end;
                         end;
                         //
                         else Result:= nil;
                         //
                        end;
                end
                else begin
                        case AFootType of
                         FT_FOOT:
                         begin
                                // create a new struct with usage set to 1
                                // but set the filename also.
                                Result:= AddData(FT_FOOT);
                                PFootData(Result)^.FileName:= AFileName;
                         end;
                         //
                         FT_TILEFOOT:
                         begin
                                // create a new struct with usage set to 1
                                // but set the filename also.
                                Result:= AddData(FT_TILEFOOT);
                                PTileFootData(Result)^.FileName:= AFileName;
                         end;
                         //
                         else Result:= nil;
                         //
                        end;
                end;
        end
        else Result:= nil;
end;


function TFootManager.AddData(AData: Pointer; AFootType: Integer): Pointer;
var i: Integer;
begin
        if (AData <> nil) then
        begin
                case AFootType of
                 FT_FOOT:
                 begin
                        if (not FCache) then
                        begin
                                // create a new data struct but copy the buffer.
                                Result:= AddData(FT_FOOT);
                                HeapCopyByte(Result, AData, SizeOf(TFootData) - 8); // don't copy filename and usage.

                                GetMem(PFootData(Result)^.Buffer, PFootData(Result)^.ByteSize);
                                HeapCopy(PFootData(Result)^.Buffer, PFootData(AData)^.Buffer, PFootData(Result)^.Size);
                        end
                        else begin
                                // just increment the usage.
                                Result:= AData;
                                Inc(PFootData(Result)^.Usage);
                        end;
                 end;
                 //
                 FT_TILEFOOT:
                 begin
                        if (not FCache) then
                        begin
                                // create a new data struct but copy the buffers.
                                Result:= AddData(FT_TILEFOOT);
                                HeapCopyByte(Result, AData, SizeOf(TTileFootData) - 8); // don't copy filename and usage.

                                for i:= 0 to 8 do
                                begin
                                        GetMem(PTileFootData(Result)^.Buffer[i], PTileFootData(Result)^.ByteSize[i]);
                                        HeapCopy(PTileFootData(Result)^.Buffer[i], PTileFootData(AData)^.Buffer[i], PTileFootData(Result)^.Size[i]);
                                end;
                        end
                        else begin
                                // just increment the usage.
                                Result:= AData;
                                Inc(PTileFootData(Result)^.Usage);
                        end;
                 end;
                 //
                 else Result:= nil;
                 //
                end;
        end
        else Result:= nil;
end;


function TFootManager.AddData(AFootType: Integer): Pointer;
begin
        case AFootType of
         FT_FOOT:
         begin
                // create a new data struct and set the usage to 1.
                GetMem(Result, SizeOf(TFootData));
                PFootData(Result)^.Usage:= 1;

                FFootData.Add(Result);
                Inc(FFootDataCount);
         end;
         //
         FT_TILEFOOT:
         begin
                // create a new data struct and set the usage to 1.
                GetMem(Result, SizeOf(TTileFootData));
                PTileFootData(Result)^.Usage:= 1;

                FTileFootData.Add(Result);
                Inc(FTileFootDataCount);
         end;
         //
         else Result:= nil;
         //
        end;
end;


function TFootManager.RemoveData(AData: Pointer; AFootType: Integer): Boolean;
var AIndex, i: Integer;
begin
        if (AData <> nil) then
        begin
                case AFootType of
                 FT_FOOT:
                 begin
                        Dec(PFootData(AData)^.Usage);
                        Result:= True;

                        if (PFootData(AData)^.Usage = 0) then
                        begin
                                AIndex:= FindData(AData, FT_FOOT);
                                FFootData.Delete(AIndex);
                                Dec(FFootDataCount);

                                FreeMem(PFootData(AData)^.Buffer);
                                Finalize(PFootData(AData).FileName);
                                FreeMem(AData);
                        end;
                 end;
                 //
                 FT_TILEFOOT:
                 begin
                        Dec(PTileFootData(AData)^.Usage);
                        Result:= True;

                        if (PTileFootData(AData)^.Usage = 0) then
                        begin
                                AIndex:= FindData(AData, FT_TILEFOOT);
                                FTileFootData.Delete(AIndex);
                                Dec(FTileFootDataCount);

                                for i:= 0 to 8 do FreeMem(PTileFootData(AData)^.Buffer[i]);
                                Finalize(PTileFootData(AData).FileName);                                
                                FreeMem(AData);
                        end;
                 end;
                 //
                 else Result:= False;
                 //
                end;
        end
        else Result:= False;
end;


function TFootManager.FindData(const AFileName: String; AFootType: Integer): Integer;
begin
        case AFootType of
         FT_FOOT:
         begin
                Result:= 0;
                while (Result < FFootDataCount)and
                      (not StringEqual(AFileName, PFootData(FFootData.Items[Result])^.FileName, False)) do
                Inc(Result);

                if (Result = FFootDataCount) then Result:= -1;
         end;
         //
         FT_TILEFOOT:
         begin
                Result:= 0;
                while (Result < FTileFootDataCount)and
                      (not StringEqual(AFileName, PTileFootData(FFootData.Items[Result])^.FileName, False)) do
                Inc(Result);

                if (Result = FTileFootDataCount) then Result:= -1;
         end;
         //
         else Result:= -1;
         //
        end;
end;


function TFootManager.FindData(AData: Pointer; AFootType: Integer): Integer;
begin
        case AFootType of
         FT_FOOT:
         begin
                Result:= 0;
                while (Result < FFootDataCount)and
                      (Integer(AData) <> Integer(FFootData.Items[Result])) do
                Inc(Result);

                if (Result = FFootDataCount) then Result:= -1;
         end;
         //
         FT_TILEFOOT:
         begin
                Result:= 0;
                while (Result < FTileFootDataCount)and
                      (Integer(AData) <> Integer(FTileFootData.Items[Result])) do
                Inc(Result);

                if (Result = FTileFootDataCount) then Result:= -1;
         end;
         //
         else Result:= -1;
         //
        end;
end;




//##############################################################################
//##                                    FONT                                  ##
//##############################################################################


{ TAFont}




class function TFont.LoadFont(const AFileName: String; AFont: TFont): Boolean;
var AFileStream: TAFileStream;

    Data: PFootData;
    Cached: Boolean;
begin
        // remove the old data in the foot.
        FootManager.RemoveData(AFont.FFootData, FT_FOOT);
        // retrive a data struct from cache or create a new one.
        Data:= FootManager.AddData(PathComplete(AFileName), FT_FOOT, Cached);

        if (not Cached) then
        begin
                AFileStream:= TAFileStream.Create(AFileName, FM_READ, FM_SHARE_NONE, FM_ACCESS_SEQUENTIAL);
                AFileStream.ReadBuffer(Data^, SizeOf(TFootHeader));


                GetMem(Data^.Buffer, Data^.ByteSize);


                AFileStream.ReadBuffer(Data^.Buffer^, Data^.ByteSize);
                AFileStream.ReadBuffer(AFont.FLefts, 255 * SizeOf(Integer));
                AFileStream.ReadBuffer(AFont.FWidths, 255 * SizeOf(Integer));
                AFileStream.Free;

                Result:= True;
        end
        else Result:= False;

        AFont.FFootData:= Data;
        AFont.UpdateBitmapInfo;
end;


class procedure TFont.SaveFont(const AFileName: String; AFont: TFont);
var AFileStream: TAFileStream;
begin
        AFileStream:= TAFileStream.Create(AFileName, FM_WRITE or FM_EMPTY, FM_SHARE_NONE, FM_ACCESS_SEQUENTIAL);

        AFileStream.WriteBuffer(AFont.FFootData^, SizeOf(TFootHeader));
        AFileStream.WriteBuffer(AFont.FFootData^.Buffer^, AFont.FFootData^.ByteSize);
        AFileStream.WriteBuffer(AFont.FLefts, 255 * SizeOf(Integer));
        AFileStream.WriteBuffer(AFont.FWidths, 255 * SizeOf(Integer));

        AFileStream.Free;
end;


function TFont.Load(const AFileName: String): Boolean;
var Ext: String;
begin
        if (FileExists(AFileName)) then
        begin
                Ext:= StringUpper(FileExtractExt(AFileName));

                if (Ext = 'BMP') then Result:= TFoot.LoadBitmap(AFileName, Self)
                //
                else if (Ext = 'F') then Result:= TFoot.LoadFoot(AFileName, Self)
                //
                else if (Ext = 'FNT') then Result:= TFont.LoadFont(AFileName, Self)
                //
                else Result:= False;
        end
        else Result:= False;
end;


function TFont.Save(const AFileName: String): Boolean;
var Ext: String;
begin
        Ext:= StringUpper(FileExtractExt(AFileName));
        Result:= True;

        if (Ext = 'BMP') then TFoot.SaveBitmap(AFileName, Self)
        //
        else if (Ext = 'F') then TFoot.SaveFoot(AFileName, Self)
        //
        else if (Ext = 'FNT') then TFont.SaveFont(AFileName, Self)
        //
        else Result:= False;
end;



//##############################################################################
//##                               FONTMANAGER                                ##
//##############################################################################


{ TFontManager }




constructor TFontManager.Create;
begin
        FFontList:= TAList.Create;
        FFontCount:= 0;
end;


destructor TFontManager.Destroy;
begin
        FFontList.Free;



inherited;
end;


function TFontManager.AddFont(const AFileName: String): Boolean;
var AFont: TFont;
begin
        if FileExists(AFileName)and(FindFont(FileExtractName(AFileName)) = -1) then
        begin
                AFont:= TFont.Create;
                AFont.Load(AFileName);
                AFont.FName:= FileExtractName(AFileName);

                FFontList.Add(AFont);
                Inc(FFontCount);
                Result:= True;
        end
        else Result:= False;
end;


function TFontManager.RemoveFont(const AName: String): Boolean;
var AIndex: Integer;
    AFont: TFont;
begin
        AIndex:= FindFont(AName);

        if (AIndex > -1) then
        begin
                AFont:= FFontList.Items[AIndex];
                AFont.Free;

                FFontList.Delete(AIndex);
                Dec(FFontCount);
                Result:= True;
        end
        else Result:= False;
end;


function TFontManager.FindFont(const AName: String): Integer;
begin
        Result:= 0;
        while (Result < FFontCount)and
              (not StringEqual(AName, TFont(FFontList.Items[Result]).FName, False)) do
              Inc(Result);

        if (Result = FFontCount) then Result:= -1;
end;


procedure TFontManager.RenderText(const AFontName: String; ADest: TFoot; ADestPos: TPoint; const AText: String; AAlpha: Integer; ARenderMode: Integer; MultiLine: Boolean = True);
var AIndex, ALength, i: Integer;
    AFont: TFont;
    ADestX: Integer;
begin
        AIndex:= FindFont(AFontName);

        if (AIndex > -1) then
        begin
                AFont:= FFontList.Items[AIndex];
                ALength:= Length(AText);

                ADestX:= ADestPos.X;
                for i:= 1 to ALength do
                begin
                        if (AText[i] <> #13)and(AText[i] <> #10) then
                                AFont.Render(ADest, ADestPos, NewRect(AFont.FLefts[Byte(AText[i])], 0, AFont.FLefts[Byte(AText[i])] + AFont.FWidths[Byte(AText[i])], AFont.Height), AAlpha, ARenderMode);

                        Inc(ADestPos.X, AFont.FWidths[Byte(AText[i])]);

                        if (Multiline)and(AText[i] = #10) then
                        begin
                                Inc(ADestPos.Y, AFont.Height);
                                ADestPos.X:= ADestX;
                        end;
                end;
        end;
end;


procedure TFontManager.RenderText(const AFontName: String; ADest: TFoot; ADestPos: TPoint; ABounds: TRect; const AText: String; AAlpha: Integer; ARenderMode: Integer; MultiLine: Boolean = True);
var AIndex, ALength, i: Integer;
    AFont: TFont;
    ADestX: Integer;
    SrcRect: TRect;
    DestPos: TPoint;
begin
        AIndex:= FindFont(AFontName);

        if (AIndex > -1) then
        begin
                AFont:= FFontList.Items[AIndex];
                ALength:= Length(AText);

                ADestX:= ADestPos.X;
                for i:= 1 to ALength do
                begin
                        if (AText[i] <> #13)and(AText[i] <> #10) then
                        begin
                                DestPos:= ADestPos;
                                SrcRect:= NewRect(AFont.FLefts[Byte(AText[i])], 0, AFont.FLefts[Byte(AText[i])] + AFont.FWidths[Byte(AText[i])], AFont.Height);

                                if (ABounds.Left > DestPos.X) then
                                begin
                                        SrcRect.Left:= SrcRect.Left + ABounds.Left - DestPos.X;
                                        DestPos.X:= ABounds.Left;
                                end;
                                if (ABounds.Top > DestPos.Y) then
                                begin
                                        SrcRect.Top:= SrcRect.Top + ABounds.Top - DestPos.Y;
                                        DestPos.Y:= ABounds.Top;
                                end;
                                if (SrcRect.Right > ABounds.Right - SrcRect.Left - DestPos.X) then
                                        SrcRect.Right:= ABounds.Right - SrcRect.Left - DestPos.X;
                                if (SrcRect.Bottom > ABounds.Bottom - SrcRect.Top - DestPos.Y) then
                                        SrcRect.Bottom:= ABounds.Bottom - SrcRect.Top - DestPos.Y;

                                AFont.Render(ADest, DestPos, SrcRect, AAlpha, ARenderMode);
                        end;

                        Inc(ADestPos.X, AFont.FWidths[Byte(AText[i])]);

                        if (Multiline)and(AText[i] = #10) then
                        begin
                                Inc(ADestPos.Y, AFont.Height);
                                ADestPos.X:= ADestX;
                        end;
                end;
        end;
end;


function TFontManager.FontSize(const AFontName: String): TPoint;
var AFont: TFont;
    AIndex, i: Integer;
begin
        AIndex:= FindFont(AFontName);

        if (AIndex > -1) then
        begin
                AFont:= FFontList.Items[AIndex];


                Result.X:= 0;
                Result.Y:= AFont.Height;
                for i:= 0 to 255 do Result.X:= Max(Result.X, AFont.FWidths[i]);
        end
        else begin
                Result.X:= 0;
                Result.Y:= 0;
        end;
end;


function TFontManager.FontStringSize(const AFontName: String; const AText: String; MultiLine: Boolean = True): TPoint;
var AFont: TFont;
    X, AIndex, i: Integer;
begin
        AIndex:= FindFont(AFontName);

        if (AIndex > -1) then
        begin
                AFont:= FFontList.Items[AIndex];


                X:= 0;
                Result.X:= 0;
                Result.Y:= AFont.Height;
                for i:= 1 to Length(AText) do
                begin
                        Inc(X, AFont.FWidths[Byte(AText[i])]);

                        if (Multiline)and(AText[i] = #10) then
                        begin
                                Inc(Result.Y, AFont.Height);
                                Result.X:= Max(X, Result.X);
                                X:= 0;
                        end;
                end;

                Result.X:= Max(X, Result.X);
        end
        else begin
                Result.X:= 0;
                Result.Y:= 0;
        end;
end;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//#######################                                 ######################
//#######################                                 ######################
//##                              INITIALIZATION                              ##
//#######################                                 ######################
//#######################                                 ######################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
procedure Init;
begin
          try
            FootManager:= TFootManager.Create;
            FontManager:= TFontManager.Create;

            GetMem(AlphaTable, $20000);
            CreateAlphaTable(AlphaTable);
          except
            (*++++++++++++++*)
            (**) HandleException('Foot initialization');
            (*++++++++++++++*)
          end;
end;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//#######################                                 ######################
//#######################                                 ######################
//##                                FINALIZATION                              ##
//#######################                                 ######################
//#######################                                 ######################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
procedure Final;
begin
          try
            FreeMem(AlphaTable);

            FontManager.Free;
            FootManager.Free;
          except
            (*++++++++++++++*)
            (**) HandleException('Foot finalization');
            (*++++++++++++++*)
          end;
end;

//##############################################################################
//##############################################################################

End.
