(*==============*)
        // AN EVENT IS RAN
(*--------------*)
        // A MESSAGE IS POSTED OR SENT
(*++++++++++++++*)
        // AN EXCEPTION IS RAISED
(*><><><><><><><*)
        // A THREADSAFE SECTION
(*[][][][][][][]*)
        // THE HOVER STATE IS UPDATED
(*{}{}{}{}{}{}{}*)
        // THE REGION IS UPDATED
(*~~~~~~~~~~~~~~~*)
        // CONTAINER CHILD IS UPDATED




// v4.0
//##############################################################################
//#################                 BASIC                     ##################
//##############################################################################


        (*
          DEFINE THREADSAFE TO MAKE ALL THE OBJECTS THREADSAFE
          || TAForm
          || TAControl
          || TALayerManager
          || TAMessageTable
        *)
        {$DEFINE THREADSAFE}


        (*
          DEFINE USE_FAST_PAINT TO ENABLE FAST CM_PAINT MESSAGE
          DELIVERY TO ALL WINDOWS.
        *)
        {$DEFINE USE_FAST_PAINT}


        (*
          DEFINE LAYERMANAGER_CONSOLE TO MAKE LAYERMANAGERS RUN GLOBAL
          EVENTS FOR MOUSE AND KEYBOARD.
        *)
        {$DEFINE LAYERMANAGER_CONSOLE}


//##############################################################################
//#################                 BASIC                     ##################
//##############################################################################
Unit UBasic;




        		//###############
        		//## INTERFACE ##
        		//###############
        		Interface

        		//##############
        		//##   USES   ##
        		//##############
        		Uses
                        //######################################################
        		//######################## SYSTEM ######################
                                		  {System,}
                                		  HWindows,
                                                  HMessages,
                                                  HMultimedia,
                                                  HNetwork,

                        //######################################################
                        //######################### OWN ########################
                                                  AHeap,
                                                  ARoutine,
                                                  ADevices,
                                                  UCore,

                        //######################################################
                        //######################### FOOT #######################
                                                  Foot;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                                INTERFACE                                 ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################




                        //##############
                        //### CONST  ###
                        //##############
                        Const
                        //######################################################
                        //################### TIMER CONSTANTS ##################


  // system timers start at 1024. they are all reserved up to 2048.

  TID_FIRST         = 1024;
  TID_FIRST_BASIC   = TID_FIRST + 1;
  TID_LAST_BASIC    = TID_FIRST_BASIC + 6;
  TID_LAST          = 2048;

                        //######################################################
                        //################### ANIMATION TIMERS #################

    TID_MOVE_ANIMATION          = TID_FIRST_BASIC + 1;
    TID_SIZE_ANIMATION          = TID_FIRST_BASIC + 2;
    TID_ALPHA_ANIMATION         = TID_FIRST_BASIC + 3;
    TID_BLUR_ANIMATION          = TID_FIRST_BASIC + 4;
    //#
    TID_MENU                    = TID_FIRST_BASIC + 5;

                        //######################################################
                        //################## MESSAGE CONSTANTS #################


  // CM_X MESSAGES WON'T MAKE IT TO A PROCESSMESSAGE POINT. THEY ARE
  // USED TO EMULATE AN ADVANCED FEATURE LIKE POSTMESSAGE TO (OBJECT).

  AM_FIRST_BASIC = AM_LAST_CORE + 1;
  AM_LAST_BASIC  = AM_FIRST_BASIC + 48;

                        //######################################################
                        //#################### LAYER MESSAGES ##################

    //   || WParam = old hover layer (object)
    AM_MOUSE_ENTER                      = AM_FIRST_BASIC + 1;
    AM_MOUSE_LEAVE                      = AM_FIRST_BASIC + 2;
    AM_BOUNDS_CHANGE                    = AM_FIRST_BASIC + 3;
    //   || WParamLo = by X
    //   || WParamHi = by Y
    //   || LParamLo = from X
    //   || LParamHi = from Y
    AM_MOVE                             = AM_FIRST_BASIC + 4;
    //   || WParamLo = by X
    //   || WParamHi = by Y
    //   || LParamLo = from X
    //   || LParamHi = from Y
    AM_SIZE                             = AM_FIRST_BASIC + 5;
    //   || WParam = layer (object)
    //   || LParam = old layer index
    AM_LAYER_CHANGE                     = AM_FIRST_BASIC + 6;
    AM_SHOW                             = AM_FIRST_BASIC + 7;
    AM_HIDE                             = AM_FIRST_BASIC + 8;
    AM_SET_ALWAYSONTOP                  = AM_FIRST_BASIC + 9;
    AM_RELEASE_ALWAYSONTOP              = AM_FIRST_BASIC + 10;
    AM_SET_CREATERGN                    = AM_FIRST_BASIC + 11;
    AM_RELEASE_CREATERGN                = AM_FIRST_BASIC + 12;
    //   || WParam = old focused layer (object)
    AM_SET_FOCUS                        = AM_FIRST_BASIC + 13;
    AM_RELEASE_FOCUS                    = AM_FIRST_BASIC + 14;
    //   || WParam = old capture layer (object)
    AM_SET_CAPTURE                      = AM_FIRST_BASIC + 15;
    AM_RELEASE_CAPTURE                  = AM_FIRST_BASIC + 16;
    //   || WParam = new parent (object)
    //   || LParam = old parent (object)
    AM_SET_PARENT                       = AM_FIRST_BASIC + 17;
    //   || WParam = old parent (object)
    AM_RELEASE_PARENT                   = AM_FIRST_BASIC + 18;
    AM_SET_DRAW                         = AM_FIRST_BASIC + 19;
    AM_RELEASE_DRAW                     = AM_FIRST_BASIC + 20;
    AM_SET_MSG                          = AM_FIRST_BASIC + 21;
    AM_RELEASE_MSG                      = AM_FIRST_BASIC + 22;
    AM_SET_CONTROLS_DRAW                = AM_FIRST_BASIC + 23;
    AM_RELEASE_CONTROLS_DRAW            = AM_FIRST_BASIC + 24;
    AM_SET_CONTROLS_MSG                 = AM_FIRST_BASIC + 25;
    AM_RELEASE_CONTROLS_MSG             = AM_FIRST_BASIC + 26;
    //
    AM_TIMER                            = AM_FIRST_BASIC + 27;
    //
    AM_MOVE_ANIMATION_START             = AM_FIRST_BASIC + 28;
    // || WParam = target destination was achieved
    AM_MOVE_ANIMATION_STOP              = AM_FIRST_BASIC + 29;
    AM_SIZE_ANIMATION_START             = AM_FIRST_BASIC + 30;
    // || WParam = target destination was achieved
    AM_SIZE_ANIMATION_STOP              = AM_FIRST_BASIC + 31;
    AM_ALPHA_ANIMATION_START            = AM_FIRST_BASIC + 32;
    // || WParam = target destination was achieved
    AM_ALPHA_ANIMATION_STOP             = AM_FIRST_BASIC + 33;
    AM_BLUR_ANIMATION_START             = AM_FIRST_BASIC + 34;
    AM_BLUR_ANIMATION_STOP               = AM_FIRST_BASIC + 35;
    //
    // used to emulate a postmessage to an (object)
    CM_MSG_POST                         = AM_FIRST_BASIC + 36;
    //
    AM_UPDATE_RGN                       = AM_FIRST_BASIC + 37;

                        //######################################################
                        //################# LAYERMANAGER MESSAGES ##############

    // this message is posted after a rectangle is added to the repaint queue.
    // the layermanager queue is flushed when the form gets this message.
    CM_LAYERMANAGER_FLUSHQUEUE                  = AM_FIRST_BASIC + 38;
    //   || WParam = layer (object)
    //   || LParam = old layer index
    AM_LAYERMANAGER_UPDATE_LAYER                = AM_FIRST_BASIC + 39;
    //   || WParam = new focused layer (object)
    //   || LParam = old focused layer (object)
    AM_LAYERMANAGER_SET_FOCUS                   = AM_FIRST_BASIC + 40;
    //   || WParam = old focused layer (object)
    AM_LAYERMANAGER_RELEASE_FOCUS               = AM_FIRST_BASIC + 41;
    //   || WParam = new capture layer (object)
    //   || LParam = old capture layer (object)
    AM_LAYERMANAGER_SET_CAPTURE                 = AM_FIRST_BASIC + 42;
    //   || WParam = old capture layer (object)
    AM_LAYERMANAGER_RELEASE_CAPTURE             = AM_FIRST_BASIC + 43;
    //   || WParam = new hover layer (object)
    //   || LParam = old hover layer (object)
    AM_LAYERMANAGER_UPDATE_HOVER                = AM_FIRST_BASIC + 44;
    //
    //
    //   || WParam = message
    //   || LParam = sender layer (object)
    AM_MESSAGE_NOTIFY                           = AM_FIRST_BASIC + 45;

                        //######################################################
                        //################# TIMERMANAGER MESSAGES ##############

    AM_HOOK_TIMER                               = AM_FIRST_BASIC + 46;
    AM_RUN_TIMER                                = AM_FIRST_BASIC + 47;

                        //######################################################
                        //###################### MESSAGE TYPES #################

  // message types or layers are stored in the same variable on
  // posting a message so all types are below LAYER_NONE.
  MT_FIRST       = -2;
    //#
    MT_NA        = -3;          // message is not redirected.
    MT_HOVER     = -4;          // message is redirected to the topmost layer beneath the mouse.
    MT_FOCUS     = -5;          // message is redirected to the layer that has focus.
    MT_CAPTURE   = -6;          // message is redirected to the layer that has mouse capture.
    //#
    MT_BROADCAST = -7;          // message is not redirected. if a call to sentmessage or postmessage.
                                // is made with this message type then the message will be broadcased
                                // to all layers of the owning form.
    //#
    MT_MODAL     = -8;          // message will only get to the modal layer, if any and it's
                                // container children with CF_PARENT flags.
    //#
    MT_MSG_POST  = -9;          // used to emulate a postmessage to a layer
                                // WParam is a pointer to a TMessage struct
                                // LParam is a pointer to the layer that is to recive the message
                                // this way the window message queue can be used to post messages
                                // to a layer.
    //#
  MT_LAST        = -10;

                        //######################################################
                        //######################### LAYERS #####################

  LAYER_FORM   = -1;
  LAYER_NONE   = -2;

                        //######################################################
                        //###################### REPAINT TYPE ##################

  RT_RELAYER        = 1;     // a backbuffer level repaint will be done with no
                             // screen level changes.
  RT_REDRAW         = 2;     // a screen level repaint will be done with no
                             // backbuffer level changes.
  RT_RELAYER_REDRAW = RT_REDRAW or RT_RELAYER;

                        //######################################################
                        //###################### BUFFER TYPE ###################

  BT_FOOT     = 1;         // buffer is a foot
  BT_TILEFOOT = 2;         // buffer is a tilefoot
  BT_RESIZE   = 4;         // the buffer is resized with the layer

                        //######################################################
                        //###################### FORM TYPE #####################

  FT_VISIBLE            = 1;   //0000000001;
  FT_ALWAYS_ON_TOP      = 2;   //0000000010;
  FT_FOCUSABLE          = 4;   //0000000100;
  FT_CREATERGN          = 8;   //0000001000;
  FT_OPTIMALRGN         = 16;  //0000010000;
  FT_MENU               = 32;  //0000100000;
  //#
  FT_CONTROL_MOVABLE       = 64;    //0001000000;
  FT_CONTROL_SIZABLE       = 128;   //0010000000;
  //#
  FT_CONTROLS_DRAW         = 256;   //0100000000;
  FT_CONTROLS_MSG          = 512;   //1000000000;
  FT_CONTROLS_ON           = 768;   //1100000000;

                        //######################################################
                        //################### CONTROL TYPE #####################

  CT_VISIBLE            = 1;   //00000000001;
  CT_ALWAYS_ON_TOP      = 2;   //00000000010;
  CT_CURSOR             = 4;   //00000000100;
  CT_FOCUSABLE          = 8;   //00000001000;
  //#
  CT_MOVABLE         = 32;   //00000100000;
  CT_SIZABLE         = 64;   //00001000000;
  //#
  // non message controls cannot be focused or setcapture.
  CT_MSG             = 128;   //00010000000;
  CT_DRAW            = 256;   //00100000000;
  CT_ON              = 384;   //00110000000;
  //#
  CT_PANEL           = CT_VISIBLE or CT_ON or CT_MOVABLE or CT_SIZABLE;
  CT_REGION          = CT_VISIBLE or CT_MSG;
  CT_LAYER           = CT_VISIBLE or CT_DRAW;

                        //######################################################
                        //################## CONTAINER FLAGS ###################

  CF_MOVE        = 1;
  CF_SIZE        = 2;
  CF_ALPHA       = 4;
  // the child will only paint, recive mouse input and updatergnlist
  // in the parent's bounding box.
  CF_PARENT      = 8;

                        //######################################################
                        //#################### ANCHOR TYPES ####################

  AK_NONE    = 0;
  AK_LEFT    = 1;
  AK_TOP     = 2;
  AK_RIGHT   = 4;
  AK_BOTTOM  = 8;

                        //######################################################
                        //################### CONSTRAINTS TYPES ################

  CT_NONE                       = 0;    // 000000000;
  CT_CUSTOM                     = 1;    // 000000001;   // enable custom constrains flags.
  //#
  CT_MIN_BUFFER                 = 2;    // 000000010;
  CT_MAX_BUFFER                 = 4;    // 000000100;
  CT_EQUAL_BUFFER               = 6;    // 000000110;
  //#
  CT_PARENT_IN                  = 8;    // 000001000;

                        //######################################################
                        //############## CUSTOM CONSTRAINTS FLAGS ##############

  CF_NONE                       = 0;   // 000000000000;
  //#
  CF_MIN_WIDTH                  = 1;   // 000000000001;
  CF_MAX_WIDTH                  = 2;   // 000000000010;
  CF_BOTH_WIDTH                 = 3;   // 000000000011;
  //#
  CF_MIN_HEIGHT                 = 4;   // 000000000100;
  CF_MAX_HEIGHT                 = 8;   // 000000001000;
  CF_BOTH_HEIGHT                = 12;  // 000000001100;
  //#
  CF_MIN_LEFT                   = 16;  // 000000010000;
  CF_MAX_LEFT                   = 32;  // 000000100000;
  CF_BOTH_LEFT                  = 48;  // 000000110000;
  //#
  CF_MIN_TOP                    = 64;  // 000001000000;
  CF_MAX_TOP                    = 128; // 000010000000;
  CF_BOTH_TOP                   = 196; // 000011000000;
  //#
  CF_MIN_RIGHT                  = 256; // 000100000000;
  CF_MAX_RIGHT                  = 512; // 001000000000;
  CF_BOTH_RIGHT                 = 768; // 001100000000;
  //#
  CF_MIN_BOTTOM                 = 1024; // 010000000000;
  CF_MAX_BOTTOM                 = 2048; // 100000000000;
  CF_BOTH_BOTTOM                = 3072; // 110000000000;

                        //######################################################
                        //############### MOVE CONSTRAINTS INDEXES #############

  MCI_MIN_LEFT          = 0;
  MCI_MAX_LEFT          = 1;
  MCI_MIN_TOP           = 2;
  MCI_MAX_TOP           = 3;
  MCI_MIN_RIGHT         = 4;
  MCI_MAX_RIGHT         = 5;
  MCI_MIN_BOTTON        = 6;
  MCI_MAX_BOTTOM        = 7;

                        //######################################################
                        //############### SIZE CONSTRAINTS INDEXES #############

  SCI_MIN_WIDTH          = 0;
  SCI_MAX_WIDTH          = 1;
  SCI_MIN_HEIGHT         = 2;
  SCI_MAX_HEIGHT         = 3;

                        //######################################################
                        //############ TIMERMANAGER TIMER MANAGEMENT ###########

  TT_HOOK       = 1;
  TT_THREAD     = 2;
  TT_SYNC       = 3;

  TT_HOOK_HID   = 1024;

                        //######################################################
                        //#################### CURSOR STATES ###################

  CS_ARROW      = 0;
  CS_TEXT       = 1;
  CS_MOVE       = 2;
  CS_SIZE       = 3;




                        //##############
                        //### TYPES  ###
                        //##############
                        Type
                        //######################################################
                        //################ MESSAGETABLE LIST ###################

  TMessageTypeArray = array[0..(MAX_INT div SizeOf(Integer) - SizeOf(Integer))] of Integer;
  PMessageTypeArray = ^TMessageTypeArray;

                        //######################################################
                        //##################### EVENTS #########################

  TOnMouseEvent = procedure(Sender: TObject; x, y: Integer; Buttons: Integer);
  TOnKeyEvent = procedure(Sender: TObject; Key: Integer; ShiftState: Integer);
  TOnCharEvent = procedure(Sender: TObject; Key: Char; ShiftState: Integer);

                        //######################################################
                        //################# PROCESSMESSGE EVENT ################

  TOnProcessMessage = procedure(ASender: TObject; AMsg, WParam, LParam: Cardinal);

                        //######################################################
                        //#################### MESSAGE NOTIFY ##################

  TNotifyRec = record
    Msg: Integer;
    Sender,
    Reciver: TObject;
  end;

  PNotifyRec = ^TNotifyRec;

                        //######################################################
                        //################## ANIMATION STRUCTS #################

  TMoveSizeAnimationRec = record
    SrcX,
    SrcY,
    DestX,
    DestY: Integer;
    SpeedX,
    SpeedY,
    AccelerationX,
    AccelerationY: Extended;
    //#
    Frame: Integer;
    BlankFrameMaxX,
    BlankFrameMaxY,
    BlankFrameCountX,
    BlankFrameCountY: Integer;
  end;

  TAlphaAnimationRec = record
    Src,
    Dest: Byte;
    Speed,
    Acceleration: Extended;
    //#
    Frame: Integer;
    BlankFrameMax,
    BlankFrameCount: Integer;
  end;

                        //######################################################
                        //################## ANIMATION METHODS #################

  TMoveSize = function(AX, AY: Integer): Boolean of object;
  TSetAlpha = procedure(AAlpha: Byte) of object;
  TStop = function: Boolean of object;

                        //######################################################
                        //############## TIMERMANAGER TIMER STRUCTS ############

  THookTimerRec = record
    Id,
    TimeOut,
    LastTick: Cardinal;
    Reciver: Pointer;
  end;
  PHookTimerRec = ^THookTimerRec;


  TThreadTimerRec = record
    Id,
    TimeOut: Cardinal;
    Reciver: Pointer;
  end;
  PThreadTimerRec = ^TThreadTimerRec;


  TSyncTimerRec = record
    Id,
    TimeOut: Cardinal;
    Reciver: Pointer;
  end;
  PSyncTimerRec = ^TSyncTimerRec;

                        //######################################################
                        //################## CONSTRAINTS STRUCT ################

  TMoveConstraints = record
    MinLeft,
    MaxLeft,
    MinTop,
    MaxTop,
    MinRight,
    MaxRight,
    MinBottom,
    MaxBottom: Integer;
  end;

  TSizeConstraints = record
    MinWidth,
    MaxWidth,
    MinHeight,
    MaxHeight: Integer;
  end;

                        //######################################################
                        //####################### CLASS TYPES ##################

  TAForm = class;
  TAControl = class;
  //#
  TALayerManager = class;
  //#
  TAMessageTable = class;
  //#
  TATimerManager = class;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                            EXPLICIT INTERFACE                            ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################




//##############################################################################
//##                                   FORM                                   ##
//##############################################################################




  // EACH FORM MUST HAVE A UNIQUE NAME. IF NOT THEN AN EXCEPTION IS RAISED.

  TAForm = class(TABasicForm)
  protected
    FLayerManager: TALayerManager;
    FBuffer: TFoot;
    FBufferType: Integer;
    //#
    FFormType: Integer;
    //#
    FFocusable,
    FCreateRgn,
    FOptimalRgn,
    FControlMovable,
    FControlSizable,
    FControlsDraw,
    FControlsMsg: Boolean;
    //#
    FMoveControl,
    FSizeControl: TAControl;
    FMoving,
    FSizing: Boolean;
    Fx, Fy: Integer;
    //#
    FSizeConstraints: TSizeConstraints;
    FMoveConstraints: TMoveConstraints;
    FConstraintsType,
    FConstraintsFlags: Integer;
    //#
    //#
    // this is true when a request for a region update has been posted.
    // it should be set to false on AM_UPDATE_RGN.
    FRgnUpdate: Boolean;
    //#
    // this is the default cursor state when the mouse is hover.
    FCursorDef: Integer;
    //#
    // this is the count of message notifications this object has to do.
    FNotify: Integer;
    //#
    //#
    // animation structures.
    FMoveAnimationRec: TMoveSizeAnimationRec;
    FMoveAnimation: Boolean;
    FSizeAnimationRec: TMoveSizeAnimationRec;
    FSizeAnimation: Boolean;
    //#
    //#
    // if the form is a rgn layer then this is the minimum opaque
    // alpha to consider a rect added to the region list.
    FRgnAlpha: Byte;
    FRgnList: TARectList;
    FRgnIncluded: Boolean;
    //#
    FRgn: Cardinal;
    FRgnBuffer: Pointer;
    FRgnRegion: TARectList;
    FRgnLayerList: TAList;
    FRgnLayerCount: Integer;
    FRgnWidth,
    FRgnHeight: Integer;
(*============================================================================*)
    FOnProcessMessage: TOnProcessMessage;
    //#
    //#
    FOnBeforeSetBounds,
    FOnAfterSetBounds,
    FOnShow,                            //# RAN ON MESSAGE
    FOnHide,                            //# RAN ON MESSAGE
    FOnSetAlwaysOnTop,                  //# RAN ON MESSAGE
    FOnReleaseAlwaysOnTop,              //# RAN ON MESSAGE
    FOnSetFocus,                        //# RAN ON MESSAGE
    FOnReleaseFocus,                    //# RAN ON MESSAGE
    FOnSetCapture,                      //# RAN ON MESSAGE
    FOnReleaseCapture,                  //# RAN ON MESSAGE
    FOnSetControlsDraw,                 //# RAN ON MESSAGE
    FOnReleaseControlsDraw,             //# RAN ON MESSAGE
    FOnSetControlsMsg,                  //# RAN ON MESSAGE
    FOnReleaseControlsMsg,              //# RAN ON MESSAGE
    FOnMouseEnter,                      //# RAN ON MESSAGE
    FOnMouseLeave: TOnEvent;            //# RAN ON MESSAGE
    //#
    FOnMouseMove,                       //# RAN ON MESSAGE
    FOnMouseDown,                       //# RAN ON MESSAGE
    FOnMouseUp,                         //# RAN ON MESSAGE
    FOnMouseClick,                      //# RAN ON MESSAGE
    FOnMouseDblClick: TOnMouseEvent;    //# RAN ON MESSAGE
    FOnMouseWheel: TOnWheelEvent;       //# RAN ON MESSAGE
    FOnKeyDown,                         //# RAN ON MESSAGE
    FOnKeyUp: TOnKeyEvent;              //# RAN ON MESSAGE
    FOnKeyChar: TOnCharEvent;           //# RAN ON MESSAGE
    //#
    FOnMoveStart,                       //# RAN ON MESSAGE
    FOnMoving,                          //# RAN ON MESSAGE
    FOnMoveStop,                        //# RAN ON MESSAGE
    FOnSizeStart,                       //# RAN ON MESSAGE
    FOnSizing,                          //# RAN ON MESSAGE
    FOnSizeStop: TOnEvent;              //# RAN ON MESSAGE
    //#
    FOnMoveAnimationStart,              //# RAN ON MESSAGE
    FOnMoveAnimating,                   //# RAN ON MESSAGE
    FOnMoveAnimationStop,               //# RAN ON MESSAGE
    FOnSizeAnimationStart,              //# RAN ON MESSAGE
    FOnSizeAnimating,                   //# RAN ON MESSAGE
    FOnSizeAnimationStop:TOnEvent;      //# RAN ON MESSAGE
    //#
    FOnUpdateRgn: TOnEvent;             //# RAN ON MESSAGE
(*============================================================================*)
    procedure SetCursorDef(ACursorDef: Integer);
    //#
    function GetFocused: Boolean; override;
    procedure SetFocused(AFocused: Boolean); override;
    function GetCapture: Boolean; override;
    procedure SetCapture(ACapture: Boolean); override;
    function GetLayer: Integer;
    //#
    procedure SetBufferType(ABufferType: Integer);
    //#
    procedure SetFormType(AFormType:  Integer);
    //#
    // while invisible or minimized the form will not paint or updatergn.
    // we need to do these operations after we show or restore the form.
    procedure SetVisible(AVisible: Boolean); override;
    procedure SetAlwaysOnTop(AAlwaysOnTop: Boolean); override;
    procedure SetFocusable(AFocusable: Boolean);
    procedure SetCreateRgn(ACreateRgn: Boolean);
    procedure SetOptimalRgn(AOptimalRgn: Boolean);
    procedure SetMenu(AMenu: Boolean);
    procedure SetControlMovable(AControlMovable: Boolean);
    procedure SetControlSizable(AControlSizable: Boolean);
    procedure SetControlsDraw(AControlsDraw: Boolean);
    procedure SetControlsMsg(AControlsMsg: Boolean);
    //#
    function GetTabFocusIndex: Integer;
    procedure SetTabFocusIndex(AIndex: Integer);
    //#
    procedure SetMoveControl(AMoveControl: TAControl);
    procedure SetSizeControl(ASizeControl: TAControl);
    //#
    function GetSizeConstraints(AIndex: Integer): Integer;
    function GetMoveConstraints(AIndex: Integer): Integer;
    procedure SetSizeConstraints(AIndex: Integer; ASizeConstraints: Integer);
    procedure SetMoveConstraints(AIndex: Integer; AMoveConstraints: Integer);
    procedure SetConstraintsType(AConstraintsType: Integer);
    procedure SetConstraintsFlags(AConstraintsFlags: Integer);
    //#
    function GetControl(AIndex: Integer): TAControl;
    function GetControlCount: Integer;
    //#
    //#
    procedure SetRgnAlpha(ARgnAlpha: Byte);
(*============================================================================*)
    function WindowProc(AHandle: Cardinal; Msg, WParam, LParam: Integer): Integer; override; stdcall;
    //#
    procedure ProcessMessage(Msg, WParam, LParam: Integer); virtual;
    //#
    procedure PaintLayer(ADestBuffer: TFoot); overload; virtual;
    procedure PaintLayer(ADestBuffer: TFoot; ADestRect: TRect); overload; virtual;
    //#
    //#
    // constrain the parameters to the parameters set and to the parent.
    class procedure RunConstraints(AConstraintsType, AConstraintsFlags: Integer; AMoveConstraints: TMoveConstraints; ASizeConstraints: TSizeConstraints; FLeft, FTop, FWidth, FHeight: Integer; AParentBounds: TARect; ABuffer: TFoot; var ALeft, ATop, AWidth, AHeight: Integer);
(*============================================================================*)
  public
    //#
    //#
    constructor Create(const AName: String; ABufferType, AFormType: Integer; AWindowProcPointer: Pointer = nil); overload; virtual;
    destructor Destroy; override;
    //#
    //#
    // you can load both foot and tilefoot. if a foot is loaded then the
    // BT_RESIZE property will be disabled until the buffertype is changed to
    // BT_TILEFOOT or a tilefoot is loaded.
    procedure Load(const AFileName: String);
    procedure Unload;
    //#
    //#
    property CursorDef: Integer read FCursorDef write SetCursorDef;
    property CursorPos: TPoint read GetCursorPos write SetCursorPos;
    procedure UpdateCursor;
    function PointInBounds(P: TPoint): Boolean; // client coordonates are expected.
    //#
    property Focused;
    property Capture;
    property Handle;
    property DC;
    //#
    property Left;
    property Top;
    property Width;
    property Height;
    property Bounds;
    function SetBounds(ALeft, ATop, AWidth, AHeight: Integer): Integer; override;
    //#
    property SizeConstraints[AIndex: Integer]: Integer read GetSizeConstraints write SetSizeConstraints;
    property MoveConstraints[AIndex: Integer]: Integer read GetMoveConstraints write SetMoveConstraints;
    // if custom constraints are activated by including CT_CUSTOM in constraintstype
    // then constraints flags will set which fields of the size/move constraints
    // will be active.
    property ConstraintsType: Integer read FConstraintsType write SetConstraintsType;
    property ConstraintsFlags: Integer read FConstraintsFlags write SetConstraintsFlags;
    procedure UpdateConstraints;
    //#
    procedure Invalidate(RepaintType: Integer); overload;
    procedure Invalidate(RepaintType: Integer; ARect: TRect); overload;
    procedure Repaint(RepaintType: Integer); overload;
    procedure Repaint(RepaintType: Integer; ARect: TRect); overload;
    procedure Update; override;
    //#
    property FormType: Integer read FFormType write SetFormType;
    //#
    property Name;
    property Visible;
    property AlwaysOnTop;
    property AllowHide;
    property Focusable: Boolean read FFocusable write SetFocusable;
    property CreateRgn: Boolean read FCreateRgn write SetCreateRgn;
    property OptimalRgn: Boolean read FOptimalRgn write SetOptimalRgn;
    property Menu: Boolean read FMenu write SetMenu;
    property ControlMovable: Boolean read FControlMovable write SetControlMovable;
    property ControlSizable: Boolean read FControlSizable write SetControlSizable;
    property ControlsDraw: Boolean read FControlsDraw write SetControlsDraw;
    property ControlsMsg: Boolean read FControlsMsg write SetControlsMsg;
    //#
    property TabFocusIndex: Integer read GetTabFocusIndex write SetTabFocusIndex;
    //#
    property MoveControl: TAControl read FMoveControl write SetMoveControl;
    property SizeControl: TAControl read FSizeControl write SetSizeControl;
    property Moving: Boolean read FMoving;
    property Sizing: Boolean read FSizing;
    //#
    property LayerManager: TALayerManager read FLayerManager;
    property Buffer: TFoot read FBuffer;
    property BufferType: Integer read FBufferType write SetBufferType;
    property Layer: Integer read GetLayer;
    //#
    //#
    // animation functions like this. the speed must always be positive. the acceleration
    // depends if you want to accelerate or decelerate. if the speed decelerates so much
    // that it would reverse the direction then the animation stops.
    function StartMoveAnimation(ASrcX, ASrcY, ADestX, ADestY: Integer; ASpeedX, ASpeedY, AAccelerationX, AAccelerationY: Extended; ATimeOut: Integer): Boolean;
    function StopMoveAnimation: Boolean;
    property MoveAnimating: Boolean read FMoveAnimation;
    property MoveAnimationRec: TMoveSizeAnimationRec read FMoveAnimationRec;
    //#
    function StartSizeAnimation(ASrcX, ASrcY, ADestX, ADestY: Integer; ASpeedX, ASpeedY, AAccelerationX, AAccelerationY: Extended; ATimeOut: Integer): Boolean;
    function StopSizeAnimation: Boolean;
    property SizeAnimating: Boolean read FSizeAnimation;
    property SizeAnimationRec: TMoveSizeAnimationRec read FSizeAnimationRec;
    //#
    //#
    // if the form is a rgn layer then this is the minimum opaque alpha
    // to consider a rect added to the region list. the layer needs only
    // to be visible to be able to updatergnlist.
    property RgnAlpha: Byte read FRgnAlpha write SetRgnAlpha;
    property RgnList: TARectList read FRgnList;
    procedure UpdateRgnList;
    //#
    function AddRgnLayer(ALayer: TObject): Boolean;
    function RemoveRgnLayer(ALayer: TObject): Boolean;
    //#
    property RgnLayerCount: Integer read FRgnLayerCount;
    property RgnWidth: Integer read FRgnWidth;
    property RgnHeight: Integer read FRgnHeight;
    procedure UpdateRgn(Now: Boolean = False);
(*============================================================================*)
    property OnProcessMessage: TOnProcessMessage read FOnProcessMessage write FOnProcessMessage;
    //#
    //#
    property OnDestroy;
    property OnBeforeSetBounds: TOnEvent read FOnBeforeSetBounds write FOnBeforeSetBounds;
    property OnAfterSetBounds: TOnEvent read FOnAfterSetBounds write FOnAfterSetBounds;
    property OnShow: TOnEvent read FOnShow write FOnShow;
    property OnHide: TOnEvent read FOnHide write FOnHide;
    property OnSetAlwaysOnTop: TOnEvent read FOnSetAlwaysOnTop write FOnSetAlwaysOnTop;
    property OnReleaseAlwaysOnTop: TOnEvent read FOnReleaseAlwaysOnTop write FOnReleaseAlwaysOnTop;
    property OnSetFocus: TOnEvent read FOnSetFocus write FOnSetFocus;
    property OnReleaseFocus: TOnEvent read FOnReleaseFocus write FOnReleaseFocus;
    property OnSetCapture: TOnEvent read FOnSetCapture write FOnSetCapture;
    property OnReleaseCapture: TOnEvent read FOnReleaseCapture write FOnReleaseCapture;
    property OnSetControlsDraw: TOnEvent read FOnSetControlsDraw write FOnSetControlsDraw;
    property OnReleaseControlsDraw: TOnEvent read FOnReleaseControlsDraw write FOnReleaseControlsDraw;
    property OnSetControlsMsg: TOnEvent read FOnSetControlsMsg write FOnSetControlsMsg;
    property OnReleaseControlsMsg: TOnEvent read FOnReleaseControlsMsg write FOnReleaseControlsMsg;
    property OnMouseEnter: TOnEvent read FOnMouseEnter write FOnMouseEnter;
    property OnMouseLeave: TOnEvent read FOnMouseLeave write FOnMouseLeave;
    property OnMouseWheel: TOnWheelEvent read FOnMouseWheel write FOnMouseWheel;
    //#
    property OnMouseMove: TOnMouseEvent read FOnMouseMove write FOnMouseMove;
    property OnMouseDown: TOnMouseEvent read FOnMouseDown write FOnMouseDown;
    property OnMouseUp: TOnMouseEvent read FOnMouseUp write FOnMouseUp;
    property OnMouseClick: TOnMouseEvent read FOnMouseClick write FOnMouseClick;
    property OnMouseDblClick: TOnMouseEvent read FOnMouseDblClick write FOnMouseDblClick;
    property OnKeyDown: TOnKeyEvent read FOnKeyDown write FOnKeyDown;
    property OnKeyUp: TOnKeyEvent read FOnKeyUp write FOnKeyUp;
    property OnKeyChar: TOnCharEvent read FOnKeyChar write FOnKeyChar;
    //#
    property OnMoveStart: TOnEvent read FOnMoveStart write FOnMoveStart;
    property OnMoving: TOnEvent read FOnMoving write FOnMoving;
    property OnMoveStop: TOnEvent read FOnMoveStop write FOnMoveStop;
    property OnSizeStart: TOnEvent read FOnSizeStart write FOnSizeStart;
    property OnSizing: TOnEvent read FOnSizing write FOnSizing;
    property OnSizeStop: TOnEvent read FOnSizeStop write FOnSizeStop;
    //#
    property OnMoveAnimationStart: TOnEvent read FOnMoveAnimationStart write FOnMoveAnimationStart;
    property OnMoveAnimating: TOnEvent read FOnMoveAnimating write FOnMoveAnimating;
    property OnMoveAnimationStop: TOnEvent read FOnMoveAnimationStop write FOnMoveAnimationStop;
    property OnSizeAnimationStart: TOnEvent read FOnSizeAnimationStart write FOnSizeAnimationStart;
    property OnSizeAnimating: TOnEvent read FOnSizeAnimating write FOnSizeAnimating;
    property OnSizeAnimationStop: TOnEvent read FOnSizeAnimationStop write FOnSizeAnimationStop;
    //#
    property OnUpdateRgn: TOnEvent read FOnUpdateRgn write FOnUpdateRgn;
  end;




//##############################################################################
//##                                 CONTROL                                  ##
//##############################################################################




  // EACH CONTROL MUST HAVE A UNIQUE NAME. IF NOT THEN AN EXCEPTION IS RAISED.

  TAControl = class(TObject)
  protected
    FLayerManager: TALayerManager;
    FParent: TAForm;
    FBuffer: TFoot;
    FBufferType: Integer;
    FBufferRender: Integer;
    FChanged: Boolean; // needs rebuffer before relayer.
    //#
    FControlType: Integer;
    //#
    FName: String;
    FVisible,
    FAlwaysOnTop,
    FCursor, // the control is topmost over all alwaysontop controls.
    FFocusable,
    FCreateRgn,
    FMovable,
    FSizable,
    FDraw,
    FMsg: Boolean; // non message controls cannot be focused or setcapture.
    //#
    FMoveRect,
    FSizeRect: TARect;
    FMoving,
    FSizing: Boolean;
    Fx, Fy: Integer;
    //#
    FLeft,
    FTop,
    FWidth,
    FHeight: Integer;
    //#
    FAnchors: Integer;
    FAx, FAy: Extended;
    FSizeConstraints: TSizeConstraints;
    FMoveConstraints: TMoveConstraints;
    FConstraintsType,
    FConstraintsFlags: Integer;
    //#
    // locationalpha is the minimun amount of alpha needed to consider
    // the layer visible and to get the mouse messages.
    FLocationAlpha: Byte;
    FAlpha: Byte;
    //#
    //#
    // this is used to emulate click message. it holds the buttons pressed on
    // the layer so that when a press matches a release a click message is posted.
    FButtonDown: Integer;
    //#
    // this is the default cursor state when the mouse is hover.
    FCursorDef: Integer;
    //#
    // this is the count of message notifications this object has to do.
    FNotify: Integer;
    //#
    //#
    // the container that has the current control.
    FContainer: TAControl;
    FContainerFlags: Integer;
    FContainerChildList: TAList;
    FContainerChildCount: Integer;
    //#
    //#
    // animation structures.
    FMoveAnimationRec: TMoveSizeAnimationRec;
    FMoveAnimation: Boolean;
    FSizeAnimationRec: TMoveSizeAnimationRec;
    FSizeAnimation: Boolean;
    FAlphaAnimationRec: TAlphaAnimationRec;
    FAlphaAnimation: Boolean;
    //#
    //#
    // if the control is a rgn layer then this is the minimum opaque
    // alpha to consider a rect added to the region list.
    FRgnAlpha: Byte;
    FRgnList: TARectList;
    FRgnIncluded: Boolean;
(*============================================================================*)
    FOnProcessMessage: TOnProcessMessage;
    //#
    //#
    FOnDestroy,
    FOnBeforeSetBounds,
    FOnAfterSetBounds,
    FOnShow,                            //# RAN ON MESSAGE
    FOnHide,                            //# RAN ON MESSAGE
    FOnSetAlwaysOnTop,                  //# RAN ON MESSAGE
    FOnReleaseAlwaysOnTop,              //# RAN ON MESSAGE
    FOnSetFocus,                        //# RAN ON MESSAGE
    FOnReleaseFocus,                    //# RAN ON MESSAGE
    FOnSetCapture,                      //# RAN ON MESSAGE
    FOnReleaseCapture,                  //# RAN ON MESSAGE
    FOnChangeLayer,                     //# RAN ON MESSAGE
    FOnSetDraw,                         //# RAN ON MESSAGE
    FOnReleaseDraw,                     //# RAN ON MESSAGE
    FOnSetMsg,                          //# RAN ON MESSAGE
    FOnReleaseMsg,                      //# RAN ON MESSAGE
    FOnMouseEnter,                      //# RAN ON MESSAGE
    FOnMouseLeave: TOnEvent;            //# RAN ON MESSAGE
    //#
    FOnMouseMove,                       //# RAN ON MESSAGE
    FOnMouseDown,                       //# RAN ON MESSAGE
    FOnMouseUp,                         //# RAN ON MESSAGE
    FOnMouseClick,                      //# RAN ON MESSAGE
    FOnMouseDblClick: TOnMouseEvent;    //# RAN ON MESSAGE
    FOnMouseWheel: TOnWheelEvent;       //# RAN ON MESSAGE
    FOnKeyDown,                         //# RAN ON MESSAGE
    FOnKeyUp: TOnKeyEvent;              //# RAN ON MESSAGE
    FOnKeyChar: TOnCharEvent;           //# RAN ON MESSAGE
    //#
    FOnMoveStart,                       //# RAN ON MESSAGE
    FOnMoving,                          //# RAN ON MESSAGE
    FOnMoveStop,                        //# RAN ON MESSAGE
    FOnSizeStart,                       //# RAN ON MESSAGE
    FOnSizing,                          //# RAN ON MESSAGE
    FOnSizeStop: TOnEvent;              //# RAN ON MESSAGE
    //#
    FOnMoveAnimationStart,              //# RAN ON MESSAGE
    FOnMoveAnimating,                   //# RAN ON MESSAGE
    FOnMoveAnimationStop,               //# RAN ON MESSAGE
    FOnSizeAnimationStart,              //# RAN ON MESSAGE
    FOnSizeAnimating,                   //# RAN ON MESSAGE
    FOnSizeAnimationStop:TOnEvent;      //# RAN ON MESSAGE
    FOnAlphaAnimationStart,             //# RAN ON MESSAGE
    FOnAlphaAnimating,                  //# RAN ON MESSAGE
    FOnAlphaAnimationStop: TOnEvent;    //# RAN ON MESSAGE
(*============================================================================*)
    procedure SetCursorDef(ACursorDef: Integer); virtual;
    // cursor property will return the cursor coordonates the
    // mouse had when the last message was getmessage.
    function GetCursorPos: TPoint;
    procedure SetCursorPos(ACursorPos: TPoint);
    //#
    procedure SetParent(AParent: TAForm);
    //#
    procedure SetLeft(ALeft: Integer);
    procedure SetTop(ATop: Integer);
    procedure SetWidth(AWidth: Integer);
    procedure SetHeight(AHeight: Integer);
    function GetBounds: TARect;
    //#
    function GetSizeConstraints(AIndex: Integer): Integer;
    function GetMoveConstraints(AIndex: Integer): Integer;
    procedure SetSizeConstraints(AIndex: Integer; ASizeConstraints: Integer);
    procedure SetMoveConstraints(AIndex: Integer; AMoveConstraints: Integer);
    procedure SetConstraintsType(AConstraintsType: Integer);
    procedure SetConstraintsFlags(AConstraintsFlags: Integer);
    //#
    function GetFocused: Boolean;
    procedure SetFocused(AFocused: Boolean);
    function GetCapture: Boolean;
    procedure SetCapture(ACapture: Boolean);
    function GetLayer: Integer;
    procedure SetLayer(ALayer: Integer);
    //#
    procedure SetBufferType(ABufferType: Integer); virtual;
    procedure SetBufferRender(ABufferRender: Integer);
    //#
    procedure SetControlType(AControlType: Integer); virtual;
    //#
    procedure SetVisible(AVisible: Boolean); virtual;
    procedure SetAlwaysOnTop(AAlwaysOnTop: Boolean); virtual;
    procedure SetCursor(ACursor: Boolean); virtual;
    procedure SetFocusable(AFocusable: Boolean); virtual;
    procedure SetMovable(AMovable: Boolean); virtual;
    procedure SetSizable(ASizable: Boolean); virtual;
    procedure SetDraw(ADraw: Boolean); virtual;
    procedure SetMsg(AMsg: Boolean); virtual;
    //#
    function GetTabFocusIndex: Integer;
    procedure SetTabFocusIndex(AIndex: Integer);
    //#
    procedure SetLocationAlpha(ALocationAlpha: Byte);
    procedure SetAlpha(AAlpha: Byte);
    //#
    //#
    procedure SetContainerFlags(AContainerFlags: Integer);
    function GetContainerChild(AIndex: Integer): TAControl;
    //#
    //#
    procedure SetRgnAlpha(ARgnAlpha: Byte);
(*============================================================================*)
    procedure ProcessMessage(Msg, WParam, LParam: Integer); virtual;
    //#
    // in this procedure all descendant controls will paint
    // their custom content on the control's buffer.
    procedure Paint; virtual;
    // paintlayer will paint the control's buffer on the layermanager's layerbuffer
    // which holds the content of the window. the rect sent is the rect that needs to
    // be filled with data (in form coordonates).
    procedure PaintLayer(ADestBuffer: TFoot); overload; virtual;
    procedure PaintLayer(ADestBuffer: TFoot; ADestRect: TRect); overload; virtual;
    //#
    //#
    // runs one animation step. the code is the same so it can be used by TAForm as well.
    class procedure RunMoveSizeAnimation(MoveSize: TMoveSize; Stop: TStop; var Struct: TMoveSizeAnimationRec; var X, Y: Integer);
    class procedure RunAlphaAnimation(ASet: TSetAlpha; Stop: TStop; var Struct: TAlphaAnimationRec; var X: Byte);
(*============================================================================*)
  public
    //#
    //#
    constructor Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer); overload; virtual;
    destructor Destroy; override;
    //#
    //#
    property CursorDef: Integer read FCursorDef write SetCursorDef;
    property CursorPos: TPoint read GetCursorPos write SetCursorPos;
    procedure UpdateCursor;
    procedure ParentToClient(var P: TPoint);
    procedure ClientToParent(var P: TPoint);
    procedure ScreenToClient(var P: TPoint);
    procedure ClientToScreen(var P: TPoint);
    function PointInBounds(P: TPoint): Boolean; // client coordonates are expected.
    //#
    property Focused: Boolean read GetFocused write SetFocused;
    property Capture: Boolean read GetCapture write SetCapture;
    //#
    property Left: Integer read FLeft write SetLeft;
    property Top: Integer read FTop write SetTop;
    property Width: Integer read FWidth write SetWidth;
    property Height: Integer read FHeight write SetHeight;
    property Bounds: TARect read GetBounds;
    //#
    function SetBounds(ALeft, ATop, AWidth, AHeight: Integer): Integer; overload; virtual;
    function SetBounds(ARect: TARect): Integer; overload;
    function Move(ALeft, ATop: Integer): Boolean;
    function Size(AWidth, AHeight: Integer): Boolean;
    //#
    property Anchors: Integer read FAnchors write FAnchors;
    property SizeConstraints[AIndex: Integer]: Integer read GetSizeConstraints write SetSizeConstraints;
    property MoveConstraints[AIndex: Integer]: Integer read GetMoveConstraints write SetMoveConstraints;
    // if custom constraints are activated by including CT_CUSTOM in constraintstype
    // then constraints flags will set which fields of the size/move constraints
    // will be active.
    property ConstraintsType: Integer read FConstraintsType write SetConstraintsType;
    property ConstraintsFlags: Integer read FConstraintsFlags write SetConstraintsFlags;
    procedure UpdateConstraints;
    //#
    procedure Invalidate(RepaintType: Integer; ReBuffer: Boolean = False); overload;
    procedure Invalidate(RepaintType: Integer; ARect: TRect; ReBuffer: Boolean = False); overload;
    procedure Repaint(RepaintType: Integer; ReBuffer: Boolean = False); overload;
    procedure Repaint(RepaintType: Integer; ARect: TRect; ReBuffer: Boolean = False); overload;
    procedure Changed; virtual;
    //#
    procedure Show;
    procedure Hide;
    property LocationAlpha: Byte read FLocationAlpha write SetLocationAlpha;
    property Alpha: Byte read FAlpha write SetAlpha;
    //#
    property ControlType: Integer read FControlType write SetControlType;
    //#
    property Name: String read FName;
    property Visible: Boolean read FVisible write SetVisible;
    property AlwaysOnTop: Boolean read FAlwaysOnTop write SetAlwaysOnTop;
    property Cursor: Boolean read FCursor write SetCursor;
    property Focusable: Boolean read FFocusable write SetFocusable;
    property Movable: Boolean read FMovable write SetMovable;
    property Sizable: Boolean read FSizable write SetSizable;
    property Draw: Boolean read FDraw write SetDraw;
    property Msg: Boolean read FMsg write SetMsg;
    //#
    property TabFocusIndex: Integer read GetTabFocusIndex write SetTabFocusIndex;
    //#
    property MoveRect: TARect read FMoveRect write FMoveRect;
    property SizeRect: TARect read FSizeRect write FSizeRect;
    property Moving: Boolean read FMoving;
    property Sizing: Boolean read FSizing;
    //#
    property LayerManager: TALayerManager read FLayerManager;
    property Parent: TAForm read FParent write SetParent;
    property Buffer: TFoot read FBuffer write FBuffer;
    property BufferType: Integer read FBufferType write SetBufferType;
    property BufferRender: Integer read FBufferRender write SetBufferRender;
    //#
    property Layer: Integer read GetLayer write SetLayer;
    procedure Surface; overload;
    procedure Surface(By: Integer); overload;
    procedure SurfaceTo(ALayer: Integer);
    procedure Dive; overload;
    procedure Dive(By: Integer); overload;
    procedure DiveTo(ALayer: Integer);
    procedure LayerTo(ALayer: Integer);
    //#
    //#
    // controls can be held in a single container at a time. children can be added only
    // if the control has a parent and the container and child share the
    // same parent. when the parent is changed the child is removed.
    property Container: TAControl read FContainer;
    property ContainerFlags: Integer read FContainerFlags write SetContainerFlags;
    //#
    function AddContainerChild(AControl: TAControl; AControlSetFlags: Integer = 0): Boolean;
    function RemoveContainerChild(AControl: TAControl): Boolean;
    function FindContainerChild(AControl: TAControl): Integer;
    //#
    property ContainerChild[AIndex: Integer]: TAControl read GetContainerChild;
    property ContainerChildCount: Integer read FContainerChildCount;
    //#
    //#
    // animation functions like this. the speed must always be positive. the acceleration
    // depends if you want to accelerate or decelerate. if the speed decelerates so much
    // that it would reverse the direction then the animation stops.
    function StartMoveAnimation(ASrcX, ASrcY, ADestX, ADestY: Integer; ASpeedX, ASpeedY, AAccelerationX, AAccelerationY: Extended; ATimeOut: Integer): Boolean;
    function StopMoveAnimation: Boolean;
    property MoveAnimating: Boolean read FMoveAnimation;
    property MoveAnimationRec: TMoveSizeAnimationRec read FMoveAnimationRec;
    //#
    function StartSizeAnimation(ASrcX, ASrcY, ADestX, ADestY: Integer; ASpeedX, ASpeedY, AAccelerationX, AAccelerationY: Extended; ATimeOut: Integer): Boolean;
    function StopSizeAnimation: Boolean;
    property SizeAnimating: Boolean read FSizeAnimation;
    property SizeAnimationRec: TMoveSizeAnimationRec read FSizeAnimationRec;
    //#
    function StartAlphaAnimation(ASrc, ADest: Byte; ASpeed, AAcceleration: Extended; ATimeOut: Integer): Boolean;
    function StopAlphaAnimation: Boolean;
    property AlphaAnimating: Boolean read FAlphaAnimation;
    property AlphaAnimationRec: TAlphaAnimationRec read FAlphaAnimationRec;
    //#
    //#
    // if the form is a rgn layer then this is the minimum opaque alpha
    // to consider a rect added to the region list. the layer has to be visible
    // to updatergnlist.
    property RgnAlpha: Byte read FRgnAlpha write SetRgnAlpha;
    property RgnList: TARectList read FRgnList;
    procedure UpdateRgnList;
(*============================================================================*)
    property OnProcessMessage: TOnProcessMessage read FOnProcessMessage write FOnProcessMessage;
    //#
    //#
    property OnDestroy: TOnEvent read FOnDestroy write FOnDestroy;
    property OnBeforeSetBounds: TOnEvent read FOnBeforeSetBounds write FOnBeforeSetBounds;
    property OnAfterSetBounds: TOnEvent read FOnAfterSetBounds write FOnAfterSetBounds;
    property OnShow: TOnEvent read FOnShow write FOnShow;
    property OnHide: TOnEvent read FOnHide write FOnHide;
    property OnSetAlwaysOnTop: TOnEvent read FOnSetAlwaysOnTop write FOnSetAlwaysOnTop;
    property OnReleaseAlwaysOnTop: TOnEvent read FOnReleaseAlwaysOnTop write FOnReleaseAlwaysOnTop;
    property OnSetFocus: TOnEvent read FOnSetFocus write FOnSetFocus;
    property OnReleaseFocus: TOnEvent read FOnReleaseFocus write FOnReleaseFocus;
    property OnSetCapture: TOnEvent read FOnSetCapture write FOnSetCapture;
    property OnReleaseCapture: TOnEvent read FOnReleaseCapture write FOnReleaseCapture;
    property OnChangeLayer: TOnEvent read FOnChangeLayer write FOnChangeLayer;
    property OnSetDraw: TOnEvent read FOnSetDraw write FOnSetDraw;
    property OnReleaseDraw: TOnEvent read FOnReleaseDraw write FOnReleaseDraw;
    property OnSetMsg: TOnEvent read FOnSetMsg write FOnSetMsg;
    property OnReleaseMsg: TOnEvent read FOnReleaseMsg write FOnReleaseMsg;
    property OnMouseEnter: TOnEvent read FOnMouseEnter write FOnMouseEnter;
    property OnMouseLeave: TOnEvent read FOnMouseLeave write FOnMouseLeave;
    //#
    property OnMouseMove: TOnMouseEvent read FOnMouseMove write FOnMouseMove;
    property OnMouseDown: TOnMouseEvent read FOnMouseDown write FOnMouseDown;
    property OnMouseUp: TOnMouseEvent read FOnMouseUp write FOnMouseUp;
    property OnMouseClick: TOnMouseEvent read FOnMouseClick write FOnMouseClick;
    property OnMouseDblClick: TOnMouseEvent read FOnMouseDblClick write FOnMouseDblClick;
    property OnMouseWheel: TOnWheelEvent read FOnMouseWheel write FOnMouseWheel;
    property OnKeyDown: TOnKeyEvent read FOnKeyDown write FOnKeyDown;
    property OnKeyUp: TOnKeyEvent read FOnKeyUp write FOnKeyUp;
    property OnKeyChar: TOnCharEvent read FOnKeyChar write FOnKeyChar;
    //#
    property OnMoveStart: TOnEvent read FOnMoveStart write FOnMoveStart;
    property OnMoving: TOnEvent read FOnMoving write FOnMoving;
    property OnMoveStop: TOnEvent read FOnMoveStop write FOnMoveStop;
    property OnSizeStart: TOnEvent read FOnSizeStart write FOnSizeStart;
    property OnSizing: TOnEvent read FOnSizing write FOnSizing;
    property OnSizeStop: TOnEvent read FOnSizeStop write FOnSizeStop;
    //#
    property OnMoveAnimationStart: TOnEvent read FOnMoveAnimationStart write FOnMoveAnimationStart;
    property OnMoveAnimating: TOnEvent read FOnMoveAnimating write FOnMoveAnimating;
    property OnMoveAnimationStop: TOnEvent read FOnMoveAnimationStop write FOnMoveAnimationStop;
    property OnSizeAnimationStart: TOnEvent read FOnSizeAnimationStart write FOnSizeAnimationStart;
    property OnSizeAnimating: TOnEvent read FOnSizeAnimating write FOnSizeAnimating;
    property OnSizeAnimationStop: TOnEvent read FOnSizeAnimationStop write FOnSizeAnimationStop;
    property OnAlphaAnimationStart: TOnEvent read FOnAlphaAnimationStart write FOnAlphaAnimationStart;
    property OnAlphaAnimating: TOnEvent read FOnAlphaAnimating write FOnAlphaAnimating;
    property OnAlphaAnimationStop: TOnEvent read FOnAlphaAnimationStop write FOnAlphaAnimationStop;
  end;



//##############################################################################
//##                               LAYERMANAGER                               ##
//##############################################################################



  TALayerManager = class(TObject)
  protected
    FForm: TAForm;
    //#
    // this is the buffer where all the layers will be painted on.
    // the image painted on the windows device context.
    FLayerBuffer: TFoot;
    FRedrawList,
    FRelayerList: TARectList;
    //#
    FHoverLayer,
    FFocusedLayer,
    FCaptureLayer: TObject;
    //#
    FControlList: TAList;
    FControlCount: Integer;
    FTabFocusList: TAList;
    FTabFocusCount: Integer;
    //#
    //#
    // used to move nonalwaysontop layers under the alwaysontop layers.
    FAlwaysOnTopCount: Integer;
    //#
    // this is true when a relayer/redraw flushqueue message is in queue.
    // it should be set to false when CM_LAYERMANAGER_FLUSHQUEUE is processed.
    FFlushQueue: Boolean;
    //#
    // this is used to emulate click message. it holds the buttons pressed on
    // the form so that when a press matches a release a click message is posted.
    FButtonDown: Integer;
    //#
    //#
    // a layer can notify another layer of a processed message. this list will
    // hold the layers which does the notifying. the actual operation is done in
    // processmessage points.
    FMessageNotifyList: TAList;
    FMessageNotifyCount: Integer;
(*============================================================================*)
    FOnDestroy,
    FOnBeforeSetCapture,
    FOnAfterSetCapture,
    FOnBeforeReleaseCapture,
    FOnAfterReleaseCapture,
    FOnBeforeSetFocus,
    FOnAfterSetFocus,
    FOnBeforeReleaseFocus,
    FOnAfterReleaseFocus,
    FOnUpdateHover: TOnEvent;
    FOnFlushQueue: TOnEvent;
    //#
    FOnMouseMove,
    FOnMouseDown,
    FOnMouseUp,
    FOnMouseClick,
    FOnMouseDblClick: TOnMouseEvent;
    FOnMouseWheel: TOnWheelEvent;
    FOnKeyDown,
    FOnKeyUp: TOnKeyEvent;
    FOnKeyChar: TOnCharEvent;
(*============================================================================*)
    function GetControl(AIndex: Integer): TAControl;
    function GetLayer(AIndex: Integer): TObject;
    procedure SetLayer(AIndex: Integer; AControl: TObject);
    // will return the true hover layer no matter which layer has mouse capture.
    function GetHoverLayer(P: TPoint): TObject;
(*============================================================================*)
    function ConvertCursorPos(AControl: TAControl; Msg, LParam: Integer): Integer;
    procedure ReAnchor(AX, AY: Integer);
    //#
    // this procedure cycles through all layers and paints them on the backbuffer.
    procedure ReLayer; overload;
    procedure ReLayer(ARect: TRect); overload;
    // this procedure paints a rectangle of the backbuffer on the DC of the form window.
    procedure ReDraw; overload;
    procedure ReDraw(ARect: TRect); overload;
    //#
    // the procedure recives all the window messages and calls decodemessage to
    // distribute them to processmessage procs by separating messages into
    // categories and decideing which layer should recive them.
    procedure RedirectMessage(Msg, WParam, LParam: Integer);
    // only messages that have the other than MT_NA will make it to a layer
    // processmessage procedure else they just get processed by the form wndproc.
    procedure DecodeMessage(Msg, WParam, LParam: Integer; AMsgType: Integer);
(*============================================================================*)
  public
    //#
    //#
    constructor Create(AForm: TAForm);
    destructor Destroy; override;
    //#
    //#
    // functions with the (object) parameter will post or send a message to
    // a layer which doesn't have to be connected to this layermanager or have a parent.
    function SendMessage(Msg, WParam, LParam: Integer; ATypeOrLayer: Integer): Boolean; overload;
    function SendMessage(Msg, WParam, LParam: Integer; ALayer: TObject): Boolean; overload;
    function PostMessage(Msg, WParam, LParam: Integer; ATypeOrLayer: Integer): Boolean; overload;
    function PostMessage(Msg, WParam, LParam: Integer; ALayer: TObject): Boolean; overload;
    //#
    procedure Invalidate(ARepaintType: Integer); overload;
    procedure Invalidate(ARepaintType: Integer; ARect: TRect); overload;
    procedure Invalidate(ARepaintType: Integer; ALayer: TObject; ACheckVisibleDraw: Boolean = True); overload;
    procedure Invalidate(ARepaintType: Integer; ALayer: TObject; ARect: TRect; ACheckVisibleDraw: Boolean = True); overload;
    procedure Repaint(ARepaintType: Integer); overload;
    procedure Repaint(ARepaintType: Integer; ARect: TRect); overload;
    procedure Repaint(ARepaintType: Integer; ALayer: TObject; ACheckVisibleDraw: Boolean = True); overload;
    procedure Repaint(ARepaintType: Integer; ALayer: TObject; ARect: TRect; ACheckVisibleDraw: Boolean = True); overload;
    property RedrawQueue: TARectList read FRedrawList;
    property RelayerQueue: TARectList read FRelayerList;
    property LayerBuffer: TFoot read FLayerBuffer write FLayerBuffer;
    //#
    procedure FlushQueue;
    //#
    // if a layer on the form has focus then the form itself is focused. if you
    // release focus of a layer then the host form is unfocused. same with capture.
    function SetFocus(ALayer: TObject): Boolean;
    function SetCapture(ALayer: TObject): Boolean;
    function ReleaseFocus(ALayer: TObject; RelFormManager: Boolean = True): Boolean;
    function ReleaseCapture(ALayer: TObject; RelFormManager: Boolean = True): Boolean;
    property CaptureLayer: TObject read FCaptureLayer;
    property FocusedLayer: TObject read FFocusedLayer;
    property HoverLayer: TObject read FHoverLayer;
    // call this procedure when the mouse position changed like on a mousemove
    // message but also when a new control is made visible or when it changes bounds.
    procedure UpdateHover;
    //#
    function AddControl(AControl: TAControl): Boolean;
    function RemoveControl(AControl: TAControl): Boolean;
    function FindControl(const AName: String): Integer; overload;
    function FindControl(AControl: TObject): Integer; overload;
    //#
    property Controls[AIndex: Integer]: TAControl read GetControl;
    property ControlCount: Integer read FControlCount;
    property Layers[AIndex: Integer]: TObject read GetLayer;
    function FindLayer(ALayer: TObject): Integer;
    //#
    property Form: TAForm read FForm;
    //#
    //#
    function AddMessageNotify(AMsg: Integer; ASender, AReciver: TObject): Boolean;
    function RemoveMessageNotify(AMsg: Integer; ASender, AReciver: TObject): Boolean; overload;
    function RemoveMessageNotify(AMsg: Integer; ASender: TObject): Boolean; overload;
    function RemoveMessageNotifySender(ASender: TObject): Boolean; overload;
    function RemoveMessageNotifyReciver(AReciver: TObject): Boolean; overload;
    function FindMessageNotify(AMsg: Integer; ASender, AReciver: TObject): Integer;
    //#
    // this is ran by the processmessage procedures when a layer needs to notify
    // others of a message it has processed.
    procedure RunMessageNotify(AMsg: Integer; ASender: TObject);
(*============================================================================*)
    property OnDestroy: TOnEvent read FOnDestroy write FOnDestroy;
    property OnBeforeSetCapture: TOnEvent read FOnBeforeSetCapture write FOnBeforeSetCapture;
    property OnAfterSetCapture: TOnEvent read FOnAfterSetCapture write FOnAfterSetCapture;
    property OnBeforeReleaseCapture: TOnEvent read FOnBeforeReleaseCapture write FOnBeforeReleaseCapture;
    property OnAfterReleaseCapture: TOnEvent read FOnAfterReleaseCapture write FOnAfterReleaseCapture;
    property OnBeforeSetFocus: TOnEvent read FOnBeforeSetFocus write FOnBeforeSetFocus;
    property OnAfterSetFocus: TOnEvent read FOnAfterSetFocus write FOnAfterSetFocus;
    property OnBeforeReleaseFocus: TOnEvent read FOnBeforeReleaseFocus write FOnBeforeReleaseFocus;
    property OnAfterReleaseFocus: TOnEvent read FOnAfterReleaseFocus write FOnAfterReleaseFocus;
    property OnUpdateHover: TOnEvent read FOnUpdateHover write FOnUpdateHover;
    property OnFlushQueue: TOnEvent read FOnFlushQueue write FOnFlushQueue;
    //#
    property OnMouseMove: TOnMouseEvent read FOnMouseMove write FOnMouseMove;
    property OnMouseDown: TOnMouseEvent read FOnMouseDown write FOnMouseDown;
    property OnMouseUp: TOnMouseEvent read FOnMouseUp write FOnMouseUp;
    property OnMouseClick: TOnMouseEvent read FOnMouseClick write FOnMouseClick;
    property OnMouseDblClick: TOnMouseEvent read FOnMouseDblClick write FOnMouseDblClick;
    property OnMouseWheel: TOnWheelEvent read FOnMouseWheel write FOnMouseWheel;
    property OnKeyDown: TOnKeyEvent read FOnKeyDown write FOnKeyDown;
    property OnKeyUp: TOnKeyEvent read FOnKeyUp write FOnKeyUp;
    property OnKeyChar: TOnCharEvent read FOnKeyChar write FOnKeyChar;
  end;



//##############################################################################
//##                                MESSAGETABLE                              ##
//##############################################################################



  // MESSAGETABLE STORES ALL MESSAGES (WM_FIRST..AM_LAST) OR A CUSTOM NUMBER
  // OF MESSAGES AND ASSIGNES EACH MSG A TYPE. FOR THE MESSAGE TYPES CHECK OUT
  // THE CONSTANTS SECTION.

  TAMessageTable = class(TObject)
  protected
    FList: PMessageTypeArray;
    FCapacity: Integer;
    //#
    FFirstMsg,
    FLastMsg: Cardinal;
(*============================================================================*)
    function GetCount: Integer;
    function GetMessageType(AMessage: Cardinal): Integer;
    procedure SetMessageType(AMessage: Cardinal; AMsgType: Integer);
(*============================================================================*)
    procedure SetCapacity(ACapacity: Integer);
(*============================================================================*)
  public
    //#
    //#
    constructor Create(AFirstMsg, ALastMsg: Integer); overload;
    constructor Create; overload;
    destructor Destroy; override;
    //#
    //#
    property MessageType[AMessage: Cardinal]: Integer read GetMessageType write SetMessageType;
    property FirstMsg: Cardinal read FFirstMsg;
    property LastMsg: Cardinal read FLastMsg;
    property Count: Integer read GetCount;
  end;



//##############################################################################
//##                               TIMERMANAGER                               ##
//##############################################################################



  TATimerManager = class(TAThread)
  protected
    FHookTimerList: TAList;
    FHookTimerCount: Integer;
    //#
    FSyncTimerList: TAList;
    FSyncTimerCount: Integer;
    FSyncHandle: Cardinal;
    FSyncWindowProcInstance: Pointer;
    //#
    FThreadTimerList: TAList;
    FThreadTimerCount: Integer;
    FThreadTimerListLock: TALock;
    FThreadTimerWaitLock: TALock;
    FThreadHandle: Cardinal;
    FThreadWindowProcInstance: Pointer;
(*============================================================================*)
    procedure HookProcedure;
    function SyncProcedure(AHandle: Cardinal; Msg, WParam, LParam: Integer): Integer; stdcall;
    function ThreadProcedure(AHandle: Cardinal; Msg, WParam, LParam: Integer): Integer; stdcall;
    //#
    procedure Execute; override;
    //#
    function CreateSyncHandle: Boolean;
    function DestroySyncHandle: Boolean;
    function CreateThreadHandle: Boolean;
    function DestroyThreadHandle: Boolean;
(*============================================================================*)
  public
    //#
    //#
    constructor Create;
    destructor Destroy; override;
    //#
    //#
    function AddTimer(ATimerType: Integer; AId: Cardinal; ATimeOut: Cardinal; AReciver: TObject): Boolean;
    function RemoveTimer(ATimerType: Integer; AId: Cardinal; AReciver: TObject): Boolean;
    function FindTimer(ATimerType: Integer; AId: Cardinal; AReciver: TObject): Integer; overload;
    //#
    // this is a way to request that the manager send a timer message between
    // timeouts. this will not reset the counters.
    function RunTimer(ATimerType: Integer; AId: Cardinal; AReciver: TObject): Boolean;
    //#
    property HookTimerCount: Integer read FHookTimerCount;
    //#
    property SyncTimerCount: Integer read FSyncTimerCount;
    property SyncHandle: Cardinal read FSyncHandle;
    //#
    // thread timers execute without entering the global lock and the remove
    // procedure will wait for a running timer to exit before removing it.
    property ThreadTimerCount: Integer read FThreadTimerCount;
    property ThreadTimerListLock: TALock read FThreadTimerListLock;
    property ThreadTimerWaitLock: TALock read FThreadTimerWaitLock;
    property ThreadHandle: Cardinal read FThreadHandle;
  end;




//##############################################################################
//##                              init and final                              ##
//##############################################################################

procedure Init;
procedure Final;

//##############################################################################
//##                            cursor functions                              ##
//##############################################################################

procedure SetCursor(ACursor: TAControl; Offset: TPoint);
procedure SetCursorState(AState: Integer);
procedure SetCursorVisible(AVisible: Boolean);

//##############################################################################
//##                             menu functions                               ##
//##############################################################################

procedure SetMenu(AMinimize, ARestore, AClose: TAControl);
procedure AddMenu(AControl: TAControl);
procedure RemoveMenu(AControl: TAControl);
//#
procedure ProcessMenu(ASender: TObject; AMsg, WParam, LParam: Cardinal);
procedure UpdateMenu;




                        //##############
                        //###  VAR   ###
                        //##############
                        Var
                        //######################################################
                        //##################### GLOBAL USED ####################

  MessageTable: TAMessageTable;
  TimerManager: TATimerManager;

                        //######################################################
                        //################### CURSOR VARIABILES ################

  Cursor: TAControl;
  CursorState: Integer = -1;
  CursorVisible: Boolean = True;
  CursorOffset: TPoint;

  CursorStateConvert: array[0..3] of PChar = (IDC_ARROW, IDC_IBEAM, IDC_SIZEALL, IDC_SIZENWSE);

                        //######################################################
                        //#################### MENU VARIABILES #################

  Menu: TAForm;
  MenuWidth,
  MenuHeight: Integer;

  Minimize,
  Restore,
  Close: TAControl;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                              IMPLEMENTATION                              ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
Implementation




        		//##############
        		//##   USES   ##
        		//##############
        		Uses
                        //######################################################
                        //######################### OWN ########################
                                                  UPrimitives;




                        //##############
                        //### CONST  ###
                        //##############
                        Const
                        //######################################################
                        //############ BASE CLASS FOR THREADTIMER ##############

  ThreadTimerWindowClass: TWndClass = (
            Style: 0;
            lpfnWndProc: @DefWindowProc;
            cbClsExtra: 0;
            cbWndExtra: 0;
            hInstance: 0;
            hIcon: 0;
            hCursor: 0;
            hbrBackground: 0;
            lpszMenuName: nil;
            lpszClassName: 'classATimerManagerThread');

                        //######################################################
                        //############## BASE CLASS FOR SYNCTIMER ##############

  SyncTimerWindowClass: TWndClass = (
            Style: 0;
            lpfnWndProc: @DefWindowProc;
            cbClsExtra: 0;
            cbWndExtra: 0;
            hInstance: 0;
            hIcon: 0;
            hCursor: 0;
            hbrBackground: 0;
            lpszMenuName: nil;
            lpszClassName: 'classATimerManagerSync');




//##############################################################################
//##                            cursor functions                              ##
//##############################################################################

procedure SetCursor(ACursor: TAControl; Offset: TPoint);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ACursor is TAAnimation) then
        begin
                // disable the cursor first.
                SetCursor(nil, NewPoint(0, 0));

                // enable it again.
                Cursor:= ACursor;
                Cursor.Draw:= True;
                Cursor.Msg:= False;
                Cursor.AlwaysOnTop:= True;                
                Cursor.Cursor:= True;
                Cursor.Visible:= CursorVisible;
                TAAnimation(Cursor).State:= CursorState;

                CursorOffset:= Offset;

                if (FormManager.HoverForm is TAForm) then
                begin
                        Cursor.SetParent(TAForm(FormManager.HoverForm));
                        Mouse.Visible:= False;
                end
                else begin
                        Cursor.SetParent(nil);
                        Mouse.Visible:= True;
                end;
        end
        else begin
                if (Cursor <> nil) then
                begin
                        Cursor.SetParent(nil);
                        Cursor.Cursor:= False;
                        Cursor:= nil;
                end;

                Mouse.Visible:= CursorVisible;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure SetCursorState(AState: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AState <> CursorState) then
        begin
                CursorState:= AState;


                if (Cursor <> nil) then TAAnimation(Cursor).State:= CursorState
                else HWindows.SetCursor(LoadCursor(0, CursorStateConvert[AState]));
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure SetCursorVisible(AVisible: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (CursorVisible <> AVisible) then
        begin
                CursorVisible:= AVisible;


                if (Cursor <> nil) then Cursor.Visible:= CursorVisible
                else Mouse.Visible:= AVisible;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;

//##############################################################################
//##                             menu functions                               ##
//##############################################################################

procedure SetMenu(AMinimize, ARestore, AClose: TAControl);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AMinimize is TAButton)and(ARestore is TAButton)and(AClose is TAButton) then
        begin
                // disable the menu first.
                SetMenu(nil, nil, nil);

                // enable it again.
                Menu:= TAForm.Create('applicationMenu', BT_FOOT, FT_CONTROLS_ON or FT_ALWAYS_ON_TOP or FT_FOCUSABLE or FT_MENU);
                Menu.OnProcessMessage:= ProcessMenu;

                Minimize:= AMinimize;
                Minimize.SetParent(Menu);
                Minimize.OnProcessMessage:= ProcessMenu;

                Restore:= ARestore;
                Restore.SetParent(Menu);
                Restore.OnProcessMessage:= ProcessMenu;

                Close:= AClose;
                Close.SetParent(Menu);
                Close.OnProcessMessage:= ProcessMenu;

                Application.AllowMenu:= False;
        end
        else begin
                if (Menu <> nil) then
                begin
                        if (Minimize <> nil) then
                        begin
                                Minimize.SetParent(nil);
                                Minimize.OnProcessMessage:= nil;
                                Minimize:= nil;
                        end;

                        if (Restore <> nil) then
                        begin
                                Restore.SetParent(nil);
                                Restore.OnProcessMessage:= nil;
                                Restore:= nil;
                        end;

                        if (Close <> nil) then
                        begin
                                Close.SetParent(nil);
                                Close.OnProcessMessage:= nil;
                                Close:= nil;
                        end;

                        FreeNil(Menu);
                end;

                Application.AllowMenu:= True;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure AddMenu(AControl: TAControl);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (Menu <> nil)and(AControl <> nil) then
        begin
                AControl.SetParent(Menu);
                AControl.OnProcessMessage:= ProcessMenu;


                UpdateMenu;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure RemoveMenu(AControl: TAControl);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (Menu <> nil)and(AControl <> nil)and(AControl.FParent = Menu)and
           (AControl <> Minimize)and(AControl <> Restore)and(AControl <> Close) then
        begin
                AControl.SetParent(nil);
                AControl.OnProcessMessage:= nil;


                UpdateMenu;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure ProcessMenu(ASender: TObject; AMsg, WParam, LParam: Cardinal);
var ScreenRect: TRect;
    X, Y: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        case AMsg of
          AM_APPLICATION_SHOW_MENU:
          begin
                if (ASender = Menu) then
                begin
                        ScreenRect:= Screen.Bounds;
                        X:= 0;
                        Y:= 0;

                        if (LowInt(LParam) + MenuWidth > ScreenRect.Right) then X:= -MenuWidth;
                        if (HighInt(LParam) + MenuHeight > ScreenRect.Bottom) then Y:= -MenuHeight;
                        Menu.Move(LowInt(LParam) + X, HighInt(LParam) + Y);
                        Menu.StartSizeAnimation(0, 0, MenuWidth, MenuHeight, 2.5, 2.5, 0.1, 0.1, 8);
                        Menu.Show;
                end;
          end;
          //
          AM_APPLICATION_UPDATE_MENU: if (ASender = Menu) then UpdateMenu;
          //
          AM_LAYER_CHANGE: UpdateMenu;
          //
          AM_RELEASE_FOCUS:
          if (ASender = Menu) then
          begin
                Menu.StopSizeAnimation;
                Menu.Hide;
          end;
          //
          AM_HIDE: if (ASender = Menu) then Menu.Size(MenuWidth, MenuHeight);
          //
          AM_PUSH:
          begin
                if (ASender = Minimize) then begin Menu.Hide; Application.Minimize; end
                else if (ASender = Restore) then begin Menu.Hide; Application.Restore; end
                else if (ASender = Close) then begin Menu.Hide; Application.Terminate; end;
          end;
          //
          AM_KEY_DOWN, AM_SYSKEY_DOWN:
          begin
                case CharUpper(Char(WParam)) of
                  'N':
                  begin
                        Menu.Hide;
                        Application.Minimize;
                  end;
                  //
                  'R':
                  begin
                        Menu.Hide;
                        Application.Restore;
                  end;
                  //
                  'C':
                  begin
                        Menu.Hide;
                        Application.Terminate;
                  end;
                  //
                  Char(VK_ESCAPE): Menu.Hide;
                  //
                end;
          end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure UpdateMenu;
var i, Y: Integer;
    AControl: TAControl;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (Menu <> nil) then
        begin
                TAButton(Minimize).Disabled:= Application.Minimized;
                TAButton(Restore).Disabled:= not Application.Minimized;
                TAButton(Close).Disabled:= not Application.AllowTerminate;

                MenuWidth:= 0;
                MenuHeight:= 0;
                Y:= 0;

                for i:= 0 to Menu.FLayerManager.FControlCount - 1 - Integer((Cursor <> nil)and(Cursor.FParent = Menu)) do
                begin
                        AControl:= Menu.FLayerManager.Controls[i];

                        AControl.Move(0, Y);
                        Inc(Y, AControl.Height);
                        MenuWidth:= Max(MenuWidth, AControl.Width);
                        MenuHeight:= MenuHeight + AControl.Height;
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##                                   FORM                                   ##
//##############################################################################


{ TAForm }




constructor TAForm.Create(const AName: String; ABufferType, AFormType: Integer; AWindowProcPointer: Pointer = nil);
begin
if (AWindowProcPointer = nil) then FWindowProcPointer:= @TAForm.WindowProc
else FWindowProcPointer:= AWindowProcPointer;

FName:= AName;
FBufferType:= ABufferType;



        FHandle:= 0;
        FDC:= 0;
        FWindowProcInstance:= nil;

        FLeft:= 0;
        FTop:= 0;
        FWidth:= 0;
        FHeight:= 0;
        FConstraintsFlags:= CF_NONE;
        FConstraintsType:= CT_CUSTOM;

        FVisible:= False;
        FAlwaysOnTop:= False;
        FAllowHide:= True;
        FFocusable:= False;
        FCreateRgn:= False;
        FOptimalRgn:= False;
        FMenu:= False;
        FControlMovable:= False;
        FControlSizable:= False;
        FControlsDraw:= False;
        FControlsMsg:= False;

        FMoveControl:= nil;
        FSizeControl:= nil;
        FMoving:= False;
        FSizing:= False;



        FButtonDown:= 0;

        FRgnUpdate:= False;

        FCursorDef:= CS_ARROW;

        FNotify:= 0;



        FMoveAnimation:= False;
        FSizeAnimation:= False;

        FRgnAlpha:= A_CLEAR;
        FRgnList:= TARectList.Create;
        FRgn:= HWindows.CreateRectRgn(0, 0, $FFF, $FFF);
        FRgnRegion:= TARectList.Create;
        FRgnLayerList:= TAList.Create;
        FRgnLayerCount:= 0;



        FLayerManager:= TALayerManager.Create(Self);

        case FBufferType and (not BT_RESIZE) of
          BT_FOOT: FBuffer:= TFoot.Create;
          BT_TILEFOOT: FBuffer:= TTileFoot.Create;
        end;

        CreateHandle;
        SetFormType(AFormType);
        FormManager.AddForm(Self);
end;


destructor TAForm.Destroy;
begin
        FormManager.RemoveForm(Self);
        DestroyHandle;

        FreeNil(FLayerManager);
        FreeNil(FBuffer);



        StopMoveAnimation;
        StopSizeAnimation;

        HWindows.DeleteObject(FRgn);
        FreeNil(FRgnRegion);
        FreeNil(FRgnLayerList);
        FreeNil(FRgnList);



(*==============*)
(**) if Assigned(FOnDestroy) then FOnDestroy(Self);
(*==============*)
end;


procedure TAForm.SetCursorDef(ACursorDef: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FCursorDef <> ACursorDef) then
        begin
                FCursorDef:= ACursorDef;


                UpdateCursor;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAForm.GetFocused: Boolean;
begin
        Result:= (Integer(FLayerManager.FFocusedLayer) = Integer(Self));
end;


procedure TAForm.SetFocused(AFocused: Boolean);
begin
        case AFocused of
          True: FLayerManager.SetFocus(Self);
          else FLayerManager.ReleaseFocus(Self);
        end;

        (*[][][][][][][]*)
        // updatehover is done in release/set focus
        (*[][][][][][][]*)
end;


function TAForm.GetCapture: Boolean;
begin
        Result:= (Integer(FLayerManager.FCaptureLayer) = Integer(Self));
end;


procedure TAForm.SetCapture(ACapture: Boolean);
begin
        case ACapture of
          True: FLayerManager.SetCapture(Self);
          else FLayerManager.ReleaseCapture(Self);
        end;

        (*[][][][][][][]*)
        // updatehover is done in release/set capture
        (*[][][][][][][]*)
end;


procedure TAForm.SetBufferType(ABufferType: Integer);
var AOldType: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FBufferType <> ABufferType) then
        begin
                AOldType:= FBufferType;
                FBufferType:= ABufferType;


                if (FBufferType and (not BT_RESIZE)) <> (AOldType and (not BT_RESIZE)) then
                begin
                        FreeNil(FBuffer);

                        case FBufferType and (not BT_RESIZE) of
                          BT_FOOT: FBuffer:= TFoot.Create;
                          BT_TILEFOOT: FBuffer:= TTileFoot.Create;
                        end;
                end;

                // just in case BT_RESIZE was modified.
                if (FBufferType and BT_RESIZE <> 0) then FBuffer.Resize(FWidth, FHeight);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetFormType(AFormType:  Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AFormType <> FFormType) then
        begin
                SetVisible(AFormType and FT_VISIBLE <> 0);
                SetAlwaysOnTop(AFormType and FT_ALWAYS_ON_TOP <> 0);
                SetFocusable(AFormType and FT_FOCUSABLE <> 0);
                SetCreateRgn(AFormType and FT_CREATERGN <> 0);
                SetOptimalRgn(AFormType and FT_OPTIMALRGN <> 0);
                SetMenu(AFormType and FT_MENU <> 0);
                SetControlMovable(AFormType and FT_CONTROL_MOVABLE <> 0);
                SetControlSizable(AFormType and FT_CONTROL_SIZABLE <> 0);
                SetControlsDraw(AFormType and FT_CONTROLS_DRAW <> 0);
                SetControlsMsg(AFormType and FT_CONTROLS_MSG <> 0);

                FFormType:= AFormType;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetVisible(AVisible: Boolean);
var ALayer: TObject;
    i: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FVisible <> (AVisible or (not FAllowHide))) then
        begin
                FFormType:= FFormType xor FT_VISIBLE;
                FVisible:= AVisible or (not FAllowHide);


                case (FVisible or (not FAllowHide)) of
                  True:
                  begin
                        HWindows.SetWindowPos(FHandle, 0, 0, 0, 0, 0, SWP_SHOWWINDOW or SWP_NOMOVE or SWP_NOSIZE or SWP_ASYNCWINDOWPOS);

                        Surface;
                        FormManager.SetFocus(Self);
                        FLayerManager.Invalidate(RT_RELAYER_REDRAW);

                        (*{}{}{}{}{}{}{}*)
                        (**) if (FCreateRgn) then
                        (**) begin
                        (**)         for i:= 0 to FRgnLayerCount-1 do
                        (**)         begin
                        (**)                 ALayer:= FRgnLayerList.Items[i];
                        (**)
                        (**)                 if (ALayer is TAForm) then TAForm(ALayer).UpdateRgnList
                        (**)                 else if (ALayer is TAControl) then TAControl(ALayer).UpdateRgnList;
                        (**)         end;
                        (**)
                        (**)         UpdateRgn(True);
                        (**) end;
                        (*{}{}{}{}{}{}{}*)

                        (*--------------*)
                        (**) FLayerManager.PostMessage(AM_SHOW, 0, 0, Self);
                        (*--------------*)
                  end;
                  //
                  else begin
                        HWindows.SetWindowPos(FHandle, 0, 0, 0, 0, 0, SWP_HIDEWINDOW or SWP_NOMOVE or SWP_NOSIZE or SWP_ASYNCWINDOWPOS);

                        FormManager.ReleaseFocus(Self);
                        FormManager.ReleaseCapture(Self);
                        FMoving:= False;
                        FSizing:= False;

                        FButtonDown:= 0;

                        // focus another window of the same application.
                        if (Self <> FormManager.CoreForm) then FormManager.SetFocus(FormManager.CoreForm);

                        (*--------------*)
                        (**) FLayerManager.PostMessage(AM_HIDE, 0, 0, Self);
                        (*--------------*)
                  end;
                  //
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetAlwaysOnTop(AAlwaysOnTop: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FAlwaysOnTop <> AAlwaysOnTop) then
        begin
                FFormType:= FFormType xor FT_ALWAYS_ON_TOP;
                FAlwaysOnTop:= AAlwaysOnTop;


                case FAlwaysOnTop of
                  True:
                  begin
                        HWindows.SetWindowPos(FHandle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_ASYNCWINDOWPOS);

                        Surface;

                        (*--------------*)
                        (**) FLayerManager.PostMessage(AM_SET_ALWAYSONTOP, 0, 0, Self);
                        (*--------------*)
                  end;
                  //
                  else begin
                        HWindows.SetWindowPos(FHandle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_ASYNCWINDOWPOS);

                        (*--------------*)
                        (**) FLayerManager.PostMessage(AM_RELEASE_ALWAYSONTOP, 0, 0, Self);
                        (*--------------*)
                  end;
                  //
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetFocusable(AFocusable: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AFocusable <> FFocusable) then
        begin
                FFormType:= FFormType xor FT_FOCUSABLE;
                FFocusable:= AFocusable;


                case FFocusable of
                  True:
                  begin
                        FLayerManager.FTabFocusList.Add(Self);
                        Inc(FLayerManager.FTabFocusCount);
                  end;
                  //
                  else begin
                        FLayerManager.FTabFocusList.Remove(Self);
                        Dec(FLayerManager.FTabFocusCount);

                        FLayerManager.ReleaseFocus(Self);
                  end;
                  //
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetCreateRgn(ACreateRgn: Boolean);
var i: Integer;
    ALayer: TObject;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FCreateRgn <> ACreateRgn) then
        begin
                FFormType:= FFormType xor FT_CREATERGN;
                FCreateRgn:= ACreateRgn;


                case FCreateRgn of
                  True:
                  begin
                        (*{}{}{}{}{}{}{}*)
                        (**) for i:= 0 to FRgnLayerCount-1 do
                        (**) begin
                        (**)         ALayer:= FRgnLayerList.Items[i];
                        (**)
                        (**)         if (ALayer is TAForm) then TAForm(ALayer).UpdateRgnList
                        (**)         else if (ALayer is TAControl) then TAControl(ALayer).UpdateRgnList;
                        (**) end;
                        (*{}{}{}{}{}{}{}*)

                        (*--------------*)
                        (**) FLayerManager.SendMessage(AM_SET_CREATERGN, 0, 0, Self);
                        (*--------------*)
                  end;
                  //
                  else
                        (*--------------*)
                        (**) FLayerManager.SendMessage(AM_RELEASE_CREATERGN, 0, 0, Self);
                        (*--------------*)
                  //
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetOptimalRgn(AOptimalRgn: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FOptimalRgn <> AOptimalRgn) then
        begin
                FFormType:= FFormType xor FT_OPTIMALRGN;
                FOptimalRgn:= AOptimalRgn;


                (*{}{}{}{}{}{}{}*)
                (**) UpdateRgn;
                (*{}{}{}{}{}{}{}*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetMenu(AMenu: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FMenu <> AMenu) then
        begin
                FFormType:= FFormType xor FT_MENU;
                FMenu:= AMenu;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetControlMovable(AControlMovable: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FControlMovable <> AControlMovable) then
        begin
                FFormType:= FFormType xor FT_CONTROL_MOVABLE;
                FControlMovable:= AControlMovable;


                if (not FControlMovable)and(FMoving) then
                begin
                        FMoving:= False;
                        FLayerManager.ReleaseCapture(Self);
                        FLayerManager.ReleaseCapture(FMoveControl);
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetControlSizable(AControlSizable: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FControlSizable <> AControlSizable) then
        begin
                FFormType:= FFormType xor FT_CONTROL_SIZABLE;
                FControlSizable:= AControlSizable;


                if (not FControlSizable)and(FSizing) then
                begin
                        FSizing:= False;
                        FLayerManager.ReleaseCapture(Self);
                        FLayerManager.ReleaseCapture(FSizeControl);
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetControlsDraw(AControlsDraw: Boolean);
var ALayer: TObject;
    i: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FControlsDraw <> AControlsDraw) then
        begin
                FFormType:= FFormType xor FT_CONTROLS_DRAW;
                FControlsDraw:= AControlsDraw;


                (*[][][][][][][]*)
                (**) FLayerManager.UpdateHover;
                (*[][][][][][][]*)

                FLayerManager.Invalidate(RT_RELAYER_REDRAW);

                case FControlsDraw of
                  True:
                  begin
                        (*{}{}{}{}{}{}{}*)
                        (**) if (FCreateRgn) then
                        (**) begin
                        (**)         for i:= 0 to FRgnLayerCount-1 do
                        (**)         begin
                        (**)                 ALayer:= FRgnLayerList.Items[i];
                        (**)
                        (**)                 if (ALayer is TAControl) then TAControl(ALayer).UpdateRgnList;
                        (**)         end;
                        (**) end;
                        (*{}{}{}{}{}{}{}*)

                        (*--------------*)
                        (**) FLayerManager.SendMessage(AM_SET_CONTROLS_DRAW, 0, 0, Self);
                        (*--------------*)
                  end;
                  //
                  else begin
                        (*{}{}{}{}{}{}{}*)
                        (**) UpdateRgn;
                        (*{}{}{}{}{}{}{}*)

                        (*--------------*)
                        (**) FLayerManager.SendMessage(AM_RELEASE_CONTROLS_DRAW, 0, 0, Self);
                        (*--------------*)
                  end;
                  //
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetControlsMsg(AControlsMsg: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AControlsMsg <> FControlsMsg) then
        begin
                FFormType:= FFormType xor FT_CONTROLS_MSG;
                FControlsMsg:= AControlsMsg;


                (*[][][][][][][]*)
                (**) FLayerManager.UpdateHover;
                (*[][][][][][][]*)

                case FControlsMsg of
                  True:
                         (*--------------*)
                         (**) FLayerManager.SendMessage(AM_SET_CONTROLS_MSG, 0, 0, Self);
                         (*--------------*)
                  //
                  else begin
                        if (FMoving or FSizing) then
                        begin
                                FMoving:= False;
                                FSizing:= False;
                                FLayerManager.ReleaseFocus(FMoveControl);
                                FLayerManager.ReleaseCapture(FSizeControl);
                        end;

                        if (Integer(Self) <> Integer(FLayerManager.FFocusedLayer)) then
                                FLayerManager.ReleaseFocus(FLayerManager.FFocusedLayer);
                        if (Integer(Self) <> Integer(FLayerManager.FCaptureLayer)) then
                                FLayerManager.ReleaseCapture(FLayerManager.FCaptureLayer);

                        (*--------------*)
                        (**) FLayerManager.SendMessage(AM_RELEASE_CONTROLS_MSG, 0, 0, Self);
                        (*--------------*)
                  end;
                  //
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAForm.GetTabFocusIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FFocusable) then Result:= FLayerManager.FTabFocusList.Find(Self)
        else Result:= -1;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetTabFocusIndex(AIndex: Integer);
var OldIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FFocusable) then
        begin
                Restrict(AIndex, 0, FLayerManager.FTabFocusCount-1);

                OldIndex:= FLayerManager.FTabFocusList.Find(Self);
                FLayerManager.FTabFocusList.Move(OldIndex, AIndex);

        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetMoveControl(AMoveControl: TAControl);
var OldControl: TAControl;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FMoveControl <> AMoveControl)and(Integer(AMoveControl.FParent) = Integer(Self)) then
        begin
                OldControl:= FMoveControl;
                FMoveControl:= AMoveControl;


                if (FMoving) then
                begin
                        FMoving:= False;
                        FLayerManager.ReleaseCapture(Self);
                        FLayerManager.ReleaseCapture(OldControl);

                        (*[][][][][][][]*)
                        // updatehover is done in releasecapture
                        (*[][][][][][][]*)
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetSizeControl(ASizeControl: TAControl);
var OldControl: TAControl;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FSizeControl <> ASizeControl)and(Integer(ASizeControl.FParent) = Integer(Self)) then
        begin
                OldControl:= FSizeControl;
                FSizeControl:= ASizeControl;


                if (FSizing) then
                begin
                        FSizing:= False;
                        FLayerManager.ReleaseCapture(Self);
                        FLayerManager.ReleaseCapture(OldControl);

                        (*[][][][][][][]*)
                        // updatehover is done in releasecapture
                        (*[][][][][][][]*)
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAForm.GetSizeConstraints(AIndex: Integer): Integer;
var P: ^Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        P:= @FSizeConstraints;
        Integer(P):= Integer(P) + (AIndex shl 2);
        Result:= P^;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAForm.GetMoveConstraints(AIndex: Integer): Integer;
var P: ^Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        P:= @FMoveConstraints;
        Integer(P):= Integer(P) + (AIndex shl 2);
        Result:= P^;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetSizeConstraints(AIndex: Integer; ASizeConstraints: Integer);
var P: ^Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        P:= @FSizeConstraints;
        Integer(P):= Integer(P) + (AIndex shl 2);

        if (P^ <> ASizeConstraints) then
        begin
                P^:= ASizeConstraints;


                UpdateConstraints;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetMoveConstraints(AIndex: Integer; AMoveConstraints: Integer);
var P: ^Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        P:= @FMoveConstraints;
        Integer(P):= Integer(P) + (AIndex shl 2);

        if (P^ <> AMoveConstraints) then
        begin
                P^:= AMoveConstraints;


                UpdateConstraints;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.SetConstraintsType(AConstraintsType: Integer);
begin
        FConstraintsType:= AConstraintsType;

        UpdateConstraints;
end;


procedure TAForm.SetConstraintsFlags(AConstraintsFlags: Integer);
begin
        FConstraintsFlags:= AConstraintsFlags;

        UpdateConstraints;
end;


function TAForm.GetLayer: Integer;
begin
        Result:= LAYER_FORM;
end;


function TAForm.GetControl(AIndex: Integer): TAControl;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AIndex > -1)and(AIndex < FLayerManager.FControlCount) then
                Result:= FLayerManager.GetControl(AIndex)
        else begin
                Result:= nil;

                {$IFDEF THREADSAFE}
                 ThreadManager.ClearExclusive;
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Getcontrol index out of bounds. Requested ' + IntToStr(AIndex) + ', count ' + IntToStr(FLayerManager.FControlCount) + '.', 'TAForm.GetControl | ' + FName, Self);
                (*++++++++++++++*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAForm.GetControlCount: Integer;
begin
        Result:= FLayerManager.FControlCount;
end;


procedure TAForm.SetRgnAlpha(ARgnAlpha: Byte);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ARgnAlpha <> FRgnAlpha) then
        begin
                FRgnAlpha:= ARgnAlpha;


                (*{}{}{}{}{}{}{}*)
                (**) UpdateRgnList;
                (*{}{}{}{}{}{}{}*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAForm.WindowProc(AHandle: Cardinal; Msg, WParam, LParam: Integer): Integer;
var Redraw: Boolean;
    Data: PRgnData;
    Rgn: Cardinal;
    Size, Count, i: Integer;
    Rect: PRect;
begin
        case Msg of
          WM_SHOWWINDOW,
          WM_CLOSE,
          WM_CAPTURECHANGED,
          WM_ACTIVATE,
          WM_SETFOCUS,
          WM_KILLFOCUS,
          WM_MOUSEHOVER,
          WM_MOUSELEAVE:
                Result:= inherited WindowProc(AHandle, Msg, WParam, LParam);
          //
          WM_MOUSEMOVE:
          begin
                (*[][][][][][][]*)
                (**) FLayerManager.UpdateHover;
                (*[][][][][][][]*)

                if (Cursor <> nil) then Cursor.Move(LowInt(LParam) - CursorOffset.X, HighInt(LParam) - CursorOffset.Y);

                Result:= inherited WindowProc(AHandle, Msg, WParam, LParam);
          end;
          //
          CM_MOUSE_LEAVE:
          begin
                (*[][][][][][][]*)
                (**) FLayerManager.UpdateHover;
                (*[][][][][][][]*)

                if (Cursor <> nil) then
                begin
                        RemoveRgnLayer(Cursor);
                        Cursor.SetParent(nil);
                        Mouse.Visible:= True;
                end;

                Result:= inherited WindowProc(AHandle, Msg, WParam, LParam);
          end;
          //
          CM_MOUSE_ENTER:
          begin
                (*[][][][][][][]*)
                (**) FLayerManager.UpdateHover;
                (*[][][][][][][]*)

                if (Cursor <> nil) then
                begin
                        Cursor.SetParent(Self);
                        AddRgnLayer(Cursor);                        
                        Mouse.Visible:= False;
                end;

                Result:= inherited WindowProc(AHandle, Msg, WParam, LParam);
          end;
          //
          WM_KEYDOWN, WM_SYSKEYDOWN:
          begin
                if (not FMenu) then
                begin
                        if (Msg = WM_SYSKEYDOWN)and(WParam = VK_SPACE)or(Msg = WM_KEYDOWN)and(WParam = VK_APPS) then
                                (*--------------*)
                                (**) Application.SendMessage(Application.Handle, WM_REQUESTMENU, 0, 0);
                                (*--------------*)
                end;

                Result:= inherited WindowProc(AHandle, Msg, WParam, LParam);
          end;
          //
          WM_DISPLAYCHANGE:
          begin
                UpdateConstraints;

                Result:= inherited WindowProc(AHandle, Msg, WParam, LParam);
          end;
          //
          AM_CREATE_HANDLE,
          AM_DESTROY_HANDLE:
                (*--------------*)
                (**) Result:= Integer(FLayerManager.SendMessage(Msg, WParam, LParam, Self));
                (*--------------*)
          //
          AM_APPLICATION_MINIMIZE,
          AM_APPLICATION_RESTORE,
          AM_APPLICATION_SHOW_MENU,
          AM_APPLICATION_HIDE_MENU,
          AM_APPLICATION_UPDATE_MENU,
          AM_FORMMANAGER_SET_CAPTURE,
          AM_FORMMANAGER_RELEASE_CAPTURE,
          AM_FORMMANAGER_SET_FOCUS,
          AM_FORMMANAGER_RELEASE_FOCUS,
          AM_FORMMANAGER_UPDATE_HOVER:
                (*--------------*)
                (**) Result:= Integer(FLayerManager.SendMessage(Msg, WParam, LParam, MT_BROADCAST));
                (*--------------*)
          //
          CM_SET_FOCUS:
          begin
                // only focus the form if no layer is focused
                if (FLayerManager.FFocusedLayer = nil) then Result:= Integer(FLayerManager.SetFocus(Self))
                else Result:= 0;
          end;
          //
          CM_RELEASE_FOCUS:
                Result:= Integer(FLayerManager.ReleaseFocus(FLayerManager.FFocusedLayer));
          //
          CM_SET_CAPTURE:
          begin
                // only setcapture the form if no layer has capture
                if (FLayerManager.FCaptureLayer = nil) then Result:= Integer(FLayerManager.SetCapture(Self))
                else Result:= 0;
          end;
          //
          CM_RELEASE_CAPTURE:
                Result:= Integer(FLayerManager.ReleaseCapture(FLayerManager.FCaptureLayer));
          //
          // will only handle backbuffer painting when outside factor
          // like other windows ask for invalidation.
          CM_PAINT, WM_PAINT:
          begin
                Rgn:= CreateRectRgn(0, 0, 0, 0);
                Redraw:= GetUpdateRgn(FHandle, Rgn, False) <> NULLREGION;

                // run the default wndproc so the area is validated and the
                // WM_PAINT is erased from the message queue.
                Result:= HWindows.DefWindowProc(AHandle, WM_PAINT, DC, LParam);

                if (Redraw) then
                begin
                       Size:= HWindows.GetRegionData(Rgn, 0, nil);
                       GetMem(Data, Size);
                       HWindows.GetRegionData(Rgn, Size, Data);

                       Rect:= @Data^.Buffer;
                       Count:= Data^.rdh.nCount;
                       for i:= 0 to Count-1 do
                       begin
                               FLayerManager.Invalidate(RT_REDRAW, Rect^);
                               Inc(Integer(Rect), SizeOf(TRect));
                       end;

                       FreeMem(Data);
                end;

                HWindows.DeleteObject(Rgn);

                FFastPaint:= False;
          end;
          //
          CM_LAYERMANAGER_FLUSHQUEUE:
          begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

                FLayerManager.FlushQueue;

                FLayerManager.FFlushQueue:= False;

                Result:= 0;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}
          end;
          //
          // always pass all other messages to the default
          // window procedure (system handled).
          else Result:= HWindows.DefWindowProc(FHandle, Msg, WParam, LParam);
          //
        end;




        (*~~~~~~~~~~~~~~~~~~~~*)
        (**) FLayerManager.RedirectMessage(Msg, WParam, LParam);
        (*~~~~~~~~~~~~~~~~~~~~*)
end;


procedure TAForm.ProcessMessage(Msg, WParam, LParam: Integer);
var AControl: TAControl;
    AForm: TAForm;
    ALayer: TObject;
    R: TRect;
    AIndex, i, j: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        (*==============*)
        (**) if (Assigned(FOnProcessMessage)) then FOnProcessMessage(Self, Msg, WParam, LParam);
        (*==============*)




        case Msg of
          AM_DESTROY_HANDLE:
          begin
                // remove the region inclusion.
                if (FRgnIncluded) then RemoveRgnLayer(Self);

                // remove all layers to which this has to send notifications.
                if (FNotify > 0) then FLayerManager.RemoveMessageNotifySender(Self);
          end;
          //
          AM_MOUSE_DOWNL:
          begin
                // controlmovable handle
                if (FControlMovable)and(FMoveControl <> nil)and(FMoveControl.FVisible)and
                   (FMoveControl.PointInBounds(NewPoint(LowInt(LParam) - FMoveControl.FLeft, HighInt(LParam) - FMoveControl.FTop))) then
                begin
                        FLayerManager.SetCapture(Self);
                        FMoving:= True;
                        Fx:= LowInt(LParam);
                        Fy:= HighInt(LParam);

                        (*==============*)
                        (**) if (Assigned(FOnMoveStart)) then FOnMoveStart(Self);
                        (*==============*)
                end
                // controlsizable handle
                else if (FControlSizable)and(FSizeControl <> nil)and(FSizeControl.FVisible)and
                        (FSizeControl.PointInBounds(NewPoint(LowInt(LParam) - FSizeControl.FLeft, HighInt(LParam) - FSizeControl.FTop))) then
                begin
                        FLayerManager.SetCapture(Self);
                        FSizing:= True;
                        Fx:= FWidth - LowInt(LParam);
                        Fy:= FHeight - HighInt(LParam);

                        (*==============*)
                        (**) if (Assigned(FOnSizeStart)) then FOnSizeStart(Self);
                        (*==============*)
                end;

                FLayerManager.SetFocus(Self);

                (*==============*)
                (**) if (Assigned(FOnMouseDown)) then FOnMouseDown(Self, LowInt(LParam), HighInt(LParam), WParam);
                (**) FButtonDown:= FButtonDown or MB_LEFT;
                (*==============*)
          end;
          //
          AM_MOUSE_DOWNM:
          begin
                FLayerManager.SetFocus(Self);

                (*==============*)
                (**) if (Assigned(FOnMouseDown)) then FOnMouseDown(Self, LowInt(LParam), HighInt(LParam), WParam);
                (**) FButtonDown:= FButtonDown or MB_MIDDLE;
                (*==============*)
          end;
          //
          AM_MOUSE_DOWNR:
          begin
                FLayerManager.SetFocus(Self);

                (*==============*)
                (**) if (Assigned(FOnMouseDown)) then FOnMouseDown(Self, LowInt(LParam), HighInt(LParam), WParam);
                (**) FButtonDown:= FButtonDown or MB_RIGHT;
                (*==============*)
          end;
          //
          AM_MOUSE_UPL:
          begin
                if (FMoving)and(FMoveControl <> nil) then
                begin
                        FLayerManager.ReleaseCapture(Self);
                        FMoving:= False;

                        (*==============*)
                        (**) if (Assigned(FOnMoveStop)) then FOnMoveStop(Self);
                        (*==============*)
                end
                else if (FSizeControl <> nil)and(FSizing) then
                begin
                        FLayerManager.ReleaseCapture(Self);
                        FSizing:= False;

                        (*==============*)
                        (**) if (Assigned(FOnSizeStop)) then FOnSizeStop(Self);
                        (*==============*)
                end;

                (*==============*)
                (**) if (Assigned(FOnMouseUp)) then FOnMouseUp(Self, LowInt(LParam), HighInt(LParam), WParam);
                (*==============*)

                (*--------------*)
                (**) if (FButtonDown and MB_LEFT <> 0) then FLayerManager.SendMessage(AM_MOUSE_CLICKL, WParam, LParam, Self);
                (**) FButtonDown:= FButtonDown and (not MB_LEFT);
                (*--------------*)
          end;
          //
          AM_MOUSE_UPM:
          begin
                (*==============*)
                (**) if (Assigned(FOnMouseUp)) then FOnMouseUp(Self, LowInt(LParam), HighInt(LParam), WParam);
                (*==============*)

                (*--------------*)
                (**) if (FButtonDown and MB_MIDDLE <> 0) then FLayerManager.SendMessage(AM_MOUSE_CLICKM, WParam, LParam, LAYER_FORM);
                (**) FButtonDown:= FButtonDown and (not MB_MIDDLE);
                (*--------------*)
          end;
          //
          AM_MOUSE_UPR:
          begin
                (*==============*)
                (**) if (Assigned(FOnMouseUp)) then FOnMouseUp(Self, LowInt(LParam), HighInt(LParam), WParam);
                (*==============*)

                (*--------------*)
                (**) if (FButtonDown and MB_RIGHT <> 0) then FLayerManager.SendMessage(AM_MOUSE_CLICKR, WParam, LParam, LAYER_FORM);
                (**) FButtonDown:= FButtonDown and (not MB_RIGHT);
                (*--------------*)
          end;
          //
          AM_MOUSE_MOVE:
          begin
                UpdateCursor;

                if (FMoving)and(FMoveControl <> nil) then
                begin
                        Move(Left + LowInt(LParam) - Fx, Top + HighInt(LParam) - Fy);

                        (*==============*)
                        (**) if (Assigned(FOnMoving)) then FOnMoving(Self);
                        (*==============*)
                end
                else if (FSizeControl <> nil)and(FSizing) then
                begin
                        Size(LowInt(LParam) + Fx, HighInt(LParam) + Fy);

                        (*==============*)
                        (**) if (Assigned(FOnSizing)) then FOnSizing(Self);
                        (*==============*)
                end;

                (*==============*)
                (**) if (Assigned(FOnMouseMove)) then FOnMouseMove(Self, LowInt(LParam), HighInt(LParam), WParam);
                (*==============*)
          end;
          //
          AM_MOUSE_CLICKL, AM_MOUSE_CLICKM, AM_MOUSE_CLICKR:
                 (*==============*)
                 (**) if (Assigned(FOnMouseClick)) then FOnMouseClick(Self, LowInt(LParam), HighInt(LParam), WParam);
                 (*==============*)
          //
          AM_MOUSE_DBLCLICKL, AM_MOUSE_DBLCLICKM, AM_MOUSE_DBLCLICKR:
                (*==============*)
                (**) if (Assigned(FOnMouseDblClick)) then FOnMouseDblClick(Self, LowInt(LParam), HighInt(LParam), WParam);
                (*==============*)
          //
          AM_MOUSE_WHEEL:
                (*==============*)
                (**) if (Assigned(FOnMouseWheel)) then FOnMouseWheel(Self, LowInt(LParam), HighInt(LParam), HighInt(WParam), LowInt(WParam));
                (*==============*)
          //
          AM_SYSKEY_DOWN, AM_KEY_DOWN:
          begin
                // tab focus next.
                if (WParam = VK_TAB)and(FFocusable) then
                begin
                        AIndex:= FLayerManager.FTabFocusList.Find(Self);

                        if (Keyboard.ShiftState and SS_SHIFT = 0) then
                        begin
                                if (AIndex < FLayerManager.FTabFocusCount - 1) then FLayerManager.SetFocus(FLayerManager.FTabFocusList.Items[AIndex + 1])
                                else FLayerManager.SetFocus(FLayerManager.FTabFocusList.Items[0]);
                        end
                        else begin
                                if (AIndex > 0) then FLayerManager.SetFocus(FLayerManager.FTabFocusList.Items[AIndex - 1])
                                else FLayerManager.SetFocus(FLayerManager.FTabFocusList.Items[FLayerManager.FTabFocusCount - 1]);
                        end;
                end;

                (*==============*)
                (**) if (Assigned(FOnKeyDown)) then FOnKeyDown(Self, WParam, Keyboard.ShiftState);
                (*==============*)
          end;
          //
          AM_SYSKEY_UP, AM_KEY_UP:
                (*==============*)
                (**) if (Assigned(FOnKeyUp)) then FOnKeyUp(Self, WParam, Keyboard.ShiftState);
                (*==============*)
          //
          AM_SYSKEY_CHAR, AM_KEY_CHAR:
                (*==============*)
                (**) if (Assigned(FOnKeyChar)) then FOnKeyChar(Self, Char(WParam), Keyboard.ShiftState);
                (*==============*)
          //
          AM_MOUSE_ENTER:
          begin
                UpdateCursor;

                (*==============*)
                (**) if (Assigned(FOnMouseEnter)) then FOnMouseEnter(Self);
                (*==============*)
          end;
          //
          AM_MOUSE_LEAVE:
          begin
                UpdateCursor;

                (*==============*)
                (**) if (Assigned(FOnMouseLeave)) then FOnMouseLeave(Self);
                (*==============*)
          end;
          //
          AM_SHOW:
                (*==============*)
                (**) if (Assigned(FOnShow)) then FOnShow(Self);
                (*==============*)
          //
          AM_HIDE:
                (*==============*)
                (**) if (Assigned(FOnHide)) then FOnHide(Self);
                (*==============*)
          //
          AM_SET_ALWAYSONTOP:
                (*==============*)
                (**) if (Assigned(FOnSetAlwaysOnTop)) then FOnSetAlwaysOnTop(Self);
                (*==============*)
          //
          AM_RELEASE_ALWAYSONTOP:
                (*==============*)
                (**) if (Assigned(FOnReleaseAlwaysOnTop)) then FOnReleaseAlwaysOnTop(Self);
                (*==============*)
          //
          AM_RELEASE_CREATERGN:
          begin
                HWindows.DeleteObject(FRgn);

                FRgnWidth:= FWidth;
                FRgnHeight:= FHeight;
                FRgn:= HWindows.CreateRectRgn(0, 0, $FFF, $FFF);

                // resize the layerbuffer.
                if (FLayerManager.LayerBuffer.Width <> FRgnWidth)or(FLayerManager.LayerBuffer.Height <> FRgnHeight) then
                begin
                        HWindows.SetWindowPos(FHandle, 0, 0, 0, FRgnWidth, FRgnHeight, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOACTIVATE or SWP_NOZORDER or SWP_ASYNCWINDOWPOS);
                        FLayerManager.LayerBuffer.Resize(FRgnWidth, FRgnHeight);
                        FLayerManager.Invalidate(RT_RELAYER);
                end;

                HWindows.SetWindowRgn(FHandle, FRgn, True);
          end;
          //
          AM_SET_FOCUS:
                (*==============*)
                (**) if (Assigned(FOnSetFocus)) then FOnSetFocus(Self);
                (*==============*)
          //
          AM_RELEASE_FOCUS:
                (*==============*)
                (**) if (Assigned(FOnReleaseFocus)) then FOnReleaseFocus(Self);
                (*==============*)
          //
          AM_SET_CAPTURE:
                (*==============*)
                (**) if (Assigned(FOnSetCapture)) then FOnSetCapture(Self);
                (*==============*)
          //
          AM_RELEASE_CAPTURE:
                (*==============*)
                (**) if (Assigned(FOnReleaseCapture)) then FOnReleaseCapture(Self);
                (*==============*)
          //
          AM_SET_CONTROLS_DRAW:
                (*==============*)
                (**) if (Assigned(FOnSetControlsDraw)) then FOnSetControlsDraw(Self);
                (*==============*)
          //
          AM_RELEASE_CONTROLS_DRAW:
                (*==============*)
                (**) if (Assigned(FOnReleaseControlsDraw)) then FOnReleaseControlsDraw(Self);
                (*==============*)
          //
          AM_SET_CONTROLS_MSG:
                (*==============*)
                (**) if (Assigned(FOnSetControlsMsg)) then FOnSetControlsMsg(Self);
                (*==============*)
          //
          AM_RELEASE_CONTROLS_MSG:
                (*==============*)
                (**) if (Assigned(FOnReleaseControlsMsg)) then FOnReleaseControlsMsg(Self);
                (*==============*)
          //
          AM_APPLICATION_RESTORE:
          begin
                FLayerManager.Invalidate(RT_RELAYER_REDRAW);

                (*{}{}{}{}{}{}{}*)
                (**) if (FCreateRgn) then
                (**) begin
                (**)         for i:= 0 to FRgnLayerCount-1 do
                (**)         begin
                (**)                 ALayer:= FRgnLayerList.Items[i];
                (**)
                (**)                 if (ALayer is TAForm) then TAForm(ALayer).UpdateRgnList
                (**)                 else if (ALayer is TAControl) then TAControl(ALayer).UpdateRgnList;
                (**)         end;
                (**)
                (**)         UpdateRgn(True);
                (**) end;
                (*{}{}{}{}{}{}{}*)
          end;
          //
          AM_MOVE_ANIMATION_START:
                (*==============*)
                (**) if (Assigned(FOnMoveAnimationStart)) then FOnMoveAnimationStart(Self);
                (*==============*)
          //
          AM_MOVE_ANIMATION_STOP:
                (*==============*)
                (**) if (Assigned(FOnMoveAnimationStop)) then FOnMoveAnimationStop(Self);
                (*==============*)
          //
          AM_SIZE_ANIMATION_START:
                (*==============*)
                (**) if (Assigned(FOnSizeAnimationStart)) then FOnSizeAnimationStart(Self);
                (*==============*)
          //
          AM_SIZE_ANIMATION_STOP:
                (*==============*)
                (**) if (Assigned(FOnSizeAnimationStop)) then FOnSizeAnimationStop(Self);
                (*==============*)
          //
          AM_UPDATE_RGN:
          begin
                if (FCreateRgn)and(FVisible)and((not Application.Minimized)or(FMenu)) then
                begin
                        HWindows.DeleteObject(FRgn);

                        // optimal means the real window size is just as much as it is needed.
                        // with windows that modify size it takes time to resize the buffer.
                        if (FOptimalRgn) then
                        begin
                                FRgnWidth:= 0;
                                FRgnHeight:= 0;
                        end
                        else begin
                                FRgnWidth:= Screen.Bounds.Right;
                                FRgnHeight:= Screen.Bounds.Bottom;
                        end;

                        // create the actual region.
                        FRgnRegion.Clear;
                        for i:= 0 to FRgnLayerCount-1 do
                        begin
                                if (FControlsDraw)and(TObject(FRgnLayerList.Items[i]) is TAControl) then
                                begin
                                        AControl:= TAControl(FRgnLayerList.Items[i]);

                                        if (AControl.FVisible) then
                                        for j:= 0 to AControl.FRgnList.Count-1 do
                                        begin
                                                R:= AControl.FRgnList.Items[j];
                                                RectOffset(R, NewPoint(AControl.Left, AControl.Top));
                                                if (FOptimalRgn) then
                                                begin
                                                        FRgnWidth:= Max(FRgnWidth, R.Right);
                                                        FRgnHeight:= Max(FRgnHeight, R.Bottom);
                                                end;
                                                FRgnRegion.Add(R);
                                        end;
                                end
                                else if (TObject(FRgnLayerList.Items[i]) is TAForm) then
                                begin
                                        AForm:= TAForm(FRgnLayerList.Items[i]);
                                        
                                        for j:= 0 to AForm.FRgnList.Count-1 do
                                        begin
                                                R:= AForm.FRgnList.Items[j];
                                                if (FOptimalRgn) then
                                                begin
                                                        FRgnWidth:= Max(FRgnWidth, R.Right);
                                                        FRgnHeight:= Max(FRgnHeight, R.Bottom);
                                                end;
                                                FRgnRegion.Add(R);
                                        end;
                                end;
                        end;

                        ReallocMem(FRgnBuffer, FRgnRegion.Count*SizeOf(TRect) + SizeOf(TRgnDataHeader));
                        for j:= 0 to FRgnRegion.Count-1 do PRect(SizeOf(TRgnDataHeader) + Integer(FRgnBuffer) + j*SizeOf(TRect))^:= FRgnRegion.Items[j];
                        PRgnData(FRgnBuffer).rdh.dwSize:= Sizeof(TRgnDataHeader);
                        PRgnData(FRgnBuffer).rdh.iType:= RDH_RECTANGLES;
                        PRgnData(FRgnBuffer).rdh.nCount:= FRgnRegion.Count;
                        PRgnData(FRgnBuffer).rdh.nRgnSize:= FRgnRegion.Count*SizeOf(TRect);

                        FRgn:= HWindows.ExtCreateRegion(nil, PRgnData(FRgnBuffer).rdh.dwSize + PRgnData(FRgnBuffer).rdh.nRgnSize, PRgnData(FRgnBuffer)^);

                        // resize the layerbuffer.
                        if (FLayerManager.LayerBuffer.Width <> FRgnWidth)or(FLayerManager.LayerBuffer.Height <> FRgnHeight) then
                        begin
                                HWindows.SetWindowPos(FHandle, 0, 0, 0, FRgnWidth, FRgnHeight, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOACTIVATE or SWP_NOZORDER or SWP_ASYNCWINDOWPOS);
                                FLayerManager.LayerBuffer.Resize(FRgnWidth, FRgnHeight);
                                FLayerManager.Invalidate(RT_RELAYER);
                        end;

                        HWindows.SetWindowRgn(FHandle, FRgn, True);

                        FRgnUpdate:= False;

                        (*==============*)
                        (**) if (Assigned(FOnUpdateRgn)) then FOnUpdateRgn(Self);
                        (*==============*)
                end;
          end;
          //
          AM_TIMER:
          begin
                case WParam of
                  //
                  TID_MOVE_ANIMATION:
                  if (not FMoving) then
                  begin
                        TAControl.RunMoveSizeAnimation(Move, StopMoveAnimation, FMoveAnimationRec, FLeft, FTop);

                        (*==============*)
                        (**) if (Assigned(FOnMoveAnimating)) then FOnMoveAnimating(Self);
                        (*==============*)
                  end;
                  //
                  TID_SIZE_ANIMATION:
                  if (not FSizing) then
                  begin
                        TAControl.RunMoveSizeAnimation(Size, StopSizeAnimation, FSizeAnimationRec, FWidth, FHeight);

                        (*==============*)
                        (**) if (Assigned(FOnSizeAnimating)) then FOnSizeAnimating(Self);
                        (*==============*)
                  end;
                  //
                end;
          end;
          //
        end;




        (*``````````````*)
        (**) if (FNotify > 0) then FLayerManager.RunMessageNotify(Msg, Self);
        (*,,,,,,,,,,,,,,*)

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.PaintLayer(ADestBuffer: TFoot);
begin
        FBuffer.Render(ADestBuffer, A_OPAQUE, RM_COPY);
end;


procedure TAForm.PaintLayer(ADestBuffer: TFoot; ADestRect: TRect);
begin
        FBuffer.Render(ADestBuffer, NewPoint(ADestRect.Left, ADestRect.Top), ADestRect, A_OPAQUE, RM_COPY);
end;


class procedure TAForm.RunConstraints(AConstraintsType, AConstraintsFlags: Integer; AMoveConstraints: TMoveConstraints; ASizeConstraints: TSizeConstraints; FLeft, FTop, FWidth, FHeight: Integer; AParentBounds: TARect; ABuffer: TFoot; var ALeft, ATop, AWidth, AHeight: Integer);
var AMin, AMax, LMin, LMax, TMin, TMax: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AConstraintsType <> CT_NONE) then
        begin
                // left
                LMin:= -MAX_INT;
                if (AConstraintsType and CT_PARENT_IN <> 0) then LMin:= Max(LMin, 0);
                if (AConstraintsType and CT_CUSTOM <> 0)and(AConstraintsFlags and CF_MIN_LEFT <> 0) then LMin:= Max(LMin, AMoveConstraints.MinLeft);
                //
                LMax:= MAX_INT;
                if (AConstraintsType and CT_PARENT_IN <> 0) then LMax:= Min(LMax, AParentBounds.Width - AWidth);
                if (AConstraintsType and CT_CUSTOM <> 0)and(AConstraintsFlags and CF_MAX_LEFT <> 0) then LMax:= Min(LMax, AMoveConstraints.MaxLeft);
                Restrict(ALeft, LMin, LMax);

                // top
                TMin:= -MAX_INT;
                if (AConstraintsType and CT_PARENT_IN <> 0) then TMin:= Max(TMin, 0);
                if (AConstraintsType and CT_CUSTOM <> 0)and(AConstraintsFlags and CF_MIN_TOP <> 0) then TMin:= Max(TMin, AMoveConstraints.MinTop);
                //
                TMax:= MAX_INT;
                if (AConstraintsType and CT_PARENT_IN <> 0) then TMax:= Min(TMax, AParentBounds.Height - AHeight);
                if (AConstraintsType and CT_CUSTOM <> 0)and(AConstraintsFlags and CF_MAX_TOP <> 0) then TMax:= Min(TMax, AMoveConstraints.MaxTop);
                Restrict(ATop, TMin, TMax);

                // width
                AMin:= -MAX_INT;
                if (AConstraintsType and CT_MIN_BUFFER <> 0) then AMin:= Max(AMin, ABuffer.Width);
                if (AConstraintsType and CT_CUSTOM <> 0)and(AConstraintsFlags and CF_MIN_WIDTH <> 0) then AMin:= Max(AMin, ASizeConstraints.MinWidth);
                //
                AMax:= MAX_INT;
                if (AConstraintsType and CT_MAX_BUFFER <> 0) then AMax:= Min(AMax, ABuffer.Width)
                else if (AConstraintsType and CT_PARENT_IN <> 0) then AMax:= AParentBounds.Width - FLeft;
                if (AConstraintsType and CT_CUSTOM <> 0)and(AConstraintsFlags and CF_MAX_WIDTH <> 0) then AMax:= Min(AMax, ASizeConstraints.MaxWidth);
                Restrict(AWidth, AMin, AMax);

                // height
                AMin:= -MAX_INT;
                if (AConstraintsType and CT_MIN_BUFFER <> 0) then AMin:= Max(AMin, ABuffer.Height);
                if (AConstraintsType and CT_CUSTOM <> 0)and(AConstraintsFlags and CF_MIN_HEIGHT <> 0) then AMin:= Max(AMin, ASizeConstraints.MinHeight);
                //
                AMax:= MAX_INT;
                if (AConstraintsType and CT_MAX_BUFFER <> 0) then AMax:= Min(AMax, ABuffer.Height)
                else if (AConstraintsType and CT_PARENT_IN <> 0) then AMax:= AParentBounds.Height - FTop;
                if (AConstraintsType and CT_CUSTOM <> 0)and(AConstraintsFlags and CF_MAX_HEIGHT <> 0) then AMax:= Min(AMax, ASizeConstraints.MaxHeight);
                Restrict(AHeight, AMin, AMax);

                // right
                AMin:= LMin;
                if (AConstraintsType and CT_PARENT_IN <> 0) then AMin:= Max(AMin, 0);
                if (AConstraintsType and CT_CUSTOM <> 0)and(AConstraintsFlags and CF_MIN_RIGHT <> 0) then AMin:= Max(AMin, AMoveConstraints.MinRight - AWidth);
                //
                AMax:= LMax;
                if (AConstraintsType and CT_PARENT_IN <> 0) then AMax:= Min(AMax, AParentBounds.Width - AWidth);
                if (AConstraintsType and CT_CUSTOM <> 0)and(AConstraintsFlags and CF_MAX_RIGHT <> 0) then AMax:= Min(AMax, AMoveConstraints.MaxRight - AWidth);
                Restrict(ALeft, AMin, AMax);

                // bottom
                AMin:= TMin;
                if (AConstraintsType and CT_PARENT_IN <> 0) then AMin:= Max(AMin, 0);
                if (AConstraintsType and CT_CUSTOM <> 0)and(AConstraintsFlags and CF_MIN_BOTTOM <> 0) then AMin:= Max(AMin, AMoveConstraints.MinBottom - AHeight);
                //
                AMax:= TMax;
                if (AConstraintsType and CT_PARENT_IN <> 0) then AMax:= Min(AMax, AParentBounds.Height - AHeight);
                if (AConstraintsType and CT_CUSTOM <> 0)and(AConstraintsFlags and CF_MAX_BOTTOM <> 0) then AMax:= Min(AMax, AMoveConstraints.MaxBottom - AHeight);
                Restrict(ATop, AMin, AMax);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.Load(const AFileName: String);
var Ext: String;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Unload;

        if FileExists(AFileName) then
        begin
                Ext:= StringUpper(FileExtractExt(AFileName));
                if (Ext = 'TF') then SetBufferType(BT_TILEFOOT)
                else if (Ext = 'F')or(Ext = 'BMP') then SetBufferType(BT_FOOT);

                FBuffer.Load(AFileName);

                // invalidate the form.
                FLayerManager.Invalidate(RT_RELAYER_REDRAW);
                UpdateConstraints;

                (*{}{}{}{}{}{}{}*)
                (**) UpdateRgnList;
                (*{}{}{}{}{}{}{}*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.UnLoad;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FBufferType and BT_TILEFOOT <> 0) then TTileFoot(FBuffer).TileEmpty:= True;
        FBuffer.Resize(0, 0);

        // invalidate the form.
        FLayerManager.Invalidate(RT_RELAYER_REDRAW);
        UpdateConstraints;

        (*{}{}{}{}{}{}{}*)
        (**) UpdateRgnList;
        (*{}{}{}{}{}{}{}*)

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.UpdateCursor;
var ACursor: TPoint;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        ACursor:= GetCursorPos;

        if (FControlMovable)and(FMoveControl <> nil)and(FMoveControl.FVisible)and
           ((FMoveControl.PointInBounds(NewPoint(ACursor.X - FMoveControl.FLeft, ACursor.Y - FMoveControl.FTop)))or(FMoving)) then SetCursorState(CS_MOVE)
        else if (FControlSizable)and(FSizeControl <> nil)and(FSizeControl.FVisible)and
                ((FSizeControl.PointInBounds(NewPoint(ACursor.X - FSizeControl.FLeft, ACursor.Y - FSizeControl.FTop)))or(FSizing)) then SetCursorState(CS_SIZE)
        else SetCursorState(FCursorDef);

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAForm.PointInBounds(P: TPoint): Boolean;
var i: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        case FCreateRgn of
          True:
          begin
                Result:= False;

                // restrict to region rects.
                for i:= 0 to FRgnRegion.Count-1 do
                begin
                        Result:= Result or PointInRect(P, FRgnRegion.Items[i]);
                        if Result then Break;
                end;
          end;
          //
          else  Result:= PointInRect(P, NewRect(0, 0, FWidth, FHeight));
          //
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAForm.SetBounds(ALeft, ATop, AWidth, AHeight: Integer): Integer;
var OLeft, OTop, OWidth, OHeight: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        // constrain the bounds to the parameters set and to the parent.
        TAForm.RunConstraints(FConstraintsType, FConstraintsFlags, FMoveConstraints, FSizeConstraints, FLeft, FTop, FWidth, FHeight, TARect(Screen.DesktopBounds), FBuffer, ALeft, ATop, AWidth, AHeight);

        // set the window real size to the current size.
        if (not FCreateRgn) then
        begin
                FRgnWidth:= AWidth;
                FRgnHeight:= AHeight;
        end;

        Result:= SB_NONE;

        if (AWidth <> FWidth)or(AHeight <> FHeight)or(ALeft <> FLeft)or(ATop <> FTop) then
        begin
                (*==============*)
                (**) if Assigned(FOnBeforeSetBounds) then FOnBeforeSetBounds(Self);
                (*==============*)

                case FBufferType and (not BT_RESIZE) of
                  BT_FOOT:
                  begin
                        HWindows.SetWindowPos(FHandle, 0, ALeft, ATop, FRgnWidth, FRgnHeight, SWP_NOACTIVATE or SWP_NOZORDER or SWP_ASYNCWINDOWPOS);

                        // move
                        if (ALeft <> FLeft)or(ATop <> FTop) then Result:= Result or SB_MOVE;

                        // size
                        if (FWidth <> AWidth)or(FHeight <> AHeight) then
                        begin
                                FLayerManager.FLayerBuffer.Resize(FRgnWidth, FRgnHeight);

                                // if we resize then we need to reanchor
                                FLayerManager.ReAnchor(AWidth-FWidth, AHeight-FHeight);

                                // keep layerbuffer updated
                                FLayerManager.Invalidate(RT_RELAYER, NewRect(0, 0, Min(FWidth, AWidth), Min(FHeight, AHeight)));
                                // make on-screen changes to the resized portion
                                FLayerManager.Invalidate(RT_RELAYER_REDRAW, NewRect(FWidth, 0, AWidth, FHeight));
                                FLayerManager.Invalidate(RT_RELAYER_REDRAW, NewRect(0, FHeight, AWidth, AHeight));

                                Result:= Result or SB_SIZE;
                        end;
                  end;
                  //
                  BT_TILEFOOT:
                  begin
                        HWindows.SetWindowPos(FHandle, 0, ALeft, ATop, FRgnWidth, FRgnHeight, SWP_NOACTIVATE or SWP_NOZORDER or SWP_ASYNCWINDOWPOS);

                        // move
                        if (ALeft <> FLeft)or(ATop <> FTop) then Result:= Result or SB_MOVE;

                        // size
                        if (FWidth <> AWidth)or(FHeight <> AHeight) then
                        begin
                                FLayerManager.FLayerBuffer.Resize(FRgnWidth, FRgnHeight);

                                // if we resize then we need to reanchor
                                FLayerManager.ReAnchor(AWidth-FWidth, AHeight-FHeight);

                                // keep layerbuffer updated
                                FLayerManager.Invalidate(RT_RELAYER, NewRect(0, 0, Min(FWidth, AWidth), Min(FHeight, AHeight)));
                                // the bottom tile after and before
                                FLayerManager.Invalidate(RT_RELAYER_REDRAW, NewRect(0, AHeight-TTileFoot(FBuffer).TileHeight[TID_RIGHT_BOTTOM], AWidth, AHeight));
                                FLayerManager.Invalidate(RT_RELAYER_REDRAW, NewRect(0, FHeight-TTileFoot(FBuffer).TileHeight[TID_RIGHT_BOTTOM], FWidth, FHeight));
                                // the right tile after and before
                                FLayerManager.Invalidate(RT_RELAYER_REDRAW, NewRect(AWidth-TTileFoot(FBuffer).TileWidth[TID_RIGHT_BOTTOM], 0, AWidth, AHeight-TTileFoot(FBuffer).TileHeight[TID_RIGHT_BOTTOM]));
                                FLayerManager.Invalidate(RT_RELAYER_REDRAW, NewRect(FWidth-TTileFoot(FBuffer).TileWidth[TID_RIGHT_BOTTOM], 0, FWidth, FHeight-TTileFoot(FBuffer).TileHeight[TID_RIGHT_BOTTOM]));
                                // the uncovered portion
                                FLayerManager.Invalidate(RT_RELAYER_REDRAW, NewRect(Min(FWidth, AWidth), 0, Max(AWidth, FWidth)-TTileFoot(FBuffer).TileWidth[TID_RIGHT_BOTTOM], Min(AHeight, FHeight)));
                                FLayerManager.Invalidate(RT_RELAYER_REDRAW, NewRect(0, Min(FHeight, AHeight), Max(FWidth, AWidth)-TTileFoot(FBuffer).TileWidth[TID_RIGHT_BOTTOM], Max(AHeight, FHeight)-TTileFoot(FBuffer).TileHeight[TID_RIGHT_BOTTOM]));

                                Result:= Result or SB_SIZE;
                        end;
                  end;
                  //
                end;

                if (FBufferType and BT_RESIZE <> 0) then FBuffer.Resize(FWidth, FHeight);

                OLeft:= FLeft;
                OTop:= FTop;
                OWidth:= FWidth;
                OHeight:= FHeight;
                FLeft:= ALeft;
                FTop:= ATop;
                FWidth:= AWidth;
                FHeight:= AHeight;

                (*{}{}{}{}{}{}{}*)
                (**) if (Result and SB_SIZE <> 0) then UpdateRgnList;
                (*{}{}{}{}{}{}{}*)

                (*[][][][][][][]*)
                (**) FLayerManager.UpdateHover;
                (*[][][][][][][]*)

                (*--------------*)
                (**) FLayerManager.SendMessage(AM_BOUNDS_CHANGE, 0, 0, Self);
                (*--------------*)

                (*--------------*)
                //   || WParamLo = by X
                //   || WParamHi = by Y
                //   || LParamLo = from X
                //   || LParamHi = from Y
                (**) if (Result and SB_MOVE <> 0) then FLayerManager.SendMessage(AM_MOVE, LowHigh(FLeft-OLeft, FTop-OTop), LowHigh(OLeft, OTop), Self);
                (*--------------*)

                (*--------------*)
                //   || WParamLo = by X
                //   || WParamHi = by Y
                //   || LParamLo = from X
                //   || LParamHi = from Y
                (**) if (Result and SB_SIZE <> 0) then FLayerManager.SendMessage(AM_SIZE, LowHigh(FWidth-OWidth, FHeight-OHeight), LowHigh(OWidth, OHeight), Self);
                (*--------------*)

                (*==============*)
                (**) if Assigned(FOnAfterSetBounds) then FOnAfterSetBounds(Self);
                (*==============*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.UpdateConstraints;
begin
        SetBounds(FLeft, FTop, FWidth, FHeight);
end;


procedure TAForm.Invalidate(RepaintType: Integer);
begin
        FLayerManager.Invalidate(RepaintType);
end;


procedure TAForm.Invalidate(RepaintType: Integer; ARect: TRect);
begin
        FLayerManager.Invalidate(RepaintType, ARect);
end;


procedure TAForm.Repaint(RepaintType: Integer);
begin
        FLayerManager.Repaint(RepaintType);
end;


procedure TAForm.Repaint(RepaintType: Integer; ARect: TRect);
begin
        FLayerManager.Repaint(RepaintType, ARect);
end;


procedure TAForm.Update;
begin
        FLayerManager.FlushQueue;

        HWindows.UpdateWindow(FHandle);
end;


function TAForm.StartMoveAnimation(ASrcX, ASrcY, ADestX, ADestY: Integer; ASpeedX, ASpeedY, AAccelerationX, AAccelerationY: Extended; ATimeOut: Integer): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FMoveAnimation)and((ASpeedX > 0)or(ASpeedY > 0))and(ATimeOut > 0)and
           ((ASrcX <> ADestX)or(ASrcY <> ADestY)) then
        begin
                Result:= True;
                FMoveAnimation:= True;

                Move(ASrcX, ASrcY);

                FMoveAnimationRec.SrcX:= ASrcX;
                FMoveAnimationRec.SrcY:= ASrcY;
                FMoveAnimationRec.DestX:= ADestX;
                FMoveAnimationRec.DestY:= ADestY;
                FMoveAnimationRec.SpeedX:= ASpeedX;
                FMoveAnimationRec.SpeedY:= ASpeedY;
                FMoveAnimationRec.AccelerationX:= AAccelerationX;
                FMoveAnimationRec.AccelerationY:= AAccelerationY;
                FMoveAnimationRec.Frame:= 1;
                if ASpeedX <> 0 then
                        FMoveAnimationRec.BlankFrameMaxX:= Ceil(1 / ASpeedX)
                else FMoveAnimationRec.BlankFrameMaxX:= 0;
                if ASpeedY <> 0 then
                        FMoveAnimationRec.BlankFrameMaxY:= Ceil(1 / ASpeedY)
                else FMoveAnimationRec.BlankFrameMaxY:= 0;
                FMoveAnimationRec.BlankFrameCountX:= 0;
                FMoveAnimationRec.BlankFrameCountY:= 0;

                TimerManager.AddTimer(TT_HOOK, TID_MOVE_ANIMATION, ATimeOut, Self);

                (*--------------*)
                (**) FLayerManager.SendMessage(AM_MOVE_ANIMATION_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAForm.StopMoveAnimation: Boolean;
var ASuccess: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FMoveAnimation) then
        begin
                Result:= True;
                FMoveAnimation:= False;
                ASuccess:= (FMoveAnimationRec.DestX = FLeft)and(FMoveAnimationRec.DestY = FTop);

                TimerManager.RemoveTimer(TT_HOOK, TID_MOVE_ANIMATION, Self);

                (*--------------*)
                // || WParam = target destination was achieved
                (**) FLayerManager.SendMessage(AM_MOVE_ANIMATION_STOP, Integer(ASuccess), 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAForm.StartSizeAnimation(ASrcX, AsrcY, ADestX, ADestY: Integer; ASpeedX, ASpeedY, AAccelerationX, AAccelerationY: Extended; ATimeOut: Integer): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FSizeAnimation)and((ASpeedX > 0)or(ASpeedY > 0))and(ATimeOut > 0)and
           ((ASrcX <> ADestX)or(ASrcY <> ADestY)) then
        begin
                Result:= True;
                FSizeAnimation:= True;

                Size(ASrcX, ASrcY);

                FSizeAnimationRec.SrcX:= ASrcX;
                FSizeAnimationRec.SrcY:= ASrcY;
                FSizeAnimationRec.DestX:= ADestX;
                FSizeAnimationRec.DestY:= ADestY;
                FSizeAnimationRec.SpeedX:= ASpeedX;
                FSizeAnimationRec.SpeedY:= ASpeedY;
                FSizeAnimationRec.AccelerationX:= AAccelerationX;
                FSizeAnimationRec.AccelerationY:= AAccelerationY;
                FSizeAnimationRec.Frame:= 1;
                if ASpeedX <> 0 then
                        FSizeAnimationRec.BlankFrameMaxX:= Ceil(1 / ASpeedX)
                else FSizeAnimationRec.BlankFrameMaxX:= 0;
                if ASpeedY <> 0 then
                        FSizeAnimationRec.BlankFrameMaxY:= Ceil(1 / ASpeedY)
                else FSizeAnimationRec.BlankFrameMaxY:= 0;
                FSizeAnimationRec.BlankFrameCountX:= 0;
                FSizeAnimationRec.BlankFrameCountY:= 0;

                TimerManager.AddTimer(TT_HOOK, TID_SIZE_ANIMATION, ATimeOut, Self);

                (*--------------*)
                (**) FLayerManager.SendMessage(AM_SIZE_ANIMATION_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAForm.StopSizeAnimation: Boolean;
var ASuccess: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FSizeAnimation) then
        begin
                Result:= True;
                FSizeAnimation:= False;
                ASuccess:= (FSizeAnimationRec.DestX = FWidth)and(FSizeAnimationRec.DestY = FHeight);

                TimerManager.RemoveTimer(TT_HOOK, TID_SIZE_ANIMATION, Self);

                (*--------------*)
                // || WParam = target destination was achieved
                (**) FLayerManager.SendMessage(AM_SIZE_ANIMATION_STOP, Integer(ASuccess), 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAForm.UpdateRgnList;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FCreateRgn)and(FRgnIncluded)and(FVisible)and((not Application.Minimized)or(FMenu)) then
        begin
                if (FRgnAlpha = 0) then
                begin
                        FRgnList.Clear;
                        FRgnList.Add(NewRect(0, 0, Min(FBuffer.Width, FWidth), Min(FBuffer.Height, Height)));
                end
                else FBuffer.ProcessOpacity(FRgnList, NewRect(0, 0, Min(FBuffer.Width, FWidth), Min(FBuffer.Height, Height)), FRgnAlpha);

                (*{}{}{}{}{}{}{}*)
                (**) UpdateRgn;
                (*{}{}{}{}{}{}{}*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAForm.AddRgnLayer(ALayer: TObject): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ALayer <> nil)and(((ALayer is TAForm)and(TAForm(ALayer) = Self))or
           ((ALayer is TAControl)and(TAControl(ALayer).FParent = Self)))and(FRgnLayerList.Find(ALayer) = -1) then
        begin
                FRgnLayerList.Add(ALayer);
                Inc(FRgnLayerCount);
                Result:= True;


                if (ALayer is TAForm) then
                begin
                        TAForm(ALayer).FRgnIncluded:= True;

                        (*{}{}{}{}{}{}{}*)
                        (**) TAForm(ALayer).UpdateRgnList;
                        (*{}{}{}{}{}{}{}*)
                end
                else if (ALayer is TAControl) then
                begin
                        TAControl(ALayer).FRgnIncluded:= True;

                        (*{}{}{}{}{}{}{}*)
                        (**) TAControl(ALayer).UpdateRgnList;
                        (*{}{}{}{}{}{}{}*)
                end;
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAForm.RemoveRgnLayer(ALayer: TObject): Boolean;
var AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        AIndex:= FRgnLayerList.Find(ALayer);

        if (ALayer <> nil)and(AIndex > -1) then
        begin
                FRgnLayerList.Delete(AIndex);
                Dec(FRgnLayerCount);
                Result:= True;

                if (ALayer is TAForm) then TAForm(ALayer).FRgnIncluded:= False
                else if (ALayer is TAControl) then TAControl(ALayer).FRgnIncluded:= False;

                (*{}{}{}{}{}{}{}*)
                (**) UpdateRgn;
                (*{}{}{}{}{}{}{}*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;

procedure TAForm.UpdateRgn(Now: Boolean = False);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FRgnUpdate)and(FCreateRgn)and(FVisible)and((not Application.Minimized)or(FMenu)) then
        begin
                FRgnUpdate:= True;
               
                case Now of
                  True:
                          (*--------------*)
                          (**) FLayerManager.SendMessage(AM_UPDATE_RGN, 0, 0, Self)
                          (*--------------*)
                  //
                  else
                          (*--------------*)
                          (**) FLayerManager.PostMessage(AM_UPDATE_RGN, 0, 0, Self)
                          (*--------------*)
                  //
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##                                 CONTROL                                  ##
//##############################################################################


{ TAControl }




constructor TAControl.Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer);
begin
FName:= AName;



        FLeft:= 0;
        FTop:= 0;
        FWidth:= 0;
        FHeight:= 0;
        FAnchors:= AK_LEFT or AK_TOP;
        FConstraintsType:= CT_CUSTOM;
        FConstraintsFlags:= CF_NONE;

        FVisible:= False;
        FAlwaysOnTop:= False;
        FCursor:= False;
        FFocusable:= False;
        FMovable:= False;
        FSizable:= False;
        FDraw:= False;
        FMsg:= False;

        FMoving:= False;
        FSizing:= False;

        FLocationAlpha:= A_CLEAR;
        FAlpha:= A_OPAQUE;
        FBufferRender:= RM_COPY;


        FButtonDown:= 0;

        FCursorDef:= CS_ARROW;

        FNotify:= 0;



        FContainerFlags:= 0;
        FContainerChildList:= TAList.Create;
        FContainerChildCount:= 0;

        FMoveAnimation:= False;
        FSizeAnimation:= False;
        FAlphaAnimation:= False;

        FRgnAlpha:= A_CLEAR;
        FRgnList:= TARectList.Create;



        SetBufferType(ABufferType);

        SetControlType(AControlType);
        SetParent(AParent);
end;



destructor TAControl.Destroy;
begin
        SetParent(nil);

        FreeNil(FBuffer);



        FreeNil(FRgnList);

        StopMoveAnimation;
        StopSizeAnimation;
        StopAlphaAnimation;

        FreeNil(FContainerChildList);



(*==============*)
(**) if Assigned(FOnDestroy) then FOnDestroy(Self);
(*==============*)

inherited;
end;


procedure TAControl.SetCursorDef(ACursorDef: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FCursorDef <> ACursorDef) then
        begin
                FCursorDef:= ACursorDef;


                UpdateCursor;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.GetCursorPos: TPoint;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                Result:= Mouse.MessagePosition;

                Dec(Result.X, FLeft + FParent.FLeft);
                Dec(Result.Y, FTop + FParent.FTop);
        end
        else begin
                Result.X:= -1;
                Result.Y:= -1;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;

procedure TAControl.SetCursorPos(ACursorPos: TPoint);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                Inc(ACursorPos.X, FLeft + FParent.FLeft);
                Inc(ACursorPos.Y, FTop + FParent.FTop);

                Mouse.Position:= ACursorPos;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetParent(AParent: TAForm);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> AParent) then
        begin
                // the AddControl removes the control from old parent
                if (AParent <> nil) then AParent.FLayerManager.AddControl(Self)

                // just remove from old parent and parent will become nil
                else if (FParent <> nil) then FParent.FLayerManager.RemoveControl(Self);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetLeft(ALeft: Integer);
begin
        if (FLeft <> ALeft) then
                SetBounds(ALeft, FTop, FWidth, FHeight);
end;


procedure TAControl.SetTop(ATop: Integer);
begin
        if (FTop <> ATop) then
                SetBounds(FLeft, ATop, FWidth, FHeight);
end;


procedure TAControl.SetWidth(AWidth: Integer);
begin
        if (FWidth <> AWidth) then
                SetBounds(FLeft, FTop, AWidth, FHeight);
end;


procedure TAControl.SetHeight(AHeight: Integer);
begin
        if (FHeight <> AHeight) then
                SetBounds(FLeft, FTop, FWidth, AHeight);
end;


function TAControl.GetBounds: TARect;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

          with Result do
          begin
                  Left:= FLeft;
                  Top:= FTop;
                  Width:= FWidth;
                  Height:= FHeight;
          end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.GetSizeConstraints(AIndex: Integer): Integer;
var P: ^Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        P:= @FSizeConstraints;
        Integer(P):= Integer(P) + (AIndex shl 2);
        Result:= P^;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.GetMoveConstraints(AIndex: Integer): Integer;
var P: ^Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        P:= @FMoveConstraints;
        Integer(P):= Integer(P) + (AIndex shl 2);
        Result:= P^;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetSizeConstraints(AIndex: Integer; ASizeConstraints: Integer);
var P: ^Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        P:= @FSizeConstraints;
        Integer(P):= Integer(P) + (AIndex shl 2);

        if (P^ <> ASizeConstraints) then
        begin
                P^:= ASizeConstraints;


                UpdateConstraints;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetMoveConstraints(AIndex: Integer; AMoveConstraints: Integer);
var P: ^Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        P:= @FMoveConstraints;
        Integer(P):= Integer(P) + (AIndex shl 2);

        if (P^ <> AMoveConstraints) then
        begin
                P^:= AMoveConstraints;


                UpdateConstraints;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetConstraintsFlags(AConstraintsFlags: Integer);
begin
        FConstraintsFlags:= AConstraintsFlags;

        UpdateConstraints;
end;


procedure TAControl.SetConstraintsType(AConstraintsType: Integer);
begin
        FConstraintsType:= AConstraintsType;

        UpdateConstraints;
end;


function TAControl.GetFocused: Boolean;
begin
        Result:= (FParent <> nil)and(Integer(Self) = Integer(FLayerManager.FFocusedLayer));
end;


procedure TAControl.SetFocused(AFocused: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                case AFocused of
                  True: FLayerManager.SetFocus(Self);
                  else FLayerManager.ReleaseFocus(Self);
                end;

                (*[][][][][][][]*)
                // updatehover is done in set/release focus
                (*[][][][][][][]*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.GetCapture: Boolean;
begin
        Result:= (FParent <> nil)and(Integer(Self) = Integer(FLayerManager.FCaptureLayer));
end;


procedure TAControl.SetCapture(ACapture: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                case ACapture of
                  True: FLayerManager.SetCapture(Self);
                  else FLayerManager.ReleaseCapture(Self);
                end;

                (*[][][][][][][]*)
                // updatehover is done in set/release capture
                (*[][][][][][][]*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.GetLayer: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then Result:= FLayerManager.FindControl(Self)
        else Result:= LAYER_NONE;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetLayer(ALayer: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil)and(ALayer <> GetLayer) then
                FLayerManager.SetLayer(ALayer, Self);

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetBufferType(ABufferType: Integer);
var AOldType: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FBufferType <> ABufferType) then
        begin
                AOldType:= FBufferType;
                FBufferType:= ABufferType;


                if (FBufferType and (not BT_RESIZE)) <> (AOldType and (not BT_RESIZE)) then
                begin
                        FreeNil(FBuffer);

                        case FBufferType and (not BT_RESIZE) of
                          BT_FOOT: FBuffer:= TFoot.Create;
                          BT_TILEFOOT: FBuffer:= TTileFoot.Create;
                        end;
                end;

                // just in case BT_RESIZE was modified.
                if (FBufferType and BT_RESIZE <> 0) then FBuffer.Resize(FWidth, FHeight);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetBufferRender(ABufferRender: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FBufferRender <> ABufferRender) then
        begin
                FBufferRender:= ABufferRender;


                if (FParent <> nil) then FLayerManager.Invalidate(RT_RELAYER_REDRAW, Self);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetControlType(AControlType: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AControlType <> FControlType) then
        begin
                SetVisible((AControlType and CT_VISIBLE) <> 0);
                SetAlwaysOnTop((AControlType and CT_ALWAYS_ON_TOP) <> 0);
                SetCursor((AControlType and CT_CURSOR) <> 0);
                SetFocusable((AControlType and CT_FOCUSABLE) <> 0);
                SetMovable((AControlType and CT_MOVABLE) <> 0);
                SetSizable((AControlType and CT_SIZABLE) <> 0);
                SetDraw((AControlType and CT_DRAW) <> 0);
                SetMsg((AControlType and CT_MSG) <> 0);

                FControlType:= AControlType;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetVisible(AVisible: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FVisible <> AVisible) then
        begin
                FControlType:= FControlType xor CT_VISIBLE;
                FVisible:= AVisible;


                if (FParent <> nil) then
                begin
                        (*{}{}{}{}{}{}{}*)
                        (**) UpdateRgnList;
                        (*{}{}{}{}{}{}{}*)

                        (*[][][][][][][]*)
                        (**) FLayerManager.UpdateHover;
                        (*[][][][][][][]*)

                        if (FDraw) then FLayerManager.Invalidate(RT_RELAYER_REDRAW, Self, False);

                        case FVisible of
                          True:
                                (*--------------*)
                                (**) FLayerManager.SendMessage(AM_SHOW, 0, 0, Self);
                                (*--------------*)
                          //
                          else begin
                                FLayerManager.ReleaseFocus(Self);
                                FLayerManager.ReleaseCapture(Self);
                                FMoving:= False;
                                FSizing:= False;

                                FButtonDown:= 0;

                                (*--------------*)
                                (**) FLayerManager.SendMessage(AM_HIDE, 0, 0, Self);
                                (*--------------*)
                          end;
                          //
                        end;
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetAlwaysOnTop(AAlwaysOnTop: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AAlwaysOnTop <> FAlwaysOnTop) then
        begin
                FControlType:= FControlType xor CT_ALWAYS_ON_TOP;
                FAlwaysOnTop:= AAlwaysOnTop;


                if (FParent <> nil) then
                begin
                        case FAlwaysOnTop of
                          True:
                          begin
                                Inc(FLayerManager.FAlwaysOnTopCount);

                                Surface;

                                (*--------------*)
                                (**) FLayerManager.SendMessage(AM_SET_ALWAYSONTOP, 0, 0, Self);
                                (*--------------*)
                          end;
                          //
                          else begin
                                Dec(FLayerManager.FAlwaysOnTopCount);
                                Surface;

                                (*--------------*)
                                (**) FLayerManager.SendMessage(AM_RELEASE_ALWAYSONTOP, 0, 0, Self);
                                (*--------------*)
                          end;
                          //
                        end;
                end;
        end
        else if (FParent <> nil)and(FAlwaysOnTop) then Surface;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetCursor(ACursor: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ACursor <> FCursor) then
        begin
                FControlType:= FControlType xor CT_CURSOR;
                FCursor:= ACursor;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetFocusable(AFocusable: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AFocusable <> FFocusable) then
        begin
                FControlType:= FControlType xor CT_FOCUSABLE;
                FFocusable:= AFocusable;


                if (FParent <> nil) then
                begin
                        case FFocusable of
                          True:
                          begin
                                FLayerManager.FTabFocusList.Add(Self);
                                Inc(FLayerManager.FTabFocusCount);
                          end;
                          //
                          else begin
                                FLayerManager.FTabFocusList.Remove(Self);
                                Dec(FLayerManager.FTabFocusCount);

                                FLayerManager.ReleaseFocus(Self);
                          end;
                          //
                        end;
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetMovable(AMovable: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FMovable <> AMovable) then
        begin
                FControlType:= FControlType xor CT_MOVABLE;
                FMovable:= AMovable;


                if (FParent <> nil)and(not FMovable)and(FMoving) then
                begin
                        FMoving:= False;
                        FLayerManager.ReleaseCapture(Self);

                        (*[][][][][][][]*)
                        // updatehover is done in releasecapture
                        (*[][][][][][][]*)
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetSizable(ASizable: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FSizable <> ASizable) then
        begin
                FControlType:= FControlType xor CT_SIZABLE;
                FSizable:= ASizable;


                if (FParent <> nil)and(not FSizable)and(FSizing) then
                begin
                        FSizing:= False;
                        FLayerManager.ReleaseCapture(Self);

                        (*[][][][][][][]*)
                        // updatehover is done in releasecapture
                        (*[][][][][][][]*)
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetDraw(ADraw: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ADraw <> FDraw) then
        begin
                FControlType:= FControlType xor CT_DRAW;
                FDraw:= ADraw;


                if (FParent <> nil) then
                begin
                        (*[][][][][][][]*)
                        (**) FLayerManager.UpdateHover;
                        (*[][][][][][][]*)

                        if (FVisible) then FLayerManager.Invalidate(RT_RELAYER_REDRAW, Self, False);

                        case FDraw of
                          True:
                                (*--------------*)
                                (**) FLayerManager.SendMessage(AM_SET_DRAW, 0, 0, Self);
                                (*--------------*)
                          //
                          else
                                (*--------------*)
                                (**) FLayerManager.SendMessage(AM_RELEASE_DRAW, 0, 0, Self);
                                (*--------------*)
                          //
                        end;
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetMsg(AMsg: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AMsg <> FMsg) then
        begin
                FControlType:= FControlType xor CT_MSG;
                FMsg:= AMsg;


                if (FParent <> nil) then
                begin
                        (*[][][][][][][]*)
                        (**) FLayerManager.UpdateHover;
                        (*[][][][][][][]*)

                        case FMsg of
                          True:
                                (*--------------*)
                                (**) FLayerManager.SendMessage(AM_SET_MSG, 0, 0, Self);
                                (*--------------*)
                          //
                          else begin
                                FMoving:= False;
                                FSizing:= False;
                                FLayerManager.ReleaseFocus(Self);
                                FLayerManager.ReleaseCapture(Self);

                                FButtonDown:= 0;

                                (*--------------*)
                                (**) FLayerManager.SendMessage(AM_RELEASE_MSG, 0, 0, Self);
                                (*--------------*)
                          end;
                          //
                        end;
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.GetTabFocusIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil)and(FFocusable) then Result:= FLayerManager.FTabFocusList.Find(Self)
        else Result:= -1;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetTabFocusIndex(AIndex: Integer);
var OldIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil)and(FFocusable) then
        begin
                Restrict(AIndex, 0, FLayerManager.FTabFocusCount-1);

                OldIndex:= FLayerManager.FTabFocusList.Find(Self);
                FLayerManager.FTabFocusList.Move(OldIndex, AIndex);

        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetLocationAlpha(ALocationAlpha: Byte);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FLocationAlpha <> ALocationAlpha) then
        begin
                FLocationAlpha:= ALocationAlpha;

                (*[][][][][][][]*)
                (**) if (FParent <> nil) then FLayerManager.UpdateHover;
                (*[][][][][][][]*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetAlpha(AAlpha: Byte);
var AControl: TAControl;
    i, OldAlpha: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FAlpha <> AAlpha) then
        begin
                OldAlpha:= FAlpha;
                FAlpha:= AAlpha;


                if (FParent <> nil) then
                begin
                        (*~~~~~~~~~~~~~~~*)
                        (**) for i:= 0 to FContainerChildCount-1 do
                        (**) begin
                        (**)         AControl:= FContainerChildList.Items[i];
                        (**)
                        (**)         if (AControl.FContainerFlags and CF_ALPHA <> 0) then AControl.SetAlpha(AControl.FAlpha + FAlpha - OldAlpha);
                        (**) end;
                        (*~~~~~~~~~~~~~~~*)

                        if (FBufferRender and RM_GLOBALALPHA <> 0) then FLayerManager.Invalidate(RT_RELAYER_REDRAW, Self);
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetContainerFlags(AContainerFlags: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FContainerFlags <> AContainerFlags) then
        begin
                FContainerFlags:= AContainerFlags;


                if (FParent <> nil)and(FContainer <> nil) then
                begin
                        (*{}{}{}{}{}{}{}*)
                        (**) UpdateRgnList;
                        (*{}{}{}{}{}{}{}*)

                        FLayerManager.Invalidate(RT_RELAYER_REDRAW, Self);
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.GetContainerChild(AIndex: Integer): TAControl;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AIndex > -1)and(AIndex < FContainerChildCount) then Result:= FContainerChildList.Items[AIndex]
        else begin
                Result:= nil;

                {$IFDEF THREADSAFE}
                 ThreadManager.ClearExclusive;
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Getcontainerchild index out of bounds. Requested ' + IntToStr(AIndex) + ', count ' + IntToStr(FContainerChildCount) + '.', 'TAControl.GetContainerChild | ' + FName, Self);
                (*++++++++++++++*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SetRgnAlpha(ARgnAlpha: Byte);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ARgnAlpha <> FRgnAlpha) then
        begin
                FRgnAlpha:= ARgnAlpha;


                (*{}{}{}{}{}{}{}*)
                (**) UpdateRgnList;
                (*{}{}{}{}{}{}{}*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.ProcessMessage(Msg, WParam, LParam: Integer);
var AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        (*==============*)
        (**) if (Assigned(FOnProcessMessage)) then FOnProcessMessage(Self, Msg, WParam, LParam);
        (*==============*)




        case Msg of
          AM_RELEASE_PARENT:
          begin
                // remove all container chilren.
                while (FContainerChildCount > 0) do RemoveContainerChild(FContainerChildList.Items[0]);

                // remove self from container.
                if (FContainer <> nil) then FContainer.RemoveContainerChild(Self);

                // remove the region inclusion.
                if (FRgnIncluded) then FParent.RemoveRgnLayer(Self);

                // remove all layers to which this has to send notifications.
                if (FNotify > 0) then FLayerManager.RemoveMessageNotifySender(Self);

                // remove from all layers which notify this one.
                FLayerManager.RemoveMessageNotifyReciver(Self);
          end;
          //
          AM_MOUSE_DOWNL:
          begin
                if (FMovable)and(PointInARect(LowInt(LParam), HighInt(LParam), FMoveRect)) then
                begin
                        FLayerManager.SetCapture(Self);
                        FMoving:= True;
                        Fx:= LowInt(LParam);
                        Fy:= HighInt(LParam);

                        (*==============*)
                        (**) if (Assigned(FOnMoveStart)) then FOnMoveStart(Self);
                        (*==============*)
                end
                else if (FSizable)and(PointInARect(LowInt(LParam), HighInt(LParam), FSizeRect)) then
                begin
                        FLayerManager.SetCapture(Self);
                        FSizing:= True;
                        Fx:= FWidth - LowInt(LParam);
                        Fy:= FHeight - HighInt(LParam);

                        (*==============*)
                        (**) if (Assigned(FOnSizeStart)) then FOnSizeStart(Self);
                        (*==============*)
                end
                // move parent
                else if (FParent.FMoveControl = Self)and(FParent.FControlMovable) then
                begin
                        LayerManager.SetCapture(Self);
                        FParent.FMoving:= True;
                        FParent.Fx:= LowInt(LParam);
                        FParent.Fy:= HighInt(LParam);

                        (*==============*)
                        (**) if (Assigned(FParent.FOnMoveStart)) then FParent.FOnMoveStart(Self);
                        (*==============*)
                end
                // size parent
                else if (FParent.FSizeControl = Self)and(FParent.FControlSizable) then
                begin
                        LayerManager.SetCapture(Self);
                        FParent.FSizing:= True;
                        FParent.Fx:= FParent.FWidth - FLeft - LowInt(LParam);
                        FParent.Fy:= FParent.FHeight - FTop - HighInt(LParam);

                        (*==============*)
                        (**) if (Assigned(FParent.FOnSizeStart)) then FParent.FOnSizeStart(Self);
                        (*==============*)
                end;

                FLayerManager.SetFocus(Self);

                (*==============*)
                (**) if (Assigned(FOnMouseDown)) then FOnMouseDown(Self, LowInt(LParam), HighInt(LParam), WParam);
                (**) FButtonDown:= FButtonDown or MB_LEFT;
                (*==============*)
          end;
          //
          AM_MOUSE_DOWNM:
          begin
                FLayerManager.SetFocus(Self);

                (*==============*)
                (**) if (Assigned(FOnMouseDown)) then FOnMouseDown(Self, LowInt(LParam), HighInt(LParam), WParam);
                (**) FButtonDown:= FButtonDown or MB_MIDDLE;
                (*==============*)
          end;
          //
          AM_MOUSE_DOWNR:
          begin
                FLayerManager.SetFocus(Self);

                (*==============*)
                (**) if (Assigned(FOnMouseDown)) then FOnMouseDown(Self, LowInt(LParam), HighInt(LParam), WParam);
                (**) FButtonDown:= FButtonDown or MB_RIGHT;
                (*==============*)
          end;
          //
          AM_MOUSE_UPL:
          begin
                if (FMovable)and(FMoving) then
                begin
                        FLayerManager.ReleaseCapture(Self);
                        FMoving:= False;

                        // do not screw up the animation if one was in progress.
                        if (FMoveAnimation) then
                        begin
                                FMoveAnimationRec.SrcX:= FLeft;
                                FMoveAnimationRec.SrcY:= FTop;
                                FMoveAnimationRec.Frame:= 1;
                                if FMoveAnimationRec.SpeedX <> 0 then
                                        FMoveAnimationRec.BlankFrameMaxX:= Ceil(1 / FMoveAnimationRec.SpeedX)
                                else FMoveAnimationRec.BlankFrameMaxX:= 0;
                                if FMoveAnimationRec.SpeedY <> 0 then
                                        FMoveAnimationRec.BlankFrameMaxY:= Ceil(1 / FMoveAnimationRec.SpeedY)
                                else FMoveAnimationRec.BlankFrameMaxY:= 0;
                                FMoveAnimationRec.BlankFrameCountX:= 0;
                                FMoveAnimationRec.BlankFrameCountY:= 0;
                        end;

                        (*==============*)
                        (**) if (Assigned(FOnMoveStop)) then FOnMoveStop(Self);
                        (*==============*)
                end
                else if (FSizable)and(FSizing) then
                begin
                        FLayerManager.ReleaseCapture(Self);
                        FSizing:= False;

                        // do not screw up the animation if one was in progress.
                        if (FSizeAnimation) then
                        begin
                                FSizeAnimationRec.SrcX:= FWidth;
                                FSizeAnimationRec.SrcY:= FHeight;
                                FSizeAnimationRec.Frame:= 1;
                                if FSizeAnimationRec.SpeedX <> 0 then
                                        FSizeAnimationRec.BlankFrameMaxX:= Ceil(1 / FMoveAnimationRec.SpeedX)
                                else FSizeAnimationRec.BlankFrameMaxX:= 0;
                                if FSizeAnimationRec.SpeedY <> 0 then
                                        FSizeAnimationRec.BlankFrameMaxY:= Ceil(1 / FMoveAnimationRec.SpeedY)
                                else FSizeAnimationRec.BlankFrameMaxY:= 0;
                                FSizeAnimationRec.BlankFrameCountX:= 0;
                                FSizeAnimationRec.BlankFrameCountY:= 0;
                        end;

                        (*==============*)
                        (**) if (Assigned(FOnSizeStop)) then FOnSizeStop(Self);
                        (*==============*)
                end
                // move parent
                else if (FParent.FMoveControl <> nil)and(FParent.FMoving) then
                begin
                        FLayerManager.ReleaseCapture(Self);
                        FParent.FMoving:= False;

                        (*==============*)
                        (**) if (Assigned(FParent.FOnMoveStop)) then FParent.FOnMoveStop(Self);
                        (*==============*)
                end
                // size parent
                else if (FParent.FSizeControl <> nil)and(FParent.FSizing) then
                begin
                        FLayerManager.ReleaseCapture(Self);
                        FParent.FSizing:= False;

                        (*==============*)
                        (**) if (Assigned(FParent.FOnSizeStop)) then FParent.FOnSizeStop(Self);
                        (*==============*)
                end;

                (*==============*)
                (**) if (Assigned(FOnMouseUp)) then FOnMouseUp(Self, LowInt(LParam), HighInt(LParam), WParam);
                (*==============*)

                (*--------------*)
                (**) if (FButtonDown and MB_LEFT <> 0) then FLayerManager.SendMessage(AM_MOUSE_CLICKL, WParam, LParam, Layer);
                (**) FButtonDown:= FButtonDown and (not MB_LEFT);
                (*--------------*)
          end;
          //
          AM_MOUSE_UPM:
          begin
                (*==============*)
                (**) if (Assigned(FOnMouseUp)) then FOnMouseUp(Self, LowInt(LParam), HighInt(LParam), WParam);
                (*==============*)

                (*--------------*)
                (**) if (FButtonDown and MB_MIDDLE <> 0) then FLayerManager.SendMessage(AM_MOUSE_CLICKM, WParam, LParam, Layer);
                (**) FButtonDown:= FButtonDown and (not MB_MIDDLE);
                (*--------------*)
          end;
          //
          AM_MOUSE_UPR:
          begin
                (*==============*)
                (**) if (Assigned(FOnMouseUp)) then FOnMouseUp(Self, LowInt(LParam), HighInt(LParam), WParam);
                (*==============*)

                (*--------------*)
                (**) if (FButtonDown and MB_RIGHT <> 0) then FLayerManager.SendMessage(AM_MOUSE_CLICKR, WParam, LParam, Layer);
                (**) FButtonDown:= FButtonDown and (not MB_RIGHT);
                (*--------------*)
          end;
          //
          AM_MOUSE_MOVE:
          begin
                UpdateCursor;

                if (FMovable)and(FMoving) then
                begin
                        Move(FLeft + LowInt(LParam) - Fx, FTop + HighInt(LParam) - Fy);

                        (*==============*)
                        (**) if (Assigned(FOnMoving)) then FOnMoving(Self);
                        (*==============*)
                end
                else if (FSizable)and(FSizing) then
                begin
                        Size(LowInt(LParam) + Fx, HighInt(LParam) + Fy);

                        (*==============*)
                        (**) if (Assigned(FOnSizing)) then FOnSizing(Self);
                        (*==============*)
                end
                // move parent
                else if (FParent.FMoveControl <> nil)and(FParent.FMoving) then
                begin
                        FParent.Move(FParent.FLeft + LowInt(LParam) - FParent.Fx, FParent.FTop + HighInt(LParam) - FParent.Fy);

                        (*==============*)
                        (**) if (Assigned(FParent.FOnMoving)) then FParent.FOnMoving(Self);
                        (*==============*)
                end
                // size parent
                else if (FParent.FSizeControl <> nil)and(FParent.FSizing) then
                begin
                        FParent.Size(FLeft + LowInt(LParam) + FParent.Fx, FTop + HighInt(LParam) + FParent.Fy);

                        (*==============*)
                        (**) if (Assigned(FParent.FOnSizing)) then FParent.FOnSizing(Self);
                        (*==============*)
                end;

                (*==============*)
                (**) if (Assigned(FOnMouseMove)) then FOnMouseMove(Self, LowInt(LParam), HighInt(LParam), WParam);
                (*==============*)
          end;
          //
          AM_MOUSE_CLICKL, AM_MOUSE_CLICKM, AM_MOUSE_CLICKR:
                (*==============*)
                (**) if (Assigned(FOnMouseClick)) then FOnMouseClick(Self, LowInt(LParam), HighInt(LParam), WParam);
                (*==============*)
          //
          AM_MOUSE_DBLCLICKL, AM_MOUSE_DBLCLICKM, AM_MOUSE_DBLCLICKR:
                (*==============*)
                (**) if (Assigned(FOnMouseDblClick)) then FOnMouseDblClick(Self, LowInt(LParam), HighInt(LParam), WParam);
                (*==============*)
          //
          AM_MOUSE_WHEEL:
                (*==============*)
                (**) if (Assigned(FOnMouseWheel)) then FOnMouseWheel(Self, LowInt(LParam), HighInt(LParam), HighInt(WParam), LowInt(WParam));
                (*==============*)
          //
          AM_SYSKEY_DOWN, AM_KEY_DOWN:
          begin
                // tab focus next.
                if (WParam = VK_TAB)and(FFocusable) then
                begin
                        AIndex:= FLayerManager.FTabFocusList.Find(Self);

                        if (Keyboard.ShiftState and SS_SHIFT = 0) then
                        begin
                                if (AIndex < FLayerManager.FTabFocusCount - 1) then FLayerManager.SetFocus(FLayerManager.FTabFocusList.Items[AIndex + 1])
                                else FLayerManager.SetFocus(FLayerManager.FTabFocusList.Items[0]);
                        end
                        else begin
                                if (AIndex > 0) then FLayerManager.SetFocus(FLayerManager.FTabFocusList.Items[AIndex - 1])
                                else FLayerManager.SetFocus(FLayerManager.FTabFocusList.Items[FLayerManager.FTabFocusCount - 1]);
                        end;
                end;

                (*==============*)
                (**) if (Assigned(FOnKeyDown)) then FOnKeyDown(Self, WParam, Keyboard.ShiftState);
                (*==============*)
          end;
          //
          AM_SYSKEY_UP, AM_KEY_UP:
                (*==============*)
                (**) if (Assigned(FOnKeyUp)) then FOnKeyUp(Self, WParam, Keyboard.ShiftState);
                (*==============*)
          //
          AM_SYSKEY_CHAR, AM_KEY_CHAR:
                (*==============*)
                (**) if (Assigned(FOnKeyChar)) then FOnKeyChar(Self, Char(WParam), Keyboard.ShiftState);
                (*==============*)
          //
          AM_MOUSE_ENTER:
          begin
                UpdateCursor;

                (*==============*)
                (**) if (Assigned(FOnMouseEnter)) then FOnMouseEnter(Self);
                (*==============*)
          end;
          //
          AM_MOUSE_LEAVE:
          begin
                UpdateCursor;

                (*==============*)
                (**) if (Assigned(FOnMouseLeave)) then FOnMouseLeave(Self);
                (*==============*)
          end;
          //
          AM_SHOW:
                (*==============*)
                (**) if (Assigned(FOnShow)) then FOnShow(Self);
                (*==============*)
          //
          AM_HIDE:
                (*==============*)
                (**) if (Assigned(FOnHide)) then FOnHide(Self);
                (*==============*)
          //
          AM_SET_ALWAYSONTOP:
                (*==============*)
                (**) if (Assigned(FOnSetAlwaysOnTop)) then FOnSetAlwaysOnTop(Self);
                (*==============*)
          //
          AM_RELEASE_ALWAYSONTOP:
                (*==============*)
                (**) if (Assigned(FOnReleaseAlwaysOnTop)) then FOnReleaseAlwaysOnTop(Self);
                (*==============*)
          //
          AM_SET_FOCUS:
                (*==============*)
                (**) if (Assigned(FOnSetFocus)) then FOnSetFocus(Self);
                (*==============*)
          //
          AM_RELEASE_FOCUS:
                (*==============*)
                (**) if (Assigned(FOnReleaseFocus)) then FOnReleaseFocus(Self);
                (*==============*)
          //
          AM_SET_CAPTURE:
                (*==============*)
                (**) if (Assigned(FOnSetCapture)) then FOnSetCapture(Self);
                (*==============*)
          //
          AM_RELEASE_CAPTURE:
                (*==============*)
                (**) if (Assigned(FOnReleaseCapture)) then FOnReleaseCapture(Self);
                (*==============*)
          //
          AM_SET_DRAW:
                (*==============*)
                (**) if (Assigned(FOnSetDraw)) then FOnSetDraw(Self);
                (*==============*)
          //
          AM_RELEASE_DRAW:
                (*==============*)
                (**) if (Assigned(FOnReleaseDraw)) then FOnReleaseDraw(Self);
                (*==============*)
          //
          AM_SET_MSG:
                (*==============*)
                (**) if (Assigned(FOnSetMsg)) then FOnSetMsg(Self);
                (*==============*)
          //
          AM_RELEASE_MSG:
                (*==============*)
                (**) if (Assigned(FOnReleaseMsg)) then FOnReleaseMsg(Self);
                (*==============*)
          //
          AM_LAYER_CHANGE:
                (*==============*)
                (**) if (Assigned(FOnChangeLayer)) then FOnChangeLayer(Self);
                (*==============*)
          //
          AM_MOVE_ANIMATION_START:
                (*==============*)
                (**) if (Assigned(FOnMoveAnimationStart)) then FOnMoveAnimationStart(Self);
                (*==============*)
          //
          AM_MOVE_ANIMATION_STOP:
                (*==============*)
                (**) if (Assigned(FOnMoveAnimationStop)) then FOnMoveAnimationStop(Self);
                (*==============*)
          //
          AM_SIZE_ANIMATION_START:
                (*==============*)
                (**) if (Assigned(FOnSizeAnimationStart)) then FOnSizeAnimationStart(Self);
                (*==============*)
          //
          AM_SIZE_ANIMATION_STOP:
                (*==============*)
                (**) if (Assigned(FOnSizeAnimationStop)) then FOnSizeAnimationStop(Self);
                (*==============*)
          //
          AM_ALPHA_ANIMATION_START:
                (*==============*)
                (**) if (Assigned(FOnAlphaAnimationStart)) then FOnAlphaAnimationStart(Self);
                (*==============*)
          //
          AM_ALPHA_ANIMATION_STOP:
                (*==============*)
                (**) if (Assigned(FOnAlphaAnimationStop)) then FOnAlphaAnimationStop(Self);
                (*==============*)
          //
          AM_TIMER:
          begin
                case WParam of
                  //
                  TID_MOVE_ANIMATION:
                  if (not FMoving) then
                  begin
                        RunMoveSizeAnimation(Move, StopMoveAnimation, FMoveAnimationRec, FLeft, FTop);

                        (*==============*)
                        (**) if (Assigned(FOnMoveAnimating)) then FOnMoveAnimating(Self);
                        (*==============*)
                  end;
                  //
                  TID_SIZE_ANIMATION:
                  if (not FSizing) then
                  begin
                        RunMoveSizeAnimation(Size, StopSizeAnimation, FSizeAnimationRec, FWidth, FHeight);

                        (*==============*)
                        (**) if (Assigned(FOnSizeAnimating)) then FOnSizeAnimating(Self);
                        (*==============*)
                  end;
                  //
                  TID_ALPHA_ANIMATION:
                  begin
                        RunAlphaAnimation(SetAlpha, StopAlphaAnimation, FAlphaAnimationRec, FAlpha);

                        (*==============*)
                        (**) if (Assigned(FOnAlphaAnimating)) then FOnAlphaAnimating(Self);
                        (*==============*)
                  end;
                  //
                end;
          end;
          //
        end;




        (*``````````````*)
        (**) if (FNotify > 0) then FLayerManager.RunMessageNotify(Msg, Self);
        (*,,,,,,,,,,,,,,*)

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.Paint;
begin
end;


procedure TAControl.PaintLayer(ADestBuffer: TFoot);
begin
        FBuffer.Render(ADestBuffer, NewPoint(FLeft, FTop), NewRect(0, 0, FWidth, FHeight), FAlpha, FBufferRender or RMX_FLAT);
end;


procedure TAControl.PaintLayer(ADestBuffer: TFoot; ADestRect: TRect);
begin
        // transform in client coordonates
        RectOffset(ADestRect, NewPoint(-FLeft, -FTop));
        FBuffer.Render(ADestBuffer, NewPoint(ADestRect.Left + FLeft, ADestRect.Top + FTop), ADestRect, FAlpha, FBufferRender or RMX_FLAT);
end;


class procedure TAControl.RunMoveSizeAnimation(MoveSize: TMoveSize; Stop: TStop; var Struct: TMoveSizeAnimationRec; var X, Y: Integer);
var a: Integer;
    Result: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        with Struct do
        begin
                if (DestX > SrcX) then
                begin
                        a:= Trunc(SrcX + SpeedX*Frame + AccelerationX*Frame*Frame);

                        if (a >= DestX) then
                        begin
                                MoveSize(DestX, Y);
                                BlankFrameCountX:= MAX_INT;
                        end
                        else if (a > X) then
                        begin
                                Result:= MoveSize(a, Y);
                                if (not Result) then Inc(BlankFrameCountX)
                                else BlankFrameCountX:= 0;
                        end
                        else if (a = X) then Inc(BlankFrameCountX)
                        else if (a < X) then BlankFrameCountX:= MAX_INT - 1;
                end
                else begin
                        a:= Trunc(SrcX - SpeedX*Frame - AccelerationX*Frame*Frame);

                        if (a <= DestX) then
                        begin
                                MoveSize(DestX, Y);
                                BlankFrameCountX:= MAX_INT;
                        end
                        else if (a < X) then
                        begin
                                Result:= MoveSize(a, Y);
                                if (not Result) then Inc(BlankFrameCountX)
                                else BlankFrameCountX:= 0;
                        end
                        else if (a = X) then Inc(BlankFrameCountX)
                        else if (a > X) then BlankFrameCountX:= MAX_INT - 1;
                end;

                if (DestY > SrcY) then
                begin
                        a:= Trunc(SrcY + SpeedY*Frame + AccelerationY*Frame*Frame);

                        if (a >= DestY) then
                        begin
                                MoveSize(X, DestY);
                                BlankFrameCountY:= MAX_INT;
                        end
                        else if (a > Y) then
                        begin
                                Result:= MoveSize(X, a);
                                if (not Result) then Inc(BlankFrameCountY)
                                else BlankFrameCountY:= 1;
                        end
                        else if (a = Y) then Inc(BlankFrameCountY)
                        else if (a < Y) then BlankFrameCountY:= MAX_INT - 1;
                end
                else begin
                        a:= Trunc(SrcY - SpeedY*Frame - AccelerationY*Frame*Frame);

                        if (a <= DestY) then
                        begin
                                MoveSize(X, DestY);
                                BlankFrameCountY:= MAX_INT;
                        end
                        else if (a < Y) then
                        begin
                                Result:= MoveSize(X, a);
                                if (not Result) then Inc(BlankFrameCountY)
                                else BlankFrameCountY:= 1;
                        end
                        else if (a = Y) then Inc(BlankFrameCountY)
                        else if (a > Y) then BlankFrameCountY:= MAX_INT - 1;
                end;

                Inc(Frame);
                if (BlankFrameCountX > BlankFrameMaxX)and
                   (BlankFrameCountY > BlankFrameMaxY) then Stop;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


class procedure TAControl.RunAlphaAnimation(ASet: TSetAlpha; Stop: TStop; var Struct: TAlphaAnimationRec; var X: Byte);
var a: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        with Struct do
        begin

                if (Dest > Src) then
                begin
                        a:= Trunc(Src + Speed*Frame + Acceleration*Frame*Frame);

                        if (a >= Dest) then
                        begin
                                ASet(Dest);
                                Stop;
                        end
                        else if (a > X) then
                        begin
                                ASet(a);
                                BlankFrameCount:= 0;
                        end
                        else if (a = X) then Inc(BlankFrameCount)
                        else if (a < X) then Stop;
                end
                else begin
                        a:= Trunc(Src - Speed*Frame - Acceleration*Frame*Frame);

                        if (a <= Dest) then
                        begin
                                ASet(Dest);
                                Stop;
                        end
                        else if (a < X) then
                        begin
                                ASet(a);
                                BlankFrameCount:= 0;
                        end
                        else if (a = X) then Inc(BlankFrameCount)
                        else if (a > X) then Stop;
                end;

                Inc(Frame);
                if (BlankFrameCount > BlankFrameMax) then Stop;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.UpdateCursor;
var ACursor: TPoint;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        ACursor:= GetCursorPos;

        if (FParent <> nil) then
        begin
                if (FMovable)and(PointInARect(ACursor.X, ACursor.Y, FMoveRect))or(FMoving) then SetCursorState(CS_MOVE)
                else if (FSizable)and(PointInARect(ACursor.X, ACursor.Y, FSizeRect))or(FSizing) then SetCursorState(CS_SIZE)
                else if (FParent.FMoveControl = Self)and(FParent.FControlMovable) then SetCursorState(CS_MOVE)
                else if (FParent.FSizeControl = Self)and(FParent.FControlSizable) then SetCursorState(CS_SIZE)
                else SetCursorState(FCursorDef);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.ParentToClient(var P: TPoint);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Dec(P.X, FLeft);
        Dec(P.Y, FTop);

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.ClientToParent(var P: TPoint);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Inc(P.X, FLeft);
        Inc(P.Y, FTop);

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.ScreenToClient(var P: TPoint);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                Dec(P.X, FLeft + FParent.Left);
                Dec(P.Y, FTop + FParent.Top);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.ClientToScreen(var P: TPoint);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                Inc(P.X, FLeft + FParent.Left);
                Inc(P.Y, FTop + FParent.Top);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.PointInBounds(P: TPoint): Boolean;
var R: TRect;
    AChild: TAControl;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                // restrict to own bounds.
                Result:= PointInRect(P, NewRect(0, 0, Min(FWidth, FBuffer.Width), Min(FHeight, FBuffer.Height)));

                // restrict to the container bounds.
                AChild:= Self;
                while (Result)and(AChild.FContainer <> nil)and(AChild.FContainerFlags and CF_PARENT <> 0) do
                begin
                        if (AChild.FContainer.FVisible) then R:= NewRect(AChild.FContainer.GetBounds)
                        else begin
                                Result:= False;
                                Break;
                        end;
                        RectOffset(R, NewPoint(-FLeft, -FTop));
                        Result:= Result and PointInRect(P, R);

                        AChild:= AChild.FContainer;
                end;

                // restrict to locationalpha.
                if (FBufferRender and RM_LOCALALPHA <> 0) then Result:= Result and (FBuffer.PixelAlpha[P.X, P.Y] >= FLocationAlpha);
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.SetBounds(ALeft, ATop, AWidth, AHeight: Integer): Integer;
var AControl: TAControl;
    i: Integer;
    OLeft, OTop, OWidth, OHeight: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        // constrain the bounds to the parameters set and to the parent.
        if (FParent <> nil) then TAForm.RunConstraints(FConstraintsType, FConstraintsFlags, FMoveConstraints, FSizeConstraints, FLeft, FTop, FWidth, FHeight, FParent.GetBounds, FBuffer, ALeft, ATop, AWidth, AHeight)
        else TAForm.RunConstraints(FConstraintsType, FConstraintsFlags, FMoveConstraints, FSizeConstraints, FLeft, FTop, FWidth, FHeight, NewARect(-MAX_INT, -MAX_INT, MAX_INT, MAX_INT), FBuffer, ALeft, ATop, AWidth, AHeight);

        Result:= SB_NONE;

        if (AWidth <> FWidth)or(AHeight <> FHeight)or(ALeft <> FLeft)or(ATop <> FTop) then
        begin
                (*==============*)
                (**) if Assigned(FOnBeforeSetBounds) then FOnBeforeSetBounds(Self);
                (*==============*)

                // move
                if (ALeft <> FLeft)or(ATop <> FTop) then
                begin
                        (*~~~~~~~~~~~~~~~*)
                        (**) for i:= 0 to FContainerChildCount-1 do
                        (**) begin
                        (**)         AControl:= FContainerChildList.Items[i];
                        (**)
                        (**)         if (AControl.FContainerFlags and CF_MOVE <> 0) then AControl.Move(AControl.FLeft + ALeft-FLeft, AControl.FTop + ATop-FTop);
                        (**) end;
                        (*~~~~~~~~~~~~~~~*)

                        Result:= Result or SB_MOVE;
                end;

                // size
                if (AWidth <> FWidth)or(AHeight <> FHeight) then
                begin
                        (*~~~~~~~~~~~~~~~*)
                        (**) for i:= 0 to FContainerChildCount-1 do
                        (**) begin
                        (**)         AControl:= FContainerChildList.Items[i];
                        (**)
                        (**)         if (AControl.FContainerFlags and CF_SIZE <> 0) then AControl.Size(AControl.FWidth + AWidth-FWidth, AControl.FHeight + AHeight-FHeight);
                        (**) end;
                        (*~~~~~~~~~~~~~~~*)

                        Result:= Result or SB_SIZE;
                end;

                if (FParent <> nil) then
                begin
                        FLayerManager.Invalidate(RT_RELAYER_REDRAW, NewRect(FLeft, FTop, FLeft + FWidth, FTop + FHeight));
                        FLayerManager.Invalidate(RT_RELAYER_REDRAW, NewRect(ALeft, ATop, ALeft + AWidth, ATop + AHeight));
                end;

                if (FBufferType and BT_RESIZE <> 0) then FBuffer.Resize(AWidth, AHeight);

                OLeft:= FLeft;
                OTop:= FTop;
                OWidth:= FWidth;
                OHeight:= FHeight;
                FLeft:= ALeft;
                FTop:= ATop;
                FWidth:= AWidth;
                FHeight:= AHeight;

                if (FParent <> nil) then
                begin
                        (*{}{}{}{}{}{}{}*)
                        (**) if (Result <> SB_NONE) then UpdateRgnList;
                        (*{}{}{}{}{}{}{}*)

                        (*[][][][][][][]*)
                        (**) FLayerManager.UpdateHover;
                        (*[][][][][][][]*)

                        (*--------------*)
                        (**) FLayerManager.SendMessage(AM_BOUNDS_CHANGE, 0, 0, Self);
                        (*--------------*)

                        (*--------------*)
                        //   || WParamLo = by X
                        //   || WParamHi = by Y
                        //   || LParamLo = from X
                        //   || LParamHi = from Y
                        (**) if (Result and SB_MOVE <> 0) then FLayerManager.SendMessage(AM_MOVE, LowHigh(FLeft-OLeft, FTop-OTop), LowHigh(OLeft, OTop), Self);
                        (*--------------*)

                        (*--------------*)
                        //   || WParamLo = by X
                        //   || WParamHi = by Y
                        //   || LParamLo = from X
                        //   || LParamHi = from Y
                        (**) if (Result and SB_SIZE <> 0) then FLayerManager.SendMessage(AM_SIZE, LowHigh(FWidth-OWidth, FHeight-OHeight), LowHigh(OWidth, OHeight), Self);
                        (*--------------*)
                end;

                (*==============*)
                (**) if Assigned(FOnAfterSetBounds) then FOnAfterSetBounds(Self);
                (*==============*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.SetBounds(ARect: TARect): Integer;
begin
        with ARect do Result:= SetBounds(Left, Top, Width, Height);
end;


function TAControl.Move(ALeft, ATop: Integer): Boolean;
begin
        Result:= (SetBounds(ALeft, ATop, FWidth, FHeight) and SB_MOVE <> 0);
end;


function TAControl.Size(AWidth, AHeight: Integer): Boolean;
begin
        Result:= (SetBounds(FLeft, FTop, AWidth, AHeight) and SB_SIZE <> 0);
end;


procedure TAControl.UpdateConstraints;
begin
        SetBounds(FLeft, FTop, FWidth, FHeight);
end;


procedure TAControl.Invalidate(RepaintType: Integer; ReBuffer: Boolean = False);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                if (ReBuffer) then FChanged:= True;

                FLayerManager.Invalidate(RepaintType, Self);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.Invalidate(RepaintType: Integer; ARect: TRect; ReBuffer: Boolean = False);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                if (ReBuffer) then FChanged:= True;

                FLayerManager.Invalidate(RepaintType, Self, ARect);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.Repaint(RepaintType: Integer; ReBuffer: Boolean = False);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                if (ReBuffer) then FChanged:= True;

                FLayerManager.Repaint(RepaintType, Self);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.Repaint(RepaintType: Integer; ARect: TRect; ReBuffer: Boolean = False);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                if (ReBuffer) then FChanged:= True;

                FLayerManager.Repaint(RepaintType, Self, ARect);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.Changed;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        FChanged:= True;

        if (FParent <> nil) then FLayerManager.Invalidate(RT_RELAYER_REDRAW, Self);

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.Show;
begin
        SetVisible(True);
end;


procedure TAControl.Hide;
begin
        SetVisible(False);
end;


procedure TAControl.Surface;
var ALayer: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                ALayer:= FLayerManager.FControlCount - 1;
                if (FAlwaysOnTop) then
                        Restrict(ALayer, FLayerManager.FControlCount-1-FLayerManager.FAlwaysOnTopCount, FLayerManager.FControlCount-1)
                else Restrict(ALayer, 0, FLayerManager.FControlCount-1-FLayerManager.FAlwaysOnTopCount);


                FLayerManager.SetLayer(ALayer, Self);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.Surface(By: Integer);
var ALayer: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                ALayer:= GetLayer + By;
                if (FAlwaysOnTop) then
                        Restrict(ALayer, FLayerManager.FControlCount-1-FLayerManager.FAlwaysOnTopCount, FLayerManager.FControlCount-1)
                else Restrict(ALayer, 0, FLayerManager.FControlCount-1-FLayerManager.FAlwaysOnTopCount);


                FLayerManager.SetLayer(ALayer, Self);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.SurfaceTo(ALayer: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                if (FAlwaysOnTop) then
                        Restrict(ALayer, FLayerManager.FControlCount-1-FLayerManager.FAlwaysOnTopCount, FLayerManager.FControlCount-1)
                else Restrict(ALayer, 0, FLayerManager.FControlCount-1-FLayerManager.FAlwaysOnTopCount);


                if (GetLayer < ALayer) then
                        FLayerManager.SetLayer(ALayer, Self);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.Dive;
var ALayer: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                ALayer:= 0;
                if (FAlwaysOnTop) then
                        Restrict(ALayer, FLayerManager.FControlCount-1-FLayerManager.FAlwaysOnTopCount, FLayerManager.FControlCount-1)
                else Restrict(ALayer, 0, FLayerManager.FControlCount-1-FLayerManager.FAlwaysOnTopCount);


                FLayerManager.SetLayer(ALayer, Self);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.Dive(By: Integer);
var ALayer: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                ALayer:= GetLayer - By;
                if (FAlwaysOnTop) then
                        Restrict(ALayer, FLayerManager.FControlCount-1-FLayerManager.FAlwaysOnTopCount, FLayerManager.FControlCount-1)
                else Restrict(ALayer, 0, FLayerManager.FControlCount-1-FLayerManager.FAlwaysOnTopCount);


                FLayerManager.SetLayer(ALayer, Self);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.DiveTo(ALayer: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                if (FAlwaysOnTop) then
                        Restrict(ALayer, FLayerManager.FControlCount-1-FLayerManager.FAlwaysOnTopCount, FLayerManager.FControlCount-1)
                else Restrict(ALayer, 0, FLayerManager.FControlCount-1-FLayerManager.FAlwaysOnTopCount);


                if (GetLayer > ALayer) then
                        FLayerManager.SetLayer(ALayer, Self);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.LayerTo(ALayer: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil) then
        begin
                if (FAlwaysOnTop) then
                        Restrict(ALayer, FLayerManager.FControlCount-1-FLayerManager.FAlwaysOnTopCount, FLayerManager.FControlCount-1)
                else Restrict(ALayer, 0, FLayerManager.FControlCount-1-FLayerManager.FAlwaysOnTopCount);


                FLayerManager.SetLayer(ALayer, Self);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.AddContainerChild(AControl: TAControl; AControlSetFlags: Integer = 0): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil)and(AControl <> nil)and(AControl.FParent = FParent)and(AControl.FContainer = nil)and
           (FindContainerChild(AControl) = -1)and(AControl.FindContainerChild(Self) = -1)and(AControl <> Self) then
        begin
                AControl.FContainer:= Self;
                FContainerChildList.Add(AControl);
                Inc(FContainerChildCount);
                Result:= True;

                if (AControlSetFlags <> 0) then AControl.SetContainerFlags(AControlSetFlags);

                FLayerManager.Invalidate(RT_RELAYER_REDRAW, AControl);
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.RemoveContainerChild(AControl: TAControl): Boolean;
var AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        AIndex:= FindContainerChild(AControl);

        if (FParent <> nil)and(AControl <> nil)and(AIndex > -1) then
        begin
                AControl.FContainer:= nil;
                FContainerChildList.Delete(AIndex);
                Dec(FContainerChildCount);
                Result:= True;

                FLayerManager.Invalidate(RT_RELAYER_REDRAW, AControl);
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.FindContainerChild(AControl: TAControl): Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Result:= 0;
        while (Result < FContainerChildCount)and(FContainerChildList.Items[Result] <> AControl) do
              Inc(Result);

        if (Result = FContainerChildCount) then Result:= -1;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.StartMoveAnimation(ASrcX, ASrcY, ADestX, ADestY: Integer; ASpeedX, ASpeedY, AAccelerationX, AAccelerationY: Extended; ATimeOut: Integer): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FMoveAnimation)and((ASpeedX > 0)or(ASpeedY > 0))and(ATimeOut > 0)and
           ((ASrcX <> ADestX)or(ASrcY <> ADestY)) then
        begin
                Result:= True;
                FMoveAnimation:= True;

                Move(ASrcX, ASrcY);

                FMoveAnimationRec.SrcX:= ASrcX;
                FMoveAnimationRec.SrcY:= ASrcY;
                FMoveAnimationRec.DestX:= ADestX;
                FMoveAnimationRec.DestY:= ADestY;
                FMoveAnimationRec.SpeedX:= ASpeedX;
                FMoveAnimationRec.SpeedY:= ASpeedY;
                FMoveAnimationRec.AccelerationX:= AAccelerationX;
                FMoveAnimationRec.AccelerationY:= AAccelerationY;
                FMoveAnimationRec.Frame:= 1;
                if ASpeedX <> 0 then
                        FMoveAnimationRec.BlankFrameMaxX:= Ceil(1 / ASpeedX)
                else FMoveAnimationRec.BlankFrameMaxX:= 0;
                if ASpeedY <> 0 then
                        FMoveAnimationRec.BlankFrameMaxY:= Ceil(1 / ASpeedY)
                else FMoveAnimationRec.BlankFrameMaxY:= 0;
                FMoveAnimationRec.BlankFrameCountX:= 0;
                FMoveAnimationRec.BlankFrameCountY:= 0;

                TimerManager.AddTimer(TT_HOOK, TID_MOVE_ANIMATION, ATimeOut, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_MOVE_ANIMATION_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.StopMoveAnimation: Boolean;
var ASuccess: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FMoveAnimation) then
        begin
                Result:= True;
                FMoveAnimation:= False;
                ASuccess:= (FMoveAnimationRec.DestX = FLeft)and(FMoveAnimationRec.DestY = FTop);

                TimerManager.RemoveTimer(TT_HOOK, TID_MOVE_ANIMATION, Self);

                (*--------------*)
                // || WParam = target destination was achieved
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_MOVE_ANIMATION_STOP, Integer(ASuccess), 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.StartSizeAnimation(ASrcX, ASrcY, ADestX, ADestY: Integer; ASpeedX, ASpeedY, AAccelerationX, AAccelerationY: Extended; ATimeOut: Integer): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FSizeAnimation)and((ASpeedX > 0)or(ASpeedY > 0))and(ATimeOut > 0)and
           ((ASrcX <> ADestX)or(ASrcY <> ADestY)) then
        begin
                Result:= True;
                FSizeAnimation:= True;

                Size(ASrcX, ASrcY);

                FSizeAnimationRec.SrcX:= ASrcX;
                FSizeAnimationRec.SrcY:= ASrcY;
                FSizeAnimationRec.DestX:= ADestX;
                FSizeAnimationRec.DestY:= ADestY;
                FSizeAnimationRec.SpeedX:= ASpeedX;
                FSizeAnimationRec.SpeedY:= ASpeedY;
                FSizeAnimationRec.AccelerationX:= AAccelerationX;
                FSizeAnimationRec.AccelerationY:= AAccelerationY;
                FSizeAnimationRec.Frame:= 1;
                if ASpeedX <> 0 then
                        FSizeAnimationRec.BlankFrameMaxX:= Ceil(1 / ASpeedX)
                else FSizeAnimationRec.BlankFrameMaxX:= 0;
                if ASpeedY <> 0 then
                        FSizeAnimationRec.BlankFrameMaxY:= Ceil(1 / ASpeedY)
                else FSizeAnimationRec.BlankFrameMaxY:= 0;
                FSizeAnimationRec.BlankFrameCountX:= 0;
                FSizeAnimationRec.BlankFrameCountY:= 0;

                TimerManager.AddTimer(TT_HOOK, TID_SIZE_ANIMATION, ATimeOut, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_SIZE_ANIMATION_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.StopSizeAnimation: Boolean;
var ASuccess: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FSizeAnimation) then
        begin
                Result:= True;
                FSizeAnimation:= False;
                ASuccess:= (FSizeAnimationRec.DestX = FWidth)and(FSizeAnimationRec.DestY = FHeight);

                TimerManager.RemoveTimer(TT_HOOK, TID_SIZE_ANIMATION, Self);

                (*--------------*)
                // || WParam = target destination was achieved
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_SIZE_ANIMATION_STOP, Integer(ASuccess), 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.StartAlphaAnimation(ASrc, ADest: Byte; ASpeed, AAcceleration: Extended; ATimeOut: Integer): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FAlphaAnimation)and(ASpeed > 0)and(ATimeOut > 0)and(ASrc <> ADest) then
        begin
                Result:= True;
                FAlphaAnimation:= True;

                SetAlpha(ASrc);

                FAlphaAnimationRec.Src:= ASrc;
                FAlphaAnimationRec.Dest:= ADest;
                FAlphaAnimationRec.Speed:= ASpeed;
                FAlphaAnimationRec.Acceleration:= AAcceleration;
                FAlphaAnimationRec.Frame:= 1;
                FAlphaAnimationRec.BlankFrameMax:= Ceil(1 / ASpeed);
                FAlphaAnimationRec.BlankFrameCount:= 0;

                TimerManager.AddTimer(TT_HOOK, TID_ALPHA_ANIMATION, ATimeOut, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_ALPHA_ANIMATION_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;



      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAControl.StopAlphaAnimation: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FAlphaAnimation) then
        begin
                Result:= True;
                FAlphaAnimation:= False;

                TimerManager.RemoveTimer(TT_HOOK, TID_ALPHA_ANIMATION, Self);

                (*--------------*)
                // || WParam = target destination was achieved
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_ALPHA_ANIMATION_STOP, Integer(FAlphaAnimationRec.Dest = FAlpha), 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAControl.UpdateRgnList;
var AChild: TAControl;
    AControl: TAControl;
    RgnRect, R: TRect;
    i: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FParent <> nil)and(FParent.FCreateRgn)and(FParent.FVisible)and(FParent.FControlsDraw)and
           ((not Application.Minimized)or(FParent.FMenu)) then
        begin
                if (FRgnIncluded)and(FVisible) then
                begin
                        RgnRect:= NewRect(0, 0, Min(FBuffer.Width, FWidth), Min(FBuffer.Height, FHeight));

                        // restrict to the container parent bounds.
                        AChild:= Self;
                        while (AChild.FContainer <> nil)and(AChild.FContainerFlags and CF_PARENT <> 0) do
                        begin
                                if (AChild.FContainer.FVisible) then R:= NewRect(AChild.FContainer.GetBounds)
                                else begin
                                        RgnRect:= EMPTY_RECT;
                                        Break;
                                end;
                                RectOffset(R, NewPoint(-FLeft, -FTop));
                                Restrict(RgnRect, R);

                                AChild:= AChild.FContainer;
                        end;


                        if (FRgnAlpha = 0) then
                        begin
                                FRgnList.Clear;
                                FRgnList.Add(RgnRect);
                        end
                        else FBuffer.ProcessOpacity(FRgnList, RgnRect, FRgnAlpha);

                        (*{}{}{}{}{}{}{}*)
                        (**) FParent.UpdateRgn;
                        (*{}{}{}{}{}{}{}*)
                end;


                (*~~~~~~~~~~~~~~~*)
                (**) for i:= 0 to FContainerChildCount-1 do
                (**) begin
                (**)         AControl:= FContainerChildList.Items[i];
                (**)
                (**)         AControl.UpdateRgnList;
                (**) end;
                (*~~~~~~~~~~~~~~~*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##                               LAYERMANAGER                               ##
//##############################################################################


{ TALayerManager }




constructor TALayerManager.Create(AForm: TAForm);
begin
FForm:= AForm;



        FAlwaysOnTopCount:= 0;

        FFlushQueue:= False;

        FButtonDown:= 0;



        FLayerBuffer:= TFoot.Create;
        FRedrawList:= TARectList.Create;
        FRelayerList:= TARectList.Create;

        FControlList:= TAList.Create;
        FControlCount:= 0;

        FTabFocusList:= TAList.Create;
        FTabFocusCount:= 0;

        FMessageNotifyList:= TAList.Create;
        FMessageNotifyCount:= 0;
end;


destructor TALayerManager.Destroy;
begin
        FreeNil(FMessageNotifyList);

        FreeNil(FTabFocusList);

        // free remaining controls.
        while (FControlCount > 0) do TAControl(FControlList.Items[0]).Free;

        FreeNil(FControlList);

        FreeNil(FRedrawList);
        FreeNil(FRelayerList);
        FreeNil(FLayerBuffer);



(*==============*)
(**) if (Assigned(FOnDestroy)) then FOnDestroy(Self);
(*==============*)

inherited;
end;


function TALayerManager.GetControl(AIndex: Integer): TAControl;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AIndex > -1)and(AIndex < FControlCount) then Result:= FControlList.Items[AIndex]
        else begin
                Result:= nil;

                {$IFDEF THREADSAFE}
                 ThreadManager.ClearExclusive;
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Getcontrol index out of bounds. Requested ' + IntToStr(AIndex) + ', count ' + IntToStr(FControlCount) + '.', 'TALayerManager.GetControl | ' + FForm.FName, Self);
                (*++++++++++++++*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.GetLayer(AIndex: Integer): TObject;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AIndex > -1)and(AIndex < FControlCount) then Result:= FControlList.Items[AIndex]
        else if (AIndex = LAYER_FORM) then Result:= FForm
        else begin
                Result:= nil;

                {$IFDEF THREADSAFE}
                 ThreadManager.ClearExclusive;
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Getlayer index out of bounds. Requested ' + IntToStr(AIndex) + ', count ' + IntToStr(FControlCount) + '.', 'TALayerManager.GetLayer | ' + FForm.FName, Self);
                (*++++++++++++++*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TALayerManager.SetLayer(AIndex: Integer; AControl: TObject);
var OldLayer: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AControl is TAControl)and(AIndex > -1)and(AIndex < FControlCount) then
        begin
                // always make the mouse cursor the topmost control.
                if TAControl(AControl).FCursor then AIndex:= FControlCount-1;


                if (AIndex <> TAControl(AControl).GetLayer) then
                begin
                        OldLayer:= TAControl(AControl).GetLayer;
                        FControlList.Move(OldLayer, AIndex);


                        (*[][][][][][][]*)
                        (**) UpdateHover;
                        (*[][][][][][][]*)

                        Invalidate(RT_RELAYER_REDRAW, AControl);

                        (*--------------*)
                        //   || WParam = old layer index
                        (**) SendMessage(AM_LAYER_CHANGE, OldLayer, 0, AControl);
                        (*--------------*)

                        (*--------------*)
                        //   || WParam = layer (object)
                        //   || LParam = old layer index
                        (**) SendMessage(AM_LAYERMANAGER_UPDATE_LAYER, Integer(AControl), OldLayer, MT_BROADCAST);
                        (*--------------*)
                end;
        end
        else begin
                {$IFDEF THREADSAFE}
                 ThreadManager.ClearExclusive;
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Setlayer index out of bounds. Requested ' + IntToStr(AIndex) + ', count ' + IntToStr(FControlCount) + '.', 'TALayerManager.SetLayer', Self);
                (*++++++++++++++*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.GetHoverLayer(P: TPoint): TObject;
var i: Integer;
    AControl: TAControl;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FormManager.HoverForm <> FForm)or(not FForm.FVisible)or(not FForm.PointInBounds(P))or
           ((Application.Minimized)and(not FForm.FMenu)) then
        begin
                Result:= nil;

                {$IFDEF THREADSAFE}
                 ThreadManager.ClearExclusive;
                {$ENDIF}

                Exit;
        end;

        // only run through controls if the form allows the controls to have messages
        if (FForm.FControlsMsg) then
        for i:= FControlCount-1 downto 0 do
        begin
                AControl:= TAControl(FControlList.Items[i]);

                if (AControl.FVisible)and(AControl.FMsg)and(AControl.PointInBounds(NewPoint(P.X - AControl.FLeft, P.Y - AControl.FTop))) then
                begin
                        Result:= AControl;

                        {$IFDEF THREADSAFE}
                         ThreadManager.ClearExclusive;
                        {$ENDIF}

                        Exit;
                end;
        end;

        Result:= FForm;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.ConvertCursorPos(AControl: TAControl; Msg, LParam: Integer): Integer;
begin
        case Msg of
          WM_MOUSEFIRST..WM_MOUSELAST: Result:= LowHigh(LowInt(LParam) - AControl.FLeft, HighInt(LParam) - AControl.FTop)
          //
          else Result:= LParam;
        end;
end;


procedure TALayerManager.Reanchor(AX, AY: Integer);
var AControl: TAControl;
    X, Y: Extended;
    R: TRect;
    i: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AX <> 0)or(AY <> 0) then
        begin
                for i:= 0 to FControlCount-1 do
                case TAControl(FControlList.Items[i]).FAnchors of
                  AK_NONE:
                  begin
                          AControl:= FControlList.Items[i];

                          X:= AX / 2 + AControl.FAx;
                          Y:= AY / 2 + AControl.FAy;
                          AControl.FAx:= Frac(X);
                          AControl.FAy:= Frac(Y);

                          AControl.Move(AControl.FLeft + Trunc(X), AControl.FTop + Trunc(Y));
                  end;
                  //
                  AK_LEFT or AK_TOP: Continue;
                  //
                  else begin
                          AControl:= FControlList.Items[i];

                          R:= NewRect(AControl.GetBounds);

                          if (AControl.FAnchors and AK_RIGHT <> 0) then Inc(R.Right, AX);
                          if (AControl.FAnchors and AK_BOTTOM <> 0) then Inc(R.Bottom, AY);
                          if (AControl.FAnchors and AK_LEFT = 0) then Inc(R.Left, AX);
                          if (AControl.FAnchors and AK_TOP = 0) then Inc(R.Top, AY);

                          AControl.SetBounds(NewARect(R));
                  end;
                  //
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TALayerManager.RedirectMessage(Msg, WParam, LParam: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        try
          if (FForm.FControlsMsg) then
                  DecodeMessage(Msg, WParam, LParam, MessageTable.MessageType[Msg])

          // if the formtype is set not to redirect messages to
          // controls then we send all the messages to the form's
          // processmessage procedure.
          else FForm.ProcessMessage(Msg, WParam, LParam);
        except
          (*++++++++++++++*)
          (**) HandleException('TALayerManager.RedirectMessage | ' + FForm.FName);
          (*++++++++++++++*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TALayerManager.DecodeMessage(Msg, WParam, LParam: Integer; AMsgType: Integer);
var ALayer: TObject;
    AMessage: PMessage;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        case AMsgType of
          MT_HOVER:
          begin
                // check for FMsg is done in gethoverlayer
                ALayer:= GetHoverLayer(FForm.CursorPos);

                if (ALayer is TAForm) then TAForm(ALayer).ProcessMessage(Msg, WParam, LParam)
                else if (ALayer is TAControl) then
                begin
                        LParam:= ConvertCursorPos(TAControl(ALayer), Msg, LParam);
                        TAControl(ALayer).ProcessMessage(Msg, WParam, LParam);
                end;
          end;
           //
          MT_FOCUS:
          begin
                // if FMsg is disabled then the control loses focus
                if (FFocusedLayer is TAForm) then TAForm(FFocusedLayer).ProcessMessage(Msg, WParam, LParam)
                else if (FFocusedLayer is TAControl) then
                begin
                        LParam:= ConvertCursorPos(TAControl(FFocusedLayer), Msg, LParam);
                        TAControl(FFocusedLayer).ProcessMessage(Msg, WParam, LParam);
                end;
          end;
          //
          MT_CAPTURE:
          begin
                // if FMsg is disabled then the control loses capture
                if (FCaptureLayer is TAForm) then TAForm(FCaptureLayer).ProcessMessage(Msg, WParam, LParam)
                else if (FCaptureLayer is TAControl) then
                begin
                        LParam:= ConvertCursorPos(TAControl(FCaptureLayer), Msg, LParam);
                        TAControl(FCaptureLayer).ProcessMessage(Msg, WParam, LParam);
                end;
          end;
          //
          MT_MSG_POST: { CM_MSG_POST }
          begin
                AMessage:= Pointer(WParam);
                ALayer:= TObject(LParam);

                if (ALayer is TAForm) then TAForm(ALayer).ProcessMessage(AMessage^.Msg, AMessage^.WParam, AMessage^.LParam)
                else if (ALayer is TAControl) then
                begin
                        AMessage^.LParam:= ConvertCursorPos(TAControl(ALayer), AMessage^.Msg, AMessage^.LParam);
                        TAControl(ALayer).ProcessMessage(AMessage^.Msg, AMessage^.WParam, AMessage^.LParam);
                end;

                FreeMem(AMessage);
          end;
          //
        end;


        {$IFDEF LAYERMANAGER_CONSOLE}

          case Msg of
            AM_MOUSE_DOWNL:
            begin
                  (*==============*)
                  (**) if (Assigned(FOnMouseDown)) then FOnMouseDown(Self, LowInt(LParam), HighInt(LParam), WParam);
                  (**) FButtonDown:= FButtonDown or MB_LEFT;
                 (*==============*)
            end;
            //
            AM_MOUSE_DOWNM:
            begin
                  (*==============*)
                  (**) if (Assigned(FOnMouseDown)) then FOnMouseDown(Self, LowInt(LParam), HighInt(LParam), WParam);
                  (**) FButtonDown:= FButtonDown or MB_MIDDLE;
                  (*==============*)
            end;
            //
            AM_MOUSE_DOWNR:
            begin
                  (*==============*)
                  (**) if (Assigned(FOnMouseDown)) then FOnMouseDown(Self, LowInt(LParam), HighInt(LParam), WParam);
                  (**) FButtonDown:= FButtonDown or MB_RIGHT;
                  (*==============*)
            end;
            //
            AM_MOUSE_UPL:
            begin
                  (*--------------*)
                  (**) if (FButtonDown and MB_LEFT <> 0)and(Assigned(FOnMouseClick)) then FOnMouseClick(Self, LowInt(LParam), HighInt(LParam), WParam);
                  (*--------------*)

                  (*==============*)
                  (**) if (Assigned(FOnMouseUp)) then FOnMouseUp(Self, LowInt(LParam), HighInt(LParam), WParam);
                  (**) FButtonDown:= FButtonDown and (not MB_LEFT);
                  (*==============*)
            end;
            //
            AM_MOUSE_UPM:
            begin
                  (*--------------*)
                  (**) if (FButtonDown and MB_MIDDLE <> 0)and(Assigned(FOnMouseClick)) then FOnMouseClick(Self, LowInt(LParam), HighInt(LParam), WParam);
                  (*--------------*)

                  (*==============*)
                  (**) if (Assigned(FOnMouseUp)) then FOnMouseUp(Self, LowInt(LParam), HighInt(LParam), WParam);
                  (**) FButtonDown:= FButtonDown and (not MB_MIDDLE);
                  (*==============*)
            end;
            //
            AM_MOUSE_UPR:
            begin
                  (*--------------*)
                  (**) if (FButtonDown and MB_RIGHT <> 0)and(Assigned(FOnMouseClick)) then FOnMouseClick(Self, LowInt(LParam), HighInt(LParam), WParam);
                  (*--------------*)

                  (*==============*)
                  (**) if (Assigned(FOnMouseUp)) then FOnMouseUp(Self, LowInt(LParam), HighInt(LParam), WParam);
                  (**) FButtonDown:= FButtonDown and (not MB_RIGHT);
                  (*==============*)
            end;
            //
            AM_MOUSE_MOVE:
                  (*==============*)
                  (**) if (Assigned(FOnMouseMove)) then FOnMouseMove(Self, LowInt(LParam), HighInt(LParam), WParam);
                  (*==============*)
            //
            AM_MOUSE_DBLCLICKL, AM_MOUSE_DBLCLICKM, AM_MOUSE_DBLCLICKR:
                  (*==============*)
                  (**) if (Assigned(FOnMouseDblClick)) then FOnMouseDblClick(Self, LowInt(LParam), HighInt(LParam), WParam);
                  (*==============*)
            //
            AM_MOUSE_WHEEL:
                  (*==============*)
                  (**) if (Assigned(FOnMouseWheel)) then FOnMouseWheel(Self, LowInt(LParam), HighInt(LParam), HighInt(WParam), LowInt(WParam));
                  (*==============*)
            //
            AM_SYSKEY_DOWN, AM_KEY_DOWN:
                  (*==============*)
                  (**) if (Assigned(FOnKeyDown)) then FOnKeyDown(Self, WParam, Keyboard.ShiftState);
                  (*==============*)
            //
            AM_SYSKEY_UP, AM_KEY_UP:
                  (*==============*)
                  (**) if (Assigned(FOnKeyUp)) then FOnKeyUp(Self, WParam, Keyboard.ShiftState);
                  (*==============*)
            //
            AM_SYSKEY_CHAR, AM_KEY_CHAR:
                  (*==============*)
                  (**) if (Assigned(FOnKeyChar)) then FOnKeyChar(Self, Char(WParam), Keyboard.ShiftState);
                  (*==============*)
            //
          end;

        {$ENDIF}

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TALayerManager.ReLayer;
var AControl, AChild: TAControl;
    R: TRect;
    a: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        // paint form layer
        FForm.PaintLayer(FLayerBuffer);


        if (FForm.FControlsDraw)and(FControlCount > 0) then
        begin
                for a:= 0 to FControlCount-1 do
                begin
                        AControl:= TAControl(FControlList.Items[a]);

                        if (AControl.FVisible)and(AControl.FDraw) then
                        begin
                                R:= NewRect(AControl.GetBounds);

                                // restrict to the container parent bounding box.
                                AChild:= AControl;
                                while (AChild.FContainer <> nil)and(AChild.FContainerFlags and CF_PARENT <> 0) do
                                begin
                                        if (AChild.FContainer.FVisible) then Restrict(R, NewRect(AChild.FContainer.GetBounds))
                                        else begin
                                                R:= EMPTY_RECT;
                                                Break;
                                        end;

                                        AChild:= AChild.FContainer;
                                end;


                                // avoid a changed rebuffer by verifying if the control
                                // is in the designated area.
                                if (not RectEmpty(R)) then
                                begin
                                        if (AControl.FChanged) then
                                        begin
                                                AControl.Paint;

                                                AControl.FChanged:= False;

                                                (*{}{}{}{}{}{}{}*)
                                                (**) AControl.UpdateRgnList;
                                                (*{}{}{}{}{}{}{}*)
                                        end;

                                        AControl.PaintLayer(FLayerBuffer, R);
                                end;
                        end;
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TALayerManager.ReLayer(ARect: TRect);
var AControl, AChild: TAControl;
    R: TRect;
    a: Integer;
begin
        // paint form layer
        FForm.PaintLayer(FLayerBuffer, ARect);


        if (FForm.FControlsDraw)and(FControlCount > 0) then
        begin
                for a:= 0 to FControlCount-1 do
                begin
                        AControl:= TAControl(FControlList.Items[a]);

                        if (AControl.FVisible)and(AControl.FDraw) then
                        begin
                                R:= ARect;

                                // restrict to own bounds.
                                Restrict(R, NewRect(AControl.GetBounds));

                                // restrict to the container parent bounds.
                                AChild:= AControl;
                                while (AChild.FContainer <> nil)and(AChild.FContainerFlags and CF_PARENT <> 0) do
                                begin
                                        if (AChild.FContainer.FVisible) then Restrict(R, NewRect(AChild.FContainer.GetBounds))
                                        else begin
                                                R:= EMPTY_RECT;
                                                Break;
                                        end;

                                        AChild:= AChild.FContainer;
                                end;


                                // avoid a changed rebuffer by verifying if the control
                                // is in the designated area.
                                if (not RectEmpty(R)) then
                                begin
                                        if (AControl.FChanged) then
                                        begin
                                                AControl.Paint;

                                                AControl.FChanged:= False;

                                                (*{}{}{}{}{}{}{}*)
                                                (**) AControl.UpdateRgnList;
                                                (*{}{}{}{}{}{}{}*)
                                        end;

                                        AControl.PaintLayer(FLayerBuffer, R);
                                end;
                        end;
                end;
        end;
end;


procedure TALayerManager.ReDraw;
begin
        FLayerBuffer.Render(FForm.FDC);
end;


procedure TALayerManager.ReDraw(ARect: TRect);
begin
        FLayerBuffer.Render(FForm.FDC, NewPoint(ARect.Left, ARect.Top), ARect);
end;


function TALayerManager.SendMessage(Msg, WParam, LParam: Integer; ATypeOrLayer: Integer): Boolean;
var i: Integer;
begin
        case ATypeOrLayer of
          MT_HOVER: Result:= SendMessage(Msg, WParam, LParam, FHoverLayer);
          //
          MT_FOCUS: Result:= SendMessage(Msg, WParam, LParam, FFocusedLayer);
          //
          MT_CAPTURE: Result:= SendMessage(Msg, WParam, LParam, FCaptureLayer);
          //
          MT_BROADCAST:
          begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

                FForm.ProcessMessage(Msg, WParam, LParam);

                for i:= 0 to FControlCount-1 do
                        TAControl(FControlList.Items[i]).ProcessMessage(Msg, WParam, LParam);
                Result:= True;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}
          end;
          //
          LAYER_FORM:
          begin
                FForm.ProcessMessage(Msg, WParam, LParam);
                Result:= True;
          end;
          //
          else begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

                  if (ATypeOrLayer > -1)and(ATypeOrLayer < FControlCount) then
                  begin
                        TAControl(FControlList.Items[ATypeOrLayer]).ProcessMessage(Msg, WParam, LParam);
                        Result:= True;
                  end
                  else Result:= False;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}
          end;
          //
        end;
end;


function TALayerManager.SendMessage(Msg, WParam, LParam: Integer; ALayer: TObject): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ALayer is TAControl)and(TAControl(ALayer).FParent <> nil) then
        begin
                TAControl(ALayer).ProcessMessage(Msg, WParam, LParam);
                Result:= True;
        end
        else if (ALayer is TAForm) then
        begin
                TAForm(ALayer).ProcessMessage(Msg, WParam, LParam);
                Result:= True;
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.PostMessage(Msg, WParam, LParam: Integer; ATypeOrLayer: Integer): Boolean;
var AMessage: PMessage;
    i: Integer;
begin
        case ATypeOrLayer of
          (*--------------*)
          (**) MT_HOVER: Result:= PostMessage(Msg, WParam, LParam, FHoverLayer);
          (*--------------*)
          //
          (*--------------*)
          (**) MT_FOCUS: Result:= PostMessage(Msg, WParam, LParam, FFocusedLayer);
          (*--------------*)
          //
          (*--------------*)
          (**) MT_CAPTURE: Result:= PostMessage(Msg, WParam, LParam, FCaptureLayer);
          (*--------------*)
          //
          MT_BROADCAST:
          begin
                GetMem(AMessage, SizeOf(TMessage));
                AMessage^.Msg:= Msg;
                AMessage^.WParam:= WParam;
                AMessage^.LParam:= LParam;

                (*--------------*)
                (**) Application.PostMessage(FForm.FHandle, CM_MSG_POST, Integer(AMessage), Integer(FForm));
                (*--------------*)

                {$IFDEF THREADSAFE}
                 ThreadManager.SetExclusive;
                {$ENDIF}

                  for i:= 0 to FControlCount-1 do
                  begin
                        GetMem(AMessage, SizeOf(TMessage));
                        AMessage^.Msg:= Msg;
                        AMessage^.WParam:= WParam;
                        AMessage^.LParam:= LParam;

                        (*--------------*)
                        (**) Application.PostMessage(FForm.FHandle, CM_MSG_POST, Integer(AMessage), Integer(FControlList.Items[i]));
                        (*--------------*)
                  end;

                {$IFDEF THREADSAFE}
                 ThreadManager.ClearExclusive;
                {$ENDIF}

                Result:= True;
          end;
          //
          LAYER_FORM:
          begin
                GetMem(AMessage, SizeOf(TMessage));
                AMessage^.Msg:= Msg;
                AMessage^.WParam:= WParam;
                AMessage^.LParam:= LParam;

                (*--------------*)
                (**) Application.PostMessage(FForm.FHandle, CM_MSG_POST, Integer(AMessage), Integer(FForm));
                (*--------------*)
                Result:= True;
          end;
          //
          else begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

                  if (ATypeOrLayer > -1)and(ATypeOrLayer < FControlCount) then
                  begin
                        GetMem(AMessage, SizeOf(TMessage));
                        AMessage^.Msg:= Msg;
                        AMessage^.WParam:= WParam;
                        AMessage^.LParam:= LParam;

                        (*--------------*)
                        (**) Application.PostMessage(FForm.FHandle, CM_MSG_POST, Integer(AMessage), Integer(FControlList.Items[ATypeOrLayer]));
                        (*--------------*)
                        Result:= True;
                  end
                  else Result:= False;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}
          end;
          //
        end;
end;


function TALayerManager.PostMessage(Msg, WParam, LParam: Integer; ALayer: TObject): Boolean;
var AMessage: PMessage;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ALayer is TAControl)and(TAControl(ALayer).FParent <> nil) then
        begin
                GetMem(AMessage, SizeOf(TMessage));
                AMessage^.Msg:= Msg;
                AMessage^.WParam:= WParam;
                AMessage^.LParam:= LParam;

                (*--------------*)
                (**) Application.PostMessage(TAControl(ALayer).FParent.FHandle, CM_MSG_POST, Integer(AMessage), Integer(ALayer));
                (*--------------*)
                Result:= True;
        end
        else if (ALayer is TAForm) then
        begin
                GetMem(AMessage, SizeOf(TMessage));
                AMessage^.Msg:= Msg;
                AMessage^.WParam:= WParam;
                AMessage^.LParam:= LParam;

                (*--------------*)
                (**) Application.PostMessage(TAForm(ALayer).FHandle, CM_MSG_POST, Integer(AMessage), Integer(ALayer));
                (*--------------*)
                Result:= True;
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TALayerManager.Invalidate(ARepaintType: Integer);
begin;
        Invalidate(ARepaintType, NewRect(0, 0, FForm.FRgnWidth, FForm.FRgnHeight));
end;


procedure TALayerManager.Invalidate(ARepaintType: Integer; ARect: TRect);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(ARect, NewRect(0, 0, FForm.FRgnWidth, FForm.FRgnHeight));

        if (not RectEmpty(ARect))and(FForm.Visible)and((not Application.Minimized)or(FForm.FMenu)) then
        begin
                case ARepaintType of
                  RT_RELAYER: FRelayerList.Add(ARect, RL_MODE_OR);
                  //
                  RT_REDRAW: FRedrawList.Add(ARect, RL_MODE_OR);
                  //
                  RT_RELAYER_REDRAW:
                  begin
                        FRedrawList.Add(ARect, RL_MODE_OR);
                        FRelayerList.Add(ARect, RL_MODE_OR);
                  end;
                  //
                end;


                if (not FFlushQueue) then
                begin
                        FFlushQueue:= True;

                        (*--------------*)
                        (**) Application.PostMessage(FForm.FHandle, CM_LAYERMANAGER_FLUSHQUEUE, 0, 0);
                        (*--------------*)
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TALayerManager.Invalidate(ARepaintType: Integer; ALayer: TObject; ACheckVisibleDraw: Boolean = True);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ALayer is TAControl)and(TAControl(ALayer).FParent <> nil)and(TAControl(ALayer).FParent.FControlsDraw)and
           ((not ACheckVisibleDraw)or((TAControl(ALayer).FVisible)and(TAControl(ALayer).FDraw))) then
                Invalidate(ARepaintType, NewRect(TAControl(ALayer).GetBounds))
        else Invalidate(ARepaintType, NewRect(0, 0, FForm.FRgnWidth, FForm.FRgnHeight));

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TALayerManager.Invalidate(ARepaintType: Integer; ALayer: TObject; ARect: TRect; ACheckVisibleDraw: Boolean = True);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ALayer is TAControl)and(TAControl(ALayer).FParent <> nil)and(TAControl(ALayer).FParent.FControlsDraw)and
           ((not ACheckVisibleDraw)or((TAControl(ALayer).FVisible)and(TAControl(ALayer).FDraw))) then
        begin
                // transform in form coordonates.
                RectOffset(ARect, NewPoint(TAControl(ALayer).FLeft, TAControl(ALayer).FTop));
                Invalidate(ARepaintType, ARect);
        end
        else Invalidate(ARepaintType, ARect);

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TALayerManager.Repaint(ARepaintType: Integer);
begin;
        Repaint(ARepaintType, NewRect(0, 0, FForm.FRgnWidth, FForm.FRgnHeight));
end;


procedure TALayerManager.Repaint(ARepaintType: Integer; ARect: TRect);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(ARect, NewRect(0, 0, FForm.FRgnWidth, FForm.FRgnHeight));

        if (not RectEmpty(ARect))and(FForm.Visible)and((not Application.Minimized)or(FForm.FMenu)) then
        begin
                case ARepaintType of
                  RT_RELAYER:
                  begin
                        // exclude the repainted rect from the queue.
                        FRelayerList.Add(ARect, RL_MODE_DIFF);

                        ReLayer(ARect);
                  end;
                  //
                  RT_REDRAW:
                  begin
                        // exclude the repainted rect from the queue.
                        FRedrawList.Add(ARect, RL_MODE_DIFF);

                        ReDraw(ARect);
                  end;
                  //
                  RT_RELAYER_REDRAW:
                  begin
                        // exclude the repainted rect from the queue.
                        FRedrawList.Add(ARect, RL_MODE_DIFF);
                        FRelayerList.Add(ARect, RL_MODE_DIFF);

                        ReLayer(ARect);
                        ReDraw(ARect);
                  end;
                  //
                end;

                (*[][][][][][][]*)
                (**) UpdateHover;
                (*[][][][][][][]*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TALayerManager.Repaint(ARepaintType: Integer; ALayer: TObject; ACheckVisibleDraw: Boolean = True);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ALayer is TAControl)and(TAControl(ALayer).FParent <> nil)and(TAControl(ALayer).FParent.FControlsDraw)and
           ((not ACheckVisibleDraw)or((TAControl(ALayer).FVisible)and(TAControl(ALayer).FDraw))) then
                Repaint(ARepaintType, NewRect(TAControl(ALayer).GetBounds))
        else Repaint(ARepaintType, NewRect(0, 0, FForm.FRgnWidth, FForm.FRgnHeight));

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TALayerManager.Repaint(ARepaintType: Integer; ALayer: TObject; ARect: TRect; ACheckVisibleDraw: Boolean = True);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ALayer is TAControl)and(TAControl(ALayer).FParent <> nil)and(TAControl(ALayer).FParent.FControlsDraw)and
           ((not ACheckVisibleDraw)or((TAControl(ALayer).FVisible)and(TAControl(ALayer).FDraw))) then
        begin
                // transform in form coordonates
                RectOffset(ARect, NewPoint(TAControl(ALayer).FLeft, TAControl(ALayer).FTop));
                Repaint(ARepaintType, ARect);
        end
        else Repaint(ARepaintType, ARect);

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TALayerManager.FlushQueue;
var i: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if ((FRelayerList.Count > 0)or(FRedrawList.Count > 0))and(FForm.FVisible)and
           ((not Application.Minimized)or(FForm.FMenu)) then
        begin
                for i:= 0 to FRelayerList.Count-1 do
                        ReLayer(FRelayerList.Items[i]);

                FRelayerList.Clear;

                for i:= 0 to FRedrawList.Count-1 do
                        ReDraw(FRedrawList.Items[i]);

                FRedrawList.Clear;

                (*[][][][][][][]*)
                (**) UpdateHover;
                (*[][][][][][][]*)

                (*============*)
                (**) if Assigned(FOnFlushQueue) then FOnFlushQueue(Self);
                (*===========*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.SetFocus(ALayer: TObject): Boolean;
var OldFocusedLayer: TObject;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ALayer <> nil)and(Integer(ALayer) <> Integer(FFocusedLayer))and(FForm.FVisible)and
           ((not Application.Minimized)or(FForm.FMenu)) then
        begin
                if (ALayer is TAForm)and(Integer(ALayer) = Integer(FForm))and(FForm.FFocusable) then
                begin
                        (*==============*)
                        (**) if Assigned(FOnBeforeSetFocus) then FOnBeforeSetFocus(Self);
                        (*==============*)

                        OldFocusedLayer:= FFocusedLayer;
                        ReleaseFocus(FFocusedLayer, False);
                        FFocusedLayer:= ALayer;
                        FormManager.SetFocus(FForm);
                        Result:= True;

                        (*[][][][][][][]*)
                        (**) UpdateHover;
                        (*[][][][][][][]*)

                        (*--------------*)
                        //   || WParam = old focused layer (object)
                        (**) SendMessage(AM_SET_FOCUS, Integer(OldFocusedLayer), 0, ALayer);
                        (*--------------*)

                        (*--------------*)
                        //   || WParam = new focused layer (object)
                        //   || LParam = old focused layer (object)
                        (**) SendMessage(AM_LAYERMANAGER_SET_FOCUS, Integer(FFocusedLayer), Integer(OldFocusedLayer), MT_BROADCAST);
                        (*--------------*)

                        (*==============*)
                        (**) if Assigned(FOnAfterSetFocus) then FOnAfterSetFocus(Self);
                        (*==============*)
                end
                else if (ALayer is TAControl)and(Integer(TAControl(ALayer).FParent) = Integer(FForm))and
                        (FForm.FControlsMsg)and(TAControl(ALayer).FVisible)and(TAControl(ALayer).FFocusable)and
                        (TAControl(ALayer).FMsg) then
                begin
                        (*==============*)
                        (**) if Assigned(FOnBeforeSetFocus) then FOnBeforeSetFocus(Self);
                        (*==============*)

                        OldFocusedLayer:= FFocusedLayer;
                        ReleaseFocus(FFocusedLayer, False);
                        FFocusedLayer:= ALayer;
                        FormManager.SetFocus(FForm);
                        Result:= True;

                        (*[][][][][][][]*)
                        (**) UpdateHover;
                        (*[][][][][][][]*)

                        (*--------------*)
                        //   || WParam = old focused layer (object)
                        (**) SendMessage(AM_SET_FOCUS, Integer(OldFocusedLayer), 0, ALayer);
                        (*--------------*)

                        (*--------------*)
                        //   || WParam = new focused layer (object)
                        //   || LParam = old focused layer (object)
                        (**) SendMessage(AM_LAYERMANAGER_SET_FOCUS, Integer(FFocusedLayer), Integer(OldFocusedLayer), MT_BROADCAST);
                        (*--------------*)

                        (*==============*)
                        (**) if Assigned(FOnAfterSetFocus) then FOnAfterSetFocus(Self);
                        (*==============*)
                end
                else Result:= False;
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.ReleaseFocus(ALayer: TObject; RelFormManager: Boolean = True): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ALayer <> nil)and(Integer(ALayer) = Integer(FFocusedLayer)) then
        begin
                if (ALayer is TAForm)and(Integer(ALayer) = Integer(FForm)) then
                begin
                        (*==============*)
                        (**) if Assigned(FOnBeforeReleaseFocus) then FOnBeforeReleaseFocus(Self);
                        (*==============*)

                        FFocusedLayer:= nil;
                        if RelFormManager then FormManager.ReleaseFocus(FForm);
                        Result:= True;

                        (*[][][][][][][]*)
                        (**) UpdateHover;
                        (*[][][][][][][]*)

                        (*--------------*)
                        (**) SendMessage(AM_RELEASE_FOCUS, 0, 0, ALayer);
                        (*--------------*)

                        (*--------------*)
                        //   || WParam = old focused layer (object)
                        (**) SendMessage(AM_LAYERMANAGER_RELEASE_FOCUS, Integer(ALayer), 0, MT_BROADCAST);
                        (*--------------*)

                        (*==============*)
                        (**) if Assigned(FOnAfterReleaseFocus) then FOnAfterReleaseFocus(Self);
                        (*==============*)
                end
                else if (ALayer is TAControl)and(Integer(TAControl(ALayer).FParent) = Integer(FForm)) then
                begin
                        (*==============*)
                        (**) if Assigned(FOnBeforeReleaseFocus) then FOnBeforeReleaseFocus(Self);
                        (*==============*)

                        FFocusedLayer:= nil;
                        if RelFormManager then FormManager.ReleaseFocus(FForm);
                        Result:= True;

                        (*[][][][][][][]*)
                        (**) UpdateHover;
                        (*[][][][][][][]*)

                        (*--------------*)
                        (**) SendMessage(AM_RELEASE_FOCUS, 0, 0, ALayer);
                        (*--------------*)

                        (*--------------*)
                        //   || WParam = old focused layer (object)
                        (**) SendMessage(AM_LAYERMANAGER_RELEASE_FOCUS, Integer(ALayer), 0, MT_BROADCAST);
                        (*--------------*)

                        (*==============*)
                        (**) if Assigned(FOnAfterReleaseFocus) then FOnAfterReleaseFocus(Self);
                        (*==============*)
                end
                else Result:= False;
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.SetCapture(ALayer: TObject): Boolean;
var OldCaptureLayer: TObject;
    i: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ALayer <> nil)and(Integer(ALayer) <> Integer(FCaptureLayer))and(FForm.FVisible)and
           ((not Application.Minimized)or(FForm.FMenu)) then
        begin
                if (ALayer is TAForm)and(Integer(ALayer) = Integer(FForm)) then
                begin
                        (*==============*)
                        (**) if Assigned(FOnBeforeSetCapture) then FOnBeforeSetCapture(Self);
                        (*==============*)

                        OldCaptureLayer:= FCaptureLayer;
                        ReleaseCapture(FCaptureLayer, False);
                        FCaptureLayer:= ALayer;
                        FormManager.SetCapture(FForm);

                        for i:= WM_MOUSEFIRST to WM_MOUSELAST do MessageTable.MessageType[i]:= MT_CAPTURE;

                        Result:= True;

                        (*[][][][][][][]*)
                        (**) UpdateHover;
                        (*[][][][][][][]*)

                        (*--------------*)
                        //   || WParam = old capture layer (object)
                        (**) SendMessage(AM_SET_CAPTURE, Integer(OldCaptureLayer), 0, ALayer);
                        (*--------------*)

                        (*--------------*)
                        //   || WParam = new capture layer (object)
                        //   || LParam = old capture layer (object)
                        (**) SendMessage(AM_LAYERMANAGER_SET_CAPTURE, Integer(FCaptureLayer), Integer(OldCaptureLayer), MT_BROADCAST);
                        (*--------------*)

                        (*==============*)
                        (**) if Assigned(FOnAfterSetCapture) then FOnAfterSetCapture(Self);
                        (*==============*)
                end
                else if (ALayer is TAControl)and(Integer(TAControl(ALayer).FParent) = Integer(FForm))and
                        (FForm.FControlsMsg)and(TAControl(ALayer).FVisible)and(TAControl(ALayer).FMsg) then
                begin
                        (*==============*)
                        (**) if Assigned(FOnBeforeSetCapture) then FOnBeforeSetCapture(Self);
                        (*==============*)

                        OldCaptureLayer:= FCaptureLayer;
                        ReleaseCapture(FCaptureLayer, False);
                        FCaptureLayer:= ALayer;
                        FormManager.SetCapture(FForm);

                        for i:= WM_MOUSEFIRST to WM_MOUSELAST do MessageTable.MessageType[i]:= MT_CAPTURE;

                        Result:= True;

                        (*[][][][][][][]*)
                        (**) UpdateHover;
                        (*[][][][][][][]*)

                        (*--------------*)
                        //   || WParam = old capture layer (object)
                        (**) SendMessage(AM_SET_CAPTURE, Integer(OldCaptureLayer), 0, ALayer);
                        (*--------------*)

                        (*--------------*)
                        //   || WParam = new capture layer (object)
                        //   || LParam = old capture layer (object)
                        (**) SendMessage(AM_LAYERMANAGER_SET_CAPTURE, Integer(FCaptureLayer), Integer(OldCaptureLayer), MT_BROADCAST);
                        (*--------------*)

                        (*==============*)
                        (**) if Assigned(FOnAfterSetCapture) then FOnAfterSetCapture(Self);
                        (*==============*)
                end
                else Result:= False;
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




function TALayerManager.ReleaseCapture(ALayer: TObject; RelFormManager: Boolean = True): Boolean;
var i: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ALayer <> nil)and(Integer(ALayer) = Integer(FCaptureLayer)) then
        begin
                if (ALayer is TAForm)and(Integer(ALayer) = Integer(FForm)) then
                begin
                        (*==============*)
                        (**) if Assigned(FOnBeforeReleaseCapture) then FOnBeforeReleaseCapture(Self);
                        (*==============*)

                        FCaptureLayer:= nil;
                        if RelFormManager then FormManager.ReleaseCapture(FForm);

                        for i:= WM_MOUSEFIRST to WM_MOUSELAST do MessageTable.MessageType[i]:= MT_HOVER;

                        Result:= True;

                        (*[][][][][][][]*)
                        (**) UpdateHover;
                        (*[][][][][][][]*)

                        (*--------------*)
                        (**) SendMessage(AM_RELEASE_CAPTURE, 0, 0, ALayer);
                        (*--------------*)

                        (*--------------*)
                        //   || WParam = old capture layer (object)
                        (**) SendMessage(AM_LAYERMANAGER_RELEASE_CAPTURE, Integer(ALayer), 0, MT_BROADCAST);
                        (*--------------*)

                        (*==============*)
                        (**) if Assigned(FOnAfterReleaseCapture) then FOnAfterReleaseCapture(Self);
                        (*==============*)
                end
                else if (ALayer is TAControl)and(Integer(TAControl(ALayer).FParent) = Integer(FForm)) then
                begin
                        (*==============*)
                        (**) if Assigned(FOnBeforeReleaseCapture) then FOnBeforeReleaseCapture(Self);
                        (*==============*)

                        FCaptureLayer:= nil;
                        if RelFormManager then FormManager.ReleaseCapture(FForm);

                        for i:= WM_MOUSEFIRST to WM_MOUSELAST do MessageTable.MessageType[i]:= MT_HOVER;

                        Result:= True;

                        (*[][][][][][][]*)
                        (**) UpdateHover;
                        (*[][][][][][][]*)

                        (*--------------*)
                        (**) SendMessage(AM_RELEASE_CAPTURE, 0, 0, ALayer);
                        (*--------------*)

                        (*--------------*)
                        //   || WParam = old capture layer (object)
                        (**) SendMessage(AM_LAYERMANAGER_RELEASE_CAPTURE, Integer(ALayer), 0, MT_BROADCAST);
                        (*--------------*)

                        (*==============*)
                        (**) if Assigned(FOnAfterReleaseCapture) then FOnAfterReleaseCapture(Self);
                        (*==============*)
                end
                else Result:= False;
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TALayerManager.UpdateHover;
var ALayer: TObject;
    OldHover: TObject;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FCaptureLayer = nil) then ALayer:= GetHoverLayer(FForm.CursorPos)
        else ALayer:= FCaptureLayer;


        if (ALayer <> FHoverLayer) then
        begin
                OldHover:= FHoverLayer;
                FHoverLayer:= ALayer;


                (*--------------*)
                (**) SendMessage(AM_MOUSE_LEAVE, 0, 0, OldHover);
                (*--------------*)

                (*--------------*)
                //   || WParam = new hover layer (object)
                //   || LParam = old hover layer (object)
                (**) SendMessage(AM_LAYERMANAGER_UPDATE_HOVER, Integer(FHoverLayer), Integer(OldHover), MT_BROADCAST);
                (*--------------*)

                (*--------------*)
                //   || WParam = old hover layer (object)
                (**) SendMessage(AM_MOUSE_ENTER, Integer(OldHover), 0, FHoverLayer);
                (*--------------*)

                (*==============*)
                (**) if Assigned(FOnUpdateHover) then FOnUpdateHover(Self);
                (*==============*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.AddControl(AControl: TAControl): Boolean;
var AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AControl <> nil) then
        begin
                if (AControl.FParent <> nil) then AControl.FLayerManager.RemoveControl(AControl);


                AIndex:= FindControl(AControl);

                if (AIndex = -1) then
                begin
                        AControl.FLayerManager:= FForm.FLayerManager;
                        AControl.FParent:= FForm;
                        FControlList.Add(AControl);
                        Inc(FControlCount);
                        Result:= True;

                        // update the constraints to parent bounds.
                        AControl.UpdateConstraints;

                        // add the control as an alwaysontop layer
                        if (AControl.AlwaysOnTop) then Inc(FAlwaysOnTopCount)
                        else AControl.Surface;

                        // add the control to the tab focus list.
                        if (AControl.FFocusable) then
                        begin
                                FTabFocusList.Add(AControl);
                                Inc(FTabFocusCount);
                        end;

                        Invalidate(RT_RELAYER_REDRAW, AControl);

                        (*--------------*)
                        (**) SendMessage(AM_SET_PARENT, 0, 0, AControl);
                        (*--------------*)

                        (*[][][][][][][]*)
                        (**) UpdateHover;
                        (*[][][][][][][]*)
                end
                else begin
                        Result:= False;

                        {$IFDEF THREADSAFE}
                         ThreadManager.ClearExclusive;
                        {$ENDIF}

                        (*++++++++++++++*)
                        (**) RaiseException('Control "' + AControl.FName + '" name not unique.', 'TALayerManager.AddControl | ' + FForm.FName, Self, True)
                        (*++++++++++++++*)
                end;
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.RemoveControl(AControl: TAControl): Boolean;
var AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        AIndex:= FindControl(AControl);

        if (AControl <> nil)and(AIndex > -1) then
        begin
                (*--------------*)
                (**) SendMessage(AM_RELEASE_PARENT, 0, 0, AControl);
                (*--------------*)

                Invalidate(RT_RELAYER_REDRAW, AControl);

                // remove the control from the alwaysontop layers
                if AControl.FAlwaysOnTop then Dec(FAlwaysOnTopCount);

                // remove the control to the tab focus list.
                if (AControl.FFocusable) then
                begin
                        FTabFocusList.Remove(AControl);
                        Dec(FTabFocusCount);
                end;

                ReleaseFocus(AControl);
                ReleaseCapture(AControl);

                AControl.FLayerManager:= nil;
                AControl.FParent:= nil;
                FControlList.Delete(AIndex);
                Dec(FControlCount);
                Result:= True;

                (*[][][][][][][]*)
                (**) UpdateHover;
                (*[][][][][][][]*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.FindControl(const AName: String): Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Result:= 0;
        while (Result < FControlCount)and(not StringEqual(TAControl(FControlList.Items[Result]).FName, AName, False)) do
              Inc(Result);

        if (Result = FControlCount) then Result:= -1;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.FindControl(AControl: TObject): Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Result:= 0;
        while (Result < FControlCount)and(Integer(FControlList.Items[Result]) <> Integer(AControl)) do
              Inc(Result);

        if (Result = FControlCount) then Result:= -1;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.FindLayer(ALayer: TObject): Integer;
begin
        if (Integer(ALayer) = Integer(FForm)) then Result:= LAYER_FORM
        else Result:= FindControl(ALayer);
end;


function TALayerManager.AddMessageNotify(AMsg: Integer; ASender, AReciver: TObject): Boolean;
var ANotify: PNotifyRec;
    AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        AIndex:= FindMessageNotify(AMsg, ASender, AReciver);

        if (AIndex = -1)and(ASender <> AReciver)and
           (((ASender is TAForm)and(TAForm(ASender) = FForm))or
           ((ASender is TAControl)and(TAControl(ASender).FParent = FForm)))and
           (((AReciver is TAForm)and(TAForm(AReciver) = FForm))or
           ((AReciver is TAControl)and(TAControl(AReciver).FParent = FForm)))and
           (AMsg <> AM_MESSAGE_NOTIFY) then
        begin
                GetMem(ANotify, SizeOf(TNotifyRec));
                ANotify^.Msg:= AMsg;
                ANotify^.Sender:= ASender;
                ANotify^.Reciver:= AReciver;
                FMessageNotifyList.Add(ANotify);
                Inc(FMessageNotifyCount);
                Result:= True;

                if (ASender is TAForm) then Inc(TAForm(ASender).FNotify)
                else if (ASender is TAControl) then Inc(TAControl(ASender).FNotify);
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.RemoveMessageNotify(AMsg: Integer; ASender, AReciver: TObject): Boolean;
var ANotify: PNotifyRec;
    AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        AIndex:= FindMessageNotify(AMsg, ASender, AReciver);

        if (ASender <> nil)and(AReciver <> nil)and(AIndex > -1) then
        begin
                ANotify:= FMessageNotifyList.Items[AIndex];
                FreeMem(ANotify);
                FMessageNotifyList.Delete(AIndex);
                Dec(FMessageNotifyCount);
                Result:= True;

                if (ASender is TAForm) then Dec(TAForm(ASender).FNotify)
                else if (ASender is TAControl) then Dec(TAControl(ASender).FNotify);
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.RemoveMessageNotify(AMsg: Integer; ASender: TObject): Boolean;
var ANotify: PNotifyRec;
    AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ASender <> nil)and(FMessageNotifyCount > 0) then
        begin
                AIndex:= 0;
                Result:= False;

                repeat
                        while (AIndex > -1)and(AIndex < FMessageNotifyCount)and((PNotifyRec(FMessageNotifyList.Items[AIndex])^.Msg <> AMsg)or
                              (Integer(PNotifyRec(FMessageNotifyList.Items[AIndex])^.Sender) <> Integer(ASender))) do
                              Inc(AIndex);

                        if (AIndex > -1)and(AIndex < FMessageNotifyCount) then
                        begin
                                ANotify:= FMessageNotifyList.Items[AIndex];
                                FreeMem(ANotify);
                                FMessageNotifyList.Delete(AIndex);
                                Dec(FMessageNotifyCount);
                                Dec(AIndex);
                                Result:= True;

                                if (ASender is TAForm) then Dec(TAForm(ASender).FNotify)
                                else if (ASender is TAControl) then Dec(TAControl(ASender).FNotify);
                        end
                        else Break;
                until (AIndex = FMessageNotifyCount);
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.RemoveMessageNotifySender(ASender: TObject): Boolean;
var ANotify: PNotifyRec;
    AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ASender <> nil)and(FMessageNotifyCount > 0) then
        begin
                AIndex:= 0;
                Result:= False;

                repeat
                        while (AIndex > -1)and(AIndex < FMessageNotifyCount)and(Integer(PNotifyRec(FMessageNotifyList.Items[AIndex])^.Sender) <> Integer(ASender)) do
                              Inc(AIndex);

                        if (AIndex > -1)and(AIndex < FMessageNotifyCount) then
                        begin
                                ANotify:= FMessageNotifyList.Items[AIndex];
                                FreeMem(ANotify);
                                FMessageNotifyList.Delete(AIndex);
                                Dec(FMessageNotifyCount);
                                Dec(AIndex);
                                Result:= True;

                                if (ASender is TAForm) then Dec(TAForm(ASender).FNotify)
                                else if (ASender is TAControl) then Dec(TAControl(ASender).FNotify);
                        end
                        else Break;
                until (AIndex = FMessageNotifyCount);
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.RemoveMessageNotifyReciver(AReciver: TObject): Boolean;
var ANotify: PNotifyRec;
    AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AReciver <> nil)and(FMessageNotifyCount > 0) then
        begin
                AIndex:= 0;
                Result:= False;

                repeat
                        while (AIndex > -1)and(AIndex < FMessageNotifyCount)and(Integer(PNotifyRec(FMessageNotifyList.Items[AIndex])^.Reciver) <> Integer(AReciver)) do
                              Inc(AIndex);

                        if (AIndex > -1)and(AIndex < FMessageNotifyCount) then
                        begin
                                ANotify:= FMessageNotifyList.Items[AIndex];

                                if (ANotify^.Sender is TAForm) then Dec(TAForm(ANotify^.Sender).FNotify)
                                else if (ANotify^.Sender is TAControl) then Dec(TAControl(ANotify^.Sender).FNotify);

                                FreeMem(ANotify);
                                FMessageNotifyList.Delete(AIndex);
                                Dec(FMessageNotifyCount);
                                Dec(AIndex);
                                Result:= True;
                        end
                        else Break;
                until (AIndex = FMessageNotifyCount);
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TALayerManager.FindMessageNotify(AMsg: Integer; ASender, AReciver: TObject): Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Result:= 0;
        while (Result < FMessageNotifyCount)and((PNotifyRec(FMessageNotifyList.Items[Result])^.Msg <> AMsg)or
              (Integer(PNotifyRec(FMessageNotifyList.Items[Result])^.Sender) <> Integer(ASender))or
              (Integer(PNotifyRec(FMessageNotifyList.Items[Result])^.Reciver) <> Integer(AReciver))) do
        Inc(Result);

        if (Result = FMessageNotifyCount) then Result:= -1;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TALayerManager.RunMessageNotify(AMsg: Integer; ASender: TObject);
var ANotify: PNotifyRec;
    AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ASender <> nil)and(FMessageNotifyCount > 0)and(AMsg <> AM_MESSAGE_NOTIFY) then
        begin
                AIndex:= 0;

                repeat
                        while (AIndex < FMessageNotifyCount)and((PNotifyRec(FMessageNotifyList.Items[AIndex])^.Msg <> AMsg)or
                              (Integer(PNotifyRec(FMessageNotifyList.Items[AIndex])^.Sender) <> Integer(ASender))) do
                              Inc(AIndex);

                        if (AIndex < FMessageNotifyCount) then
                        begin
                                ANotify:= FMessageNotifyList.Items[AIndex];

                                (*--------------*)
                                (**) SendMessage(AM_MESSAGE_NOTIFY, AMsg, Integer(ASender), ANotify^.Reciver);
                                (*--------------*)

                                Inc(AIndex);
                        end
                        else Break;
                until (AIndex = FMessageNotifyCount);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##                                MESSAGETABLE                              ##
//##############################################################################


{ TAMessageTable }




constructor TAMessageTable.Create;
begin
        Create(WM_FIRST, AM_LAST);
end;


constructor TAMessageTable.Create(AFirstMsg, ALastMsg: Integer);
var a: Integer;
begin
FFirstMsg:= AFirstMsg;
FLastMsg:= ALastMsg;



        SetCapacity(FLastMsg - FFirstMsg);

        // set the mouse messages to LOCATION
        for a:= WM_MOUSEFIRST to WM_MOUSELAST do
                SetMessageType(a, MT_HOVER);

        // set the keyboard messages to FOCUS
        for a:= WM_KEYFIRST to WM_KEYLAST do
                SetMessageType(a, MT_FOCUS);


        // set types for special messages
        MessageType[CM_MSG_POST]:= MT_MSG_POST;
end;


destructor TAMessageTable.Destroy;
begin
        SetCapacity(0);



inherited;
end;


function TAMessageTable.GetCount: Integer;
begin
        Result:= FLastMsg - FFirstMsg;
end;


function TAMessageTable.GetMessageType(AMessage: Cardinal): Integer;
begin
        if (AMessage >= FFirstMsg)and(AMessage <= FLastMsg) then Result:= FList^[AMessage - FFirstMsg]
        else Result:= MT_NA;
end;


procedure TAMessageTable.SetMessageType(AMessage: Cardinal; AMsgType: Integer);
begin
        if (AMessage >= FFirstMsg)and(AMessage <= FLastMsg) then FList^[AMessage - FFirstMsg]:= AMsgType
        (*++++++++++++++*)
        (**) else RaiseException('Set message not in table. Requested ' + IntToStr(AMessage) + ', first ' + IntToStr(FFirstMsg) + ', last ' + IntToStr(FLastMsg) + '.', 'TAMessageTable.SetMessageType', Self);
        (*++++++++++++++*)
end;


procedure TAMessageTable.SetCapacity(ACapacity: Integer);
begin
        if (ACapacity <> FCapacity) then
        begin
                ReallocMem(FList, ACapacity * SizeOf(Integer));
                FCapacity:= ACapacity;

                HeapFill(FList, Cardinal(MT_NA), FCapacity);
        end;
end;




//##############################################################################
//##                               TIMERMANAGER                               ##
//##############################################################################


{ TATimerManager }




constructor TATimerManager.Create;
begin
FThreadTimerListLock:= TALock.Create('ThreadTimer list lock | TimerManager');
FThreadTimerWaitLock:= TALock.Create('ThreadTimer wait lock | TimerManager');

inherited Create('TimerManager', False, False, TP_HIGHER);



        FHookTimerList:= TAList.Create;
        FHookTimerCount:= 0;

        FThreadTimerList:= TAList.Create;
        FThreadTimerCount:= 0;

        FSyncTimerList:= TAList.Create;
        FSyncTimerCount:= 0;

        CreateSyncHandle;
end;


destructor TATimerManager.Destroy;
begin
        DestroySyncHandle;

        FreeNil(FHookTimerList);
        FreeNil(FSyncTimerList);



        if (FHandle <> 0) then
        begin
                if (not FFinished) then
                begin
                        Terminate;

                        WaitFor(True);
                end;

                HWindows.CloseHandle(FHandle);

                ThreadManager.RemoveThread(Self);
        end;

FreeNil(FThreadTimerWaitLock);
FreeNil(FThreadTimerListLock);

(*==============*)
(**) if Assigned(FOnDestroy) then FOnDestroy(Self);
(*==============*)
end;


procedure TATimerManager.HookProcedure;
var i: Integer;
    Tick: Cardinal;
    Rec: PHookTimerRec;
begin
        {$IFDEF THREADSAFE}
         ThreadManager.SetExclusive;
        {$ENDIF}

          Tick:= HMultimedia.timeGetTime;

          for i:= 0 to FHookTimerCount-1 do
          begin
                Rec:= FHookTimerList.Items[i];

                if (Tick - Rec^.LastTick) >= Rec^.TimeOut then
                begin
                        Rec^.LastTick:= Tick;

                        if (TObject(Rec^.Reciver) is TAForm) then TAForm(Rec^.Reciver).FLayerManager.PostMessage(AM_TIMER, Rec^.Id, 0, LAYER_FORM)
                        else if (TObject(Rec^.Reciver) is TAControl)and(TAControl(Rec^.Reciver).FParent <> nil) then TAControl(Rec^.Reciver).FLayerManager.PostMessage(AM_TIMER, Rec^.Id, 0, TAControl(Rec^.Reciver));
                end;
          end;

        {$IFDEF THREADSAFE}
         ThreadManager.ClearExclusive;
        {$ENDIF}


        // stop a flow of AM_HOOK_TIMER message post for each message by
        // flushing all messages posted until now (time).
        Application.FlushQueue(False);


        (*--------------*)
        (**) Application.PostMessage(Application.Handle, AM_HOOK_TIMER, 0, 0);
        (*--------------*)
end;


function TATimerManager.SyncProcedure(AHandle: Cardinal; Msg, WParam, LParam: Integer): Integer; stdcall;
var Rec: TSyncTimerRec;
begin
        if (Msg = WM_TIMER)or(Msg = AM_RUN_TIMER) then
        begin
               {$IFDEF THREADSAFE}
                ThreadManager.SetExclusive;
               {$ENDIF}

                 if (FSyncTimerList.InBounds(WParam - 1)and(FSyncTimerList.Items[WParam - 1] <> nil)) then
                 begin
                        Rec:= PSyncTimerRec(FSyncTimerList.Items[WParam - 1])^;

                        if (TObject(Rec.Reciver) is TAForm) then TAForm(Rec.Reciver).ProcessMessage(AM_TIMER, Rec.Id, 0)
                        else if (TObject(Rec.Reciver) is TAControl) then TAControl(Rec.Reciver).ProcessMessage(AM_TIMER, Rec.Id, 0);

                        {$IFDEF THREADSAFE}
                         ThreadManager.ClearExclusive;
                        {$ENDIF}

                        // always pass the message to the default
                        // window procedure (windows handled).
                        Result:= HWindows.DefWindowProc(FHandle, Msg, WParam, LParam);

                        Exit;
                 end;

               {$IFDEF THREADSAFE}
                ThreadManager.ClearExclusive;
               {$ENDIF}
        end;

        // always pass the message to the default
        // window procedure (windows handled).
        Result:= HWindows.DefWindowProc(FHandle, Msg, WParam, LParam);
end;


function TATimerManager.ThreadProcedure(AHandle: Cardinal; Msg, WParam, LParam: Integer): Integer; stdcall;
var Rec: TThreadTimerRec;
begin
       (*><><><><><><><*)
       (**) ThreadManager.SetExclusive(FThreadTimerWaitLock);
       (*><><><><><><><*)

        if (Msg = WM_TIMER)or(Msg = AM_RUN_TIMER) then
        begin
              (*><><><><><><><*)
              (**) ThreadManager.SetExclusive(FThreadTimerListLock);
              (*><><><><><><><*)

                 if (FThreadTimerList.InBounds(WParam - 1)and(FThreadTimerList.Items[WParam - 1] <> nil)) then
                 begin
                        Rec:= PThreadTimerRec(FThreadTimerList.Items[WParam - 1])^;

                        (*><><><><><><><*)
                        (**) ThreadManager.ClearExclusive(FThreadTimerListLock);
                        (*><><><><><><><*)

                        if (TObject(Rec.Reciver) is TAForm) then TAForm(Rec.Reciver).ProcessMessage(AM_TIMER, Rec.Id, 0)
                        else if (TObject(Rec.Reciver) is TAControl) then TAControl(Rec.Reciver).ProcessMessage(AM_TIMER, Rec.Id, 0);

                        (*><><><><><><><*)
                        (**) ThreadManager.ClearExclusive(FThreadTimerWaitLock);
                        (*><><><><><><><*)

                        // always pass the message to the default
                        // window procedure (windows handled).
                        Result:= HWindows.DefWindowProc(FHandle, Msg, WParam, LParam);

                        Exit;
                 end;

              (*><><><><><><><*)
              (**) ThreadManager.ClearExclusive(FThreadTimerListLock);
              (*><><><><><><><*)
        end;

       (*><><><><><><><*)
       (**) ThreadManager.ClearExclusive(FThreadTimerWaitLock);
       (*><><><><><><><*)


        // always pass the message to the default
        // window procedure (windows handled).
        Result:= HWindows.DefWindowProc(FHandle, Msg, WParam, LParam);
end;


function TATimerManager.CreateSyncHandle: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FSyncHandle = 0) then
        begin
                FSyncWindowProcInstance:= MethodToProcedure(Self, @TATimerManager.SyncProcedure);

                SyncTimerWindowClass.HInstance:= Application.Instance;
                HWindows.RegisterClass(SyncTimerWindowClass);

                // we dont make it a child but we specify a parent window handle
                // so there windows won't create a thumb on the taskbar for the form
                FSyncHandle:= CreateWindow(
                              SyncTimerWindowClass.lpszClassName, nil,
                              WS_POPUP,
                              0, 0, 0, 0,
                              Application.Handle, 0, HInstance, nil);

                (*++++++++++++++*)
                (**) if (FSyncHandle = 0) then RaiseException('Cannot create handle for synctimer.', 'TATimerManager.CreateSyncHandle', Self, True);
                (*++++++++++++++*)

                // now we set the real WindowProc.
                SetWindowLong(FSyncHandle, GWL_WNDPROC, Integer(FSyncWindowProcInstance));

                Result:= (FSyncHandle <> 0);
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;

function TATimerManager.DestroySyncHandle: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FSyncHandle <> 0) then
        begin
                // free the handle and unregister the class
                // flush queue and kill timers
                DestroyWindow(FSyncHandle);
                FSyncHandle:= 0;

                FreeMem(FSyncWindowProcInstance);
                Result:= True;
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TATimerManager.CreateThreadHandle: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FThreadHandle = 0) then
        begin
                FThreadWindowProcInstance:= MethodToProcedure(Self, @TATimerManager.ThreadProcedure);

                ThreadTimerWindowClass.HInstance:= Application.Instance;
                HWindows.RegisterClass(ThreadTimerWindowClass);

                FThreadHandle:= CreateWindow(
                                ThreadTimerWindowClass.lpszClassName, nil,
                                WS_POPUP,
                                0, 0, 0, 0,
                                Application.Handle, 0, HInstance, nil);

                (*++++++++++++++*)
                (**) if (FThreadHandle = 0) then RaiseException('Cannot create handle for threadtimer.', 'TATimerManager.CreateThreadHandle', Self, True);
                (*++++++++++++++*)

                // now we set the real WindowProc.
                SetWindowLong(FThreadHandle, GWL_WNDPROC, Integer(FThreadWindowProcInstance));

                Result:= (FThreadHandle <> 0);
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TATimerManager.DestroyThreadHandle: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FThreadHandle <> 0) then
        begin
                // free the handle and unregister the class
                // flush queue and kill timers
                DestroyWindow(FThreadHandle);
                FThreadHandle:= 0;

                FreeMem(FThreadWindowProcInstance);
                Result:= True;
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TATimerManager.Execute;
var AMsg: TMsg;
begin
        CreateThreadHandle;

        repeat
                try
                  case Integer(HWindows.GetMessage(AMsg, 0, 0, 0)) of
                    //
                    GM_SUCCESS: HWindows.DispatchMessage(AMsg);
                    //
                    GM_TERMINATE: FTerminated:= True;
                    //
                    GM_ERROR:
                           (*++++++++++++++*)
                           (**) RaiseException('Cannot getmessage.', 'TimerManager.Execute', Self);
                           (*++++++++++++++*)
                    //
                  end;
                except
                 (*++++++++++++++*)
                 (**) HandleException('TimerManager.Execute');
                 (*++++++++++++++*)
                end;
        until (FTerminated);

        DestroyThreadHandle;
end;


function TATimerManager.AddTimer(ATimerType: Integer; AId: Cardinal; ATimeOut: Cardinal; AReciver: TObject): Boolean;
var HookTimerRec: PHookTimerRec;
    ThreadTimerRec: PThreadTimerRec;
    SyncTimerRec: PSyncTimerRec;
    i: Integer;
begin
        case ATimerType of
          TT_HOOK:
          begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

                if (AId > 0)and(ATimeOut > 0)and(AReciver <> nil)and
                   (FindTimer(ATimerType, AId, AReciver) = -1) then
                begin
                        if (FHookTimerCount = 0) then
                        begin
                                Application.OnHookTimer:= HookProcedure;

                                (*--------------*)
                                (**) Application.PostMessage(Application.Handle, AM_HOOK_TIMER, 0, 0);
                                (*--------------*)
                        end;

                        GetMem(HookTimerRec, SizeOf(THookTimerRec));
                        HookTimerRec^.Id:= AId;
                        HookTimerRec^.TimeOut:= ATimeOut;
                        HookTimerRec^.LastTick:= HMultimedia.timeGetTime;
                        HookTimerRec^.Reciver:= AReciver;

                        FHookTimerList.Add(HookTimerRec);
                        Inc(FHookTimerCount);
                        Result:= True;
                end
                else Result:= False;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}
          end;
          //
          TT_SYNC:
          begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

                if (AId > 0)and(ATimeOut > 0)and(AReciver <> nil)and
                   (FindTimer(ATimerType, AId, AReciver) = -1) then
                begin
                        GetMem(SyncTimerRec, SizeOf(TSyncTimerRec));
                        SyncTimerRec^.Id:= AId;
                        SyncTimerRec^.TimeOut:= ATimeOut;
                        SyncTimerRec^.Reciver:= AReciver;


                        i:= 0;
                        while (i < FSyncTimerCount)and(FSyncTimerList.Items[i] <> nil) do
                                Inc(i);

                        if (i = FSyncTimerCount) then
                        begin
                                HWindows.SetTimer(FSyncHandle, FSyncTimerCount + 1, ATimeOut, nil);
                                FSyncTimerList.Add(SyncTimerRec);
                                Inc(FSyncTimerCount);
                        end
                        else begin
                                HWindows.SetTimer(FSyncHandle, i + 1, ATimeOut, nil);
                                FSyncTimerList.Items[i]:= SyncTimerRec;
                        end;
                        Result:= True;
                end
                else Result:= False;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}
          end;
          //
          TT_THREAD:
          begin
              (*><><><><><><><*)
              (**) ThreadManager.SetExclusive(FThreadTimerListLock);
              (*><><><><><><><*)

                if (AId > 0)and(ATimeOut > 0)and(AReciver <> nil)and
                   (FindTimer(ATimerType, AId, AReciver) = -1) then
                begin
                        GetMem(ThreadTimerRec, SizeOf(TThreadTimerRec));
                        ThreadTimerRec^.Id:= AId;
                        ThreadTimerRec^.TimeOut:= ATimeOut;
                        ThreadTimerRec^.Reciver:= AReciver;


                        i:= 0;
                        while (i < FThreadTimerCount)and(FThreadTimerList.Items[i] <> nil) do
                                Inc(i);

                        if (i = FThreadTimerCount) then
                        begin
                                HWindows.SetTimer(FThreadHandle, FThreadTimerCount + 1, ATimeOut, nil);
                                FThreadTimerList.Add(ThreadTimerRec);
                                Inc(FThreadTimerCount);
                        end
                        else begin
                                HWindows.SetTimer(FThreadHandle, i + 1, ATimeOut, nil);
                                FThreadTimerList.Items[i]:= ThreadTimerRec;
                        end;
                        Result:= True;
                 end
                else Result:= False;

              (*><><><><><><><*)
              (**) ThreadManager.ClearExclusive(FThreadTimerListLock);
              (*><><><><><><><*)
          end;
          //
          else Result:= False;
          //
        end;
end;


function TATimerManager.RemoveTimer(ATimerType: Integer; AId: Cardinal; AReciver: TObject): Boolean;
var AIndex: Integer;
begin
        case ATimerType of
          TT_HOOK:
          begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

                AIndex:= FindTimer(ATimerType, AId, AReciver);

                if (AId > 0)and(AIndex > -1) then
                begin
                        FreeMem(FHookTimerList.Items[AIndex]);

                        FHookTimerList.Delete(AIndex);
                        Dec(FHookTimerCount);
                        Result:= True;

                        if (FHookTimerCount = 0) then Application.OnHookTimer:= nil;
                end
                else Result:= False;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}
          end;
          //
          TT_SYNC:
          begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

                AIndex:= FindTimer(ATimerType, AId, AReciver);

                if (AId > 0)and(AIndex > -1) then
                begin
                        FreeMem(FSyncTimerList.Items[AIndex]);

                        if (AIndex = FSyncTimerCount-1) then
                        begin
                                FSyncTimerList.Delete(AIndex);
                                Dec(FSyncTimerCount);
                        end
                        else FSyncTimerList.Items[AIndex]:= nil;
                        Result:= True;

                        HWindows.KillTimer(FSyncHandle, AIndex + 1);
                end
                else Result:= False;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}
          end;
          //
          TT_THREAD:
          begin
              (*><><><><><><><*)
              (**) ThreadManager.SetExclusive(FThreadTimerWaitLock);
              (*><><><><><><><*)

              (*><><><><><><><*)
              (**) ThreadManager.SetExclusive(FThreadTimerListLock);
              (*><><><><><><><*)

                AIndex:= FindTimer(ATimerType, AId, AReciver);

                if (AId > 0)and(AIndex > -1) then
                begin
                        FreeMem(FThreadTimerList.Items[AIndex]);

                        if (AIndex = FThreadTimerCount - 1) then
                        begin
                                FThreadTimerList.Delete(AIndex);
                                Dec(FThreadTimerCount);
                        end
                        else FThreadTimerList.Items[AIndex]:= nil;
                        Result:= True;

                        HWindows.KillTimer(FThreadHandle, AIndex + 1);
                end
                else Result:= False;

              (*><><><><><><><*)
              (**) ThreadManager.ClearExclusive(FThreadTimerListLock);
              (*><><><><><><><*)

              (*><><><><><><><*)                            
              (**) ThreadManager.ClearExclusive(FThreadTimerWaitLock);
              (*><><><><><><><*)
          end;
          //
          else Result:= False;
          //
        end;
end;


function TATimerManager.FindTimer(ATimerType: Integer; AId: Cardinal; AReciver: TObject): Integer;
begin
        case ATimerType of
          TT_HOOK:
          begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

                Result:= 0;
                while (Result < FHookTimerCount)and
                      ((AId <> PHookTimerRec(FHookTimerList.Items[Result])^.Id)or
                      (AReciver <> PHookTimerRec(FHookTimerList.Items[Result])^.Reciver)) do
                Inc(Result);

                if (Result = FHookTimerCount) then Result:= -1;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}
          end;
          //
          TT_SYNC:
          begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

                Result:= 0;
                while (Result < FSyncTimerCount)and((FSyncTimerList.Items[Result] = nil)or
                      ((AId <> PSyncTimerRec(FSyncTimerList.Items[Result])^.Id)or
                      (AReciver <> PSyncTimerRec(FSyncTimerList.Items[Result])^.Reciver))) do
                Inc(Result);

                if (Result = FSyncTimerCount) then Result:= -1;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}
          end;
          //
          TT_THREAD:
          begin
               (*><><><><><><><*)
               (**) ThreadManager.SetExclusive(FThreadTimerListLock);
               (*><><><><><><><*)

                Result:= 0;
                while (Result < FThreadTimerCount)and((FThreadTimerList.Items[Result] = nil)or
                      ((AId <> PThreadTimerRec(FThreadTimerList.Items[Result])^.Id)or
                      (AReciver <> PThreadTimerRec(FThreadTimerList.Items[Result])^.Reciver))) do
                Inc(Result);

                if (Result = FThreadTimerCount) then Result:= -1;

               (*><><><><><><><*)
               (**) ThreadManager.ClearExclusive(FThreadTimerListLock);
               (*><><><><><><><*)
          end;
          //
          else Result:= -1;
          //
        end;
end;


function TATimerManager.RunTimer(ATimerType: Integer; AId: Cardinal; AReciver: TObject): Boolean;
var AIndex: Integer;
begin
        case ATimerType of
          TT_HOOK:
          begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

               AIndex:= FindTimer(ATimerType, AId, AReciver);

               if (AIndex > -1) then
               begin
                      if (TObject(AReciver) is TAForm) then TAForm(AReciver).FLayerManager.PostMessage(AM_TIMER, AId, 0, LAYER_FORM)
                      else if (TObject(AReciver) is TAControl)and(TAControl(AReciver).FParent <> nil) then TAControl(AReciver).FLayerManager.PostMessage(AM_TIMER, AId, 0, TAControl(AReciver));

                      Result:= True;
               end
               else Result:= False;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}
          end;
          //
          TT_SYNC:
          begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

               AIndex:= FindTimer(ATimerType, AId, AReciver);

               if (AIndex > -1) then
               begin
                        (*--------------*)
                        (**) Application.PostMessage(FSyncHandle, AM_RUN_TIMER, AIndex + 1, 0);
                        (*--------------*)

                        Result:= True;
               end
               else Result:= False;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}
          end;
          //
          TT_THREAD:
          begin
               (*><><><><><><><*)
               (**) ThreadManager.SetExclusive(FThreadTimerListLock);
               (*><><><><><><><*)

               AIndex:= FindTimer(ATimerType, AId, AReciver);

               if (AIndex > -1) then
               begin
                        (*--------------*)
                        (**) Application.PostMessage(FThreadHandle, AM_RUN_TIMER, AIndex + 1, 0);
                        (*--------------*)

                        Result:= True;
               end
               else Result:= False;

               (*><><><><><><><*)
               (**) ThreadManager.ClearExclusive(FThreadTimerListLock);
               (*><><><><><><><*)
          end;
          //
          else Result:= False;
          //
        end;
end;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//#######################                                 ######################
//#######################                                 ######################
//##                              INITIALIZATION                              ##
//#######################                                 ######################
//#######################                                 ######################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
procedure Init;
begin
        try
           MessageTable:= TAMessageTable.Create;
           TimerManager:= TATimerManager.Create;
        except
          (*++++++++++++++*)
          (**) HandleException('UBasic initialization');
          (*++++++++++++++*)
        end;
end;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//#######################                                 ######################
//#######################                                 ######################
//##                                FINALIZATION                              ##
//#######################                                 ######################
//#######################                                 ######################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
procedure Final;
begin
        try
           FreeNil(TimerManager);
           FreeNil(MessageTable);
        except
          (*++++++++++++++*)
          (**) HandleException('UBasic finalization');
          (*++++++++++++++*)
        end;
end;

//##############################################################################
//##############################################################################

End.
